/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-gamedeployment-operator/pkg/apis/tkex/v1alpha1"
	scheme "github.com/Tencent/bk-bcs/bcs-k8s/bcs-gamedeployment-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// GameDeploymentsGetter has a method to return a GameDeploymentInterface.
// A group's client should implement this interface.
type GameDeploymentsGetter interface {
	GameDeployments(namespace string) GameDeploymentInterface
}

// GameDeploymentInterface has methods to work with GameDeployment resources.
type GameDeploymentInterface interface {
	Create(*v1alpha1.GameDeployment) (*v1alpha1.GameDeployment, error)
	Update(*v1alpha1.GameDeployment) (*v1alpha1.GameDeployment, error)
	UpdateStatus(*v1alpha1.GameDeployment) (*v1alpha1.GameDeployment, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.GameDeployment, error)
	List(opts v1.ListOptions) (*v1alpha1.GameDeploymentList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.GameDeployment, err error)
	GameDeploymentExpansion
}

// gameDeployments implements GameDeploymentInterface
type gameDeployments struct {
	client rest.Interface
	ns     string
}

// newGameDeployments returns a GameDeployments
func newGameDeployments(c *TkexV1alpha1Client, namespace string) *gameDeployments {
	return &gameDeployments{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the gameDeployment, and returns the corresponding gameDeployment object, and an error if there is any.
func (c *gameDeployments) Get(name string, options v1.GetOptions) (result *v1alpha1.GameDeployment, err error) {
	result = &v1alpha1.GameDeployment{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("gamedeployments").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of GameDeployments that match those selectors.
func (c *gameDeployments) List(opts v1.ListOptions) (result *v1alpha1.GameDeploymentList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.GameDeploymentList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("gamedeployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested gameDeployments.
func (c *gameDeployments) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("gamedeployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a gameDeployment and creates it.  Returns the server's representation of the gameDeployment, and an error, if there is any.
func (c *gameDeployments) Create(gameDeployment *v1alpha1.GameDeployment) (result *v1alpha1.GameDeployment, err error) {
	result = &v1alpha1.GameDeployment{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("gamedeployments").
		Body(gameDeployment).
		Do().
		Into(result)
	return
}

// Update takes the representation of a gameDeployment and updates it. Returns the server's representation of the gameDeployment, and an error, if there is any.
func (c *gameDeployments) Update(gameDeployment *v1alpha1.GameDeployment) (result *v1alpha1.GameDeployment, err error) {
	result = &v1alpha1.GameDeployment{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("gamedeployments").
		Name(gameDeployment.Name).
		Body(gameDeployment).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *gameDeployments) UpdateStatus(gameDeployment *v1alpha1.GameDeployment) (result *v1alpha1.GameDeployment, err error) {
	result = &v1alpha1.GameDeployment{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("gamedeployments").
		Name(gameDeployment.Name).
		SubResource("status").
		Body(gameDeployment).
		Do().
		Into(result)
	return
}

// Delete takes name of the gameDeployment and deletes it. Returns an error if one occurs.
func (c *gameDeployments) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("gamedeployments").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *gameDeployments) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("gamedeployments").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched gameDeployment.
func (c *gameDeployments) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.GameDeployment, err error) {
	result = &v1alpha1.GameDeployment{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("gamedeployments").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
