/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/core/v1alpha1"
	scheme "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/client/clientset/versioned/scheme"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterPropagatedVersionsGetter has a method to return a ClusterPropagatedVersionInterface.
// A group's client should implement this interface.
type ClusterPropagatedVersionsGetter interface {
	ClusterPropagatedVersions() ClusterPropagatedVersionInterface
}

// ClusterPropagatedVersionInterface has methods to work with ClusterPropagatedVersion resources.
type ClusterPropagatedVersionInterface interface {
	Create(*v1alpha1.ClusterPropagatedVersion) (*v1alpha1.ClusterPropagatedVersion, error)
	Update(*v1alpha1.ClusterPropagatedVersion) (*v1alpha1.ClusterPropagatedVersion, error)
	UpdateStatus(*v1alpha1.ClusterPropagatedVersion) (*v1alpha1.ClusterPropagatedVersion, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.ClusterPropagatedVersion, error)
	List(opts v1.ListOptions) (*v1alpha1.ClusterPropagatedVersionList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ClusterPropagatedVersion, err error)
	ClusterPropagatedVersionExpansion
}

// clusterPropagatedVersions implements ClusterPropagatedVersionInterface
type clusterPropagatedVersions struct {
	client rest.Interface
}

// newClusterPropagatedVersions returns a ClusterPropagatedVersions
func newClusterPropagatedVersions(c *CoreV1alpha1Client) *clusterPropagatedVersions {
	return &clusterPropagatedVersions{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterPropagatedVersion, and returns the corresponding clusterPropagatedVersion object, and an error if there is any.
func (c *clusterPropagatedVersions) Get(name string, options v1.GetOptions) (result *v1alpha1.ClusterPropagatedVersion, err error) {
	result = &v1alpha1.ClusterPropagatedVersion{}
	err = c.client.Get().
		Resource("clusterpropagatedversions").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterPropagatedVersions that match those selectors.
func (c *clusterPropagatedVersions) List(opts v1.ListOptions) (result *v1alpha1.ClusterPropagatedVersionList, err error) {
	result = &v1alpha1.ClusterPropagatedVersionList{}
	err = c.client.Get().
		Resource("clusterpropagatedversions").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterPropagatedVersions.
func (c *clusterPropagatedVersions) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Resource("clusterpropagatedversions").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a clusterPropagatedVersion and creates it.  Returns the server's representation of the clusterPropagatedVersion, and an error, if there is any.
func (c *clusterPropagatedVersions) Create(clusterPropagatedVersion *v1alpha1.ClusterPropagatedVersion) (result *v1alpha1.ClusterPropagatedVersion, err error) {
	result = &v1alpha1.ClusterPropagatedVersion{}
	err = c.client.Post().
		Resource("clusterpropagatedversions").
		Body(clusterPropagatedVersion).
		Do().
		Into(result)
	return
}

// Update takes the representation of a clusterPropagatedVersion and updates it. Returns the server's representation of the clusterPropagatedVersion, and an error, if there is any.
func (c *clusterPropagatedVersions) Update(clusterPropagatedVersion *v1alpha1.ClusterPropagatedVersion) (result *v1alpha1.ClusterPropagatedVersion, err error) {
	result = &v1alpha1.ClusterPropagatedVersion{}
	err = c.client.Put().
		Resource("clusterpropagatedversions").
		Name(clusterPropagatedVersion.Name).
		Body(clusterPropagatedVersion).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *clusterPropagatedVersions) UpdateStatus(clusterPropagatedVersion *v1alpha1.ClusterPropagatedVersion) (result *v1alpha1.ClusterPropagatedVersion, err error) {
	result = &v1alpha1.ClusterPropagatedVersion{}
	err = c.client.Put().
		Resource("clusterpropagatedversions").
		Name(clusterPropagatedVersion.Name).
		SubResource("status").
		Body(clusterPropagatedVersion).
		Do().
		Into(result)
	return
}

// Delete takes name of the clusterPropagatedVersion and deletes it. Returns an error if one occurs.
func (c *clusterPropagatedVersions) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clusterpropagatedversions").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterPropagatedVersions) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Resource("clusterpropagatedversions").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched clusterPropagatedVersion.
func (c *clusterPropagatedVersions) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ClusterPropagatedVersion, err error) {
	result = &v1alpha1.ClusterPropagatedVersion{}
	err = c.client.Patch(pt).
		Resource("clusterpropagatedversions").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
