/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/core/v1alpha1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFederatedServiceStatuses implements FederatedServiceStatusInterface
type FakeFederatedServiceStatuses struct {
	Fake *FakeCoreV1alpha1
	ns   string
}

var federatedservicestatusesResource = schema.GroupVersionResource{Group: "core.kubefed.io", Version: "v1alpha1", Resource: "federatedservicestatuses"}

var federatedservicestatusesKind = schema.GroupVersionKind{Group: "core.kubefed.io", Version: "v1alpha1", Kind: "FederatedServiceStatus"}

// Get takes name of the federatedServiceStatus, and returns the corresponding federatedServiceStatus object, and an error if there is any.
func (c *FakeFederatedServiceStatuses) Get(name string, options v1.GetOptions) (result *v1alpha1.FederatedServiceStatus, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(federatedservicestatusesResource, c.ns, name), &v1alpha1.FederatedServiceStatus{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedServiceStatus), err
}

// List takes label and field selectors, and returns the list of FederatedServiceStatuses that match those selectors.
func (c *FakeFederatedServiceStatuses) List(opts v1.ListOptions) (result *v1alpha1.FederatedServiceStatusList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(federatedservicestatusesResource, federatedservicestatusesKind, c.ns, opts), &v1alpha1.FederatedServiceStatusList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.FederatedServiceStatusList{}
	for _, item := range obj.(*v1alpha1.FederatedServiceStatusList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested federatedServiceStatuses.
func (c *FakeFederatedServiceStatuses) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(federatedservicestatusesResource, c.ns, opts))

}

// Create takes the representation of a federatedServiceStatus and creates it.  Returns the server's representation of the federatedServiceStatus, and an error, if there is any.
func (c *FakeFederatedServiceStatuses) Create(federatedServiceStatus *v1alpha1.FederatedServiceStatus) (result *v1alpha1.FederatedServiceStatus, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(federatedservicestatusesResource, c.ns, federatedServiceStatus), &v1alpha1.FederatedServiceStatus{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedServiceStatus), err
}

// Update takes the representation of a federatedServiceStatus and updates it. Returns the server's representation of the federatedServiceStatus, and an error, if there is any.
func (c *FakeFederatedServiceStatuses) Update(federatedServiceStatus *v1alpha1.FederatedServiceStatus) (result *v1alpha1.FederatedServiceStatus, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(federatedservicestatusesResource, c.ns, federatedServiceStatus), &v1alpha1.FederatedServiceStatus{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedServiceStatus), err
}

// Delete takes name of the federatedServiceStatus and deletes it. Returns an error if one occurs.
func (c *FakeFederatedServiceStatuses) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(federatedservicestatusesResource, c.ns, name), &v1alpha1.FederatedServiceStatus{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFederatedServiceStatuses) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(federatedservicestatusesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.FederatedServiceStatusList{})
	return err
}

// Patch applies the patch and returns the patched federatedServiceStatus.
func (c *FakeFederatedServiceStatuses) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.FederatedServiceStatus, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(federatedservicestatusesResource, c.ns, name, data, subresources...), &v1alpha1.FederatedServiceStatus{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedServiceStatus), err
}
