/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/core/v1beta1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKubeFedClusters implements KubeFedClusterInterface
type FakeKubeFedClusters struct {
	Fake *FakeCoreV1beta1
	ns   string
}

var kubefedclustersResource = schema.GroupVersionResource{Group: "core.kubefed.io", Version: "v1beta1", Resource: "kubefedclusters"}

var kubefedclustersKind = schema.GroupVersionKind{Group: "core.kubefed.io", Version: "v1beta1", Kind: "KubeFedCluster"}

// Get takes name of the kubeFedCluster, and returns the corresponding kubeFedCluster object, and an error if there is any.
func (c *FakeKubeFedClusters) Get(name string, options v1.GetOptions) (result *v1beta1.KubeFedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kubefedclustersResource, c.ns, name), &v1beta1.KubeFedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeFedCluster), err
}

// List takes label and field selectors, and returns the list of KubeFedClusters that match those selectors.
func (c *FakeKubeFedClusters) List(opts v1.ListOptions) (result *v1beta1.KubeFedClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kubefedclustersResource, kubefedclustersKind, c.ns, opts), &v1beta1.KubeFedClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.KubeFedClusterList{}
	for _, item := range obj.(*v1beta1.KubeFedClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kubeFedClusters.
func (c *FakeKubeFedClusters) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kubefedclustersResource, c.ns, opts))

}

// Create takes the representation of a kubeFedCluster and creates it.  Returns the server's representation of the kubeFedCluster, and an error, if there is any.
func (c *FakeKubeFedClusters) Create(kubeFedCluster *v1beta1.KubeFedCluster) (result *v1beta1.KubeFedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kubefedclustersResource, c.ns, kubeFedCluster), &v1beta1.KubeFedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeFedCluster), err
}

// Update takes the representation of a kubeFedCluster and updates it. Returns the server's representation of the kubeFedCluster, and an error, if there is any.
func (c *FakeKubeFedClusters) Update(kubeFedCluster *v1beta1.KubeFedCluster) (result *v1beta1.KubeFedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kubefedclustersResource, c.ns, kubeFedCluster), &v1beta1.KubeFedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeFedCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeKubeFedClusters) UpdateStatus(kubeFedCluster *v1beta1.KubeFedCluster) (*v1beta1.KubeFedCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(kubefedclustersResource, "status", c.ns, kubeFedCluster), &v1beta1.KubeFedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeFedCluster), err
}

// Delete takes name of the kubeFedCluster and deletes it. Returns an error if one occurs.
func (c *FakeKubeFedClusters) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kubefedclustersResource, c.ns, name), &v1beta1.KubeFedCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKubeFedClusters) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kubefedclustersResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.KubeFedClusterList{})
	return err
}

// Patch applies the patch and returns the patched kubeFedCluster.
func (c *FakeKubeFedClusters) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.KubeFedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kubefedclustersResource, c.ns, name, data, subresources...), &v1beta1.KubeFedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeFedCluster), err
}
