/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/multiclusterdns/v1alpha1"
	scheme "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/client/clientset/versioned/scheme"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DNSEndpointsGetter has a method to return a DNSEndpointInterface.
// A group's client should implement this interface.
type DNSEndpointsGetter interface {
	DNSEndpoints(namespace string) DNSEndpointInterface
}

// DNSEndpointInterface has methods to work with DNSEndpoint resources.
type DNSEndpointInterface interface {
	Create(*v1alpha1.DNSEndpoint) (*v1alpha1.DNSEndpoint, error)
	Update(*v1alpha1.DNSEndpoint) (*v1alpha1.DNSEndpoint, error)
	UpdateStatus(*v1alpha1.DNSEndpoint) (*v1alpha1.DNSEndpoint, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.DNSEndpoint, error)
	List(opts v1.ListOptions) (*v1alpha1.DNSEndpointList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DNSEndpoint, err error)
	DNSEndpointExpansion
}

// dNSEndpoints implements DNSEndpointInterface
type dNSEndpoints struct {
	client rest.Interface
	ns     string
}

// newDNSEndpoints returns a DNSEndpoints
func newDNSEndpoints(c *MulticlusterdnsV1alpha1Client, namespace string) *dNSEndpoints {
	return &dNSEndpoints{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the dNSEndpoint, and returns the corresponding dNSEndpoint object, and an error if there is any.
func (c *dNSEndpoints) Get(name string, options v1.GetOptions) (result *v1alpha1.DNSEndpoint, err error) {
	result = &v1alpha1.DNSEndpoint{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("dnsendpoints").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DNSEndpoints that match those selectors.
func (c *dNSEndpoints) List(opts v1.ListOptions) (result *v1alpha1.DNSEndpointList, err error) {
	result = &v1alpha1.DNSEndpointList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("dnsendpoints").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested dNSEndpoints.
func (c *dNSEndpoints) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("dnsendpoints").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a dNSEndpoint and creates it.  Returns the server's representation of the dNSEndpoint, and an error, if there is any.
func (c *dNSEndpoints) Create(dNSEndpoint *v1alpha1.DNSEndpoint) (result *v1alpha1.DNSEndpoint, err error) {
	result = &v1alpha1.DNSEndpoint{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("dnsendpoints").
		Body(dNSEndpoint).
		Do().
		Into(result)
	return
}

// Update takes the representation of a dNSEndpoint and updates it. Returns the server's representation of the dNSEndpoint, and an error, if there is any.
func (c *dNSEndpoints) Update(dNSEndpoint *v1alpha1.DNSEndpoint) (result *v1alpha1.DNSEndpoint, err error) {
	result = &v1alpha1.DNSEndpoint{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("dnsendpoints").
		Name(dNSEndpoint.Name).
		Body(dNSEndpoint).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *dNSEndpoints) UpdateStatus(dNSEndpoint *v1alpha1.DNSEndpoint) (result *v1alpha1.DNSEndpoint, err error) {
	result = &v1alpha1.DNSEndpoint{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("dnsendpoints").
		Name(dNSEndpoint.Name).
		SubResource("status").
		Body(dNSEndpoint).
		Do().
		Into(result)
	return
}

// Delete takes name of the dNSEndpoint and deletes it. Returns an error if one occurs.
func (c *dNSEndpoints) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("dnsendpoints").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *dNSEndpoints) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("dnsendpoints").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched dNSEndpoint.
func (c *dNSEndpoints) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DNSEndpoint, err error) {
	result = &v1alpha1.DNSEndpoint{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("dnsendpoints").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
