/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/multiclusterdns/v1alpha1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDNSEndpoints implements DNSEndpointInterface
type FakeDNSEndpoints struct {
	Fake *FakeMulticlusterdnsV1alpha1
	ns   string
}

var dnsendpointsResource = schema.GroupVersionResource{Group: "multiclusterdns.kubefed.io", Version: "v1alpha1", Resource: "dnsendpoints"}

var dnsendpointsKind = schema.GroupVersionKind{Group: "multiclusterdns.kubefed.io", Version: "v1alpha1", Kind: "DNSEndpoint"}

// Get takes name of the dNSEndpoint, and returns the corresponding dNSEndpoint object, and an error if there is any.
func (c *FakeDNSEndpoints) Get(name string, options v1.GetOptions) (result *v1alpha1.DNSEndpoint, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(dnsendpointsResource, c.ns, name), &v1alpha1.DNSEndpoint{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DNSEndpoint), err
}

// List takes label and field selectors, and returns the list of DNSEndpoints that match those selectors.
func (c *FakeDNSEndpoints) List(opts v1.ListOptions) (result *v1alpha1.DNSEndpointList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(dnsendpointsResource, dnsendpointsKind, c.ns, opts), &v1alpha1.DNSEndpointList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.DNSEndpointList{}
	for _, item := range obj.(*v1alpha1.DNSEndpointList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested dNSEndpoints.
func (c *FakeDNSEndpoints) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(dnsendpointsResource, c.ns, opts))

}

// Create takes the representation of a dNSEndpoint and creates it.  Returns the server's representation of the dNSEndpoint, and an error, if there is any.
func (c *FakeDNSEndpoints) Create(dNSEndpoint *v1alpha1.DNSEndpoint) (result *v1alpha1.DNSEndpoint, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(dnsendpointsResource, c.ns, dNSEndpoint), &v1alpha1.DNSEndpoint{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DNSEndpoint), err
}

// Update takes the representation of a dNSEndpoint and updates it. Returns the server's representation of the dNSEndpoint, and an error, if there is any.
func (c *FakeDNSEndpoints) Update(dNSEndpoint *v1alpha1.DNSEndpoint) (result *v1alpha1.DNSEndpoint, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(dnsendpointsResource, c.ns, dNSEndpoint), &v1alpha1.DNSEndpoint{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DNSEndpoint), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDNSEndpoints) UpdateStatus(dNSEndpoint *v1alpha1.DNSEndpoint) (*v1alpha1.DNSEndpoint, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(dnsendpointsResource, "status", c.ns, dNSEndpoint), &v1alpha1.DNSEndpoint{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DNSEndpoint), err
}

// Delete takes name of the dNSEndpoint and deletes it. Returns an error if one occurs.
func (c *FakeDNSEndpoints) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(dnsendpointsResource, c.ns, name), &v1alpha1.DNSEndpoint{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDNSEndpoints) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(dnsendpointsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.DNSEndpointList{})
	return err
}

// Patch applies the patch and returns the patched dNSEndpoint.
func (c *FakeDNSEndpoints) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DNSEndpoint, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(dnsendpointsResource, c.ns, name, data, subresources...), &v1alpha1.DNSEndpoint{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DNSEndpoint), err
}
