/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/scheduling/v1alpha1"
	scheme "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/client/clientset/versioned/scheme"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ReplicaSchedulingPreferencesGetter has a method to return a ReplicaSchedulingPreferenceInterface.
// A group's client should implement this interface.
type ReplicaSchedulingPreferencesGetter interface {
	ReplicaSchedulingPreferences(namespace string) ReplicaSchedulingPreferenceInterface
}

// ReplicaSchedulingPreferenceInterface has methods to work with ReplicaSchedulingPreference resources.
type ReplicaSchedulingPreferenceInterface interface {
	Create(*v1alpha1.ReplicaSchedulingPreference) (*v1alpha1.ReplicaSchedulingPreference, error)
	Update(*v1alpha1.ReplicaSchedulingPreference) (*v1alpha1.ReplicaSchedulingPreference, error)
	UpdateStatus(*v1alpha1.ReplicaSchedulingPreference) (*v1alpha1.ReplicaSchedulingPreference, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.ReplicaSchedulingPreference, error)
	List(opts v1.ListOptions) (*v1alpha1.ReplicaSchedulingPreferenceList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ReplicaSchedulingPreference, err error)
	ReplicaSchedulingPreferenceExpansion
}

// replicaSchedulingPreferences implements ReplicaSchedulingPreferenceInterface
type replicaSchedulingPreferences struct {
	client rest.Interface
	ns     string
}

// newReplicaSchedulingPreferences returns a ReplicaSchedulingPreferences
func newReplicaSchedulingPreferences(c *SchedulingV1alpha1Client, namespace string) *replicaSchedulingPreferences {
	return &replicaSchedulingPreferences{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the replicaSchedulingPreference, and returns the corresponding replicaSchedulingPreference object, and an error if there is any.
func (c *replicaSchedulingPreferences) Get(name string, options v1.GetOptions) (result *v1alpha1.ReplicaSchedulingPreference, err error) {
	result = &v1alpha1.ReplicaSchedulingPreference{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ReplicaSchedulingPreferences that match those selectors.
func (c *replicaSchedulingPreferences) List(opts v1.ListOptions) (result *v1alpha1.ReplicaSchedulingPreferenceList, err error) {
	result = &v1alpha1.ReplicaSchedulingPreferenceList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested replicaSchedulingPreferences.
func (c *replicaSchedulingPreferences) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a replicaSchedulingPreference and creates it.  Returns the server's representation of the replicaSchedulingPreference, and an error, if there is any.
func (c *replicaSchedulingPreferences) Create(replicaSchedulingPreference *v1alpha1.ReplicaSchedulingPreference) (result *v1alpha1.ReplicaSchedulingPreference, err error) {
	result = &v1alpha1.ReplicaSchedulingPreference{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		Body(replicaSchedulingPreference).
		Do().
		Into(result)
	return
}

// Update takes the representation of a replicaSchedulingPreference and updates it. Returns the server's representation of the replicaSchedulingPreference, and an error, if there is any.
func (c *replicaSchedulingPreferences) Update(replicaSchedulingPreference *v1alpha1.ReplicaSchedulingPreference) (result *v1alpha1.ReplicaSchedulingPreference, err error) {
	result = &v1alpha1.ReplicaSchedulingPreference{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		Name(replicaSchedulingPreference.Name).
		Body(replicaSchedulingPreference).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *replicaSchedulingPreferences) UpdateStatus(replicaSchedulingPreference *v1alpha1.ReplicaSchedulingPreference) (result *v1alpha1.ReplicaSchedulingPreference, err error) {
	result = &v1alpha1.ReplicaSchedulingPreference{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		Name(replicaSchedulingPreference.Name).
		SubResource("status").
		Body(replicaSchedulingPreference).
		Do().
		Into(result)
	return
}

// Delete takes name of the replicaSchedulingPreference and deletes it. Returns an error if one occurs.
func (c *replicaSchedulingPreferences) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *replicaSchedulingPreferences) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched replicaSchedulingPreference.
func (c *replicaSchedulingPreferences) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ReplicaSchedulingPreference, err error) {
	result = &v1alpha1.ReplicaSchedulingPreference{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("replicaschedulingpreferences").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
