/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/types/v1beta1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFederatedEndpointses implements FederatedEndpointsInterface
type FakeFederatedEndpointses struct {
	Fake *FakeTypesV1beta1
	ns   string
}

var federatedendpointsesResource = schema.GroupVersionResource{Group: "types.kubefed.io", Version: "v1beta1", Resource: "federatedendpointses"}

var federatedendpointsesKind = schema.GroupVersionKind{Group: "types.kubefed.io", Version: "v1beta1", Kind: "FederatedEndpoints"}

// Get takes name of the federatedEndpoints, and returns the corresponding federatedEndpoints object, and an error if there is any.
func (c *FakeFederatedEndpointses) Get(name string, options v1.GetOptions) (result *v1beta1.FederatedEndpoints, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(federatedendpointsesResource, c.ns, name), &v1beta1.FederatedEndpoints{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedEndpoints), err
}

// List takes label and field selectors, and returns the list of FederatedEndpointses that match those selectors.
func (c *FakeFederatedEndpointses) List(opts v1.ListOptions) (result *v1beta1.FederatedEndpointsList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(federatedendpointsesResource, federatedendpointsesKind, c.ns, opts), &v1beta1.FederatedEndpointsList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.FederatedEndpointsList{}
	for _, item := range obj.(*v1beta1.FederatedEndpointsList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested federatedEndpointses.
func (c *FakeFederatedEndpointses) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(federatedendpointsesResource, c.ns, opts))

}

// Create takes the representation of a federatedEndpoints and creates it.  Returns the server's representation of the federatedEndpoints, and an error, if there is any.
func (c *FakeFederatedEndpointses) Create(federatedEndpoints *v1beta1.FederatedEndpoints) (result *v1beta1.FederatedEndpoints, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(federatedendpointsesResource, c.ns, federatedEndpoints), &v1beta1.FederatedEndpoints{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedEndpoints), err
}

// Update takes the representation of a federatedEndpoints and updates it. Returns the server's representation of the federatedEndpoints, and an error, if there is any.
func (c *FakeFederatedEndpointses) Update(federatedEndpoints *v1beta1.FederatedEndpoints) (result *v1beta1.FederatedEndpoints, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(federatedendpointsesResource, c.ns, federatedEndpoints), &v1beta1.FederatedEndpoints{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedEndpoints), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFederatedEndpointses) UpdateStatus(federatedEndpoints *v1beta1.FederatedEndpoints) (*v1beta1.FederatedEndpoints, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(federatedendpointsesResource, "status", c.ns, federatedEndpoints), &v1beta1.FederatedEndpoints{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedEndpoints), err
}

// Delete takes name of the federatedEndpoints and deletes it. Returns an error if one occurs.
func (c *FakeFederatedEndpointses) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(federatedendpointsesResource, c.ns, name), &v1beta1.FederatedEndpoints{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFederatedEndpointses) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(federatedendpointsesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.FederatedEndpointsList{})
	return err
}

// Patch applies the patch and returns the patched federatedEndpoints.
func (c *FakeFederatedEndpointses) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.FederatedEndpoints, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(federatedendpointsesResource, c.ns, name, data, subresources...), &v1beta1.FederatedEndpoints{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedEndpoints), err
}
