/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/types/v1beta1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFederatedRoles implements FederatedRoleInterface
type FakeFederatedRoles struct {
	Fake *FakeTypesV1beta1
	ns   string
}

var federatedrolesResource = schema.GroupVersionResource{Group: "types.kubefed.io", Version: "v1beta1", Resource: "federatedroles"}

var federatedrolesKind = schema.GroupVersionKind{Group: "types.kubefed.io", Version: "v1beta1", Kind: "FederatedRole"}

// Get takes name of the federatedRole, and returns the corresponding federatedRole object, and an error if there is any.
func (c *FakeFederatedRoles) Get(name string, options v1.GetOptions) (result *v1beta1.FederatedRole, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(federatedrolesResource, c.ns, name), &v1beta1.FederatedRole{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRole), err
}

// List takes label and field selectors, and returns the list of FederatedRoles that match those selectors.
func (c *FakeFederatedRoles) List(opts v1.ListOptions) (result *v1beta1.FederatedRoleList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(federatedrolesResource, federatedrolesKind, c.ns, opts), &v1beta1.FederatedRoleList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.FederatedRoleList{}
	for _, item := range obj.(*v1beta1.FederatedRoleList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested federatedRoles.
func (c *FakeFederatedRoles) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(federatedrolesResource, c.ns, opts))

}

// Create takes the representation of a federatedRole and creates it.  Returns the server's representation of the federatedRole, and an error, if there is any.
func (c *FakeFederatedRoles) Create(federatedRole *v1beta1.FederatedRole) (result *v1beta1.FederatedRole, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(federatedrolesResource, c.ns, federatedRole), &v1beta1.FederatedRole{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRole), err
}

// Update takes the representation of a federatedRole and updates it. Returns the server's representation of the federatedRole, and an error, if there is any.
func (c *FakeFederatedRoles) Update(federatedRole *v1beta1.FederatedRole) (result *v1beta1.FederatedRole, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(federatedrolesResource, c.ns, federatedRole), &v1beta1.FederatedRole{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRole), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFederatedRoles) UpdateStatus(federatedRole *v1beta1.FederatedRole) (*v1beta1.FederatedRole, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(federatedrolesResource, "status", c.ns, federatedRole), &v1beta1.FederatedRole{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRole), err
}

// Delete takes name of the federatedRole and deletes it. Returns an error if one occurs.
func (c *FakeFederatedRoles) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(federatedrolesResource, c.ns, name), &v1beta1.FederatedRole{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFederatedRoles) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(federatedrolesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.FederatedRoleList{})
	return err
}

// Patch applies the patch and returns the patched federatedRole.
func (c *FakeFederatedRoles) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.FederatedRole, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(federatedrolesResource, c.ns, name, data, subresources...), &v1beta1.FederatedRole{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRole), err
}
