/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/types/v1beta1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFederatedRoleBindings implements FederatedRoleBindingInterface
type FakeFederatedRoleBindings struct {
	Fake *FakeTypesV1beta1
	ns   string
}

var federatedrolebindingsResource = schema.GroupVersionResource{Group: "types.kubefed.io", Version: "v1beta1", Resource: "federatedrolebindings"}

var federatedrolebindingsKind = schema.GroupVersionKind{Group: "types.kubefed.io", Version: "v1beta1", Kind: "FederatedRoleBinding"}

// Get takes name of the federatedRoleBinding, and returns the corresponding federatedRoleBinding object, and an error if there is any.
func (c *FakeFederatedRoleBindings) Get(name string, options v1.GetOptions) (result *v1beta1.FederatedRoleBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(federatedrolebindingsResource, c.ns, name), &v1beta1.FederatedRoleBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRoleBinding), err
}

// List takes label and field selectors, and returns the list of FederatedRoleBindings that match those selectors.
func (c *FakeFederatedRoleBindings) List(opts v1.ListOptions) (result *v1beta1.FederatedRoleBindingList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(federatedrolebindingsResource, federatedrolebindingsKind, c.ns, opts), &v1beta1.FederatedRoleBindingList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.FederatedRoleBindingList{}
	for _, item := range obj.(*v1beta1.FederatedRoleBindingList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested federatedRoleBindings.
func (c *FakeFederatedRoleBindings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(federatedrolebindingsResource, c.ns, opts))

}

// Create takes the representation of a federatedRoleBinding and creates it.  Returns the server's representation of the federatedRoleBinding, and an error, if there is any.
func (c *FakeFederatedRoleBindings) Create(federatedRoleBinding *v1beta1.FederatedRoleBinding) (result *v1beta1.FederatedRoleBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(federatedrolebindingsResource, c.ns, federatedRoleBinding), &v1beta1.FederatedRoleBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRoleBinding), err
}

// Update takes the representation of a federatedRoleBinding and updates it. Returns the server's representation of the federatedRoleBinding, and an error, if there is any.
func (c *FakeFederatedRoleBindings) Update(federatedRoleBinding *v1beta1.FederatedRoleBinding) (result *v1beta1.FederatedRoleBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(federatedrolebindingsResource, c.ns, federatedRoleBinding), &v1beta1.FederatedRoleBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRoleBinding), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFederatedRoleBindings) UpdateStatus(federatedRoleBinding *v1beta1.FederatedRoleBinding) (*v1beta1.FederatedRoleBinding, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(federatedrolebindingsResource, "status", c.ns, federatedRoleBinding), &v1beta1.FederatedRoleBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRoleBinding), err
}

// Delete takes name of the federatedRoleBinding and deletes it. Returns an error if one occurs.
func (c *FakeFederatedRoleBindings) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(federatedrolebindingsResource, c.ns, name), &v1beta1.FederatedRoleBinding{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFederatedRoleBindings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(federatedrolebindingsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.FederatedRoleBindingList{})
	return err
}

// Patch applies the patch and returns the patched federatedRoleBinding.
func (c *FakeFederatedRoleBindings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.FederatedRoleBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(federatedrolebindingsResource, c.ns, name, data, subresources...), &v1beta1.FederatedRoleBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedRoleBinding), err
}
