/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/core/v1beta1"

	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KubeFedClusterLister helps list KubeFedClusters.
type KubeFedClusterLister interface {
	// List lists all KubeFedClusters in the indexer.
	List(selector labels.Selector) (ret []*v1beta1.KubeFedCluster, err error)
	// KubeFedClusters returns an object that can list and get KubeFedClusters.
	KubeFedClusters(namespace string) KubeFedClusterNamespaceLister
	KubeFedClusterListerExpansion
}

// kubeFedClusterLister implements the KubeFedClusterLister interface.
type kubeFedClusterLister struct {
	indexer cache.Indexer
}

// NewKubeFedClusterLister returns a new KubeFedClusterLister.
func NewKubeFedClusterLister(indexer cache.Indexer) KubeFedClusterLister {
	return &kubeFedClusterLister{indexer: indexer}
}

// List lists all KubeFedClusters in the indexer.
func (s *kubeFedClusterLister) List(selector labels.Selector) (ret []*v1beta1.KubeFedCluster, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.KubeFedCluster))
	})
	return ret, err
}

// KubeFedClusters returns an object that can list and get KubeFedClusters.
func (s *kubeFedClusterLister) KubeFedClusters(namespace string) KubeFedClusterNamespaceLister {
	return kubeFedClusterNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KubeFedClusterNamespaceLister helps list and get KubeFedClusters.
type KubeFedClusterNamespaceLister interface {
	// List lists all KubeFedClusters in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1beta1.KubeFedCluster, err error)
	// Get retrieves the KubeFedCluster from the indexer for a given namespace and name.
	Get(name string) (*v1beta1.KubeFedCluster, error)
	KubeFedClusterNamespaceListerExpansion
}

// kubeFedClusterNamespaceLister implements the KubeFedClusterNamespaceLister
// interface.
type kubeFedClusterNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KubeFedClusters in the indexer for a given namespace.
func (s kubeFedClusterNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.KubeFedCluster, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.KubeFedCluster))
	})
	return ret, err
}

// Get retrieves the KubeFedCluster from the indexer for a given namespace and name.
func (s kubeFedClusterNamespaceLister) Get(name string) (*v1beta1.KubeFedCluster, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("kubefedcluster"), name)
	}
	return obj.(*v1beta1.KubeFedCluster), nil
}
