/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/types/v1beta1"

	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// FederatedDaemonSetLister helps list FederatedDaemonSets.
type FederatedDaemonSetLister interface {
	// List lists all FederatedDaemonSets in the indexer.
	List(selector labels.Selector) (ret []*v1beta1.FederatedDaemonSet, err error)
	// FederatedDaemonSets returns an object that can list and get FederatedDaemonSets.
	FederatedDaemonSets(namespace string) FederatedDaemonSetNamespaceLister
	FederatedDaemonSetListerExpansion
}

// federatedDaemonSetLister implements the FederatedDaemonSetLister interface.
type federatedDaemonSetLister struct {
	indexer cache.Indexer
}

// NewFederatedDaemonSetLister returns a new FederatedDaemonSetLister.
func NewFederatedDaemonSetLister(indexer cache.Indexer) FederatedDaemonSetLister {
	return &federatedDaemonSetLister{indexer: indexer}
}

// List lists all FederatedDaemonSets in the indexer.
func (s *federatedDaemonSetLister) List(selector labels.Selector) (ret []*v1beta1.FederatedDaemonSet, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.FederatedDaemonSet))
	})
	return ret, err
}

// FederatedDaemonSets returns an object that can list and get FederatedDaemonSets.
func (s *federatedDaemonSetLister) FederatedDaemonSets(namespace string) FederatedDaemonSetNamespaceLister {
	return federatedDaemonSetNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// FederatedDaemonSetNamespaceLister helps list and get FederatedDaemonSets.
type FederatedDaemonSetNamespaceLister interface {
	// List lists all FederatedDaemonSets in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1beta1.FederatedDaemonSet, err error)
	// Get retrieves the FederatedDaemonSet from the indexer for a given namespace and name.
	Get(name string) (*v1beta1.FederatedDaemonSet, error)
	FederatedDaemonSetNamespaceListerExpansion
}

// federatedDaemonSetNamespaceLister implements the FederatedDaemonSetNamespaceLister
// interface.
type federatedDaemonSetNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all FederatedDaemonSets in the indexer for a given namespace.
func (s federatedDaemonSetNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.FederatedDaemonSet, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.FederatedDaemonSet))
	})
	return ret, err
}

// Get retrieves the FederatedDaemonSet from the indexer for a given namespace and name.
func (s federatedDaemonSetNamespaceLister) Get(name string) (*v1beta1.FederatedDaemonSet, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("federateddaemonset"), name)
	}
	return obj.(*v1beta1.FederatedDaemonSet), nil
}
