/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/Tencent/bk-bcs/bcs-k8s/bcs-k8s-watch/pkg/kubefed/apis/types/v1beta1"

	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// FederatedNamespaceLister helps list FederatedNamespaces.
type FederatedNamespaceLister interface {
	// List lists all FederatedNamespaces in the indexer.
	List(selector labels.Selector) (ret []*v1beta1.FederatedNamespace, err error)
	// FederatedNamespaces returns an object that can list and get FederatedNamespaces.
	FederatedNamespaces(namespace string) FederatedNamespaceNamespaceLister
	FederatedNamespaceListerExpansion
}

// federatedNamespaceLister implements the FederatedNamespaceLister interface.
type federatedNamespaceLister struct {
	indexer cache.Indexer
}

// NewFederatedNamespaceLister returns a new FederatedNamespaceLister.
func NewFederatedNamespaceLister(indexer cache.Indexer) FederatedNamespaceLister {
	return &federatedNamespaceLister{indexer: indexer}
}

// List lists all FederatedNamespaces in the indexer.
func (s *federatedNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.FederatedNamespace, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.FederatedNamespace))
	})
	return ret, err
}

// FederatedNamespaces returns an object that can list and get FederatedNamespaces.
func (s *federatedNamespaceLister) FederatedNamespaces(namespace string) FederatedNamespaceNamespaceLister {
	return federatedNamespaceNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// FederatedNamespaceNamespaceLister helps list and get FederatedNamespaces.
type FederatedNamespaceNamespaceLister interface {
	// List lists all FederatedNamespaces in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1beta1.FederatedNamespace, err error)
	// Get retrieves the FederatedNamespace from the indexer for a given namespace and name.
	Get(name string) (*v1beta1.FederatedNamespace, error)
	FederatedNamespaceNamespaceListerExpansion
}

// federatedNamespaceNamespaceLister implements the FederatedNamespaceNamespaceLister
// interface.
type federatedNamespaceNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all FederatedNamespaces in the indexer for a given namespace.
func (s federatedNamespaceNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.FederatedNamespace, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.FederatedNamespace))
	})
	return ret, err
}

// Get retrieves the FederatedNamespace from the indexer for a given namespace and name.
func (s federatedNamespaceNamespaceLister) Get(name string) (*v1beta1.FederatedNamespace, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("federatednamespace"), name)
	}
	return obj.(*v1beta1.FederatedNamespace), nil
}
