/*
Copyright 2020 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	bk_bcs_v1 "github.com/Tencent/bk-bcs/bcs-k8s/kubebkbcs/apis/bk-bcs/v1"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeBcsLogConfigs implements BcsLogConfigInterface
type FakeBcsLogConfigs struct {
	Fake *FakeBkbcsV1
	ns   string
}

var bcslogconfigsResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v1", Resource: "bcslogconfigs"}

var bcslogconfigsKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v1", Kind: "BcsLogConfig"}

// Get takes name of the bcsLogConfig, and returns the corresponding bcsLogConfig object, and an error if there is any.
func (c *FakeBcsLogConfigs) Get(name string, options v1.GetOptions) (result *bk_bcs_v1.BcsLogConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(bcslogconfigsResource, c.ns, name), &bk_bcs_v1.BcsLogConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bk_bcs_v1.BcsLogConfig), err
}

// List takes label and field selectors, and returns the list of BcsLogConfigs that match those selectors.
func (c *FakeBcsLogConfigs) List(opts v1.ListOptions) (result *bk_bcs_v1.BcsLogConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(bcslogconfigsResource, bcslogconfigsKind, c.ns, opts), &bk_bcs_v1.BcsLogConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &bk_bcs_v1.BcsLogConfigList{}
	for _, item := range obj.(*bk_bcs_v1.BcsLogConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested bcsLogConfigs.
func (c *FakeBcsLogConfigs) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(bcslogconfigsResource, c.ns, opts))

}

// Create takes the representation of a bcsLogConfig and creates it.  Returns the server's representation of the bcsLogConfig, and an error, if there is any.
func (c *FakeBcsLogConfigs) Create(bcsLogConfig *bk_bcs_v1.BcsLogConfig) (result *bk_bcs_v1.BcsLogConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(bcslogconfigsResource, c.ns, bcsLogConfig), &bk_bcs_v1.BcsLogConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bk_bcs_v1.BcsLogConfig), err
}

// Update takes the representation of a bcsLogConfig and updates it. Returns the server's representation of the bcsLogConfig, and an error, if there is any.
func (c *FakeBcsLogConfigs) Update(bcsLogConfig *bk_bcs_v1.BcsLogConfig) (result *bk_bcs_v1.BcsLogConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(bcslogconfigsResource, c.ns, bcsLogConfig), &bk_bcs_v1.BcsLogConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bk_bcs_v1.BcsLogConfig), err
}

// Delete takes name of the bcsLogConfig and deletes it. Returns an error if one occurs.
func (c *FakeBcsLogConfigs) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(bcslogconfigsResource, c.ns, name), &bk_bcs_v1.BcsLogConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeBcsLogConfigs) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(bcslogconfigsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &bk_bcs_v1.BcsLogConfigList{})
	return err
}

// Patch applies the patch and returns the patched bcsLogConfig.
func (c *FakeBcsLogConfigs) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *bk_bcs_v1.BcsLogConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(bcslogconfigsResource, c.ns, name, data, subresources...), &bk_bcs_v1.BcsLogConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bk_bcs_v1.BcsLogConfig), err
}
