/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/Tencent/bk-bcs/bcs-k8s/kubernetes/common/bcs-hook/apis/tkex/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// HookTemplateLister helps list HookTemplates.
type HookTemplateLister interface {
	// List lists all HookTemplates in the indexer.
	List(selector labels.Selector) (ret []*v1alpha1.HookTemplate, err error)
	// HookTemplates returns an object that can list and get HookTemplates.
	HookTemplates(namespace string) HookTemplateNamespaceLister
	HookTemplateListerExpansion
}

// hookTemplateLister implements the HookTemplateLister interface.
type hookTemplateLister struct {
	indexer cache.Indexer
}

// NewHookTemplateLister returns a new HookTemplateLister.
func NewHookTemplateLister(indexer cache.Indexer) HookTemplateLister {
	return &hookTemplateLister{indexer: indexer}
}

// List lists all HookTemplates in the indexer.
func (s *hookTemplateLister) List(selector labels.Selector) (ret []*v1alpha1.HookTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.HookTemplate))
	})
	return ret, err
}

// HookTemplates returns an object that can list and get HookTemplates.
func (s *hookTemplateLister) HookTemplates(namespace string) HookTemplateNamespaceLister {
	return hookTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// HookTemplateNamespaceLister helps list and get HookTemplates.
type HookTemplateNamespaceLister interface {
	// List lists all HookTemplates in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1alpha1.HookTemplate, err error)
	// Get retrieves the HookTemplate from the indexer for a given namespace and name.
	Get(name string) (*v1alpha1.HookTemplate, error)
	HookTemplateNamespaceListerExpansion
}

// hookTemplateNamespaceLister implements the HookTemplateNamespaceLister
// interface.
type hookTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all HookTemplates in the indexer for a given namespace.
func (s hookTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.HookTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.HookTemplate))
	})
	return ret, err
}

// Get retrieves the HookTemplate from the indexer for a given namespace and name.
func (s hookTemplateNamespaceLister) Get(name string) (*v1alpha1.HookTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("hooktemplate"), name)
	}
	return obj.(*v1alpha1.HookTemplate), nil
}
