/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	cloudv1 "github.com/Tencent/bk-bcs/bcs-k8s/kubernetes/apis/cloud/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeNodeNetworks implements NodeNetworkInterface
type FakeNodeNetworks struct {
	Fake *FakeCloudV1
	ns   string
}

var nodenetworksResource = schema.GroupVersionResource{Group: "cloud", Version: "v1", Resource: "nodenetworks"}

var nodenetworksKind = schema.GroupVersionKind{Group: "cloud", Version: "v1", Kind: "NodeNetwork"}

// Get takes name of the nodeNetwork, and returns the corresponding nodeNetwork object, and an error if there is any.
func (c *FakeNodeNetworks) Get(ctx context.Context, name string, options v1.GetOptions) (result *cloudv1.NodeNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(nodenetworksResource, c.ns, name), &cloudv1.NodeNetwork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*cloudv1.NodeNetwork), err
}

// List takes label and field selectors, and returns the list of NodeNetworks that match those selectors.
func (c *FakeNodeNetworks) List(ctx context.Context, opts v1.ListOptions) (result *cloudv1.NodeNetworkList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(nodenetworksResource, nodenetworksKind, c.ns, opts), &cloudv1.NodeNetworkList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &cloudv1.NodeNetworkList{ListMeta: obj.(*cloudv1.NodeNetworkList).ListMeta}
	for _, item := range obj.(*cloudv1.NodeNetworkList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested nodeNetworks.
func (c *FakeNodeNetworks) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(nodenetworksResource, c.ns, opts))

}

// Create takes the representation of a nodeNetwork and creates it.  Returns the server's representation of the nodeNetwork, and an error, if there is any.
func (c *FakeNodeNetworks) Create(ctx context.Context, nodeNetwork *cloudv1.NodeNetwork, opts v1.CreateOptions) (result *cloudv1.NodeNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(nodenetworksResource, c.ns, nodeNetwork), &cloudv1.NodeNetwork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*cloudv1.NodeNetwork), err
}

// Update takes the representation of a nodeNetwork and updates it. Returns the server's representation of the nodeNetwork, and an error, if there is any.
func (c *FakeNodeNetworks) Update(ctx context.Context, nodeNetwork *cloudv1.NodeNetwork, opts v1.UpdateOptions) (result *cloudv1.NodeNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(nodenetworksResource, c.ns, nodeNetwork), &cloudv1.NodeNetwork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*cloudv1.NodeNetwork), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeNodeNetworks) UpdateStatus(ctx context.Context, nodeNetwork *cloudv1.NodeNetwork, opts v1.UpdateOptions) (*cloudv1.NodeNetwork, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(nodenetworksResource, "status", c.ns, nodeNetwork), &cloudv1.NodeNetwork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*cloudv1.NodeNetwork), err
}

// Delete takes name of the nodeNetwork and deletes it. Returns an error if one occurs.
func (c *FakeNodeNetworks) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(nodenetworksResource, c.ns, name), &cloudv1.NodeNetwork{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeNodeNetworks) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(nodenetworksResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &cloudv1.NodeNetworkList{})
	return err
}

// Patch applies the patch and returns the patched nodeNetwork.
func (c *FakeNodeNetworks) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *cloudv1.NodeNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(nodenetworksResource, c.ns, name, pt, data, subresources...), &cloudv1.NodeNetwork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*cloudv1.NodeNetwork), err
}
