/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/Tencent/bk-bcs/bcs-k8s/kubernetes/apis/cloud/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// CloudSubnetLister helps list CloudSubnets.
type CloudSubnetLister interface {
	// List lists all CloudSubnets in the indexer.
	List(selector labels.Selector) (ret []*v1.CloudSubnet, err error)
	// CloudSubnets returns an object that can list and get CloudSubnets.
	CloudSubnets(namespace string) CloudSubnetNamespaceLister
	CloudSubnetListerExpansion
}

// cloudSubnetLister implements the CloudSubnetLister interface.
type cloudSubnetLister struct {
	indexer cache.Indexer
}

// NewCloudSubnetLister returns a new CloudSubnetLister.
func NewCloudSubnetLister(indexer cache.Indexer) CloudSubnetLister {
	return &cloudSubnetLister{indexer: indexer}
}

// List lists all CloudSubnets in the indexer.
func (s *cloudSubnetLister) List(selector labels.Selector) (ret []*v1.CloudSubnet, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.CloudSubnet))
	})
	return ret, err
}

// CloudSubnets returns an object that can list and get CloudSubnets.
func (s *cloudSubnetLister) CloudSubnets(namespace string) CloudSubnetNamespaceLister {
	return cloudSubnetNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// CloudSubnetNamespaceLister helps list and get CloudSubnets.
type CloudSubnetNamespaceLister interface {
	// List lists all CloudSubnets in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.CloudSubnet, err error)
	// Get retrieves the CloudSubnet from the indexer for a given namespace and name.
	Get(name string) (*v1.CloudSubnet, error)
	CloudSubnetNamespaceListerExpansion
}

// cloudSubnetNamespaceLister implements the CloudSubnetNamespaceLister
// interface.
type cloudSubnetNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all CloudSubnets in the indexer for a given namespace.
func (s cloudSubnetNamespaceLister) List(selector labels.Selector) (ret []*v1.CloudSubnet, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.CloudSubnet))
	})
	return ret, err
}

// Get retrieves the CloudSubnet from the indexer for a given namespace and name.
func (s cloudSubnetNamespaceLister) Get(name string) (*v1.CloudSubnet, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("cloudsubnet"), name)
	}
	return obj.(*v1.CloudSubnet), nil
}
