/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package internalclientset

import (
	bkbcsv2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/typed/bkbcs/v2"
	monitorv1 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/typed/monitor/v1"
	discovery "k8s.io/client-go/discovery"
	rest "k8s.io/client-go/rest"
	flowcontrol "k8s.io/client-go/util/flowcontrol"
)

type Interface interface {
	Discovery() discovery.DiscoveryInterface
	BkbcsV2() bkbcsv2.BkbcsV2Interface
	// Deprecated: please explicitly pick a version if possible.
	Bkbcs() bkbcsv2.BkbcsV2Interface
	MonitorV1() monitorv1.MonitorV1Interface
	// Deprecated: please explicitly pick a version if possible.
	Monitor() monitorv1.MonitorV1Interface
}

// Clientset contains the clients for groups. Each group has exactly one
// version included in a Clientset.
type Clientset struct {
	*discovery.DiscoveryClient
	bkbcsV2   *bkbcsv2.BkbcsV2Client
	monitorV1 *monitorv1.MonitorV1Client
}

// BkbcsV2 retrieves the BkbcsV2Client
func (c *Clientset) BkbcsV2() bkbcsv2.BkbcsV2Interface {
	return c.bkbcsV2
}

// Deprecated: Bkbcs retrieves the default version of BkbcsClient.
// Please explicitly pick a version.
func (c *Clientset) Bkbcs() bkbcsv2.BkbcsV2Interface {
	return c.bkbcsV2
}

// MonitorV1 retrieves the MonitorV1Client
func (c *Clientset) MonitorV1() monitorv1.MonitorV1Interface {
	return c.monitorV1
}

// Deprecated: Monitor retrieves the default version of MonitorClient.
// Please explicitly pick a version.
func (c *Clientset) Monitor() monitorv1.MonitorV1Interface {
	return c.monitorV1
}

// Discovery retrieves the DiscoveryClient
func (c *Clientset) Discovery() discovery.DiscoveryInterface {
	if c == nil {
		return nil
	}
	return c.DiscoveryClient
}

// NewForConfig creates a new Clientset for the given config.
func NewForConfig(c *rest.Config) (*Clientset, error) {
	configShallowCopy := *c
	if configShallowCopy.RateLimiter == nil && configShallowCopy.QPS > 0 {
		configShallowCopy.RateLimiter = flowcontrol.NewTokenBucketRateLimiter(configShallowCopy.QPS, configShallowCopy.Burst)
	}
	var cs Clientset
	var err error
	cs.bkbcsV2, err = bkbcsv2.NewForConfig(&configShallowCopy)
	if err != nil {
		return nil, err
	}
	cs.monitorV1, err = monitorv1.NewForConfig(&configShallowCopy)
	if err != nil {
		return nil, err
	}

	cs.DiscoveryClient, err = discovery.NewDiscoveryClientForConfig(&configShallowCopy)
	if err != nil {
		return nil, err
	}
	return &cs, nil
}

// NewForConfigOrDie creates a new Clientset for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *Clientset {
	var cs Clientset
	cs.bkbcsV2 = bkbcsv2.NewForConfigOrDie(c)
	cs.monitorV1 = monitorv1.NewForConfigOrDie(c)

	cs.DiscoveryClient = discovery.NewDiscoveryClientForConfigOrDie(c)
	return &cs
}

// New creates a new Clientset for the given RESTClient.
func New(c rest.Interface) *Clientset {
	var cs Clientset
	cs.bkbcsV2 = bkbcsv2.New(c)
	cs.monitorV1 = monitorv1.New(c)

	cs.DiscoveryClient = discovery.NewDiscoveryClient(c)
	return &cs
}
