/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	scheme "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AgentsGetter has a method to return a AgentInterface.
// A group's client should implement this interface.
type AgentsGetter interface {
	Agents(namespace string) AgentInterface
}

// AgentInterface has methods to work with Agent resources.
type AgentInterface interface {
	Create(*v2.Agent) (*v2.Agent, error)
	Update(*v2.Agent) (*v2.Agent, error)
	UpdateStatus(*v2.Agent) (*v2.Agent, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v2.Agent, error)
	List(opts v1.ListOptions) (*v2.AgentList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Agent, err error)
	AgentExpansion
}

// agents implements AgentInterface
type agents struct {
	client rest.Interface
	ns     string
}

// newAgents returns a Agents
func newAgents(c *BkbcsV2Client, namespace string) *agents {
	return &agents{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the agent, and returns the corresponding agent object, and an error if there is any.
func (c *agents) Get(name string, options v1.GetOptions) (result *v2.Agent, err error) {
	result = &v2.Agent{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("agents").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Agents that match those selectors.
func (c *agents) List(opts v1.ListOptions) (result *v2.AgentList, err error) {
	result = &v2.AgentList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("agents").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested agents.
func (c *agents) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("agents").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a agent and creates it.  Returns the server's representation of the agent, and an error, if there is any.
func (c *agents) Create(agent *v2.Agent) (result *v2.Agent, err error) {
	result = &v2.Agent{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("agents").
		Body(agent).
		Do().
		Into(result)
	return
}

// Update takes the representation of a agent and updates it. Returns the server's representation of the agent, and an error, if there is any.
func (c *agents) Update(agent *v2.Agent) (result *v2.Agent, err error) {
	result = &v2.Agent{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("agents").
		Name(agent.Name).
		Body(agent).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *agents) UpdateStatus(agent *v2.Agent) (result *v2.Agent, err error) {
	result = &v2.Agent{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("agents").
		Name(agent.Name).
		SubResource("status").
		Body(agent).
		Do().
		Into(result)
	return
}

// Delete takes name of the agent and deletes it. Returns an error if one occurs.
func (c *agents) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("agents").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *agents) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("agents").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched agent.
func (c *agents) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Agent, err error) {
	result = &v2.Agent{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("agents").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
