/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	scheme "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// BcsClusterAgentSettingsGetter has a method to return a BcsClusterAgentSettingInterface.
// A group's client should implement this interface.
type BcsClusterAgentSettingsGetter interface {
	BcsClusterAgentSettings(namespace string) BcsClusterAgentSettingInterface
}

// BcsClusterAgentSettingInterface has methods to work with BcsClusterAgentSetting resources.
type BcsClusterAgentSettingInterface interface {
	Create(*v2.BcsClusterAgentSetting) (*v2.BcsClusterAgentSetting, error)
	Update(*v2.BcsClusterAgentSetting) (*v2.BcsClusterAgentSetting, error)
	UpdateStatus(*v2.BcsClusterAgentSetting) (*v2.BcsClusterAgentSetting, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v2.BcsClusterAgentSetting, error)
	List(opts v1.ListOptions) (*v2.BcsClusterAgentSettingList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsClusterAgentSetting, err error)
	BcsClusterAgentSettingExpansion
}

// bcsClusterAgentSettings implements BcsClusterAgentSettingInterface
type bcsClusterAgentSettings struct {
	client rest.Interface
	ns     string
}

// newBcsClusterAgentSettings returns a BcsClusterAgentSettings
func newBcsClusterAgentSettings(c *BkbcsV2Client, namespace string) *bcsClusterAgentSettings {
	return &bcsClusterAgentSettings{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the bcsClusterAgentSetting, and returns the corresponding bcsClusterAgentSetting object, and an error if there is any.
func (c *bcsClusterAgentSettings) Get(name string, options v1.GetOptions) (result *v2.BcsClusterAgentSetting, err error) {
	result = &v2.BcsClusterAgentSetting{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of BcsClusterAgentSettings that match those selectors.
func (c *bcsClusterAgentSettings) List(opts v1.ListOptions) (result *v2.BcsClusterAgentSettingList, err error) {
	result = &v2.BcsClusterAgentSettingList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested bcsClusterAgentSettings.
func (c *bcsClusterAgentSettings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a bcsClusterAgentSetting and creates it.  Returns the server's representation of the bcsClusterAgentSetting, and an error, if there is any.
func (c *bcsClusterAgentSettings) Create(bcsClusterAgentSetting *v2.BcsClusterAgentSetting) (result *v2.BcsClusterAgentSetting, err error) {
	result = &v2.BcsClusterAgentSetting{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		Body(bcsClusterAgentSetting).
		Do().
		Into(result)
	return
}

// Update takes the representation of a bcsClusterAgentSetting and updates it. Returns the server's representation of the bcsClusterAgentSetting, and an error, if there is any.
func (c *bcsClusterAgentSettings) Update(bcsClusterAgentSetting *v2.BcsClusterAgentSetting) (result *v2.BcsClusterAgentSetting, err error) {
	result = &v2.BcsClusterAgentSetting{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		Name(bcsClusterAgentSetting.Name).
		Body(bcsClusterAgentSetting).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *bcsClusterAgentSettings) UpdateStatus(bcsClusterAgentSetting *v2.BcsClusterAgentSetting) (result *v2.BcsClusterAgentSetting, err error) {
	result = &v2.BcsClusterAgentSetting{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		Name(bcsClusterAgentSetting.Name).
		SubResource("status").
		Body(bcsClusterAgentSetting).
		Do().
		Into(result)
	return
}

// Delete takes name of the bcsClusterAgentSetting and deletes it. Returns an error if one occurs.
func (c *bcsClusterAgentSettings) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *bcsClusterAgentSettings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched bcsClusterAgentSetting.
func (c *bcsClusterAgentSettings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsClusterAgentSetting, err error) {
	result = &v2.BcsClusterAgentSetting{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("bcsclusteragentsettings").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
