/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	scheme "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// BcsCommandInfosGetter has a method to return a BcsCommandInfoInterface.
// A group's client should implement this interface.
type BcsCommandInfosGetter interface {
	BcsCommandInfos(namespace string) BcsCommandInfoInterface
}

// BcsCommandInfoInterface has methods to work with BcsCommandInfo resources.
type BcsCommandInfoInterface interface {
	Create(*v2.BcsCommandInfo) (*v2.BcsCommandInfo, error)
	Update(*v2.BcsCommandInfo) (*v2.BcsCommandInfo, error)
	UpdateStatus(*v2.BcsCommandInfo) (*v2.BcsCommandInfo, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v2.BcsCommandInfo, error)
	List(opts v1.ListOptions) (*v2.BcsCommandInfoList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsCommandInfo, err error)
	BcsCommandInfoExpansion
}

// bcsCommandInfos implements BcsCommandInfoInterface
type bcsCommandInfos struct {
	client rest.Interface
	ns     string
}

// newBcsCommandInfos returns a BcsCommandInfos
func newBcsCommandInfos(c *BkbcsV2Client, namespace string) *bcsCommandInfos {
	return &bcsCommandInfos{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the bcsCommandInfo, and returns the corresponding bcsCommandInfo object, and an error if there is any.
func (c *bcsCommandInfos) Get(name string, options v1.GetOptions) (result *v2.BcsCommandInfo, err error) {
	result = &v2.BcsCommandInfo{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of BcsCommandInfos that match those selectors.
func (c *bcsCommandInfos) List(opts v1.ListOptions) (result *v2.BcsCommandInfoList, err error) {
	result = &v2.BcsCommandInfoList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested bcsCommandInfos.
func (c *bcsCommandInfos) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a bcsCommandInfo and creates it.  Returns the server's representation of the bcsCommandInfo, and an error, if there is any.
func (c *bcsCommandInfos) Create(bcsCommandInfo *v2.BcsCommandInfo) (result *v2.BcsCommandInfo, err error) {
	result = &v2.BcsCommandInfo{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		Body(bcsCommandInfo).
		Do().
		Into(result)
	return
}

// Update takes the representation of a bcsCommandInfo and updates it. Returns the server's representation of the bcsCommandInfo, and an error, if there is any.
func (c *bcsCommandInfos) Update(bcsCommandInfo *v2.BcsCommandInfo) (result *v2.BcsCommandInfo, err error) {
	result = &v2.BcsCommandInfo{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		Name(bcsCommandInfo.Name).
		Body(bcsCommandInfo).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *bcsCommandInfos) UpdateStatus(bcsCommandInfo *v2.BcsCommandInfo) (result *v2.BcsCommandInfo, err error) {
	result = &v2.BcsCommandInfo{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		Name(bcsCommandInfo.Name).
		SubResource("status").
		Body(bcsCommandInfo).
		Do().
		Into(result)
	return
}

// Delete takes name of the bcsCommandInfo and deletes it. Returns an error if one occurs.
func (c *bcsCommandInfos) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *bcsCommandInfos) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bcscommandinfos").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched bcsCommandInfo.
func (c *bcsCommandInfos) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsCommandInfo, err error) {
	result = &v2.BcsCommandInfo{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("bcscommandinfos").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
