/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	scheme "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// BcsDaemonsetsGetter has a method to return a BcsDaemonsetInterface.
// A group's client should implement this interface.
type BcsDaemonsetsGetter interface {
	BcsDaemonsets(namespace string) BcsDaemonsetInterface
}

// BcsDaemonsetInterface has methods to work with BcsDaemonset resources.
type BcsDaemonsetInterface interface {
	Create(*v2.BcsDaemonset) (*v2.BcsDaemonset, error)
	Update(*v2.BcsDaemonset) (*v2.BcsDaemonset, error)
	UpdateStatus(*v2.BcsDaemonset) (*v2.BcsDaemonset, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v2.BcsDaemonset, error)
	List(opts v1.ListOptions) (*v2.BcsDaemonsetList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsDaemonset, err error)
	BcsDaemonsetExpansion
}

// bcsDaemonsets implements BcsDaemonsetInterface
type bcsDaemonsets struct {
	client rest.Interface
	ns     string
}

// newBcsDaemonsets returns a BcsDaemonsets
func newBcsDaemonsets(c *BkbcsV2Client, namespace string) *bcsDaemonsets {
	return &bcsDaemonsets{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the bcsDaemonset, and returns the corresponding bcsDaemonset object, and an error if there is any.
func (c *bcsDaemonsets) Get(name string, options v1.GetOptions) (result *v2.BcsDaemonset, err error) {
	result = &v2.BcsDaemonset{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of BcsDaemonsets that match those selectors.
func (c *bcsDaemonsets) List(opts v1.ListOptions) (result *v2.BcsDaemonsetList, err error) {
	result = &v2.BcsDaemonsetList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested bcsDaemonsets.
func (c *bcsDaemonsets) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a bcsDaemonset and creates it.  Returns the server's representation of the bcsDaemonset, and an error, if there is any.
func (c *bcsDaemonsets) Create(bcsDaemonset *v2.BcsDaemonset) (result *v2.BcsDaemonset, err error) {
	result = &v2.BcsDaemonset{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		Body(bcsDaemonset).
		Do().
		Into(result)
	return
}

// Update takes the representation of a bcsDaemonset and updates it. Returns the server's representation of the bcsDaemonset, and an error, if there is any.
func (c *bcsDaemonsets) Update(bcsDaemonset *v2.BcsDaemonset) (result *v2.BcsDaemonset, err error) {
	result = &v2.BcsDaemonset{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		Name(bcsDaemonset.Name).
		Body(bcsDaemonset).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *bcsDaemonsets) UpdateStatus(bcsDaemonset *v2.BcsDaemonset) (result *v2.BcsDaemonset, err error) {
	result = &v2.BcsDaemonset{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		Name(bcsDaemonset.Name).
		SubResource("status").
		Body(bcsDaemonset).
		Do().
		Into(result)
	return
}

// Delete takes name of the bcsDaemonset and deletes it. Returns an error if one occurs.
func (c *bcsDaemonsets) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *bcsDaemonsets) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched bcsDaemonset.
func (c *bcsDaemonsets) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsDaemonset, err error) {
	result = &v2.BcsDaemonset{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("bcsdaemonsets").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
