/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	scheme "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// CrdsGetter has a method to return a CrdInterface.
// A group's client should implement this interface.
type CrdsGetter interface {
	Crds(namespace string) CrdInterface
}

// CrdInterface has methods to work with Crd resources.
type CrdInterface interface {
	Create(*v2.Crd) (*v2.Crd, error)
	Update(*v2.Crd) (*v2.Crd, error)
	UpdateStatus(*v2.Crd) (*v2.Crd, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v2.Crd, error)
	List(opts v1.ListOptions) (*v2.CrdList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Crd, err error)
	CrdExpansion
}

// crds implements CrdInterface
type crds struct {
	client rest.Interface
	ns     string
}

// newCrds returns a Crds
func newCrds(c *BkbcsV2Client, namespace string) *crds {
	return &crds{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the crd, and returns the corresponding crd object, and an error if there is any.
func (c *crds) Get(name string, options v1.GetOptions) (result *v2.Crd, err error) {
	result = &v2.Crd{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("crds").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Crds that match those selectors.
func (c *crds) List(opts v1.ListOptions) (result *v2.CrdList, err error) {
	result = &v2.CrdList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("crds").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested crds.
func (c *crds) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("crds").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a crd and creates it.  Returns the server's representation of the crd, and an error, if there is any.
func (c *crds) Create(crd *v2.Crd) (result *v2.Crd, err error) {
	result = &v2.Crd{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("crds").
		Body(crd).
		Do().
		Into(result)
	return
}

// Update takes the representation of a crd and updates it. Returns the server's representation of the crd, and an error, if there is any.
func (c *crds) Update(crd *v2.Crd) (result *v2.Crd, err error) {
	result = &v2.Crd{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("crds").
		Name(crd.Name).
		Body(crd).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *crds) UpdateStatus(crd *v2.Crd) (result *v2.Crd, err error) {
	result = &v2.Crd{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("crds").
		Name(crd.Name).
		SubResource("status").
		Body(crd).
		Do().
		Into(result)
	return
}

// Delete takes name of the crd and deletes it. Returns an error if one occurs.
func (c *crds) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("crds").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *crds) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("crds").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched crd.
func (c *crds) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Crd, err error) {
	result = &v2.Crd{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("crds").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
