/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeBcsConfigMaps implements BcsConfigMapInterface
type FakeBcsConfigMaps struct {
	Fake *FakeBkbcsV2
	ns   string
}

var bcsconfigmapsResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v2", Resource: "bcsconfigmaps"}

var bcsconfigmapsKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v2", Kind: "BcsConfigMap"}

// Get takes name of the bcsConfigMap, and returns the corresponding bcsConfigMap object, and an error if there is any.
func (c *FakeBcsConfigMaps) Get(name string, options v1.GetOptions) (result *v2.BcsConfigMap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(bcsconfigmapsResource, c.ns, name), &v2.BcsConfigMap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsConfigMap), err
}

// List takes label and field selectors, and returns the list of BcsConfigMaps that match those selectors.
func (c *FakeBcsConfigMaps) List(opts v1.ListOptions) (result *v2.BcsConfigMapList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(bcsconfigmapsResource, bcsconfigmapsKind, c.ns, opts), &v2.BcsConfigMapList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.BcsConfigMapList{ListMeta: obj.(*v2.BcsConfigMapList).ListMeta}
	for _, item := range obj.(*v2.BcsConfigMapList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested bcsConfigMaps.
func (c *FakeBcsConfigMaps) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(bcsconfigmapsResource, c.ns, opts))

}

// Create takes the representation of a bcsConfigMap and creates it.  Returns the server's representation of the bcsConfigMap, and an error, if there is any.
func (c *FakeBcsConfigMaps) Create(bcsConfigMap *v2.BcsConfigMap) (result *v2.BcsConfigMap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(bcsconfigmapsResource, c.ns, bcsConfigMap), &v2.BcsConfigMap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsConfigMap), err
}

// Update takes the representation of a bcsConfigMap and updates it. Returns the server's representation of the bcsConfigMap, and an error, if there is any.
func (c *FakeBcsConfigMaps) Update(bcsConfigMap *v2.BcsConfigMap) (result *v2.BcsConfigMap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(bcsconfigmapsResource, c.ns, bcsConfigMap), &v2.BcsConfigMap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsConfigMap), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeBcsConfigMaps) UpdateStatus(bcsConfigMap *v2.BcsConfigMap) (*v2.BcsConfigMap, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(bcsconfigmapsResource, "status", c.ns, bcsConfigMap), &v2.BcsConfigMap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsConfigMap), err
}

// Delete takes name of the bcsConfigMap and deletes it. Returns an error if one occurs.
func (c *FakeBcsConfigMaps) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(bcsconfigmapsResource, c.ns, name), &v2.BcsConfigMap{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeBcsConfigMaps) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(bcsconfigmapsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v2.BcsConfigMapList{})
	return err
}

// Patch applies the patch and returns the patched bcsConfigMap.
func (c *FakeBcsConfigMaps) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsConfigMap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(bcsconfigmapsResource, c.ns, name, data, subresources...), &v2.BcsConfigMap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsConfigMap), err
}
