/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeBcsDaemonsets implements BcsDaemonsetInterface
type FakeBcsDaemonsets struct {
	Fake *FakeBkbcsV2
	ns   string
}

var bcsdaemonsetsResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v2", Resource: "bcsdaemonsets"}

var bcsdaemonsetsKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v2", Kind: "BcsDaemonset"}

// Get takes name of the bcsDaemonset, and returns the corresponding bcsDaemonset object, and an error if there is any.
func (c *FakeBcsDaemonsets) Get(name string, options v1.GetOptions) (result *v2.BcsDaemonset, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(bcsdaemonsetsResource, c.ns, name), &v2.BcsDaemonset{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsDaemonset), err
}

// List takes label and field selectors, and returns the list of BcsDaemonsets that match those selectors.
func (c *FakeBcsDaemonsets) List(opts v1.ListOptions) (result *v2.BcsDaemonsetList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(bcsdaemonsetsResource, bcsdaemonsetsKind, c.ns, opts), &v2.BcsDaemonsetList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.BcsDaemonsetList{ListMeta: obj.(*v2.BcsDaemonsetList).ListMeta}
	for _, item := range obj.(*v2.BcsDaemonsetList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested bcsDaemonsets.
func (c *FakeBcsDaemonsets) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(bcsdaemonsetsResource, c.ns, opts))

}

// Create takes the representation of a bcsDaemonset and creates it.  Returns the server's representation of the bcsDaemonset, and an error, if there is any.
func (c *FakeBcsDaemonsets) Create(bcsDaemonset *v2.BcsDaemonset) (result *v2.BcsDaemonset, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(bcsdaemonsetsResource, c.ns, bcsDaemonset), &v2.BcsDaemonset{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsDaemonset), err
}

// Update takes the representation of a bcsDaemonset and updates it. Returns the server's representation of the bcsDaemonset, and an error, if there is any.
func (c *FakeBcsDaemonsets) Update(bcsDaemonset *v2.BcsDaemonset) (result *v2.BcsDaemonset, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(bcsdaemonsetsResource, c.ns, bcsDaemonset), &v2.BcsDaemonset{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsDaemonset), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeBcsDaemonsets) UpdateStatus(bcsDaemonset *v2.BcsDaemonset) (*v2.BcsDaemonset, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(bcsdaemonsetsResource, "status", c.ns, bcsDaemonset), &v2.BcsDaemonset{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsDaemonset), err
}

// Delete takes name of the bcsDaemonset and deletes it. Returns an error if one occurs.
func (c *FakeBcsDaemonsets) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(bcsdaemonsetsResource, c.ns, name), &v2.BcsDaemonset{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeBcsDaemonsets) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(bcsdaemonsetsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v2.BcsDaemonsetList{})
	return err
}

// Patch applies the patch and returns the patched bcsDaemonset.
func (c *FakeBcsDaemonsets) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsDaemonset, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(bcsdaemonsetsResource, c.ns, name, data, subresources...), &v2.BcsDaemonset{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsDaemonset), err
}
