/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeBcsServices implements BcsServiceInterface
type FakeBcsServices struct {
	Fake *FakeBkbcsV2
	ns   string
}

var bcsservicesResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v2", Resource: "bcsservices"}

var bcsservicesKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v2", Kind: "BcsService"}

// Get takes name of the bcsService, and returns the corresponding bcsService object, and an error if there is any.
func (c *FakeBcsServices) Get(name string, options v1.GetOptions) (result *v2.BcsService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(bcsservicesResource, c.ns, name), &v2.BcsService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsService), err
}

// List takes label and field selectors, and returns the list of BcsServices that match those selectors.
func (c *FakeBcsServices) List(opts v1.ListOptions) (result *v2.BcsServiceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(bcsservicesResource, bcsservicesKind, c.ns, opts), &v2.BcsServiceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.BcsServiceList{ListMeta: obj.(*v2.BcsServiceList).ListMeta}
	for _, item := range obj.(*v2.BcsServiceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested bcsServices.
func (c *FakeBcsServices) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(bcsservicesResource, c.ns, opts))

}

// Create takes the representation of a bcsService and creates it.  Returns the server's representation of the bcsService, and an error, if there is any.
func (c *FakeBcsServices) Create(bcsService *v2.BcsService) (result *v2.BcsService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(bcsservicesResource, c.ns, bcsService), &v2.BcsService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsService), err
}

// Update takes the representation of a bcsService and updates it. Returns the server's representation of the bcsService, and an error, if there is any.
func (c *FakeBcsServices) Update(bcsService *v2.BcsService) (result *v2.BcsService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(bcsservicesResource, c.ns, bcsService), &v2.BcsService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsService), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeBcsServices) UpdateStatus(bcsService *v2.BcsService) (*v2.BcsService, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(bcsservicesResource, "status", c.ns, bcsService), &v2.BcsService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsService), err
}

// Delete takes name of the bcsService and deletes it. Returns an error if one occurs.
func (c *FakeBcsServices) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(bcsservicesResource, c.ns, name), &v2.BcsService{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeBcsServices) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(bcsservicesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v2.BcsServiceList{})
	return err
}

// Patch applies the patch and returns the patched bcsService.
func (c *FakeBcsServices) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.BcsService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(bcsservicesResource, c.ns, name, data, subresources...), &v2.BcsService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.BcsService), err
}
