/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeCrds implements CrdInterface
type FakeCrds struct {
	Fake *FakeBkbcsV2
	ns   string
}

var crdsResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v2", Resource: "crds"}

var crdsKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v2", Kind: "Crd"}

// Get takes name of the crd, and returns the corresponding crd object, and an error if there is any.
func (c *FakeCrds) Get(name string, options v1.GetOptions) (result *v2.Crd, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(crdsResource, c.ns, name), &v2.Crd{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crd), err
}

// List takes label and field selectors, and returns the list of Crds that match those selectors.
func (c *FakeCrds) List(opts v1.ListOptions) (result *v2.CrdList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(crdsResource, crdsKind, c.ns, opts), &v2.CrdList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.CrdList{ListMeta: obj.(*v2.CrdList).ListMeta}
	for _, item := range obj.(*v2.CrdList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested crds.
func (c *FakeCrds) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(crdsResource, c.ns, opts))

}

// Create takes the representation of a crd and creates it.  Returns the server's representation of the crd, and an error, if there is any.
func (c *FakeCrds) Create(crd *v2.Crd) (result *v2.Crd, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(crdsResource, c.ns, crd), &v2.Crd{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crd), err
}

// Update takes the representation of a crd and updates it. Returns the server's representation of the crd, and an error, if there is any.
func (c *FakeCrds) Update(crd *v2.Crd) (result *v2.Crd, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(crdsResource, c.ns, crd), &v2.Crd{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crd), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeCrds) UpdateStatus(crd *v2.Crd) (*v2.Crd, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(crdsResource, "status", c.ns, crd), &v2.Crd{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crd), err
}

// Delete takes name of the crd and deletes it. Returns an error if one occurs.
func (c *FakeCrds) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(crdsResource, c.ns, name), &v2.Crd{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeCrds) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(crdsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v2.CrdList{})
	return err
}

// Patch applies the patch and returns the patched crd.
func (c *FakeCrds) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Crd, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(crdsResource, c.ns, name, data, subresources...), &v2.Crd{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crd), err
}
