/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeCrrs implements CrrInterface
type FakeCrrs struct {
	Fake *FakeBkbcsV2
	ns   string
}

var crrsResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v2", Resource: "crrs"}

var crrsKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v2", Kind: "Crr"}

// Get takes name of the crr, and returns the corresponding crr object, and an error if there is any.
func (c *FakeCrrs) Get(name string, options v1.GetOptions) (result *v2.Crr, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(crrsResource, c.ns, name), &v2.Crr{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crr), err
}

// List takes label and field selectors, and returns the list of Crrs that match those selectors.
func (c *FakeCrrs) List(opts v1.ListOptions) (result *v2.CrrList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(crrsResource, crrsKind, c.ns, opts), &v2.CrrList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.CrrList{ListMeta: obj.(*v2.CrrList).ListMeta}
	for _, item := range obj.(*v2.CrrList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested crrs.
func (c *FakeCrrs) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(crrsResource, c.ns, opts))

}

// Create takes the representation of a crr and creates it.  Returns the server's representation of the crr, and an error, if there is any.
func (c *FakeCrrs) Create(crr *v2.Crr) (result *v2.Crr, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(crrsResource, c.ns, crr), &v2.Crr{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crr), err
}

// Update takes the representation of a crr and updates it. Returns the server's representation of the crr, and an error, if there is any.
func (c *FakeCrrs) Update(crr *v2.Crr) (result *v2.Crr, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(crrsResource, c.ns, crr), &v2.Crr{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crr), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeCrrs) UpdateStatus(crr *v2.Crr) (*v2.Crr, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(crrsResource, "status", c.ns, crr), &v2.Crr{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crr), err
}

// Delete takes name of the crr and deletes it. Returns an error if one occurs.
func (c *FakeCrrs) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(crrsResource, c.ns, name), &v2.Crr{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeCrrs) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(crrsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v2.CrrList{})
	return err
}

// Patch applies the patch and returns the patched crr.
func (c *FakeCrrs) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Crr, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(crrsResource, c.ns, name, data, subresources...), &v2.Crr{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Crr), err
}
