/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFrameworks implements FrameworkInterface
type FakeFrameworks struct {
	Fake *FakeBkbcsV2
	ns   string
}

var frameworksResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v2", Resource: "frameworks"}

var frameworksKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v2", Kind: "Framework"}

// Get takes name of the framework, and returns the corresponding framework object, and an error if there is any.
func (c *FakeFrameworks) Get(name string, options v1.GetOptions) (result *v2.Framework, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(frameworksResource, c.ns, name), &v2.Framework{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Framework), err
}

// List takes label and field selectors, and returns the list of Frameworks that match those selectors.
func (c *FakeFrameworks) List(opts v1.ListOptions) (result *v2.FrameworkList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(frameworksResource, frameworksKind, c.ns, opts), &v2.FrameworkList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2.FrameworkList{ListMeta: obj.(*v2.FrameworkList).ListMeta}
	for _, item := range obj.(*v2.FrameworkList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested frameworks.
func (c *FakeFrameworks) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(frameworksResource, c.ns, opts))

}

// Create takes the representation of a framework and creates it.  Returns the server's representation of the framework, and an error, if there is any.
func (c *FakeFrameworks) Create(framework *v2.Framework) (result *v2.Framework, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(frameworksResource, c.ns, framework), &v2.Framework{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Framework), err
}

// Update takes the representation of a framework and updates it. Returns the server's representation of the framework, and an error, if there is any.
func (c *FakeFrameworks) Update(framework *v2.Framework) (result *v2.Framework, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(frameworksResource, c.ns, framework), &v2.Framework{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Framework), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFrameworks) UpdateStatus(framework *v2.Framework) (*v2.Framework, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(frameworksResource, "status", c.ns, framework), &v2.Framework{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Framework), err
}

// Delete takes name of the framework and deletes it. Returns an error if one occurs.
func (c *FakeFrameworks) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(frameworksResource, c.ns, name), &v2.Framework{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFrameworks) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(frameworksResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v2.FrameworkList{})
	return err
}

// Patch applies the patch and returns the patched framework.
func (c *FakeFrameworks) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Framework, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(frameworksResource, c.ns, name, data, subresources...), &v2.Framework{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2.Framework), err
}
