/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by client-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	scheme "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/client/internalclientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// FrameworksGetter has a method to return a FrameworkInterface.
// A group's client should implement this interface.
type FrameworksGetter interface {
	Frameworks(namespace string) FrameworkInterface
}

// FrameworkInterface has methods to work with Framework resources.
type FrameworkInterface interface {
	Create(*v2.Framework) (*v2.Framework, error)
	Update(*v2.Framework) (*v2.Framework, error)
	UpdateStatus(*v2.Framework) (*v2.Framework, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v2.Framework, error)
	List(opts v1.ListOptions) (*v2.FrameworkList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Framework, err error)
	FrameworkExpansion
}

// frameworks implements FrameworkInterface
type frameworks struct {
	client rest.Interface
	ns     string
}

// newFrameworks returns a Frameworks
func newFrameworks(c *BkbcsV2Client, namespace string) *frameworks {
	return &frameworks{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the framework, and returns the corresponding framework object, and an error if there is any.
func (c *frameworks) Get(name string, options v1.GetOptions) (result *v2.Framework, err error) {
	result = &v2.Framework{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("frameworks").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Frameworks that match those selectors.
func (c *frameworks) List(opts v1.ListOptions) (result *v2.FrameworkList, err error) {
	result = &v2.FrameworkList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("frameworks").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested frameworks.
func (c *frameworks) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("frameworks").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a framework and creates it.  Returns the server's representation of the framework, and an error, if there is any.
func (c *frameworks) Create(framework *v2.Framework) (result *v2.Framework, err error) {
	result = &v2.Framework{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("frameworks").
		Body(framework).
		Do().
		Into(result)
	return
}

// Update takes the representation of a framework and updates it. Returns the server's representation of the framework, and an error, if there is any.
func (c *frameworks) Update(framework *v2.Framework) (result *v2.Framework, err error) {
	result = &v2.Framework{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("frameworks").
		Name(framework.Name).
		Body(framework).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *frameworks) UpdateStatus(framework *v2.Framework) (result *v2.Framework, err error) {
	result = &v2.Framework{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("frameworks").
		Name(framework.Name).
		SubResource("status").
		Body(framework).
		Do().
		Into(result)
	return
}

// Delete takes name of the framework and deletes it. Returns an error if one occurs.
func (c *frameworks) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("frameworks").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *frameworks) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("frameworks").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched framework.
func (c *frameworks) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v2.Framework, err error) {
	result = &v2.Framework{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("frameworks").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
