/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AdmissionWebhookConfigurationLister helps list AdmissionWebhookConfigurations.
type AdmissionWebhookConfigurationLister interface {
	// List lists all AdmissionWebhookConfigurations in the indexer.
	List(selector labels.Selector) (ret []*v2.AdmissionWebhookConfiguration, err error)
	// AdmissionWebhookConfigurations returns an object that can list and get AdmissionWebhookConfigurations.
	AdmissionWebhookConfigurations(namespace string) AdmissionWebhookConfigurationNamespaceLister
	AdmissionWebhookConfigurationListerExpansion
}

// admissionWebhookConfigurationLister implements the AdmissionWebhookConfigurationLister interface.
type admissionWebhookConfigurationLister struct {
	indexer cache.Indexer
}

// NewAdmissionWebhookConfigurationLister returns a new AdmissionWebhookConfigurationLister.
func NewAdmissionWebhookConfigurationLister(indexer cache.Indexer) AdmissionWebhookConfigurationLister {
	return &admissionWebhookConfigurationLister{indexer: indexer}
}

// List lists all AdmissionWebhookConfigurations in the indexer.
func (s *admissionWebhookConfigurationLister) List(selector labels.Selector) (ret []*v2.AdmissionWebhookConfiguration, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.AdmissionWebhookConfiguration))
	})
	return ret, err
}

// AdmissionWebhookConfigurations returns an object that can list and get AdmissionWebhookConfigurations.
func (s *admissionWebhookConfigurationLister) AdmissionWebhookConfigurations(namespace string) AdmissionWebhookConfigurationNamespaceLister {
	return admissionWebhookConfigurationNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AdmissionWebhookConfigurationNamespaceLister helps list and get AdmissionWebhookConfigurations.
type AdmissionWebhookConfigurationNamespaceLister interface {
	// List lists all AdmissionWebhookConfigurations in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v2.AdmissionWebhookConfiguration, err error)
	// Get retrieves the AdmissionWebhookConfiguration from the indexer for a given namespace and name.
	Get(name string) (*v2.AdmissionWebhookConfiguration, error)
	AdmissionWebhookConfigurationNamespaceListerExpansion
}

// admissionWebhookConfigurationNamespaceLister implements the AdmissionWebhookConfigurationNamespaceLister
// interface.
type admissionWebhookConfigurationNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AdmissionWebhookConfigurations in the indexer for a given namespace.
func (s admissionWebhookConfigurationNamespaceLister) List(selector labels.Selector) (ret []*v2.AdmissionWebhookConfiguration, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.AdmissionWebhookConfiguration))
	})
	return ret, err
}

// Get retrieves the AdmissionWebhookConfiguration from the indexer for a given namespace and name.
func (s admissionWebhookConfigurationNamespaceLister) Get(name string) (*v2.AdmissionWebhookConfiguration, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2.Resource("admissionwebhookconfiguration"), name)
	}
	return obj.(*v2.AdmissionWebhookConfiguration), nil
}
