/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// BcsCommandInfoLister helps list BcsCommandInfos.
type BcsCommandInfoLister interface {
	// List lists all BcsCommandInfos in the indexer.
	List(selector labels.Selector) (ret []*v2.BcsCommandInfo, err error)
	// BcsCommandInfos returns an object that can list and get BcsCommandInfos.
	BcsCommandInfos(namespace string) BcsCommandInfoNamespaceLister
	BcsCommandInfoListerExpansion
}

// bcsCommandInfoLister implements the BcsCommandInfoLister interface.
type bcsCommandInfoLister struct {
	indexer cache.Indexer
}

// NewBcsCommandInfoLister returns a new BcsCommandInfoLister.
func NewBcsCommandInfoLister(indexer cache.Indexer) BcsCommandInfoLister {
	return &bcsCommandInfoLister{indexer: indexer}
}

// List lists all BcsCommandInfos in the indexer.
func (s *bcsCommandInfoLister) List(selector labels.Selector) (ret []*v2.BcsCommandInfo, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.BcsCommandInfo))
	})
	return ret, err
}

// BcsCommandInfos returns an object that can list and get BcsCommandInfos.
func (s *bcsCommandInfoLister) BcsCommandInfos(namespace string) BcsCommandInfoNamespaceLister {
	return bcsCommandInfoNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// BcsCommandInfoNamespaceLister helps list and get BcsCommandInfos.
type BcsCommandInfoNamespaceLister interface {
	// List lists all BcsCommandInfos in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v2.BcsCommandInfo, err error)
	// Get retrieves the BcsCommandInfo from the indexer for a given namespace and name.
	Get(name string) (*v2.BcsCommandInfo, error)
	BcsCommandInfoNamespaceListerExpansion
}

// bcsCommandInfoNamespaceLister implements the BcsCommandInfoNamespaceLister
// interface.
type bcsCommandInfoNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all BcsCommandInfos in the indexer for a given namespace.
func (s bcsCommandInfoNamespaceLister) List(selector labels.Selector) (ret []*v2.BcsCommandInfo, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.BcsCommandInfo))
	})
	return ret, err
}

// Get retrieves the BcsCommandInfo from the indexer for a given namespace and name.
func (s bcsCommandInfoNamespaceLister) Get(name string) (*v2.BcsCommandInfo, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2.Resource("bcscommandinfo"), name)
	}
	return obj.(*v2.BcsCommandInfo), nil
}
