/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// BcsConfigMapLister helps list BcsConfigMaps.
type BcsConfigMapLister interface {
	// List lists all BcsConfigMaps in the indexer.
	List(selector labels.Selector) (ret []*v2.BcsConfigMap, err error)
	// BcsConfigMaps returns an object that can list and get BcsConfigMaps.
	BcsConfigMaps(namespace string) BcsConfigMapNamespaceLister
	BcsConfigMapListerExpansion
}

// bcsConfigMapLister implements the BcsConfigMapLister interface.
type bcsConfigMapLister struct {
	indexer cache.Indexer
}

// NewBcsConfigMapLister returns a new BcsConfigMapLister.
func NewBcsConfigMapLister(indexer cache.Indexer) BcsConfigMapLister {
	return &bcsConfigMapLister{indexer: indexer}
}

// List lists all BcsConfigMaps in the indexer.
func (s *bcsConfigMapLister) List(selector labels.Selector) (ret []*v2.BcsConfigMap, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.BcsConfigMap))
	})
	return ret, err
}

// BcsConfigMaps returns an object that can list and get BcsConfigMaps.
func (s *bcsConfigMapLister) BcsConfigMaps(namespace string) BcsConfigMapNamespaceLister {
	return bcsConfigMapNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// BcsConfigMapNamespaceLister helps list and get BcsConfigMaps.
type BcsConfigMapNamespaceLister interface {
	// List lists all BcsConfigMaps in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v2.BcsConfigMap, err error)
	// Get retrieves the BcsConfigMap from the indexer for a given namespace and name.
	Get(name string) (*v2.BcsConfigMap, error)
	BcsConfigMapNamespaceListerExpansion
}

// bcsConfigMapNamespaceLister implements the BcsConfigMapNamespaceLister
// interface.
type bcsConfigMapNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all BcsConfigMaps in the indexer for a given namespace.
func (s bcsConfigMapNamespaceLister) List(selector labels.Selector) (ret []*v2.BcsConfigMap, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.BcsConfigMap))
	})
	return ret, err
}

// Get retrieves the BcsConfigMap from the indexer for a given namespace and name.
func (s bcsConfigMapNamespaceLister) Get(name string) (*v2.BcsConfigMap, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2.Resource("bcsconfigmap"), name)
	}
	return obj.(*v2.BcsConfigMap), nil
}
