/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// CrdLister helps list Crds.
type CrdLister interface {
	// List lists all Crds in the indexer.
	List(selector labels.Selector) (ret []*v2.Crd, err error)
	// Crds returns an object that can list and get Crds.
	Crds(namespace string) CrdNamespaceLister
	CrdListerExpansion
}

// crdLister implements the CrdLister interface.
type crdLister struct {
	indexer cache.Indexer
}

// NewCrdLister returns a new CrdLister.
func NewCrdLister(indexer cache.Indexer) CrdLister {
	return &crdLister{indexer: indexer}
}

// List lists all Crds in the indexer.
func (s *crdLister) List(selector labels.Selector) (ret []*v2.Crd, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.Crd))
	})
	return ret, err
}

// Crds returns an object that can list and get Crds.
func (s *crdLister) Crds(namespace string) CrdNamespaceLister {
	return crdNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// CrdNamespaceLister helps list and get Crds.
type CrdNamespaceLister interface {
	// List lists all Crds in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v2.Crd, err error)
	// Get retrieves the Crd from the indexer for a given namespace and name.
	Get(name string) (*v2.Crd, error)
	CrdNamespaceListerExpansion
}

// crdNamespaceLister implements the CrdNamespaceLister
// interface.
type crdNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all Crds in the indexer for a given namespace.
func (s crdNamespaceLister) List(selector labels.Selector) (ret []*v2.Crd, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.Crd))
	})
	return ret, err
}

// Get retrieves the Crd from the indexer for a given namespace and name.
func (s crdNamespaceLister) Get(name string) (*v2.Crd, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2.Resource("crd"), name)
	}
	return obj.(*v2.Crd), nil
}
