/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// FrameworkLister helps list Frameworks.
type FrameworkLister interface {
	// List lists all Frameworks in the indexer.
	List(selector labels.Selector) (ret []*v2.Framework, err error)
	// Frameworks returns an object that can list and get Frameworks.
	Frameworks(namespace string) FrameworkNamespaceLister
	FrameworkListerExpansion
}

// frameworkLister implements the FrameworkLister interface.
type frameworkLister struct {
	indexer cache.Indexer
}

// NewFrameworkLister returns a new FrameworkLister.
func NewFrameworkLister(indexer cache.Indexer) FrameworkLister {
	return &frameworkLister{indexer: indexer}
}

// List lists all Frameworks in the indexer.
func (s *frameworkLister) List(selector labels.Selector) (ret []*v2.Framework, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.Framework))
	})
	return ret, err
}

// Frameworks returns an object that can list and get Frameworks.
func (s *frameworkLister) Frameworks(namespace string) FrameworkNamespaceLister {
	return frameworkNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// FrameworkNamespaceLister helps list and get Frameworks.
type FrameworkNamespaceLister interface {
	// List lists all Frameworks in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v2.Framework, err error)
	// Get retrieves the Framework from the indexer for a given namespace and name.
	Get(name string) (*v2.Framework, error)
	FrameworkNamespaceListerExpansion
}

// frameworkNamespaceLister implements the FrameworkNamespaceLister
// interface.
type frameworkNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all Frameworks in the indexer for a given namespace.
func (s frameworkNamespaceLister) List(selector labels.Selector) (ret []*v2.Framework, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.Framework))
	})
	return ret, err
}

// Get retrieves the Framework from the indexer for a given namespace and name.
func (s frameworkNamespaceLister) Get(name string) (*v2.Framework, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2.Resource("framework"), name)
	}
	return obj.(*v2.Framework), nil
}
