/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Code generated by lister-gen. DO NOT EDIT.

package v2

import (
	v2 "github.com/Tencent/bk-bcs/bcs-mesos/kubebkbcsv2/apis/bkbcs/v2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TaskGroupLister helps list TaskGroups.
type TaskGroupLister interface {
	// List lists all TaskGroups in the indexer.
	List(selector labels.Selector) (ret []*v2.TaskGroup, err error)
	// TaskGroups returns an object that can list and get TaskGroups.
	TaskGroups(namespace string) TaskGroupNamespaceLister
	TaskGroupListerExpansion
}

// taskGroupLister implements the TaskGroupLister interface.
type taskGroupLister struct {
	indexer cache.Indexer
}

// NewTaskGroupLister returns a new TaskGroupLister.
func NewTaskGroupLister(indexer cache.Indexer) TaskGroupLister {
	return &taskGroupLister{indexer: indexer}
}

// List lists all TaskGroups in the indexer.
func (s *taskGroupLister) List(selector labels.Selector) (ret []*v2.TaskGroup, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.TaskGroup))
	})
	return ret, err
}

// TaskGroups returns an object that can list and get TaskGroups.
func (s *taskGroupLister) TaskGroups(namespace string) TaskGroupNamespaceLister {
	return taskGroupNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// TaskGroupNamespaceLister helps list and get TaskGroups.
type TaskGroupNamespaceLister interface {
	// List lists all TaskGroups in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v2.TaskGroup, err error)
	// Get retrieves the TaskGroup from the indexer for a given namespace and name.
	Get(name string) (*v2.TaskGroup, error)
	TaskGroupNamespaceListerExpansion
}

// taskGroupNamespaceLister implements the TaskGroupNamespaceLister
// interface.
type taskGroupNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all TaskGroups in the indexer for a given namespace.
func (s taskGroupNamespaceLister) List(selector labels.Selector) (ret []*v2.TaskGroup, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2.TaskGroup))
	})
	return ret, err
}

// Get retrieves the TaskGroup from the indexer for a given namespace and name.
func (s taskGroupNamespaceLister) Get(name string) (*v2.TaskGroup, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2.Resource("taskgroup"), name)
	}
	return obj.(*v2.TaskGroup), nil
}
