/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/Tencent/bk-bcs/bcs-services/bcs-clb-controller/pkg/apis/mesh/v1"
	scheme "github.com/Tencent/bk-bcs/bcs-services/bcs-clb-controller/pkg/client/internalclientset/scheme"
	meta_v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AppNodesGetter has a method to return a AppNodeInterface.
// A group's client should implement this interface.
type AppNodesGetter interface {
	AppNodes(namespace string) AppNodeInterface
}

// AppNodeInterface has methods to work with AppNode resources.
type AppNodeInterface interface {
	Create(*v1.AppNode) (*v1.AppNode, error)
	Update(*v1.AppNode) (*v1.AppNode, error)
	UpdateStatus(*v1.AppNode) (*v1.AppNode, error)
	Delete(name string, options *meta_v1.DeleteOptions) error
	DeleteCollection(options *meta_v1.DeleteOptions, listOptions meta_v1.ListOptions) error
	Get(name string, options meta_v1.GetOptions) (*v1.AppNode, error)
	List(opts meta_v1.ListOptions) (*v1.AppNodeList, error)
	Watch(opts meta_v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.AppNode, err error)
	AppNodeExpansion
}

// appNodes implements AppNodeInterface
type appNodes struct {
	client rest.Interface
	ns     string
}

// newAppNodes returns a AppNodes
func newAppNodes(c *MeshV1Client, namespace string) *appNodes {
	return &appNodes{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the appNode, and returns the corresponding appNode object, and an error if there is any.
func (c *appNodes) Get(name string, options meta_v1.GetOptions) (result *v1.AppNode, err error) {
	result = &v1.AppNode{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("appnodes").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AppNodes that match those selectors.
func (c *appNodes) List(opts meta_v1.ListOptions) (result *v1.AppNodeList, err error) {
	result = &v1.AppNodeList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("appnodes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested appNodes.
func (c *appNodes) Watch(opts meta_v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("appnodes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a appNode and creates it.  Returns the server's representation of the appNode, and an error, if there is any.
func (c *appNodes) Create(appNode *v1.AppNode) (result *v1.AppNode, err error) {
	result = &v1.AppNode{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("appnodes").
		Body(appNode).
		Do().
		Into(result)
	return
}

// Update takes the representation of a appNode and updates it. Returns the server's representation of the appNode, and an error, if there is any.
func (c *appNodes) Update(appNode *v1.AppNode) (result *v1.AppNode, err error) {
	result = &v1.AppNode{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("appnodes").
		Name(appNode.Name).
		Body(appNode).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *appNodes) UpdateStatus(appNode *v1.AppNode) (result *v1.AppNode, err error) {
	result = &v1.AppNode{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("appnodes").
		Name(appNode.Name).
		SubResource("status").
		Body(appNode).
		Do().
		Into(result)
	return
}

// Delete takes name of the appNode and deletes it. Returns an error if one occurs.
func (c *appNodes) Delete(name string, options *meta_v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("appnodes").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *appNodes) DeleteCollection(options *meta_v1.DeleteOptions, listOptions meta_v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("appnodes").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched appNode.
func (c *appNodes) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.AppNode, err error) {
	result = &v1.AppNode{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("appnodes").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
