/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/Tencent/bk-bcs/bcs-services/bcs-log-manager/pkg/apis/bkbcs.tencent.com/v1"
	scheme "github.com/Tencent/bk-bcs/bcs-services/bcs-log-manager/pkg/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// BKDataApiConfigsGetter has a method to return a BKDataApiConfigInterface.
// A group's client should implement this interface.
type BKDataApiConfigsGetter interface {
	BKDataApiConfigs(namespace string) BKDataApiConfigInterface
}

// BKDataApiConfigInterface has methods to work with BKDataApiConfig resources.
type BKDataApiConfigInterface interface {
	Create(*v1.BKDataApiConfig) (*v1.BKDataApiConfig, error)
	Update(*v1.BKDataApiConfig) (*v1.BKDataApiConfig, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.BKDataApiConfig, error)
	List(opts metav1.ListOptions) (*v1.BKDataApiConfigList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.BKDataApiConfig, err error)
	BKDataApiConfigExpansion
}

// bKDataApiConfigs implements BKDataApiConfigInterface
type bKDataApiConfigs struct {
	client rest.Interface
	ns     string
}

// newBKDataApiConfigs returns a BKDataApiConfigs
func newBKDataApiConfigs(c *BkbcsV1Client, namespace string) *bKDataApiConfigs {
	return &bKDataApiConfigs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the bKDataApiConfig, and returns the corresponding bKDataApiConfig object, and an error if there is any.
func (c *bKDataApiConfigs) Get(name string, options metav1.GetOptions) (result *v1.BKDataApiConfig, err error) {
	result = &v1.BKDataApiConfig{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of BKDataApiConfigs that match those selectors.
func (c *bKDataApiConfigs) List(opts metav1.ListOptions) (result *v1.BKDataApiConfigList, err error) {
	result = &v1.BKDataApiConfigList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested bKDataApiConfigs.
func (c *bKDataApiConfigs) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a bKDataApiConfig and creates it.  Returns the server's representation of the bKDataApiConfig, and an error, if there is any.
func (c *bKDataApiConfigs) Create(bKDataApiConfig *v1.BKDataApiConfig) (result *v1.BKDataApiConfig, err error) {
	result = &v1.BKDataApiConfig{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		Body(bKDataApiConfig).
		Do().
		Into(result)
	return
}

// Update takes the representation of a bKDataApiConfig and updates it. Returns the server's representation of the bKDataApiConfig, and an error, if there is any.
func (c *bKDataApiConfigs) Update(bKDataApiConfig *v1.BKDataApiConfig) (result *v1.BKDataApiConfig, err error) {
	result = &v1.BKDataApiConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		Name(bKDataApiConfig.Name).
		Body(bKDataApiConfig).
		Do().
		Into(result)
	return
}

// Delete takes name of the bKDataApiConfig and deletes it. Returns an error if one occurs.
func (c *bKDataApiConfigs) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *bKDataApiConfigs) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched bKDataApiConfig.
func (c *bKDataApiConfigs) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.BKDataApiConfig, err error) {
	result = &v1.BKDataApiConfig{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("bkdataapiconfigs").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
