/*
 * Tencent is pleased to support the open source community by making Blueking Container Service available.
 * Copyright (C) 2019 THL A29 Limited, a Tencent company. All rights reserved.
 * Licensed under the MIT License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/MIT
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	bkbcstencentcomv1 "github.com/Tencent/bk-bcs/bcs-services/bcs-log-manager/pkg/apis/bkbcs.tencent.com/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeBKDataApiConfigs implements BKDataApiConfigInterface
type FakeBKDataApiConfigs struct {
	Fake *FakeBkbcsV1
	ns   string
}

var bkdataapiconfigsResource = schema.GroupVersionResource{Group: "bkbcs.tencent.com", Version: "v1", Resource: "bkdataapiconfigs"}

var bkdataapiconfigsKind = schema.GroupVersionKind{Group: "bkbcs.tencent.com", Version: "v1", Kind: "BKDataApiConfig"}

// Get takes name of the bKDataApiConfig, and returns the corresponding bKDataApiConfig object, and an error if there is any.
func (c *FakeBKDataApiConfigs) Get(name string, options v1.GetOptions) (result *bkbcstencentcomv1.BKDataApiConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(bkdataapiconfigsResource, c.ns, name), &bkbcstencentcomv1.BKDataApiConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bkbcstencentcomv1.BKDataApiConfig), err
}

// List takes label and field selectors, and returns the list of BKDataApiConfigs that match those selectors.
func (c *FakeBKDataApiConfigs) List(opts v1.ListOptions) (result *bkbcstencentcomv1.BKDataApiConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(bkdataapiconfigsResource, bkdataapiconfigsKind, c.ns, opts), &bkbcstencentcomv1.BKDataApiConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &bkbcstencentcomv1.BKDataApiConfigList{ListMeta: obj.(*bkbcstencentcomv1.BKDataApiConfigList).ListMeta}
	for _, item := range obj.(*bkbcstencentcomv1.BKDataApiConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested bKDataApiConfigs.
func (c *FakeBKDataApiConfigs) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(bkdataapiconfigsResource, c.ns, opts))

}

// Create takes the representation of a bKDataApiConfig and creates it.  Returns the server's representation of the bKDataApiConfig, and an error, if there is any.
func (c *FakeBKDataApiConfigs) Create(bKDataApiConfig *bkbcstencentcomv1.BKDataApiConfig) (result *bkbcstencentcomv1.BKDataApiConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(bkdataapiconfigsResource, c.ns, bKDataApiConfig), &bkbcstencentcomv1.BKDataApiConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bkbcstencentcomv1.BKDataApiConfig), err
}

// Update takes the representation of a bKDataApiConfig and updates it. Returns the server's representation of the bKDataApiConfig, and an error, if there is any.
func (c *FakeBKDataApiConfigs) Update(bKDataApiConfig *bkbcstencentcomv1.BKDataApiConfig) (result *bkbcstencentcomv1.BKDataApiConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(bkdataapiconfigsResource, c.ns, bKDataApiConfig), &bkbcstencentcomv1.BKDataApiConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bkbcstencentcomv1.BKDataApiConfig), err
}

// Delete takes name of the bKDataApiConfig and deletes it. Returns an error if one occurs.
func (c *FakeBKDataApiConfigs) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(bkdataapiconfigsResource, c.ns, name), &bkbcstencentcomv1.BKDataApiConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeBKDataApiConfigs) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(bkdataapiconfigsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &bkbcstencentcomv1.BKDataApiConfigList{})
	return err
}

// Patch applies the patch and returns the patched bKDataApiConfig.
func (c *FakeBKDataApiConfigs) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *bkbcstencentcomv1.BKDataApiConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(bkdataapiconfigsResource, c.ns, name, data, subresources...), &bkbcstencentcomv1.BKDataApiConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*bkbcstencentcomv1.BKDataApiConfig), err
}
