# 版本规划与操作说明

## 版本号说明

版本号范例：1.10.4，数字分三位，含义如下

* 第一位：
1代表大版本，目前是1；当进行大版本调整时，或者不在向下兼容时，例如API，数据结构不兼容，该位升级；
* 第二位：
10代表一个版本迭代周期，该周期内会包含一个或多个新的特性需求、新功能，也可以映射某个Milestone；
* 第三位：
4代表当前的迭代周期，包含了特性调整、多个bugfix等内容。随着开发节奏不定期进行调整。一般为1~3周的周期。

## 版本分支管理

以version 1.10.x版本进行说明。

当进入新版本迭代/Milestone完成规划进入开发后，从master分支checkout新分支1.10.x，各开发人员在fork出来的分支完成后，提交MR到分支1.10.x上。代码合并完成进行tag **1.10.0**进入测试阶段。

在测试过程中，如有发现问题，并进行修复，则提MR合并到分支v1.10.x，进行tag为**v1.10.1**。如果仍有问题，继续修复，版本升上**1.10.2**，直到问题修复为止。

**1.10.2**完全通过测试，确认没有问题则变为发布版本，在**github中release进行发布**/**version.md中进行change log说明**，非发布版本不进行version记录。发布完成则进入下一个迭代。

新迭代开启前，将1.10.x分支合并到master中，但仍然保留1.10.x分支用于bug修复。从master分支中checkout 1.11.x分支进行新特性迭代。

## 版本修复流程

假设当前已经处于1.11.x分支开发中，但是发现已发布的**1.10.2**存在问题，需要：

* 基于1.10.x分支进行fork，完成issue修复
* 提交MR到1.10.x分支，进行tag **1.10.3**
* 1.10.3测试通过，进行**release发布**、**change log记录**
* code review进行评估，确认是否要合并到1.11.x中
* 如确认需要合并，则由开发团队合并到1.11.x中

## 升级策略

* release版本发布后，默认进行发布
