// Code generated by protoc-gen-go.
// source: mesos.proto
// DO NOT EDIT!

/*
Package mesos is a generated protocol buffer package.

It is generated from these files:
	mesos.proto

It has these top-level messages:
	FrameworkID
	OfferID
	AgentID
	TaskID
	ExecutorID
	ContainerID
	TimeInfo
	DurationInfo
	Address
	URL
	Unavailability
	MachineID
	MachineInfo
	FrameworkInfo
	HealthCheck
	KillPolicy
	CommandInfo
	ExecutorInfo
	MasterInfo
	AgentInfo
	Value
	Attribute
	Resource
	TrafficControlStatistics
	IpStatistics
	IcmpStatistics
	TcpStatistics
	UdpStatistics
	SNMPStatistics
	ResourceStatistics
	ResourceUsage
	PerfStatistics
	Request
	Offer
	InverseOffer
	TaskInfo
	TaskGroupInfo
	Task
	TaskStatus
	Filters
	Environment
	Parameter
	Parameters
	Credential
	Credentials
	RateLimit
	RateLimits
	Image
	Volume
	NetworkInfo
	CapabilityInfo
	LinuxInfo
	ContainerInfo
	ContainerStatus
	CgroupInfo
	Labels
	Label
	Port
	Ports
	DiscoveryInfo
	WeightInfo
	VersionInfo
	Flag
	Role
	Metric
	FileInfo
*/
package mesos

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// *
// Status is used to indicate the state of the scheduler and executor
// driver after function calls.
type Status int32

const (
	Status_DRIVER_NOT_STARTED Status = 1
	Status_DRIVER_RUNNING     Status = 2
	Status_DRIVER_ABORTED     Status = 3
	Status_DRIVER_STOPPED     Status = 4
)

var Status_name = map[int32]string{
	1: "DRIVER_NOT_STARTED",
	2: "DRIVER_RUNNING",
	3: "DRIVER_ABORTED",
	4: "DRIVER_STOPPED",
}
var Status_value = map[string]int32{
	"DRIVER_NOT_STARTED": 1,
	"DRIVER_RUNNING":     2,
	"DRIVER_ABORTED":     3,
	"DRIVER_STOPPED":     4,
}

func (x Status) Enum() *Status {
	p := new(Status)
	*p = x
	return p
}
func (x Status) String() string {
	return proto.EnumName(Status_name, int32(x))
}
func (x *Status) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Status_value, data, "Status")
	if err != nil {
		return err
	}
	*x = Status(value)
	return nil
}
func (Status) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

// *
// Describes possible task states. IMPORTANT: Mesos assumes tasks that
// enter terminal states (see below) imply the task is no longer
// running and thus clean up any thing associated with the task
// (ultimately offering any resources being consumed by that task to
// another task).
type TaskState int32

const (
	TaskState_TASK_STAGING  TaskState = 6
	TaskState_TASK_STARTING TaskState = 0
	TaskState_TASK_RUNNING  TaskState = 1
	// NOTE: This should only be sent when the framework has
	// the TASK_KILLING_STATE capability.
	TaskState_TASK_KILLING  TaskState = 8
	TaskState_TASK_FINISHED TaskState = 2
	TaskState_TASK_FAILED   TaskState = 3
	TaskState_TASK_KILLED   TaskState = 4
	TaskState_TASK_ERROR    TaskState = 7
	// In Mesos 1.2, this will only be sent when the framework does NOT
	// opt-in to the PARTITION_AWARE capability.
	TaskState_TASK_LOST TaskState = 5
	// The task failed to launch because of a transient error. The
	// task's executor never started running. Unlike TASK_ERROR, the
	// task description is valid -- attempting to launch the task again
	// may be successful.
	TaskState_TASK_DROPPED TaskState = 9
	// The task was running on an agent that has lost contact with the
	// master, typically due to a network failure or partition. The task
	// may or may not still be running.
	TaskState_TASK_UNREACHABLE TaskState = 10
	// The task was running on an agent that has been shutdown (e.g.,
	// the agent become partitioned, rebooted, and then reconnected to
	// the master; any tasks running before the reboot will transition
	// from UNREACHABLE to GONE). The task is no longer running.
	TaskState_TASK_GONE TaskState = 11
	// The task was running on an agent that the master cannot contact;
	// the operator has asserted that the agent has been shutdown, but
	// this has not been directly confirmed by the master. If the
	// operator is correct, the task is not running and this is a
	// terminal state; if the operator is mistaken, the task may still
	// be running and might return to RUNNING in the future.
	TaskState_TASK_GONE_BY_OPERATOR TaskState = 12
	// The master has no knowledge of the task. This is typically
	// because either (a) the master never had knowledge of the task, or
	// (b) the master forgot about the task because it garbage collected
	// its metadata about the task. The task may or may not still be
	// running.
	TaskState_TASK_UNKNOWN TaskState = 13
)

var TaskState_name = map[int32]string{
	6:  "TASK_STAGING",
	0:  "TASK_STARTING",
	1:  "TASK_RUNNING",
	8:  "TASK_KILLING",
	2:  "TASK_FINISHED",
	3:  "TASK_FAILED",
	4:  "TASK_KILLED",
	7:  "TASK_ERROR",
	5:  "TASK_LOST",
	9:  "TASK_DROPPED",
	10: "TASK_UNREACHABLE",
	11: "TASK_GONE",
	12: "TASK_GONE_BY_OPERATOR",
	13: "TASK_UNKNOWN",
}
var TaskState_value = map[string]int32{
	"TASK_STAGING":          6,
	"TASK_STARTING":         0,
	"TASK_RUNNING":          1,
	"TASK_KILLING":          8,
	"TASK_FINISHED":         2,
	"TASK_FAILED":           3,
	"TASK_KILLED":           4,
	"TASK_ERROR":            7,
	"TASK_LOST":             5,
	"TASK_DROPPED":          9,
	"TASK_UNREACHABLE":      10,
	"TASK_GONE":             11,
	"TASK_GONE_BY_OPERATOR": 12,
	"TASK_UNKNOWN":          13,
}

func (x TaskState) Enum() *TaskState {
	p := new(TaskState)
	*p = x
	return p
}
func (x TaskState) String() string {
	return proto.EnumName(TaskState_name, int32(x))
}
func (x *TaskState) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(TaskState_value, data, "TaskState")
	if err != nil {
		return err
	}
	*x = TaskState(value)
	return nil
}
func (TaskState) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

// Describes the several states that a machine can be in.  A `Mode`
// applies to a machine and to all associated agents on the machine.
type MachineInfo_Mode int32

const (
	// In this mode, a machine is behaving normally;
	// offering resources, executing tasks, etc.
	MachineInfo_UP MachineInfo_Mode = 1
	// In this mode, all agents on the machine are expected to cooperate with
	// frameworks to drain resources.  In general, draining is done ahead of
	// a pending `unavailability`.  The resources should be drained so as to
	// maximize utilization prior to the maintenance but without knowingly
	// violating the frameworks' requirements.
	MachineInfo_DRAINING MachineInfo_Mode = 2
	// In this mode, a machine is not running any tasks and will not offer
	// any of its resources.  Agents on the machine will not be allowed to
	// register with the master.
	MachineInfo_DOWN MachineInfo_Mode = 3
)

var MachineInfo_Mode_name = map[int32]string{
	1: "UP",
	2: "DRAINING",
	3: "DOWN",
}
var MachineInfo_Mode_value = map[string]int32{
	"UP":       1,
	"DRAINING": 2,
	"DOWN":     3,
}

func (x MachineInfo_Mode) Enum() *MachineInfo_Mode {
	p := new(MachineInfo_Mode)
	*p = x
	return p
}
func (x MachineInfo_Mode) String() string {
	return proto.EnumName(MachineInfo_Mode_name, int32(x))
}
func (x *MachineInfo_Mode) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(MachineInfo_Mode_value, data, "MachineInfo_Mode")
	if err != nil {
		return err
	}
	*x = MachineInfo_Mode(value)
	return nil
}
func (MachineInfo_Mode) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{12, 0} }

type FrameworkInfo_Capability_Type int32

const (
	// This must be the first enum value in this list, to
	// ensure that if 'type' is not set, the default value
	// is UNKNOWN. This enables enum values to be added
	// in a backwards-compatible way. See: MESOS-4997.
	FrameworkInfo_Capability_UNKNOWN FrameworkInfo_Capability_Type = 0
	// Receive offers with revocable resources. See 'Resource'
	// message for details.
	FrameworkInfo_Capability_REVOCABLE_RESOURCES FrameworkInfo_Capability_Type = 1
	// Receive the TASK_KILLING TaskState when a task is being
	// killed by an executor. The executor will examine this
	// capability to determine whether it can send TASK_KILLING.
	FrameworkInfo_Capability_TASK_KILLING_STATE FrameworkInfo_Capability_Type = 2
	// Indicates whether the framework is aware of GPU resources.
	// Frameworks that are aware of GPU resources are expected to
	// avoid placing non-GPU workloads on GPU agents, in order
	// to avoid occupying a GPU agent and preventing GPU workloads
	// from running! Currently, if a framework is unaware of GPU
	// resources, it will not be offered *any* of the resources on
	// an agent with GPUs. This restriction is in place because we
	// do not have a revocation mechanism that ensures GPU workloads
	// can evict GPU agent occupants if necessary.
	//
	// TODO(bmahler): As we add revocation we can relax the
	// restriction here. See MESOS-5634 for more information.
	FrameworkInfo_Capability_GPU_RESOURCES FrameworkInfo_Capability_Type = 3
	// Receive offers with resources that are shared.
	FrameworkInfo_Capability_SHARED_RESOURCES FrameworkInfo_Capability_Type = 4
	// Indicates that (1) the framework is prepared to handle the
	// following TaskStates: TASK_UNREACHABLE, TASK_DROPPED,
	// TASK_GONE, TASK_GONE_BY_OPERATOR, and TASK_UNKNOWN, and (2)
	// the framework will assume responsibility for managing
	// partitioned tasks that reregister with the master.
	//
	// Frameworks that enable this capability can define how they
	// would like to handle partitioned tasks. Frameworks will
	// receive TASK_UNREACHABLE for tasks on agents that are
	// partitioned from the master. If/when a partitioned agent
	// reregisters, tasks on the agent that were started by
	// PARTITION_AWARE frameworks will not killed.
	//
	// Without this capability, frameworks will receive TASK_LOST
	// for tasks on partitioned agents; such tasks will be killed by
	// Mesos when the agent reregisters (unless the master has
	// failed over).
	FrameworkInfo_Capability_PARTITION_AWARE FrameworkInfo_Capability_Type = 5
)

var FrameworkInfo_Capability_Type_name = map[int32]string{
	0: "UNKNOWN",
	1: "REVOCABLE_RESOURCES",
	2: "TASK_KILLING_STATE",
	3: "GPU_RESOURCES",
	4: "SHARED_RESOURCES",
	5: "PARTITION_AWARE",
}
var FrameworkInfo_Capability_Type_value = map[string]int32{
	"UNKNOWN":             0,
	"REVOCABLE_RESOURCES": 1,
	"TASK_KILLING_STATE":  2,
	"GPU_RESOURCES":       3,
	"SHARED_RESOURCES":    4,
	"PARTITION_AWARE":     5,
}

func (x FrameworkInfo_Capability_Type) Enum() *FrameworkInfo_Capability_Type {
	p := new(FrameworkInfo_Capability_Type)
	*p = x
	return p
}
func (x FrameworkInfo_Capability_Type) String() string {
	return proto.EnumName(FrameworkInfo_Capability_Type_name, int32(x))
}
func (x *FrameworkInfo_Capability_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(FrameworkInfo_Capability_Type_value, data, "FrameworkInfo_Capability_Type")
	if err != nil {
		return err
	}
	*x = FrameworkInfo_Capability_Type(value)
	return nil
}
func (FrameworkInfo_Capability_Type) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{13, 0, 0}
}

type HealthCheck_Type int32

const (
	HealthCheck_UNKNOWN HealthCheck_Type = 0
	HealthCheck_COMMAND HealthCheck_Type = 1
	HealthCheck_HTTP    HealthCheck_Type = 2
	HealthCheck_TCP     HealthCheck_Type = 3
)

var HealthCheck_Type_name = map[int32]string{
	0: "UNKNOWN",
	1: "COMMAND",
	2: "HTTP",
	3: "TCP",
}
var HealthCheck_Type_value = map[string]int32{
	"UNKNOWN": 0,
	"COMMAND": 1,
	"HTTP":    2,
	"TCP":     3,
}

func (x HealthCheck_Type) Enum() *HealthCheck_Type {
	p := new(HealthCheck_Type)
	*p = x
	return p
}
func (x HealthCheck_Type) String() string {
	return proto.EnumName(HealthCheck_Type_name, int32(x))
}
func (x *HealthCheck_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(HealthCheck_Type_value, data, "HealthCheck_Type")
	if err != nil {
		return err
	}
	*x = HealthCheck_Type(value)
	return nil
}
func (HealthCheck_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{14, 0} }

type ExecutorInfo_Type int32

const (
	ExecutorInfo_UNKNOWN ExecutorInfo_Type = 0
	// Mesos provides a simple built-in default executor that frameworks can
	// leverage to run shell commands and containers.
	//
	// NOTES:
	//
	// 1) `command` must not be set when using a default executor.
	//
	// 2) Default executor only accepts a *single* `LAUNCH` or `LAUNCH_GROUP`
	//    offer operation.
	ExecutorInfo_DEFAULT ExecutorInfo_Type = 1
	// For frameworks that need custom functionality to run tasks, a `CUSTOM`
	// executor can be used. Note that `command` must be set when using a
	// `CUSTOM` executor.
	ExecutorInfo_CUSTOM ExecutorInfo_Type = 2
)

var ExecutorInfo_Type_name = map[int32]string{
	0: "UNKNOWN",
	1: "DEFAULT",
	2: "CUSTOM",
}
var ExecutorInfo_Type_value = map[string]int32{
	"UNKNOWN": 0,
	"DEFAULT": 1,
	"CUSTOM":  2,
}

func (x ExecutorInfo_Type) Enum() *ExecutorInfo_Type {
	p := new(ExecutorInfo_Type)
	*p = x
	return p
}
func (x ExecutorInfo_Type) String() string {
	return proto.EnumName(ExecutorInfo_Type_name, int32(x))
}
func (x *ExecutorInfo_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(ExecutorInfo_Type_value, data, "ExecutorInfo_Type")
	if err != nil {
		return err
	}
	*x = ExecutorInfo_Type(value)
	return nil
}
func (ExecutorInfo_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{17, 0} }

type Value_Type int32

const (
	Value_SCALAR Value_Type = 0
	Value_RANGES Value_Type = 1
	Value_SET    Value_Type = 2
	Value_TEXT   Value_Type = 3
)

var Value_Type_name = map[int32]string{
	0: "SCALAR",
	1: "RANGES",
	2: "SET",
	3: "TEXT",
}
var Value_Type_value = map[string]int32{
	"SCALAR": 0,
	"RANGES": 1,
	"SET":    2,
	"TEXT":   3,
}

func (x Value_Type) Enum() *Value_Type {
	p := new(Value_Type)
	*p = x
	return p
}
func (x Value_Type) String() string {
	return proto.EnumName(Value_Type_name, int32(x))
}
func (x *Value_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Value_Type_value, data, "Value_Type")
	if err != nil {
		return err
	}
	*x = Value_Type(value)
	return nil
}
func (Value_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{20, 0} }

type Resource_DiskInfo_Source_Type int32

const (
	Resource_DiskInfo_Source_PATH  Resource_DiskInfo_Source_Type = 1
	Resource_DiskInfo_Source_MOUNT Resource_DiskInfo_Source_Type = 2
)

var Resource_DiskInfo_Source_Type_name = map[int32]string{
	1: "PATH",
	2: "MOUNT",
}
var Resource_DiskInfo_Source_Type_value = map[string]int32{
	"PATH":  1,
	"MOUNT": 2,
}

func (x Resource_DiskInfo_Source_Type) Enum() *Resource_DiskInfo_Source_Type {
	p := new(Resource_DiskInfo_Source_Type)
	*p = x
	return p
}
func (x Resource_DiskInfo_Source_Type) String() string {
	return proto.EnumName(Resource_DiskInfo_Source_Type_name, int32(x))
}
func (x *Resource_DiskInfo_Source_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Resource_DiskInfo_Source_Type_value, data, "Resource_DiskInfo_Source_Type")
	if err != nil {
		return err
	}
	*x = Resource_DiskInfo_Source_Type(value)
	return nil
}
func (Resource_DiskInfo_Source_Type) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{22, 1, 1, 0}
}

type Offer_Operation_Type int32

const (
	Offer_Operation_UNKNOWN      Offer_Operation_Type = 0
	Offer_Operation_LAUNCH       Offer_Operation_Type = 1
	Offer_Operation_LAUNCH_GROUP Offer_Operation_Type = 6
	Offer_Operation_RESERVE      Offer_Operation_Type = 2
	Offer_Operation_UNRESERVE    Offer_Operation_Type = 3
	Offer_Operation_CREATE       Offer_Operation_Type = 4
	Offer_Operation_DESTROY      Offer_Operation_Type = 5
)

var Offer_Operation_Type_name = map[int32]string{
	0: "UNKNOWN",
	1: "LAUNCH",
	6: "LAUNCH_GROUP",
	2: "RESERVE",
	3: "UNRESERVE",
	4: "CREATE",
	5: "DESTROY",
}
var Offer_Operation_Type_value = map[string]int32{
	"UNKNOWN":      0,
	"LAUNCH":       1,
	"LAUNCH_GROUP": 6,
	"RESERVE":      2,
	"UNRESERVE":    3,
	"CREATE":       4,
	"DESTROY":      5,
}

func (x Offer_Operation_Type) Enum() *Offer_Operation_Type {
	p := new(Offer_Operation_Type)
	*p = x
	return p
}
func (x Offer_Operation_Type) String() string {
	return proto.EnumName(Offer_Operation_Type_name, int32(x))
}
func (x *Offer_Operation_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Offer_Operation_Type_value, data, "Offer_Operation_Type")
	if err != nil {
		return err
	}
	*x = Offer_Operation_Type(value)
	return nil
}
func (Offer_Operation_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{33, 0, 0} }

// Describes the source of the task status update.
type TaskStatus_Source int32

const (
	TaskStatus_SOURCE_MASTER   TaskStatus_Source = 0
	TaskStatus_SOURCE_AGENT    TaskStatus_Source = 1
	TaskStatus_SOURCE_EXECUTOR TaskStatus_Source = 2
)

var TaskStatus_Source_name = map[int32]string{
	0: "SOURCE_MASTER",
	1: "SOURCE_AGENT",
	2: "SOURCE_EXECUTOR",
}
var TaskStatus_Source_value = map[string]int32{
	"SOURCE_MASTER":   0,
	"SOURCE_AGENT":    1,
	"SOURCE_EXECUTOR": 2,
}

func (x TaskStatus_Source) Enum() *TaskStatus_Source {
	p := new(TaskStatus_Source)
	*p = x
	return p
}
func (x TaskStatus_Source) String() string {
	return proto.EnumName(TaskStatus_Source_name, int32(x))
}
func (x *TaskStatus_Source) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(TaskStatus_Source_value, data, "TaskStatus_Source")
	if err != nil {
		return err
	}
	*x = TaskStatus_Source(value)
	return nil
}
func (TaskStatus_Source) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{38, 0} }

// Detailed reason for the task status update.
//
// TODO(bmahler): Differentiate between agent removal reasons
// (e.g. unhealthy vs. unregistered for maintenance).
type TaskStatus_Reason int32

const (
	// TODO(jieyu): The default value when a caller doesn't check for
	// presence is 0 and so ideally the 0 reason is not a valid one.
	// Since this is not used anywhere, consider removing this reason.
	TaskStatus_REASON_COMMAND_EXECUTOR_FAILED         TaskStatus_Reason = 0
	TaskStatus_REASON_CONTAINER_LAUNCH_FAILED         TaskStatus_Reason = 21
	TaskStatus_REASON_CONTAINER_LIMITATION            TaskStatus_Reason = 19
	TaskStatus_REASON_CONTAINER_LIMITATION_DISK       TaskStatus_Reason = 20
	TaskStatus_REASON_CONTAINER_LIMITATION_MEMORY     TaskStatus_Reason = 8
	TaskStatus_REASON_CONTAINER_PREEMPTED             TaskStatus_Reason = 17
	TaskStatus_REASON_CONTAINER_UPDATE_FAILED         TaskStatus_Reason = 22
	TaskStatus_REASON_EXECUTOR_REGISTRATION_TIMEOUT   TaskStatus_Reason = 23
	TaskStatus_REASON_EXECUTOR_REREGISTRATION_TIMEOUT TaskStatus_Reason = 24
	TaskStatus_REASON_EXECUTOR_TERMINATED             TaskStatus_Reason = 1
	TaskStatus_REASON_EXECUTOR_UNREGISTERED           TaskStatus_Reason = 2
	TaskStatus_REASON_FRAMEWORK_REMOVED               TaskStatus_Reason = 3
	TaskStatus_REASON_GC_ERROR                        TaskStatus_Reason = 4
	TaskStatus_REASON_INVALID_FRAMEWORKID             TaskStatus_Reason = 5
	TaskStatus_REASON_INVALID_OFFERS                  TaskStatus_Reason = 6
	TaskStatus_REASON_MASTER_DISCONNECTED             TaskStatus_Reason = 7
	TaskStatus_REASON_RECONCILIATION                  TaskStatus_Reason = 9
	TaskStatus_REASON_RESOURCES_UNKNOWN               TaskStatus_Reason = 18
	TaskStatus_REASON_AGENT_DISCONNECTED              TaskStatus_Reason = 10
	TaskStatus_REASON_AGENT_REMOVED                   TaskStatus_Reason = 11
	TaskStatus_REASON_AGENT_RESTARTED                 TaskStatus_Reason = 12
	TaskStatus_REASON_AGENT_UNKNOWN                   TaskStatus_Reason = 13
	TaskStatus_REASON_TASK_GROUP_INVALID              TaskStatus_Reason = 25
	TaskStatus_REASON_TASK_GROUP_UNAUTHORIZED         TaskStatus_Reason = 26
	TaskStatus_REASON_TASK_INVALID                    TaskStatus_Reason = 14
	TaskStatus_REASON_TASK_UNAUTHORIZED               TaskStatus_Reason = 15
	TaskStatus_REASON_TASK_UNKNOWN                    TaskStatus_Reason = 16
)

var TaskStatus_Reason_name = map[int32]string{
	0:  "REASON_COMMAND_EXECUTOR_FAILED",
	21: "REASON_CONTAINER_LAUNCH_FAILED",
	19: "REASON_CONTAINER_LIMITATION",
	20: "REASON_CONTAINER_LIMITATION_DISK",
	8:  "REASON_CONTAINER_LIMITATION_MEMORY",
	17: "REASON_CONTAINER_PREEMPTED",
	22: "REASON_CONTAINER_UPDATE_FAILED",
	23: "REASON_EXECUTOR_REGISTRATION_TIMEOUT",
	24: "REASON_EXECUTOR_REREGISTRATION_TIMEOUT",
	1:  "REASON_EXECUTOR_TERMINATED",
	2:  "REASON_EXECUTOR_UNREGISTERED",
	3:  "REASON_FRAMEWORK_REMOVED",
	4:  "REASON_GC_ERROR",
	5:  "REASON_INVALID_FRAMEWORKID",
	6:  "REASON_INVALID_OFFERS",
	7:  "REASON_MASTER_DISCONNECTED",
	9:  "REASON_RECONCILIATION",
	18: "REASON_RESOURCES_UNKNOWN",
	10: "REASON_AGENT_DISCONNECTED",
	11: "REASON_AGENT_REMOVED",
	12: "REASON_AGENT_RESTARTED",
	13: "REASON_AGENT_UNKNOWN",
	25: "REASON_TASK_GROUP_INVALID",
	26: "REASON_TASK_GROUP_UNAUTHORIZED",
	14: "REASON_TASK_INVALID",
	15: "REASON_TASK_UNAUTHORIZED",
	16: "REASON_TASK_UNKNOWN",
}
var TaskStatus_Reason_value = map[string]int32{
	"REASON_COMMAND_EXECUTOR_FAILED":         0,
	"REASON_CONTAINER_LAUNCH_FAILED":         21,
	"REASON_CONTAINER_LIMITATION":            19,
	"REASON_CONTAINER_LIMITATION_DISK":       20,
	"REASON_CONTAINER_LIMITATION_MEMORY":     8,
	"REASON_CONTAINER_PREEMPTED":             17,
	"REASON_CONTAINER_UPDATE_FAILED":         22,
	"REASON_EXECUTOR_REGISTRATION_TIMEOUT":   23,
	"REASON_EXECUTOR_REREGISTRATION_TIMEOUT": 24,
	"REASON_EXECUTOR_TERMINATED":             1,
	"REASON_EXECUTOR_UNREGISTERED":           2,
	"REASON_FRAMEWORK_REMOVED":               3,
	"REASON_GC_ERROR":                        4,
	"REASON_INVALID_FRAMEWORKID":             5,
	"REASON_INVALID_OFFERS":                  6,
	"REASON_MASTER_DISCONNECTED":             7,
	"REASON_RECONCILIATION":                  9,
	"REASON_RESOURCES_UNKNOWN":               18,
	"REASON_AGENT_DISCONNECTED":              10,
	"REASON_AGENT_REMOVED":                   11,
	"REASON_AGENT_RESTARTED":                 12,
	"REASON_AGENT_UNKNOWN":                   13,
	"REASON_TASK_GROUP_INVALID":              25,
	"REASON_TASK_GROUP_UNAUTHORIZED":         26,
	"REASON_TASK_INVALID":                    14,
	"REASON_TASK_UNAUTHORIZED":               15,
	"REASON_TASK_UNKNOWN":                    16,
}

func (x TaskStatus_Reason) Enum() *TaskStatus_Reason {
	p := new(TaskStatus_Reason)
	*p = x
	return p
}
func (x TaskStatus_Reason) String() string {
	return proto.EnumName(TaskStatus_Reason_name, int32(x))
}
func (x *TaskStatus_Reason) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(TaskStatus_Reason_value, data, "TaskStatus_Reason")
	if err != nil {
		return err
	}
	*x = TaskStatus_Reason(value)
	return nil
}
func (TaskStatus_Reason) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{38, 1} }

type Image_Type int32

const (
	Image_APPC   Image_Type = 1
	Image_DOCKER Image_Type = 2
)

var Image_Type_name = map[int32]string{
	1: "APPC",
	2: "DOCKER",
}
var Image_Type_value = map[string]int32{
	"APPC":   1,
	"DOCKER": 2,
}

func (x Image_Type) Enum() *Image_Type {
	p := new(Image_Type)
	*p = x
	return p
}
func (x Image_Type) String() string {
	return proto.EnumName(Image_Type_name, int32(x))
}
func (x *Image_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Image_Type_value, data, "Image_Type")
	if err != nil {
		return err
	}
	*x = Image_Type(value)
	return nil
}
func (Image_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{47, 0} }

type Volume_Mode int32

const (
	Volume_RW Volume_Mode = 1
	Volume_RO Volume_Mode = 2
)

var Volume_Mode_name = map[int32]string{
	1: "RW",
	2: "RO",
}
var Volume_Mode_value = map[string]int32{
	"RW": 1,
	"RO": 2,
}

func (x Volume_Mode) Enum() *Volume_Mode {
	p := new(Volume_Mode)
	*p = x
	return p
}
func (x Volume_Mode) String() string {
	return proto.EnumName(Volume_Mode_name, int32(x))
}
func (x *Volume_Mode) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Volume_Mode_value, data, "Volume_Mode")
	if err != nil {
		return err
	}
	*x = Volume_Mode(value)
	return nil
}
func (Volume_Mode) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{48, 0} }

type Volume_Source_Type int32

const (
	// This must be the first enum value in this list, to
	// ensure that if 'type' is not set, the default value
	// is UNKNOWN. This enables enum values to be added
	// in a backwards-compatible way. See: MESOS-4997.
	Volume_Source_UNKNOWN Volume_Source_Type = 0
	// TODO(gyliu513): Add HOST_PATH and IMAGE as volume source type.
	Volume_Source_DOCKER_VOLUME Volume_Source_Type = 1
	Volume_Source_SANDBOX_PATH  Volume_Source_Type = 2
)

var Volume_Source_Type_name = map[int32]string{
	0: "UNKNOWN",
	1: "DOCKER_VOLUME",
	2: "SANDBOX_PATH",
}
var Volume_Source_Type_value = map[string]int32{
	"UNKNOWN":       0,
	"DOCKER_VOLUME": 1,
	"SANDBOX_PATH":  2,
}

func (x Volume_Source_Type) Enum() *Volume_Source_Type {
	p := new(Volume_Source_Type)
	*p = x
	return p
}
func (x Volume_Source_Type) String() string {
	return proto.EnumName(Volume_Source_Type_name, int32(x))
}
func (x *Volume_Source_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Volume_Source_Type_value, data, "Volume_Source_Type")
	if err != nil {
		return err
	}
	*x = Volume_Source_Type(value)
	return nil
}
func (Volume_Source_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{48, 0, 0} }

type Volume_Source_SandboxPath_Type int32

const (
	Volume_Source_SandboxPath_UNKNOWN Volume_Source_SandboxPath_Type = 0
	Volume_Source_SandboxPath_SELF    Volume_Source_SandboxPath_Type = 1
	Volume_Source_SandboxPath_PARENT  Volume_Source_SandboxPath_Type = 2
)

var Volume_Source_SandboxPath_Type_name = map[int32]string{
	0: "UNKNOWN",
	1: "SELF",
	2: "PARENT",
}
var Volume_Source_SandboxPath_Type_value = map[string]int32{
	"UNKNOWN": 0,
	"SELF":    1,
	"PARENT":  2,
}

func (x Volume_Source_SandboxPath_Type) Enum() *Volume_Source_SandboxPath_Type {
	p := new(Volume_Source_SandboxPath_Type)
	*p = x
	return p
}
func (x Volume_Source_SandboxPath_Type) String() string {
	return proto.EnumName(Volume_Source_SandboxPath_Type_name, int32(x))
}
func (x *Volume_Source_SandboxPath_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Volume_Source_SandboxPath_Type_value, data, "Volume_Source_SandboxPath_Type")
	if err != nil {
		return err
	}
	*x = Volume_Source_SandboxPath_Type(value)
	return nil
}
func (Volume_Source_SandboxPath_Type) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{48, 0, 1, 0}
}

type NetworkInfo_Protocol int32

const (
	NetworkInfo_IPv4 NetworkInfo_Protocol = 1
	NetworkInfo_IPv6 NetworkInfo_Protocol = 2
)

var NetworkInfo_Protocol_name = map[int32]string{
	1: "IPv4",
	2: "IPv6",
}
var NetworkInfo_Protocol_value = map[string]int32{
	"IPv4": 1,
	"IPv6": 2,
}

func (x NetworkInfo_Protocol) Enum() *NetworkInfo_Protocol {
	p := new(NetworkInfo_Protocol)
	*p = x
	return p
}
func (x NetworkInfo_Protocol) String() string {
	return proto.EnumName(NetworkInfo_Protocol_name, int32(x))
}
func (x *NetworkInfo_Protocol) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(NetworkInfo_Protocol_value, data, "NetworkInfo_Protocol")
	if err != nil {
		return err
	}
	*x = NetworkInfo_Protocol(value)
	return nil
}
func (NetworkInfo_Protocol) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{49, 0} }

// We start the actual values at an offset(1000) because Protobuf 2
// uses the first value as the default one. Separating the default
// value from the real first value helps to disambiguate them. This
// is especially valuable for backward compatibility.
// See: MESOS-4997.
type CapabilityInfo_Capability int32

const (
	CapabilityInfo_UNKNOWN          CapabilityInfo_Capability = 0
	CapabilityInfo_CHOWN            CapabilityInfo_Capability = 1000
	CapabilityInfo_DAC_OVERRIDE     CapabilityInfo_Capability = 1001
	CapabilityInfo_DAC_READ_SEARCH  CapabilityInfo_Capability = 1002
	CapabilityInfo_FOWNER           CapabilityInfo_Capability = 1003
	CapabilityInfo_FSETID           CapabilityInfo_Capability = 1004
	CapabilityInfo_KILL             CapabilityInfo_Capability = 1005
	CapabilityInfo_SETGID           CapabilityInfo_Capability = 1006
	CapabilityInfo_SETUID           CapabilityInfo_Capability = 1007
	CapabilityInfo_SETPCAP          CapabilityInfo_Capability = 1008
	CapabilityInfo_LINUX_IMMUTABLE  CapabilityInfo_Capability = 1009
	CapabilityInfo_NET_BIND_SERVICE CapabilityInfo_Capability = 1010
	CapabilityInfo_NET_BROADCAST    CapabilityInfo_Capability = 1011
	CapabilityInfo_NET_ADMIN        CapabilityInfo_Capability = 1012
	CapabilityInfo_NET_RAW          CapabilityInfo_Capability = 1013
	CapabilityInfo_IPC_LOCK         CapabilityInfo_Capability = 1014
	CapabilityInfo_IPC_OWNER        CapabilityInfo_Capability = 1015
	CapabilityInfo_SYS_MODULE       CapabilityInfo_Capability = 1016
	CapabilityInfo_SYS_RAWIO        CapabilityInfo_Capability = 1017
	CapabilityInfo_SYS_CHROOT       CapabilityInfo_Capability = 1018
	CapabilityInfo_SYS_PTRACE       CapabilityInfo_Capability = 1019
	CapabilityInfo_SYS_PACCT        CapabilityInfo_Capability = 1020
	CapabilityInfo_SYS_ADMIN        CapabilityInfo_Capability = 1021
	CapabilityInfo_SYS_BOOT         CapabilityInfo_Capability = 1022
	CapabilityInfo_SYS_NICE         CapabilityInfo_Capability = 1023
	CapabilityInfo_SYS_RESOURCE     CapabilityInfo_Capability = 1024
	CapabilityInfo_SYS_TIME         CapabilityInfo_Capability = 1025
	CapabilityInfo_SYS_TTY_CONFIG   CapabilityInfo_Capability = 1026
	CapabilityInfo_MKNOD            CapabilityInfo_Capability = 1027
	CapabilityInfo_LEASE            CapabilityInfo_Capability = 1028
	CapabilityInfo_AUDIT_WRITE      CapabilityInfo_Capability = 1029
	CapabilityInfo_AUDIT_CONTROL    CapabilityInfo_Capability = 1030
	CapabilityInfo_SETFCAP          CapabilityInfo_Capability = 1031
	CapabilityInfo_MAC_OVERRIDE     CapabilityInfo_Capability = 1032
	CapabilityInfo_MAC_ADMIN        CapabilityInfo_Capability = 1033
	CapabilityInfo_SYSLOG           CapabilityInfo_Capability = 1034
	CapabilityInfo_WAKE_ALARM       CapabilityInfo_Capability = 1035
	CapabilityInfo_BLOCK_SUSPEND    CapabilityInfo_Capability = 1036
	CapabilityInfo_AUDIT_READ       CapabilityInfo_Capability = 1037
)

var CapabilityInfo_Capability_name = map[int32]string{
	0:    "UNKNOWN",
	1000: "CHOWN",
	1001: "DAC_OVERRIDE",
	1002: "DAC_READ_SEARCH",
	1003: "FOWNER",
	1004: "FSETID",
	1005: "KILL",
	1006: "SETGID",
	1007: "SETUID",
	1008: "SETPCAP",
	1009: "LINUX_IMMUTABLE",
	1010: "NET_BIND_SERVICE",
	1011: "NET_BROADCAST",
	1012: "NET_ADMIN",
	1013: "NET_RAW",
	1014: "IPC_LOCK",
	1015: "IPC_OWNER",
	1016: "SYS_MODULE",
	1017: "SYS_RAWIO",
	1018: "SYS_CHROOT",
	1019: "SYS_PTRACE",
	1020: "SYS_PACCT",
	1021: "SYS_ADMIN",
	1022: "SYS_BOOT",
	1023: "SYS_NICE",
	1024: "SYS_RESOURCE",
	1025: "SYS_TIME",
	1026: "SYS_TTY_CONFIG",
	1027: "MKNOD",
	1028: "LEASE",
	1029: "AUDIT_WRITE",
	1030: "AUDIT_CONTROL",
	1031: "SETFCAP",
	1032: "MAC_OVERRIDE",
	1033: "MAC_ADMIN",
	1034: "SYSLOG",
	1035: "WAKE_ALARM",
	1036: "BLOCK_SUSPEND",
	1037: "AUDIT_READ",
}
var CapabilityInfo_Capability_value = map[string]int32{
	"UNKNOWN":          0,
	"CHOWN":            1000,
	"DAC_OVERRIDE":     1001,
	"DAC_READ_SEARCH":  1002,
	"FOWNER":           1003,
	"FSETID":           1004,
	"KILL":             1005,
	"SETGID":           1006,
	"SETUID":           1007,
	"SETPCAP":          1008,
	"LINUX_IMMUTABLE":  1009,
	"NET_BIND_SERVICE": 1010,
	"NET_BROADCAST":    1011,
	"NET_ADMIN":        1012,
	"NET_RAW":          1013,
	"IPC_LOCK":         1014,
	"IPC_OWNER":        1015,
	"SYS_MODULE":       1016,
	"SYS_RAWIO":        1017,
	"SYS_CHROOT":       1018,
	"SYS_PTRACE":       1019,
	"SYS_PACCT":        1020,
	"SYS_ADMIN":        1021,
	"SYS_BOOT":         1022,
	"SYS_NICE":         1023,
	"SYS_RESOURCE":     1024,
	"SYS_TIME":         1025,
	"SYS_TTY_CONFIG":   1026,
	"MKNOD":            1027,
	"LEASE":            1028,
	"AUDIT_WRITE":      1029,
	"AUDIT_CONTROL":    1030,
	"SETFCAP":          1031,
	"MAC_OVERRIDE":     1032,
	"MAC_ADMIN":        1033,
	"SYSLOG":           1034,
	"WAKE_ALARM":       1035,
	"BLOCK_SUSPEND":    1036,
	"AUDIT_READ":       1037,
}

func (x CapabilityInfo_Capability) Enum() *CapabilityInfo_Capability {
	p := new(CapabilityInfo_Capability)
	*p = x
	return p
}
func (x CapabilityInfo_Capability) String() string {
	return proto.EnumName(CapabilityInfo_Capability_name, int32(x))
}
func (x *CapabilityInfo_Capability) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(CapabilityInfo_Capability_value, data, "CapabilityInfo_Capability")
	if err != nil {
		return err
	}
	*x = CapabilityInfo_Capability(value)
	return nil
}
func (CapabilityInfo_Capability) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{50, 0}
}

// All container implementation types.
type ContainerInfo_Type int32

const (
	ContainerInfo_DOCKER ContainerInfo_Type = 1
	ContainerInfo_MESOS  ContainerInfo_Type = 2
)

var ContainerInfo_Type_name = map[int32]string{
	1: "DOCKER",
	2: "MESOS",
}
var ContainerInfo_Type_value = map[string]int32{
	"DOCKER": 1,
	"MESOS":  2,
}

func (x ContainerInfo_Type) Enum() *ContainerInfo_Type {
	p := new(ContainerInfo_Type)
	*p = x
	return p
}
func (x ContainerInfo_Type) String() string {
	return proto.EnumName(ContainerInfo_Type_name, int32(x))
}
func (x *ContainerInfo_Type) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(ContainerInfo_Type_value, data, "ContainerInfo_Type")
	if err != nil {
		return err
	}
	*x = ContainerInfo_Type(value)
	return nil
}
func (ContainerInfo_Type) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{52, 0} }

// Network options.
type ContainerInfo_DockerInfo_Network int32

const (
	ContainerInfo_DockerInfo_HOST   ContainerInfo_DockerInfo_Network = 1
	ContainerInfo_DockerInfo_BRIDGE ContainerInfo_DockerInfo_Network = 2
	ContainerInfo_DockerInfo_NONE   ContainerInfo_DockerInfo_Network = 3
	ContainerInfo_DockerInfo_USER   ContainerInfo_DockerInfo_Network = 4
)

var ContainerInfo_DockerInfo_Network_name = map[int32]string{
	1: "HOST",
	2: "BRIDGE",
	3: "NONE",
	4: "USER",
}
var ContainerInfo_DockerInfo_Network_value = map[string]int32{
	"HOST":   1,
	"BRIDGE": 2,
	"NONE":   3,
	"USER":   4,
}

func (x ContainerInfo_DockerInfo_Network) Enum() *ContainerInfo_DockerInfo_Network {
	p := new(ContainerInfo_DockerInfo_Network)
	*p = x
	return p
}
func (x ContainerInfo_DockerInfo_Network) String() string {
	return proto.EnumName(ContainerInfo_DockerInfo_Network_name, int32(x))
}
func (x *ContainerInfo_DockerInfo_Network) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(ContainerInfo_DockerInfo_Network_value, data, "ContainerInfo_DockerInfo_Network")
	if err != nil {
		return err
	}
	*x = ContainerInfo_DockerInfo_Network(value)
	return nil
}
func (ContainerInfo_DockerInfo_Network) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{52, 0, 0}
}

type DiscoveryInfo_Visibility int32

const (
	DiscoveryInfo_FRAMEWORK DiscoveryInfo_Visibility = 0
	DiscoveryInfo_CLUSTER   DiscoveryInfo_Visibility = 1
	DiscoveryInfo_EXTERNAL  DiscoveryInfo_Visibility = 2
)

var DiscoveryInfo_Visibility_name = map[int32]string{
	0: "FRAMEWORK",
	1: "CLUSTER",
	2: "EXTERNAL",
}
var DiscoveryInfo_Visibility_value = map[string]int32{
	"FRAMEWORK": 0,
	"CLUSTER":   1,
	"EXTERNAL":  2,
}

func (x DiscoveryInfo_Visibility) Enum() *DiscoveryInfo_Visibility {
	p := new(DiscoveryInfo_Visibility)
	*p = x
	return p
}
func (x DiscoveryInfo_Visibility) String() string {
	return proto.EnumName(DiscoveryInfo_Visibility_name, int32(x))
}
func (x *DiscoveryInfo_Visibility) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(DiscoveryInfo_Visibility_value, data, "DiscoveryInfo_Visibility")
	if err != nil {
		return err
	}
	*x = DiscoveryInfo_Visibility(value)
	return nil
}
func (DiscoveryInfo_Visibility) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{59, 0}
}

// *
// A unique ID assigned to a framework. A framework can reuse this ID
// in order to do failover (see MesosSchedulerDriver).
type FrameworkID struct {
	Value            *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *FrameworkID) Reset()                    { *m = FrameworkID{} }
func (m *FrameworkID) String() string            { return proto.CompactTextString(m) }
func (*FrameworkID) ProtoMessage()               {}
func (*FrameworkID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *FrameworkID) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// A unique ID assigned to an offer.
type OfferID struct {
	Value            *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *OfferID) Reset()                    { *m = OfferID{} }
func (m *OfferID) String() string            { return proto.CompactTextString(m) }
func (*OfferID) ProtoMessage()               {}
func (*OfferID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *OfferID) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// A unique ID assigned to an agent. Currently, an agent gets a new ID
// whenever it (re)registers with Mesos. Framework writers shouldn't
// assume any binding between an agent ID and and a hostname.
type AgentID struct {
	Value            *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *AgentID) Reset()                    { *m = AgentID{} }
func (m *AgentID) String() string            { return proto.CompactTextString(m) }
func (*AgentID) ProtoMessage()               {}
func (*AgentID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *AgentID) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// A framework-generated ID to distinguish a task. The ID must remain
// unique while the task is active. A framework can reuse an ID _only_
// if the previous task with the same ID has reached a terminal state
// (e.g., TASK_FINISHED, TASK_LOST, TASK_KILLED, etc.). However,
// reusing task IDs is strongly discouraged (MESOS-2198).
type TaskID struct {
	Value            *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *TaskID) Reset()                    { *m = TaskID{} }
func (m *TaskID) String() string            { return proto.CompactTextString(m) }
func (*TaskID) ProtoMessage()               {}
func (*TaskID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{3} }

func (m *TaskID) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// A framework-generated ID to distinguish an executor. Only one
// executor with the same ID can be active on the same agent at a
// time. However, reusing executor IDs is discouraged.
type ExecutorID struct {
	Value            *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *ExecutorID) Reset()                    { *m = ExecutorID{} }
func (m *ExecutorID) String() string            { return proto.CompactTextString(m) }
func (*ExecutorID) ProtoMessage()               {}
func (*ExecutorID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{4} }

func (m *ExecutorID) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// ID used to uniquely identify a container. If the `parent` is not
// specified, the ID is a UUID generated by the agent to uniquely
// identify the container of an executor run. If the `parent` field is
// specified, it represents a nested container.
type ContainerID struct {
	Value            *string      `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	Parent           *ContainerID `protobuf:"bytes,2,opt,name=parent" json:"parent,omitempty"`
	XXX_unrecognized []byte       `json:"-"`
}

func (m *ContainerID) Reset()                    { *m = ContainerID{} }
func (m *ContainerID) String() string            { return proto.CompactTextString(m) }
func (*ContainerID) ProtoMessage()               {}
func (*ContainerID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{5} }

func (m *ContainerID) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

func (m *ContainerID) GetParent() *ContainerID {
	if m != nil {
		return m.Parent
	}
	return nil
}

// *
// Represents time since the epoch, in nanoseconds.
type TimeInfo struct {
	Nanoseconds      *int64 `protobuf:"varint,1,req,name=nanoseconds" json:"nanoseconds,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *TimeInfo) Reset()                    { *m = TimeInfo{} }
func (m *TimeInfo) String() string            { return proto.CompactTextString(m) }
func (*TimeInfo) ProtoMessage()               {}
func (*TimeInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{6} }

func (m *TimeInfo) GetNanoseconds() int64 {
	if m != nil && m.Nanoseconds != nil {
		return *m.Nanoseconds
	}
	return 0
}

// *
// Represents duration in nanoseconds.
type DurationInfo struct {
	Nanoseconds      *int64 `protobuf:"varint,1,req,name=nanoseconds" json:"nanoseconds,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *DurationInfo) Reset()                    { *m = DurationInfo{} }
func (m *DurationInfo) String() string            { return proto.CompactTextString(m) }
func (*DurationInfo) ProtoMessage()               {}
func (*DurationInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{7} }

func (m *DurationInfo) GetNanoseconds() int64 {
	if m != nil && m.Nanoseconds != nil {
		return *m.Nanoseconds
	}
	return 0
}

// *
// A network address.
//
// TODO(bmahler): Use this more widely.
type Address struct {
	// May contain a hostname, IP address, or both.
	Hostname         *string `protobuf:"bytes,1,opt,name=hostname" json:"hostname,omitempty"`
	Ip               *string `protobuf:"bytes,2,opt,name=ip" json:"ip,omitempty"`
	Port             *int32  `protobuf:"varint,3,req,name=port" json:"port,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Address) Reset()                    { *m = Address{} }
func (m *Address) String() string            { return proto.CompactTextString(m) }
func (*Address) ProtoMessage()               {}
func (*Address) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{8} }

func (m *Address) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *Address) GetIp() string {
	if m != nil && m.Ip != nil {
		return *m.Ip
	}
	return ""
}

func (m *Address) GetPort() int32 {
	if m != nil && m.Port != nil {
		return *m.Port
	}
	return 0
}

// *
// Represents a URL.
type URL struct {
	Scheme           *string      `protobuf:"bytes,1,req,name=scheme" json:"scheme,omitempty"`
	Address          *Address     `protobuf:"bytes,2,req,name=address" json:"address,omitempty"`
	Path             *string      `protobuf:"bytes,3,opt,name=path" json:"path,omitempty"`
	Query            []*Parameter `protobuf:"bytes,4,rep,name=query" json:"query,omitempty"`
	Fragment         *string      `protobuf:"bytes,5,opt,name=fragment" json:"fragment,omitempty"`
	XXX_unrecognized []byte       `json:"-"`
}

func (m *URL) Reset()                    { *m = URL{} }
func (m *URL) String() string            { return proto.CompactTextString(m) }
func (*URL) ProtoMessage()               {}
func (*URL) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{9} }

func (m *URL) GetScheme() string {
	if m != nil && m.Scheme != nil {
		return *m.Scheme
	}
	return ""
}

func (m *URL) GetAddress() *Address {
	if m != nil {
		return m.Address
	}
	return nil
}

func (m *URL) GetPath() string {
	if m != nil && m.Path != nil {
		return *m.Path
	}
	return ""
}

func (m *URL) GetQuery() []*Parameter {
	if m != nil {
		return m.Query
	}
	return nil
}

func (m *URL) GetFragment() string {
	if m != nil && m.Fragment != nil {
		return *m.Fragment
	}
	return ""
}

// *
// Represents an interval, from a given start time over a given duration.
// This interval pertains to an unavailability event, such as maintenance,
// and is not a generic interval.
type Unavailability struct {
	Start *TimeInfo `protobuf:"bytes,1,req,name=start" json:"start,omitempty"`
	// When added to `start`, this represents the end of the interval.
	// If unspecified, the duration is assumed to be infinite.
	Duration         *DurationInfo `protobuf:"bytes,2,opt,name=duration" json:"duration,omitempty"`
	XXX_unrecognized []byte        `json:"-"`
}

func (m *Unavailability) Reset()                    { *m = Unavailability{} }
func (m *Unavailability) String() string            { return proto.CompactTextString(m) }
func (*Unavailability) ProtoMessage()               {}
func (*Unavailability) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{10} }

func (m *Unavailability) GetStart() *TimeInfo {
	if m != nil {
		return m.Start
	}
	return nil
}

func (m *Unavailability) GetDuration() *DurationInfo {
	if m != nil {
		return m.Duration
	}
	return nil
}

// *
// Represents a single machine, which may hold one or more agents.
//
// NOTE: In order to match an agent to a machine, both the `hostname` and
// `ip` must match the values advertised by the agent to the master.
// Hostname is not case-sensitive.
type MachineID struct {
	Hostname         *string `protobuf:"bytes,1,opt,name=hostname" json:"hostname,omitempty"`
	Ip               *string `protobuf:"bytes,2,opt,name=ip" json:"ip,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *MachineID) Reset()                    { *m = MachineID{} }
func (m *MachineID) String() string            { return proto.CompactTextString(m) }
func (*MachineID) ProtoMessage()               {}
func (*MachineID) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{11} }

func (m *MachineID) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *MachineID) GetIp() string {
	if m != nil && m.Ip != nil {
		return *m.Ip
	}
	return ""
}

// *
// Holds information about a single machine, its `mode`, and any other
// relevant information which may affect the behavior of the machine.
type MachineInfo struct {
	Id   *MachineID        `protobuf:"bytes,1,req,name=id" json:"id,omitempty"`
	Mode *MachineInfo_Mode `protobuf:"varint,2,opt,name=mode,enum=mesos.v1.MachineInfo_Mode" json:"mode,omitempty"`
	// Signifies that the machine may be unavailable during the given interval.
	// See comments in `Unavailability` and for the `unavailability` fields
	// in `Offer` and `InverseOffer` for more information.
	Unavailability   *Unavailability `protobuf:"bytes,3,opt,name=unavailability" json:"unavailability,omitempty"`
	XXX_unrecognized []byte          `json:"-"`
}

func (m *MachineInfo) Reset()                    { *m = MachineInfo{} }
func (m *MachineInfo) String() string            { return proto.CompactTextString(m) }
func (*MachineInfo) ProtoMessage()               {}
func (*MachineInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{12} }

func (m *MachineInfo) GetId() *MachineID {
	if m != nil {
		return m.Id
	}
	return nil
}

func (m *MachineInfo) GetMode() MachineInfo_Mode {
	if m != nil && m.Mode != nil {
		return *m.Mode
	}
	return MachineInfo_UP
}

func (m *MachineInfo) GetUnavailability() *Unavailability {
	if m != nil {
		return m.Unavailability
	}
	return nil
}

// *
// Describes a framework.
type FrameworkInfo struct {
	// Used to determine the Unix user that an executor or task should be
	// launched as.
	//
	// When using the MesosSchedulerDriver, if the field is set to an
	// empty string, it will automagically set it to the current user.
	//
	// When using the HTTP Scheduler API, the user has to be set
	// explicitly.
	User *string `protobuf:"bytes,1,req,name=user" json:"user,omitempty"`
	// Name of the framework that shows up in the Mesos Web UI.
	Name *string `protobuf:"bytes,2,req,name=name" json:"name,omitempty"`
	// Note that 'id' is only available after a framework has
	// registered, however, it is included here in order to facilitate
	// scheduler failover (i.e., if it is set then the
	// MesosSchedulerDriver expects the scheduler is performing
	// failover).
	Id *FrameworkID `protobuf:"bytes,3,opt,name=id" json:"id,omitempty"`
	// The amount of time (in seconds) that the master will wait for the
	// scheduler to failover before it tears down the framework by
	// killing all its tasks/executors. This should be non-zero if a
	// framework expects to reconnect after a failure and not lose its
	// tasks/executors.
	//
	// NOTE: To avoid accidental destruction of tasks, production
	// frameworks typically set this to a large value (e.g., 1 week).
	FailoverTimeout *float64 `protobuf:"fixed64,4,opt,name=failover_timeout,json=failoverTimeout,def=0" json:"failover_timeout,omitempty"`
	// If set, agents running tasks started by this framework will write
	// the framework pid, executor pids and status updates to disk. If
	// the agent exits (e.g., due to a crash or as part of upgrading
	// Mesos), this checkpointed data allows the restarted agent to
	// reconnect to executors that were started by the old instance of
	// the agent. Enabling checkpointing improves fault tolerance, at
	// the cost of a (usually small) increase in disk I/O.
	Checkpoint *bool `protobuf:"varint,5,opt,name=checkpoint,def=0" json:"checkpoint,omitempty"`
	// Used to group frameworks for allocation decisions, depending on
	// the allocation policy being used.
	Role *string `protobuf:"bytes,6,opt,name=role,def=*" json:"role,omitempty"`
	// Used to indicate the current host from which the scheduler is
	// registered in the Mesos Web UI. If set to an empty string Mesos
	// will automagically set it to the current hostname if one is
	// available.
	Hostname *string `protobuf:"bytes,7,opt,name=hostname" json:"hostname,omitempty"`
	// This field should match the credential's principal the framework
	// uses for authentication. This field is used for framework API
	// rate limiting and dynamic reservations. It should be set even
	// if authentication is not enabled if these features are desired.
	Principal *string `protobuf:"bytes,8,opt,name=principal" json:"principal,omitempty"`
	// This field allows a framework to advertise its web UI, so that
	// the Mesos web UI can link to it. It is expected to be a full URL,
	// for example http://my-scheduler.example.com:8080/.
	WebuiUrl *string `protobuf:"bytes,9,opt,name=webui_url,json=webuiUrl" json:"webui_url,omitempty"`
	// This field allows a framework to advertise its set of
	// capabilities (e.g., ability to receive offers for revocable
	// resources).
	Capabilities []*FrameworkInfo_Capability `protobuf:"bytes,10,rep,name=capabilities" json:"capabilities,omitempty"`
	// Labels are free-form key value pairs supplied by the framework
	// scheduler (e.g., to describe additional functionality offered by
	// the framework). These labels are not interpreted by Mesos itself.
	// Labels should not contain duplicate key-value pairs.
	Labels           *Labels `protobuf:"bytes,11,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *FrameworkInfo) Reset()                    { *m = FrameworkInfo{} }
func (m *FrameworkInfo) String() string            { return proto.CompactTextString(m) }
func (*FrameworkInfo) ProtoMessage()               {}
func (*FrameworkInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{13} }

const Default_FrameworkInfo_FailoverTimeout float64 = 0
const Default_FrameworkInfo_Checkpoint bool = false
const Default_FrameworkInfo_Role string = "*"

func (m *FrameworkInfo) GetUser() string {
	if m != nil && m.User != nil {
		return *m.User
	}
	return ""
}

func (m *FrameworkInfo) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *FrameworkInfo) GetId() *FrameworkID {
	if m != nil {
		return m.Id
	}
	return nil
}

func (m *FrameworkInfo) GetFailoverTimeout() float64 {
	if m != nil && m.FailoverTimeout != nil {
		return *m.FailoverTimeout
	}
	return Default_FrameworkInfo_FailoverTimeout
}

func (m *FrameworkInfo) GetCheckpoint() bool {
	if m != nil && m.Checkpoint != nil {
		return *m.Checkpoint
	}
	return Default_FrameworkInfo_Checkpoint
}

func (m *FrameworkInfo) GetRole() string {
	if m != nil && m.Role != nil {
		return *m.Role
	}
	return Default_FrameworkInfo_Role
}

func (m *FrameworkInfo) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *FrameworkInfo) GetPrincipal() string {
	if m != nil && m.Principal != nil {
		return *m.Principal
	}
	return ""
}

func (m *FrameworkInfo) GetWebuiUrl() string {
	if m != nil && m.WebuiUrl != nil {
		return *m.WebuiUrl
	}
	return ""
}

func (m *FrameworkInfo) GetCapabilities() []*FrameworkInfo_Capability {
	if m != nil {
		return m.Capabilities
	}
	return nil
}

func (m *FrameworkInfo) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

type FrameworkInfo_Capability struct {
	// Enum fields should be optional, see: MESOS-4997.
	Type             *FrameworkInfo_Capability_Type `protobuf:"varint,1,opt,name=type,enum=mesos.v1.FrameworkInfo_Capability_Type" json:"type,omitempty"`
	XXX_unrecognized []byte                         `json:"-"`
}

func (m *FrameworkInfo_Capability) Reset()                    { *m = FrameworkInfo_Capability{} }
func (m *FrameworkInfo_Capability) String() string            { return proto.CompactTextString(m) }
func (*FrameworkInfo_Capability) ProtoMessage()               {}
func (*FrameworkInfo_Capability) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{13, 0} }

func (m *FrameworkInfo_Capability) GetType() FrameworkInfo_Capability_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return FrameworkInfo_Capability_UNKNOWN
}

// *
// Describes a health check for a task or executor (or any arbitrary
// process/command). A type is picked by specifying one of the
// optional fields. Specifying more than one type is an error.
type HealthCheck struct {
	// Amount of time to wait until starting the health checks.
	DelaySeconds *float64 `protobuf:"fixed64,2,opt,name=delay_seconds,json=delaySeconds,def=15" json:"delay_seconds,omitempty"`
	// Interval between health checks.
	IntervalSeconds *float64 `protobuf:"fixed64,3,opt,name=interval_seconds,json=intervalSeconds,def=10" json:"interval_seconds,omitempty"`
	// Amount of time to wait for the health check to complete.
	TimeoutSeconds *float64 `protobuf:"fixed64,4,opt,name=timeout_seconds,json=timeoutSeconds,def=20" json:"timeout_seconds,omitempty"`
	// Number of consecutive failures until signaling kill task.
	ConsecutiveFailures *uint32 `protobuf:"varint,5,opt,name=consecutive_failures,json=consecutiveFailures,def=3" json:"consecutive_failures,omitempty"`
	// Amount of time to allow failed health checks since launch.
	GracePeriodSeconds *float64 `protobuf:"fixed64,6,opt,name=grace_period_seconds,json=gracePeriodSeconds,def=10" json:"grace_period_seconds,omitempty"`
	// The type of health check.
	Type *HealthCheck_Type `protobuf:"varint,8,opt,name=type,enum=mesos.v1.HealthCheck_Type" json:"type,omitempty"`
	// Command health check.
	Command *CommandInfo `protobuf:"bytes,7,opt,name=command" json:"command,omitempty"`
	// HTTP health check.
	Http *HealthCheck_HTTPCheckInfo `protobuf:"bytes,1,opt,name=http" json:"http,omitempty"`
	// TCP health check.
	Tcp              *HealthCheck_TCPCheckInfo `protobuf:"bytes,9,opt,name=tcp" json:"tcp,omitempty"`
	XXX_unrecognized []byte                    `json:"-"`
}

func (m *HealthCheck) Reset()                    { *m = HealthCheck{} }
func (m *HealthCheck) String() string            { return proto.CompactTextString(m) }
func (*HealthCheck) ProtoMessage()               {}
func (*HealthCheck) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{14} }

const Default_HealthCheck_DelaySeconds float64 = 15
const Default_HealthCheck_IntervalSeconds float64 = 10
const Default_HealthCheck_TimeoutSeconds float64 = 20
const Default_HealthCheck_ConsecutiveFailures uint32 = 3
const Default_HealthCheck_GracePeriodSeconds float64 = 10

func (m *HealthCheck) GetDelaySeconds() float64 {
	if m != nil && m.DelaySeconds != nil {
		return *m.DelaySeconds
	}
	return Default_HealthCheck_DelaySeconds
}

func (m *HealthCheck) GetIntervalSeconds() float64 {
	if m != nil && m.IntervalSeconds != nil {
		return *m.IntervalSeconds
	}
	return Default_HealthCheck_IntervalSeconds
}

func (m *HealthCheck) GetTimeoutSeconds() float64 {
	if m != nil && m.TimeoutSeconds != nil {
		return *m.TimeoutSeconds
	}
	return Default_HealthCheck_TimeoutSeconds
}

func (m *HealthCheck) GetConsecutiveFailures() uint32 {
	if m != nil && m.ConsecutiveFailures != nil {
		return *m.ConsecutiveFailures
	}
	return Default_HealthCheck_ConsecutiveFailures
}

func (m *HealthCheck) GetGracePeriodSeconds() float64 {
	if m != nil && m.GracePeriodSeconds != nil {
		return *m.GracePeriodSeconds
	}
	return Default_HealthCheck_GracePeriodSeconds
}

func (m *HealthCheck) GetType() HealthCheck_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return HealthCheck_UNKNOWN
}

func (m *HealthCheck) GetCommand() *CommandInfo {
	if m != nil {
		return m.Command
	}
	return nil
}

func (m *HealthCheck) GetHttp() *HealthCheck_HTTPCheckInfo {
	if m != nil {
		return m.Http
	}
	return nil
}

func (m *HealthCheck) GetTcp() *HealthCheck_TCPCheckInfo {
	if m != nil {
		return m.Tcp
	}
	return nil
}

// Describes an HTTP health check. Sends a GET request to
// scheme://<host>:port/path. Note that <host> is not configurable and is
// resolved automatically, in most cases to 127.0.0.1. Default executors
// treat return codes between 200 and 399 as success; custom executors
// may employ a different strategy, e.g. leveraging the `statuses` field.
type HealthCheck_HTTPCheckInfo struct {
	// Currently "http" and "https" are supported.
	Scheme *string `protobuf:"bytes,3,opt,name=scheme" json:"scheme,omitempty"`
	// Port to send the HTTP request.
	Port *uint32 `protobuf:"varint,1,req,name=port" json:"port,omitempty"`
	// HTTP request path.
	Path *string `protobuf:"bytes,2,opt,name=path" json:"path,omitempty"`
	// NOTE: It is up to the custom executor to interpret and act on this
	// field. Setting this field has no effect on the default executors.
	//
	// TODO(haosdent): Deprecate this field when we add better support for
	// success and possibly failure statuses, e.g. ranges of success and
	// failure statuses.
	Statuses         []uint32 `protobuf:"varint,4,rep,name=statuses" json:"statuses,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *HealthCheck_HTTPCheckInfo) Reset()                    { *m = HealthCheck_HTTPCheckInfo{} }
func (m *HealthCheck_HTTPCheckInfo) String() string            { return proto.CompactTextString(m) }
func (*HealthCheck_HTTPCheckInfo) ProtoMessage()               {}
func (*HealthCheck_HTTPCheckInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{14, 0} }

func (m *HealthCheck_HTTPCheckInfo) GetScheme() string {
	if m != nil && m.Scheme != nil {
		return *m.Scheme
	}
	return ""
}

func (m *HealthCheck_HTTPCheckInfo) GetPort() uint32 {
	if m != nil && m.Port != nil {
		return *m.Port
	}
	return 0
}

func (m *HealthCheck_HTTPCheckInfo) GetPath() string {
	if m != nil && m.Path != nil {
		return *m.Path
	}
	return ""
}

func (m *HealthCheck_HTTPCheckInfo) GetStatuses() []uint32 {
	if m != nil {
		return m.Statuses
	}
	return nil
}

// Describes a TCP health check, i.e. based on establishing
// a TCP connection to the specified port.
type HealthCheck_TCPCheckInfo struct {
	// Port expected to be open.
	Port             *uint32 `protobuf:"varint,1,req,name=port" json:"port,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *HealthCheck_TCPCheckInfo) Reset()                    { *m = HealthCheck_TCPCheckInfo{} }
func (m *HealthCheck_TCPCheckInfo) String() string            { return proto.CompactTextString(m) }
func (*HealthCheck_TCPCheckInfo) ProtoMessage()               {}
func (*HealthCheck_TCPCheckInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{14, 1} }

func (m *HealthCheck_TCPCheckInfo) GetPort() uint32 {
	if m != nil && m.Port != nil {
		return *m.Port
	}
	return 0
}

// *
// Describes a kill policy for a task. Currently does not express
// different policies (e.g. hitting HTTP endpoints), only controls
// how long to wait between graceful and forcible task kill:
//
//     graceful kill --------------> forcible kill
//                    grace_period
//
// Kill policies are best-effort, because machine failures / forcible
// terminations may occur.
//
// NOTE: For executor-less command-based tasks, the kill is performed
// via sending a signal to the task process: SIGTERM for the graceful
// kill and SIGKILL for the forcible kill. For the docker executor-less
// tasks the grace period is passed to 'docker stop --time'.
type KillPolicy struct {
	// The grace period specifies how long to wait before forcibly
	// killing the task. It is recommended to attempt to gracefully
	// kill the task (and send TASK_KILLING) to indicate that the
	// graceful kill is in progress. Once the grace period elapses,
	// if the task has not terminated, a forcible kill should occur.
	// The task should not assume that it will always be allotted
	// the full grace period. For example, the executor may be
	// shutdown more quickly by the agent, or failures / forcible
	// terminations may occur.
	GracePeriod      *DurationInfo `protobuf:"bytes,1,opt,name=grace_period,json=gracePeriod" json:"grace_period,omitempty"`
	XXX_unrecognized []byte        `json:"-"`
}

func (m *KillPolicy) Reset()                    { *m = KillPolicy{} }
func (m *KillPolicy) String() string            { return proto.CompactTextString(m) }
func (*KillPolicy) ProtoMessage()               {}
func (*KillPolicy) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{15} }

func (m *KillPolicy) GetGracePeriod() *DurationInfo {
	if m != nil {
		return m.GracePeriod
	}
	return nil
}

// *
// Describes a command, executed via: '/bin/sh -c value'. Any URIs specified
// are fetched before executing the command.  If the executable field for an
// uri is set, executable file permission is set on the downloaded file.
// Otherwise, if the downloaded file has a recognized archive extension
// (currently [compressed] tar and zip) it is extracted into the executor's
// working directory. This extraction can be disabled by setting `extract` to
// false. In addition, any environment variables are set before executing
// the command (so they can be used to "parameterize" your command).
type CommandInfo struct {
	Uris        []*CommandInfo_URI `protobuf:"bytes,1,rep,name=uris" json:"uris,omitempty"`
	Environment *Environment       `protobuf:"bytes,2,opt,name=environment" json:"environment,omitempty"`
	// There are two ways to specify the command:
	// 1) If 'shell == true', the command will be launched via shell
	// 		(i.e., /bin/sh -c 'value'). The 'value' specified will be
	// 		treated as the shell command. The 'arguments' will be ignored.
	// 2) If 'shell == false', the command will be launched by passing
	// 		arguments to an executable. The 'value' specified will be
	// 		treated as the filename of the executable. The 'arguments'
	// 		will be treated as the arguments to the executable. This is
	// 		similar to how POSIX exec families launch processes (i.e.,
	// 		execlp(value, arguments(0), arguments(1), ...)).
	// NOTE: The field 'value' is changed from 'required' to 'optional'
	// in 0.20.0. It will only cause issues if a new framework is
	// connecting to an old master.
	Shell     *bool    `protobuf:"varint,6,opt,name=shell,def=1" json:"shell,omitempty"`
	Value     *string  `protobuf:"bytes,3,opt,name=value" json:"value,omitempty"`
	Arguments []string `protobuf:"bytes,7,rep,name=arguments" json:"arguments,omitempty"`
	// Enables executor and tasks to run as a specific user. If the user
	// field is present both in FrameworkInfo and here, the CommandInfo
	// user value takes precedence.
	User             *string `protobuf:"bytes,5,opt,name=user" json:"user,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *CommandInfo) Reset()                    { *m = CommandInfo{} }
func (m *CommandInfo) String() string            { return proto.CompactTextString(m) }
func (*CommandInfo) ProtoMessage()               {}
func (*CommandInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{16} }

const Default_CommandInfo_Shell bool = true

func (m *CommandInfo) GetUris() []*CommandInfo_URI {
	if m != nil {
		return m.Uris
	}
	return nil
}

func (m *CommandInfo) GetEnvironment() *Environment {
	if m != nil {
		return m.Environment
	}
	return nil
}

func (m *CommandInfo) GetShell() bool {
	if m != nil && m.Shell != nil {
		return *m.Shell
	}
	return Default_CommandInfo_Shell
}

func (m *CommandInfo) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

func (m *CommandInfo) GetArguments() []string {
	if m != nil {
		return m.Arguments
	}
	return nil
}

func (m *CommandInfo) GetUser() string {
	if m != nil && m.User != nil {
		return *m.User
	}
	return ""
}

type CommandInfo_URI struct {
	Value      *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	Executable *bool   `protobuf:"varint,2,opt,name=executable" json:"executable,omitempty"`
	// In case the fetched file is recognized as an archive, extract
	// its contents into the sandbox. Note that a cached archive is
	// not copied from the cache to the sandbox in case extraction
	// originates from an archive in the cache.
	Extract *bool `protobuf:"varint,3,opt,name=extract,def=1" json:"extract,omitempty"`
	// If this field is "true", the fetcher cache will be used. If not,
	// fetching bypasses the cache and downloads directly into the
	// sandbox directory, no matter whether a suitable cache file is
	// available or not. The former directs the fetcher to download to
	// the file cache, then copy from there to the sandbox. Subsequent
	// fetch attempts with the same URI will omit downloading and copy
	// from the cache as long as the file is resident there. Cache files
	// may get evicted at any time, which then leads to renewed
	// downloading. See also "docs/fetcher.md" and
	// "docs/fetcher-cache-internals.md".
	Cache *bool `protobuf:"varint,4,opt,name=cache" json:"cache,omitempty"`
	// The fetcher's default behavior is to use the URI string's basename to
	// name the local copy. If this field is provided, the local copy will be
	// named with its value instead. If there is a directory component (which
	// must be a relative path), the local copy will be stored in that
	// subdirectory inside the sandbox.
	OutputFile       *string `protobuf:"bytes,5,opt,name=output_file,json=outputFile" json:"output_file,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *CommandInfo_URI) Reset()                    { *m = CommandInfo_URI{} }
func (m *CommandInfo_URI) String() string            { return proto.CompactTextString(m) }
func (*CommandInfo_URI) ProtoMessage()               {}
func (*CommandInfo_URI) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{16, 0} }

const Default_CommandInfo_URI_Extract bool = true

func (m *CommandInfo_URI) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

func (m *CommandInfo_URI) GetExecutable() bool {
	if m != nil && m.Executable != nil {
		return *m.Executable
	}
	return false
}

func (m *CommandInfo_URI) GetExtract() bool {
	if m != nil && m.Extract != nil {
		return *m.Extract
	}
	return Default_CommandInfo_URI_Extract
}

func (m *CommandInfo_URI) GetCache() bool {
	if m != nil && m.Cache != nil {
		return *m.Cache
	}
	return false
}

func (m *CommandInfo_URI) GetOutputFile() string {
	if m != nil && m.OutputFile != nil {
		return *m.OutputFile
	}
	return ""
}

// *
// Describes information about an executor.
type ExecutorInfo struct {
	// For backwards compatibility, if this field is not set when using `LAUNCH`
	// offer operation, Mesos will infer the type by checking if `command` is
	// set (`CUSTOM`) or unset (`DEFAULT`). `type` must be set when using
	// `LAUNCH_GROUP` offer operation.
	//
	// TODO(vinod): Add support for explicitly setting `type` to `DEFAULT `
	// in `LAUNCH` offer operation.
	Type        *ExecutorInfo_Type `protobuf:"varint,15,opt,name=type,enum=mesos.v1.ExecutorInfo_Type" json:"type,omitempty"`
	ExecutorId  *ExecutorID        `protobuf:"bytes,1,req,name=executor_id,json=executorId" json:"executor_id,omitempty"`
	FrameworkId *FrameworkID       `protobuf:"bytes,8,opt,name=framework_id,json=frameworkId" json:"framework_id,omitempty"`
	Command     *CommandInfo       `protobuf:"bytes,7,opt,name=command" json:"command,omitempty"`
	// Executor provided with a container will launch the container
	// with the executor's CommandInfo and we expect the container to
	// act as a Mesos executor.
	Container *ContainerInfo `protobuf:"bytes,11,opt,name=container" json:"container,omitempty"`
	Resources []*Resource    `protobuf:"bytes,5,rep,name=resources" json:"resources,omitempty"`
	Name      *string        `protobuf:"bytes,9,opt,name=name" json:"name,omitempty"`
	// 'source' is an identifier style string used by frameworks to
	// track the source of an executor. This is useful when it's
	// possible for different executor ids to be related semantically.
	//
	// NOTE: 'source' is exposed alongside the resource usage of the
	// executor via JSON on the agent. This allows users to import usage
	// information into a time series database for monitoring.
	//
	// This field is deprecated since 1.0. Please use labels for
	// free-form metadata instead.
	Source *string `protobuf:"bytes,10,opt,name=source" json:"source,omitempty"`
	// This field can be used to pass arbitrary bytes to an executor.
	Data []byte `protobuf:"bytes,4,opt,name=data" json:"data,omitempty"`
	// Service discovery information for the executor. It is not
	// interpreted or acted upon by Mesos. It is up to a service
	// discovery system to use this information as needed and to handle
	// executors without service discovery information.
	Discovery *DiscoveryInfo `protobuf:"bytes,12,opt,name=discovery" json:"discovery,omitempty"`
	// When shutting down an executor the agent will wait in a
	// best-effort manner for the grace period specified here
	// before forcibly destroying the container. The executor
	// must not assume that it will always be allotted the full
	// grace period, as the agent may decide to allot a shorter
	// period and failures / forcible terminations may occur.
	ShutdownGracePeriod *DurationInfo `protobuf:"bytes,13,opt,name=shutdown_grace_period,json=shutdownGracePeriod" json:"shutdown_grace_period,omitempty"`
	// Labels are free-form key value pairs which are exposed through
	// master and agent endpoints. Labels will not be interpreted or
	// acted upon by Mesos itself. As opposed to the data field, labels
	// will be kept in memory on master and agent processes. Therefore,
	// labels should be used to tag executors with lightweight metadata.
	// Labels should not contain duplicate key-value pairs.
	Labels           *Labels `protobuf:"bytes,14,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *ExecutorInfo) Reset()                    { *m = ExecutorInfo{} }
func (m *ExecutorInfo) String() string            { return proto.CompactTextString(m) }
func (*ExecutorInfo) ProtoMessage()               {}
func (*ExecutorInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{17} }

func (m *ExecutorInfo) GetType() ExecutorInfo_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return ExecutorInfo_UNKNOWN
}

func (m *ExecutorInfo) GetExecutorId() *ExecutorID {
	if m != nil {
		return m.ExecutorId
	}
	return nil
}

func (m *ExecutorInfo) GetFrameworkId() *FrameworkID {
	if m != nil {
		return m.FrameworkId
	}
	return nil
}

func (m *ExecutorInfo) GetCommand() *CommandInfo {
	if m != nil {
		return m.Command
	}
	return nil
}

func (m *ExecutorInfo) GetContainer() *ContainerInfo {
	if m != nil {
		return m.Container
	}
	return nil
}

func (m *ExecutorInfo) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *ExecutorInfo) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *ExecutorInfo) GetSource() string {
	if m != nil && m.Source != nil {
		return *m.Source
	}
	return ""
}

func (m *ExecutorInfo) GetData() []byte {
	if m != nil {
		return m.Data
	}
	return nil
}

func (m *ExecutorInfo) GetDiscovery() *DiscoveryInfo {
	if m != nil {
		return m.Discovery
	}
	return nil
}

func (m *ExecutorInfo) GetShutdownGracePeriod() *DurationInfo {
	if m != nil {
		return m.ShutdownGracePeriod
	}
	return nil
}

func (m *ExecutorInfo) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

// *
// Describes a master. This will probably have more fields in the
// future which might be used, for example, to link a framework webui
// to a master webui.
type MasterInfo struct {
	Id *string `protobuf:"bytes,1,req,name=id" json:"id,omitempty"`
	// The IP address (only IPv4) as a packed 4-bytes integer,
	// stored in network order.  Deprecated, use `address.ip` instead.
	Ip *uint32 `protobuf:"varint,2,req,name=ip" json:"ip,omitempty"`
	// The TCP port the Master is listening on for incoming
	// HTTP requests; deprecated, use `address.port` instead.
	Port *uint32 `protobuf:"varint,3,req,name=port,def=5050" json:"port,omitempty"`
	// In the default implementation, this will contain information
	// about both the IP address, port and Master name; it should really
	// not be relied upon by external tooling/frameworks and be
	// considered an "internal" implementation field.
	Pid *string `protobuf:"bytes,4,opt,name=pid" json:"pid,omitempty"`
	// The server's hostname, if available; it may be unreliable
	// in environments where the DNS configuration does not resolve
	// internal hostnames (eg, some public cloud providers).
	// Deprecated, use `address.hostname` instead.
	Hostname *string `protobuf:"bytes,5,opt,name=hostname" json:"hostname,omitempty"`
	// The running Master version, as a string; taken from the
	// generated "master/version.hpp".
	Version *string `protobuf:"bytes,6,opt,name=version" json:"version,omitempty"`
	// The full IP address (supports both IPv4 and IPv6 formats)
	// and supersedes the use of `ip`, `port` and `hostname`.
	// Since Mesos 0.24.
	Address          *Address `protobuf:"bytes,7,opt,name=address" json:"address,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *MasterInfo) Reset()                    { *m = MasterInfo{} }
func (m *MasterInfo) String() string            { return proto.CompactTextString(m) }
func (*MasterInfo) ProtoMessage()               {}
func (*MasterInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{18} }

const Default_MasterInfo_Port uint32 = 5050

func (m *MasterInfo) GetId() string {
	if m != nil && m.Id != nil {
		return *m.Id
	}
	return ""
}

func (m *MasterInfo) GetIp() uint32 {
	if m != nil && m.Ip != nil {
		return *m.Ip
	}
	return 0
}

func (m *MasterInfo) GetPort() uint32 {
	if m != nil && m.Port != nil {
		return *m.Port
	}
	return Default_MasterInfo_Port
}

func (m *MasterInfo) GetPid() string {
	if m != nil && m.Pid != nil {
		return *m.Pid
	}
	return ""
}

func (m *MasterInfo) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *MasterInfo) GetVersion() string {
	if m != nil && m.Version != nil {
		return *m.Version
	}
	return ""
}

func (m *MasterInfo) GetAddress() *Address {
	if m != nil {
		return m.Address
	}
	return nil
}

// *
// Describes an agent. Note that the 'id' field is only available
// after an agent is registered with the master, and is made available
// here to facilitate re-registration.
type AgentInfo struct {
	Hostname         *string      `protobuf:"bytes,1,req,name=hostname" json:"hostname,omitempty"`
	Port             *int32       `protobuf:"varint,8,opt,name=port,def=5051" json:"port,omitempty"`
	Resources        []*Resource  `protobuf:"bytes,3,rep,name=resources" json:"resources,omitempty"`
	Attributes       []*Attribute `protobuf:"bytes,5,rep,name=attributes" json:"attributes,omitempty"`
	Id               *AgentID     `protobuf:"bytes,6,opt,name=id" json:"id,omitempty"`
	XXX_unrecognized []byte       `json:"-"`
}

func (m *AgentInfo) Reset()                    { *m = AgentInfo{} }
func (m *AgentInfo) String() string            { return proto.CompactTextString(m) }
func (*AgentInfo) ProtoMessage()               {}
func (*AgentInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{19} }

const Default_AgentInfo_Port int32 = 5051

func (m *AgentInfo) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *AgentInfo) GetPort() int32 {
	if m != nil && m.Port != nil {
		return *m.Port
	}
	return Default_AgentInfo_Port
}

func (m *AgentInfo) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *AgentInfo) GetAttributes() []*Attribute {
	if m != nil {
		return m.Attributes
	}
	return nil
}

func (m *AgentInfo) GetId() *AgentID {
	if m != nil {
		return m.Id
	}
	return nil
}

// *
// Describes an Attribute or Resource "value". A value is described
// using the standard protocol buffer "union" trick.
type Value struct {
	Type             *Value_Type   `protobuf:"varint,1,req,name=type,enum=mesos.v1.Value_Type" json:"type,omitempty"`
	Scalar           *Value_Scalar `protobuf:"bytes,2,opt,name=scalar" json:"scalar,omitempty"`
	Ranges           *Value_Ranges `protobuf:"bytes,3,opt,name=ranges" json:"ranges,omitempty"`
	Set              *Value_Set    `protobuf:"bytes,4,opt,name=set" json:"set,omitempty"`
	Text             *Value_Text   `protobuf:"bytes,5,opt,name=text" json:"text,omitempty"`
	XXX_unrecognized []byte        `json:"-"`
}

func (m *Value) Reset()                    { *m = Value{} }
func (m *Value) String() string            { return proto.CompactTextString(m) }
func (*Value) ProtoMessage()               {}
func (*Value) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20} }

func (m *Value) GetType() Value_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Value_SCALAR
}

func (m *Value) GetScalar() *Value_Scalar {
	if m != nil {
		return m.Scalar
	}
	return nil
}

func (m *Value) GetRanges() *Value_Ranges {
	if m != nil {
		return m.Ranges
	}
	return nil
}

func (m *Value) GetSet() *Value_Set {
	if m != nil {
		return m.Set
	}
	return nil
}

func (m *Value) GetText() *Value_Text {
	if m != nil {
		return m.Text
	}
	return nil
}

type Value_Scalar struct {
	// Scalar values are represented using floating point. To reduce
	// the chance of unpredictable floating point behavior due to
	// roundoff error, Mesos only supports three decimal digits of
	// precision for scalar resource values. That is, floating point
	// values are converted to a fixed point format that supports
	// three decimal digits of precision, and then converted back to
	// floating point on output. Any additional precision in scalar
	// resource values is discarded (via rounding).
	Value            *float64 `protobuf:"fixed64,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *Value_Scalar) Reset()                    { *m = Value_Scalar{} }
func (m *Value_Scalar) String() string            { return proto.CompactTextString(m) }
func (*Value_Scalar) ProtoMessage()               {}
func (*Value_Scalar) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20, 0} }

func (m *Value_Scalar) GetValue() float64 {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return 0
}

type Value_Range struct {
	Begin            *uint64 `protobuf:"varint,1,req,name=begin" json:"begin,omitempty"`
	End              *uint64 `protobuf:"varint,2,req,name=end" json:"end,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Value_Range) Reset()                    { *m = Value_Range{} }
func (m *Value_Range) String() string            { return proto.CompactTextString(m) }
func (*Value_Range) ProtoMessage()               {}
func (*Value_Range) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20, 1} }

func (m *Value_Range) GetBegin() uint64 {
	if m != nil && m.Begin != nil {
		return *m.Begin
	}
	return 0
}

func (m *Value_Range) GetEnd() uint64 {
	if m != nil && m.End != nil {
		return *m.End
	}
	return 0
}

type Value_Ranges struct {
	Range            []*Value_Range `protobuf:"bytes,1,rep,name=range" json:"range,omitempty"`
	XXX_unrecognized []byte         `json:"-"`
}

func (m *Value_Ranges) Reset()                    { *m = Value_Ranges{} }
func (m *Value_Ranges) String() string            { return proto.CompactTextString(m) }
func (*Value_Ranges) ProtoMessage()               {}
func (*Value_Ranges) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20, 2} }

func (m *Value_Ranges) GetRange() []*Value_Range {
	if m != nil {
		return m.Range
	}
	return nil
}

type Value_Set struct {
	Item             []string `protobuf:"bytes,1,rep,name=item" json:"item,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *Value_Set) Reset()                    { *m = Value_Set{} }
func (m *Value_Set) String() string            { return proto.CompactTextString(m) }
func (*Value_Set) ProtoMessage()               {}
func (*Value_Set) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20, 3} }

func (m *Value_Set) GetItem() []string {
	if m != nil {
		return m.Item
	}
	return nil
}

type Value_Text struct {
	Value            *string `protobuf:"bytes,1,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Value_Text) Reset()                    { *m = Value_Text{} }
func (m *Value_Text) String() string            { return proto.CompactTextString(m) }
func (*Value_Text) ProtoMessage()               {}
func (*Value_Text) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{20, 4} }

func (m *Value_Text) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// Describes an attribute that can be set on a machine. For now,
// attributes and resources share the same "value" type, but this may
// change in the future and attributes may only be string based.
type Attribute struct {
	Name             *string       `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Type             *Value_Type   `protobuf:"varint,2,req,name=type,enum=mesos.v1.Value_Type" json:"type,omitempty"`
	Scalar           *Value_Scalar `protobuf:"bytes,3,opt,name=scalar" json:"scalar,omitempty"`
	Ranges           *Value_Ranges `protobuf:"bytes,4,opt,name=ranges" json:"ranges,omitempty"`
	Set              *Value_Set    `protobuf:"bytes,6,opt,name=set" json:"set,omitempty"`
	Text             *Value_Text   `protobuf:"bytes,5,opt,name=text" json:"text,omitempty"`
	XXX_unrecognized []byte        `json:"-"`
}

func (m *Attribute) Reset()                    { *m = Attribute{} }
func (m *Attribute) String() string            { return proto.CompactTextString(m) }
func (*Attribute) ProtoMessage()               {}
func (*Attribute) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{21} }

func (m *Attribute) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Attribute) GetType() Value_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Value_SCALAR
}

func (m *Attribute) GetScalar() *Value_Scalar {
	if m != nil {
		return m.Scalar
	}
	return nil
}

func (m *Attribute) GetRanges() *Value_Ranges {
	if m != nil {
		return m.Ranges
	}
	return nil
}

func (m *Attribute) GetSet() *Value_Set {
	if m != nil {
		return m.Set
	}
	return nil
}

func (m *Attribute) GetText() *Value_Text {
	if m != nil {
		return m.Text
	}
	return nil
}

// *
// Describes a resource on a machine. The `name` field is a string
// like "cpus" or "mem" that indicates which kind of resource this is;
// the rest of the fields describe the properties of the resource. A
// resource can take on one of three types: scalar (double), a list of
// finite and discrete ranges (e.g., [1-10, 20-30]), or a set of
// items. A resource is described using the standard protocol buffer
// "union" trick.
//
// Note that "disk" and "mem" resources are scalar values expressed in
// megabytes. Fractional "cpus" values are allowed (e.g., "0.5"),
// which correspond to partial shares of a CPU.
type Resource struct {
	Name   *string       `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Type   *Value_Type   `protobuf:"varint,2,req,name=type,enum=mesos.v1.Value_Type" json:"type,omitempty"`
	Scalar *Value_Scalar `protobuf:"bytes,3,opt,name=scalar" json:"scalar,omitempty"`
	Ranges *Value_Ranges `protobuf:"bytes,4,opt,name=ranges" json:"ranges,omitempty"`
	Set    *Value_Set    `protobuf:"bytes,5,opt,name=set" json:"set,omitempty"`
	// The role that this resource is reserved for. If "*", this indicates
	// that the resource is unreserved. Otherwise, the resource will only
	// be offered to frameworks that belong to this role.
	Role *string `protobuf:"bytes,6,opt,name=role,def=*" json:"role,omitempty"`
	// If this is set, this resource was dynamically reserved by an
	// operator or a framework. Otherwise, this resource is either unreserved
	// or statically reserved by an operator via the --resources flag.
	Reservation *Resource_ReservationInfo `protobuf:"bytes,8,opt,name=reservation" json:"reservation,omitempty"`
	Disk        *Resource_DiskInfo        `protobuf:"bytes,7,opt,name=disk" json:"disk,omitempty"`
	// If this is set, the resources are revocable, i.e., any tasks or
	// executors launched using these resources could get preempted or
	// throttled at any time. This could be used by frameworks to run
	// best effort tasks that do not need strict uptime or performance
	// guarantees. Note that if this is set, 'disk' or 'reservation'
	// cannot be set.
	Revocable *Resource_RevocableInfo `protobuf:"bytes,9,opt,name=revocable" json:"revocable,omitempty"`
	// If this is set, the resources are shared, i.e. multiple tasks
	// can be launched using this resource and all of them shall refer
	// to the same physical resource on the cluster. Note that only
	// persistent volumes can be shared currently.
	Shared           *Resource_SharedInfo `protobuf:"bytes,10,opt,name=shared" json:"shared,omitempty"`
	XXX_unrecognized []byte               `json:"-"`
}

func (m *Resource) Reset()                    { *m = Resource{} }
func (m *Resource) String() string            { return proto.CompactTextString(m) }
func (*Resource) ProtoMessage()               {}
func (*Resource) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{22} }

const Default_Resource_Role string = "*"

func (m *Resource) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Resource) GetType() Value_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Value_SCALAR
}

func (m *Resource) GetScalar() *Value_Scalar {
	if m != nil {
		return m.Scalar
	}
	return nil
}

func (m *Resource) GetRanges() *Value_Ranges {
	if m != nil {
		return m.Ranges
	}
	return nil
}

func (m *Resource) GetSet() *Value_Set {
	if m != nil {
		return m.Set
	}
	return nil
}

func (m *Resource) GetRole() string {
	if m != nil && m.Role != nil {
		return *m.Role
	}
	return Default_Resource_Role
}

func (m *Resource) GetReservation() *Resource_ReservationInfo {
	if m != nil {
		return m.Reservation
	}
	return nil
}

func (m *Resource) GetDisk() *Resource_DiskInfo {
	if m != nil {
		return m.Disk
	}
	return nil
}

func (m *Resource) GetRevocable() *Resource_RevocableInfo {
	if m != nil {
		return m.Revocable
	}
	return nil
}

func (m *Resource) GetShared() *Resource_SharedInfo {
	if m != nil {
		return m.Shared
	}
	return nil
}

type Resource_ReservationInfo struct {
	// Indicates the principal, if any, of the framework or operator
	// that reserved this resource. If reserved by a framework, the
	// field should match the `FrameworkInfo.principal`. It is used in
	// conjunction with the `UnreserveResources` ACL to determine
	// whether the entity attempting to unreserve this resource is
	// permitted to do so.
	Principal *string `protobuf:"bytes,1,opt,name=principal" json:"principal,omitempty"`
	// Labels are free-form key value pairs that can be used to
	// associate arbitrary metadata with a reserved resource.  For
	// example, frameworks can use labels to identify the intended
	// purpose for a portion of the resources the framework has
	// reserved at a given agent. Labels should not contain duplicate
	// key-value pairs.
	Labels           *Labels `protobuf:"bytes,2,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Resource_ReservationInfo) Reset()                    { *m = Resource_ReservationInfo{} }
func (m *Resource_ReservationInfo) String() string            { return proto.CompactTextString(m) }
func (*Resource_ReservationInfo) ProtoMessage()               {}
func (*Resource_ReservationInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{22, 0} }

func (m *Resource_ReservationInfo) GetPrincipal() string {
	if m != nil && m.Principal != nil {
		return *m.Principal
	}
	return ""
}

func (m *Resource_ReservationInfo) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

type Resource_DiskInfo struct {
	Persistence *Resource_DiskInfo_Persistence `protobuf:"bytes,1,opt,name=persistence" json:"persistence,omitempty"`
	// Describes how this disk resource will be mounted in the
	// container. If not set, the disk resource will be used as the
	// sandbox. Otherwise, it will be mounted according to the
	// 'container_path' inside 'volume'. The 'host_path' inside
	// 'volume' is ignored.
	// NOTE: If 'volume' is set but 'persistence' is not set, the
	// volume will be automatically garbage collected after
	// task/executor terminates. Currently, if 'persistence' is set,
	// 'volume' must be set.
	Volume           *Volume                   `protobuf:"bytes,2,opt,name=volume" json:"volume,omitempty"`
	Source           *Resource_DiskInfo_Source `protobuf:"bytes,3,opt,name=source" json:"source,omitempty"`
	XXX_unrecognized []byte                    `json:"-"`
}

func (m *Resource_DiskInfo) Reset()                    { *m = Resource_DiskInfo{} }
func (m *Resource_DiskInfo) String() string            { return proto.CompactTextString(m) }
func (*Resource_DiskInfo) ProtoMessage()               {}
func (*Resource_DiskInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{22, 1} }

func (m *Resource_DiskInfo) GetPersistence() *Resource_DiskInfo_Persistence {
	if m != nil {
		return m.Persistence
	}
	return nil
}

func (m *Resource_DiskInfo) GetVolume() *Volume {
	if m != nil {
		return m.Volume
	}
	return nil
}

func (m *Resource_DiskInfo) GetSource() *Resource_DiskInfo_Source {
	if m != nil {
		return m.Source
	}
	return nil
}

// Describes a persistent disk volume.
//
// A persistent disk volume will not be automatically garbage
// collected if the task/executor/agent terminates, but will be
// re-offered to the framework(s) belonging to the 'role'.
//
// NOTE: Currently, we do not allow persistent disk volumes
// without a reservation (i.e., 'role' cannot be '*').
type Resource_DiskInfo_Persistence struct {
	// A unique ID for the persistent disk volume. This ID must be
	// unique per role on each agent. Although it is possible to use
	// the same ID on different agents in the cluster and to reuse
	// IDs after a volume with that ID has been destroyed, both
	// practices are discouraged.
	Id *string `protobuf:"bytes,1,req,name=id" json:"id,omitempty"`
	// This field indicates the principal of the operator or
	// framework that created this volume. It is used in conjunction
	// with the "destroy" ACL to determine whether an entity
	// attempting to destroy the volume is permitted to do so.
	//
	// NOTE: This field is optional, while the `principal` found in
	// `ReservationInfo` is required. This field is optional to
	// allow for the possibility of volume creation without a
	// principal, though currently it must be provided.
	//
	// NOTE: This field should match the FrameworkInfo.principal of
	// the framework that created the volume.
	Principal        *string `protobuf:"bytes,2,opt,name=principal" json:"principal,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Resource_DiskInfo_Persistence) Reset()         { *m = Resource_DiskInfo_Persistence{} }
func (m *Resource_DiskInfo_Persistence) String() string { return proto.CompactTextString(m) }
func (*Resource_DiskInfo_Persistence) ProtoMessage()    {}
func (*Resource_DiskInfo_Persistence) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{22, 1, 0}
}

func (m *Resource_DiskInfo_Persistence) GetId() string {
	if m != nil && m.Id != nil {
		return *m.Id
	}
	return ""
}

func (m *Resource_DiskInfo_Persistence) GetPrincipal() string {
	if m != nil && m.Principal != nil {
		return *m.Principal
	}
	return ""
}

// Describes where a disk originates from.
// TODO(jmlvanre): Add support for BLOCK devices.
type Resource_DiskInfo_Source struct {
	Type             *Resource_DiskInfo_Source_Type  `protobuf:"varint,1,req,name=type,enum=mesos.v1.Resource_DiskInfo_Source_Type" json:"type,omitempty"`
	Path             *Resource_DiskInfo_Source_Path  `protobuf:"bytes,2,opt,name=path" json:"path,omitempty"`
	Mount            *Resource_DiskInfo_Source_Mount `protobuf:"bytes,3,opt,name=mount" json:"mount,omitempty"`
	XXX_unrecognized []byte                          `json:"-"`
}

func (m *Resource_DiskInfo_Source) Reset()         { *m = Resource_DiskInfo_Source{} }
func (m *Resource_DiskInfo_Source) String() string { return proto.CompactTextString(m) }
func (*Resource_DiskInfo_Source) ProtoMessage()    {}
func (*Resource_DiskInfo_Source) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{22, 1, 1}
}

func (m *Resource_DiskInfo_Source) GetType() Resource_DiskInfo_Source_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Resource_DiskInfo_Source_PATH
}

func (m *Resource_DiskInfo_Source) GetPath() *Resource_DiskInfo_Source_Path {
	if m != nil {
		return m.Path
	}
	return nil
}

func (m *Resource_DiskInfo_Source) GetMount() *Resource_DiskInfo_Source_Mount {
	if m != nil {
		return m.Mount
	}
	return nil
}

// A folder that can be located on a separate disk device. This
// can be shared and carved up as necessary between frameworks.
type Resource_DiskInfo_Source_Path struct {
	// Path to the folder (e.g., /mnt/raid/disk0).
	Root             *string `protobuf:"bytes,1,req,name=root" json:"root,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Resource_DiskInfo_Source_Path) Reset()         { *m = Resource_DiskInfo_Source_Path{} }
func (m *Resource_DiskInfo_Source_Path) String() string { return proto.CompactTextString(m) }
func (*Resource_DiskInfo_Source_Path) ProtoMessage()    {}
func (*Resource_DiskInfo_Source_Path) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{22, 1, 1, 0}
}

func (m *Resource_DiskInfo_Source_Path) GetRoot() string {
	if m != nil && m.Root != nil {
		return *m.Root
	}
	return ""
}

// A mounted file-system set up by the Agent administrator. This
// can only be used exclusively: a framework cannot accept a
// partial amount of this disk.
type Resource_DiskInfo_Source_Mount struct {
	// Path to mount point (e.g., /mnt/raid/disk0).
	Root             *string `protobuf:"bytes,1,req,name=root" json:"root,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Resource_DiskInfo_Source_Mount) Reset()         { *m = Resource_DiskInfo_Source_Mount{} }
func (m *Resource_DiskInfo_Source_Mount) String() string { return proto.CompactTextString(m) }
func (*Resource_DiskInfo_Source_Mount) ProtoMessage()    {}
func (*Resource_DiskInfo_Source_Mount) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{22, 1, 1, 1}
}

func (m *Resource_DiskInfo_Source_Mount) GetRoot() string {
	if m != nil && m.Root != nil {
		return *m.Root
	}
	return ""
}

type Resource_RevocableInfo struct {
	XXX_unrecognized []byte `json:"-"`
}

func (m *Resource_RevocableInfo) Reset()                    { *m = Resource_RevocableInfo{} }
func (m *Resource_RevocableInfo) String() string            { return proto.CompactTextString(m) }
func (*Resource_RevocableInfo) ProtoMessage()               {}
func (*Resource_RevocableInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{22, 2} }

// Allow the resource to be shared across tasks.
type Resource_SharedInfo struct {
	XXX_unrecognized []byte `json:"-"`
}

func (m *Resource_SharedInfo) Reset()                    { *m = Resource_SharedInfo{} }
func (m *Resource_SharedInfo) String() string            { return proto.CompactTextString(m) }
func (*Resource_SharedInfo) ProtoMessage()               {}
func (*Resource_SharedInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{22, 3} }

// *
// When the network bandwidth caps are enabled and the container
// is over its limit, outbound packets may be either delayed or
// dropped completely either because it exceeds the maximum bandwidth
// allocation for a single container (the cap) or because the combined
// network traffic of multiple containers on the host exceeds the
// transmit capacity of the host (the share). We can report the
// following statistics for each of these conditions exported directly
// from the Linux Traffic Control Queueing Discipline.
//
// id         : name of the limiter, e.g. 'tx_bw_cap'
// backlog    : number of packets currently delayed
// bytes      : total bytes seen
// drops      : number of packets dropped in total
// overlimits : number of packets which exceeded allocation
// packets    : total packets seen
// qlen       : number of packets currently queued
// rate_bps   : throughput in bytes/sec
// rate_pps   : throughput in packets/sec
// requeues   : number of times a packet has been delayed due to
//              locking or device contention issues
//
// More information on the operation of Linux Traffic Control can be
// found at http://www.lartc.org/lartc.html.
type TrafficControlStatistics struct {
	Id               *string `protobuf:"bytes,1,req,name=id" json:"id,omitempty"`
	Backlog          *uint64 `protobuf:"varint,2,opt,name=backlog" json:"backlog,omitempty"`
	Bytes            *uint64 `protobuf:"varint,3,opt,name=bytes" json:"bytes,omitempty"`
	Drops            *uint64 `protobuf:"varint,4,opt,name=drops" json:"drops,omitempty"`
	Overlimits       *uint64 `protobuf:"varint,5,opt,name=overlimits" json:"overlimits,omitempty"`
	Packets          *uint64 `protobuf:"varint,6,opt,name=packets" json:"packets,omitempty"`
	Qlen             *uint64 `protobuf:"varint,7,opt,name=qlen" json:"qlen,omitempty"`
	Ratebps          *uint64 `protobuf:"varint,8,opt,name=ratebps" json:"ratebps,omitempty"`
	Ratepps          *uint64 `protobuf:"varint,9,opt,name=ratepps" json:"ratepps,omitempty"`
	Requeues         *uint64 `protobuf:"varint,10,opt,name=requeues" json:"requeues,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *TrafficControlStatistics) Reset()                    { *m = TrafficControlStatistics{} }
func (m *TrafficControlStatistics) String() string            { return proto.CompactTextString(m) }
func (*TrafficControlStatistics) ProtoMessage()               {}
func (*TrafficControlStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{23} }

func (m *TrafficControlStatistics) GetId() string {
	if m != nil && m.Id != nil {
		return *m.Id
	}
	return ""
}

func (m *TrafficControlStatistics) GetBacklog() uint64 {
	if m != nil && m.Backlog != nil {
		return *m.Backlog
	}
	return 0
}

func (m *TrafficControlStatistics) GetBytes() uint64 {
	if m != nil && m.Bytes != nil {
		return *m.Bytes
	}
	return 0
}

func (m *TrafficControlStatistics) GetDrops() uint64 {
	if m != nil && m.Drops != nil {
		return *m.Drops
	}
	return 0
}

func (m *TrafficControlStatistics) GetOverlimits() uint64 {
	if m != nil && m.Overlimits != nil {
		return *m.Overlimits
	}
	return 0
}

func (m *TrafficControlStatistics) GetPackets() uint64 {
	if m != nil && m.Packets != nil {
		return *m.Packets
	}
	return 0
}

func (m *TrafficControlStatistics) GetQlen() uint64 {
	if m != nil && m.Qlen != nil {
		return *m.Qlen
	}
	return 0
}

func (m *TrafficControlStatistics) GetRatebps() uint64 {
	if m != nil && m.Ratebps != nil {
		return *m.Ratebps
	}
	return 0
}

func (m *TrafficControlStatistics) GetRatepps() uint64 {
	if m != nil && m.Ratepps != nil {
		return *m.Ratepps
	}
	return 0
}

func (m *TrafficControlStatistics) GetRequeues() uint64 {
	if m != nil && m.Requeues != nil {
		return *m.Requeues
	}
	return 0
}

type IpStatistics struct {
	Forwarding       *int64 `protobuf:"varint,1,opt,name=Forwarding" json:"Forwarding,omitempty"`
	DefaultTTL       *int64 `protobuf:"varint,2,opt,name=DefaultTTL" json:"DefaultTTL,omitempty"`
	InReceives       *int64 `protobuf:"varint,3,opt,name=InReceives" json:"InReceives,omitempty"`
	InHdrErrors      *int64 `protobuf:"varint,4,opt,name=InHdrErrors" json:"InHdrErrors,omitempty"`
	InAddrErrors     *int64 `protobuf:"varint,5,opt,name=InAddrErrors" json:"InAddrErrors,omitempty"`
	ForwDatagrams    *int64 `protobuf:"varint,6,opt,name=ForwDatagrams" json:"ForwDatagrams,omitempty"`
	InUnknownProtos  *int64 `protobuf:"varint,7,opt,name=InUnknownProtos" json:"InUnknownProtos,omitempty"`
	InDiscards       *int64 `protobuf:"varint,8,opt,name=InDiscards" json:"InDiscards,omitempty"`
	InDelivers       *int64 `protobuf:"varint,9,opt,name=InDelivers" json:"InDelivers,omitempty"`
	OutRequests      *int64 `protobuf:"varint,10,opt,name=OutRequests" json:"OutRequests,omitempty"`
	OutDiscards      *int64 `protobuf:"varint,11,opt,name=OutDiscards" json:"OutDiscards,omitempty"`
	OutNoRoutes      *int64 `protobuf:"varint,12,opt,name=OutNoRoutes" json:"OutNoRoutes,omitempty"`
	ReasmTimeout     *int64 `protobuf:"varint,13,opt,name=ReasmTimeout" json:"ReasmTimeout,omitempty"`
	ReasmReqds       *int64 `protobuf:"varint,14,opt,name=ReasmReqds" json:"ReasmReqds,omitempty"`
	ReasmOKs         *int64 `protobuf:"varint,15,opt,name=ReasmOKs" json:"ReasmOKs,omitempty"`
	ReasmFails       *int64 `protobuf:"varint,16,opt,name=ReasmFails" json:"ReasmFails,omitempty"`
	FragOKs          *int64 `protobuf:"varint,17,opt,name=FragOKs" json:"FragOKs,omitempty"`
	FragFails        *int64 `protobuf:"varint,18,opt,name=FragFails" json:"FragFails,omitempty"`
	FragCreates      *int64 `protobuf:"varint,19,opt,name=FragCreates" json:"FragCreates,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *IpStatistics) Reset()                    { *m = IpStatistics{} }
func (m *IpStatistics) String() string            { return proto.CompactTextString(m) }
func (*IpStatistics) ProtoMessage()               {}
func (*IpStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{24} }

func (m *IpStatistics) GetForwarding() int64 {
	if m != nil && m.Forwarding != nil {
		return *m.Forwarding
	}
	return 0
}

func (m *IpStatistics) GetDefaultTTL() int64 {
	if m != nil && m.DefaultTTL != nil {
		return *m.DefaultTTL
	}
	return 0
}

func (m *IpStatistics) GetInReceives() int64 {
	if m != nil && m.InReceives != nil {
		return *m.InReceives
	}
	return 0
}

func (m *IpStatistics) GetInHdrErrors() int64 {
	if m != nil && m.InHdrErrors != nil {
		return *m.InHdrErrors
	}
	return 0
}

func (m *IpStatistics) GetInAddrErrors() int64 {
	if m != nil && m.InAddrErrors != nil {
		return *m.InAddrErrors
	}
	return 0
}

func (m *IpStatistics) GetForwDatagrams() int64 {
	if m != nil && m.ForwDatagrams != nil {
		return *m.ForwDatagrams
	}
	return 0
}

func (m *IpStatistics) GetInUnknownProtos() int64 {
	if m != nil && m.InUnknownProtos != nil {
		return *m.InUnknownProtos
	}
	return 0
}

func (m *IpStatistics) GetInDiscards() int64 {
	if m != nil && m.InDiscards != nil {
		return *m.InDiscards
	}
	return 0
}

func (m *IpStatistics) GetInDelivers() int64 {
	if m != nil && m.InDelivers != nil {
		return *m.InDelivers
	}
	return 0
}

func (m *IpStatistics) GetOutRequests() int64 {
	if m != nil && m.OutRequests != nil {
		return *m.OutRequests
	}
	return 0
}

func (m *IpStatistics) GetOutDiscards() int64 {
	if m != nil && m.OutDiscards != nil {
		return *m.OutDiscards
	}
	return 0
}

func (m *IpStatistics) GetOutNoRoutes() int64 {
	if m != nil && m.OutNoRoutes != nil {
		return *m.OutNoRoutes
	}
	return 0
}

func (m *IpStatistics) GetReasmTimeout() int64 {
	if m != nil && m.ReasmTimeout != nil {
		return *m.ReasmTimeout
	}
	return 0
}

func (m *IpStatistics) GetReasmReqds() int64 {
	if m != nil && m.ReasmReqds != nil {
		return *m.ReasmReqds
	}
	return 0
}

func (m *IpStatistics) GetReasmOKs() int64 {
	if m != nil && m.ReasmOKs != nil {
		return *m.ReasmOKs
	}
	return 0
}

func (m *IpStatistics) GetReasmFails() int64 {
	if m != nil && m.ReasmFails != nil {
		return *m.ReasmFails
	}
	return 0
}

func (m *IpStatistics) GetFragOKs() int64 {
	if m != nil && m.FragOKs != nil {
		return *m.FragOKs
	}
	return 0
}

func (m *IpStatistics) GetFragFails() int64 {
	if m != nil && m.FragFails != nil {
		return *m.FragFails
	}
	return 0
}

func (m *IpStatistics) GetFragCreates() int64 {
	if m != nil && m.FragCreates != nil {
		return *m.FragCreates
	}
	return 0
}

type IcmpStatistics struct {
	InMsgs           *int64 `protobuf:"varint,1,opt,name=InMsgs" json:"InMsgs,omitempty"`
	InErrors         *int64 `protobuf:"varint,2,opt,name=InErrors" json:"InErrors,omitempty"`
	InCsumErrors     *int64 `protobuf:"varint,3,opt,name=InCsumErrors" json:"InCsumErrors,omitempty"`
	InDestUnreachs   *int64 `protobuf:"varint,4,opt,name=InDestUnreachs" json:"InDestUnreachs,omitempty"`
	InTimeExcds      *int64 `protobuf:"varint,5,opt,name=InTimeExcds" json:"InTimeExcds,omitempty"`
	InParmProbs      *int64 `protobuf:"varint,6,opt,name=InParmProbs" json:"InParmProbs,omitempty"`
	InSrcQuenchs     *int64 `protobuf:"varint,7,opt,name=InSrcQuenchs" json:"InSrcQuenchs,omitempty"`
	InRedirects      *int64 `protobuf:"varint,8,opt,name=InRedirects" json:"InRedirects,omitempty"`
	InEchos          *int64 `protobuf:"varint,9,opt,name=InEchos" json:"InEchos,omitempty"`
	InEchoReps       *int64 `protobuf:"varint,10,opt,name=InEchoReps" json:"InEchoReps,omitempty"`
	InTimestamps     *int64 `protobuf:"varint,11,opt,name=InTimestamps" json:"InTimestamps,omitempty"`
	InTimestampReps  *int64 `protobuf:"varint,12,opt,name=InTimestampReps" json:"InTimestampReps,omitempty"`
	InAddrMasks      *int64 `protobuf:"varint,13,opt,name=InAddrMasks" json:"InAddrMasks,omitempty"`
	InAddrMaskReps   *int64 `protobuf:"varint,14,opt,name=InAddrMaskReps" json:"InAddrMaskReps,omitempty"`
	OutMsgs          *int64 `protobuf:"varint,15,opt,name=OutMsgs" json:"OutMsgs,omitempty"`
	OutErrors        *int64 `protobuf:"varint,16,opt,name=OutErrors" json:"OutErrors,omitempty"`
	OutDestUnreachs  *int64 `protobuf:"varint,17,opt,name=OutDestUnreachs" json:"OutDestUnreachs,omitempty"`
	OutTimeExcds     *int64 `protobuf:"varint,18,opt,name=OutTimeExcds" json:"OutTimeExcds,omitempty"`
	OutParmProbs     *int64 `protobuf:"varint,19,opt,name=OutParmProbs" json:"OutParmProbs,omitempty"`
	OutSrcQuenchs    *int64 `protobuf:"varint,20,opt,name=OutSrcQuenchs" json:"OutSrcQuenchs,omitempty"`
	OutRedirects     *int64 `protobuf:"varint,21,opt,name=OutRedirects" json:"OutRedirects,omitempty"`
	OutEchos         *int64 `protobuf:"varint,22,opt,name=OutEchos" json:"OutEchos,omitempty"`
	OutEchoReps      *int64 `protobuf:"varint,23,opt,name=OutEchoReps" json:"OutEchoReps,omitempty"`
	OutTimestamps    *int64 `protobuf:"varint,24,opt,name=OutTimestamps" json:"OutTimestamps,omitempty"`
	OutTimestampReps *int64 `protobuf:"varint,25,opt,name=OutTimestampReps" json:"OutTimestampReps,omitempty"`
	OutAddrMasks     *int64 `protobuf:"varint,26,opt,name=OutAddrMasks" json:"OutAddrMasks,omitempty"`
	OutAddrMaskReps  *int64 `protobuf:"varint,27,opt,name=OutAddrMaskReps" json:"OutAddrMaskReps,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *IcmpStatistics) Reset()                    { *m = IcmpStatistics{} }
func (m *IcmpStatistics) String() string            { return proto.CompactTextString(m) }
func (*IcmpStatistics) ProtoMessage()               {}
func (*IcmpStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{25} }

func (m *IcmpStatistics) GetInMsgs() int64 {
	if m != nil && m.InMsgs != nil {
		return *m.InMsgs
	}
	return 0
}

func (m *IcmpStatistics) GetInErrors() int64 {
	if m != nil && m.InErrors != nil {
		return *m.InErrors
	}
	return 0
}

func (m *IcmpStatistics) GetInCsumErrors() int64 {
	if m != nil && m.InCsumErrors != nil {
		return *m.InCsumErrors
	}
	return 0
}

func (m *IcmpStatistics) GetInDestUnreachs() int64 {
	if m != nil && m.InDestUnreachs != nil {
		return *m.InDestUnreachs
	}
	return 0
}

func (m *IcmpStatistics) GetInTimeExcds() int64 {
	if m != nil && m.InTimeExcds != nil {
		return *m.InTimeExcds
	}
	return 0
}

func (m *IcmpStatistics) GetInParmProbs() int64 {
	if m != nil && m.InParmProbs != nil {
		return *m.InParmProbs
	}
	return 0
}

func (m *IcmpStatistics) GetInSrcQuenchs() int64 {
	if m != nil && m.InSrcQuenchs != nil {
		return *m.InSrcQuenchs
	}
	return 0
}

func (m *IcmpStatistics) GetInRedirects() int64 {
	if m != nil && m.InRedirects != nil {
		return *m.InRedirects
	}
	return 0
}

func (m *IcmpStatistics) GetInEchos() int64 {
	if m != nil && m.InEchos != nil {
		return *m.InEchos
	}
	return 0
}

func (m *IcmpStatistics) GetInEchoReps() int64 {
	if m != nil && m.InEchoReps != nil {
		return *m.InEchoReps
	}
	return 0
}

func (m *IcmpStatistics) GetInTimestamps() int64 {
	if m != nil && m.InTimestamps != nil {
		return *m.InTimestamps
	}
	return 0
}

func (m *IcmpStatistics) GetInTimestampReps() int64 {
	if m != nil && m.InTimestampReps != nil {
		return *m.InTimestampReps
	}
	return 0
}

func (m *IcmpStatistics) GetInAddrMasks() int64 {
	if m != nil && m.InAddrMasks != nil {
		return *m.InAddrMasks
	}
	return 0
}

func (m *IcmpStatistics) GetInAddrMaskReps() int64 {
	if m != nil && m.InAddrMaskReps != nil {
		return *m.InAddrMaskReps
	}
	return 0
}

func (m *IcmpStatistics) GetOutMsgs() int64 {
	if m != nil && m.OutMsgs != nil {
		return *m.OutMsgs
	}
	return 0
}

func (m *IcmpStatistics) GetOutErrors() int64 {
	if m != nil && m.OutErrors != nil {
		return *m.OutErrors
	}
	return 0
}

func (m *IcmpStatistics) GetOutDestUnreachs() int64 {
	if m != nil && m.OutDestUnreachs != nil {
		return *m.OutDestUnreachs
	}
	return 0
}

func (m *IcmpStatistics) GetOutTimeExcds() int64 {
	if m != nil && m.OutTimeExcds != nil {
		return *m.OutTimeExcds
	}
	return 0
}

func (m *IcmpStatistics) GetOutParmProbs() int64 {
	if m != nil && m.OutParmProbs != nil {
		return *m.OutParmProbs
	}
	return 0
}

func (m *IcmpStatistics) GetOutSrcQuenchs() int64 {
	if m != nil && m.OutSrcQuenchs != nil {
		return *m.OutSrcQuenchs
	}
	return 0
}

func (m *IcmpStatistics) GetOutRedirects() int64 {
	if m != nil && m.OutRedirects != nil {
		return *m.OutRedirects
	}
	return 0
}

func (m *IcmpStatistics) GetOutEchos() int64 {
	if m != nil && m.OutEchos != nil {
		return *m.OutEchos
	}
	return 0
}

func (m *IcmpStatistics) GetOutEchoReps() int64 {
	if m != nil && m.OutEchoReps != nil {
		return *m.OutEchoReps
	}
	return 0
}

func (m *IcmpStatistics) GetOutTimestamps() int64 {
	if m != nil && m.OutTimestamps != nil {
		return *m.OutTimestamps
	}
	return 0
}

func (m *IcmpStatistics) GetOutTimestampReps() int64 {
	if m != nil && m.OutTimestampReps != nil {
		return *m.OutTimestampReps
	}
	return 0
}

func (m *IcmpStatistics) GetOutAddrMasks() int64 {
	if m != nil && m.OutAddrMasks != nil {
		return *m.OutAddrMasks
	}
	return 0
}

func (m *IcmpStatistics) GetOutAddrMaskReps() int64 {
	if m != nil && m.OutAddrMaskReps != nil {
		return *m.OutAddrMaskReps
	}
	return 0
}

type TcpStatistics struct {
	RtoAlgorithm     *int64 `protobuf:"varint,1,opt,name=RtoAlgorithm" json:"RtoAlgorithm,omitempty"`
	RtoMin           *int64 `protobuf:"varint,2,opt,name=RtoMin" json:"RtoMin,omitempty"`
	RtoMax           *int64 `protobuf:"varint,3,opt,name=RtoMax" json:"RtoMax,omitempty"`
	MaxConn          *int64 `protobuf:"varint,4,opt,name=MaxConn" json:"MaxConn,omitempty"`
	ActiveOpens      *int64 `protobuf:"varint,5,opt,name=ActiveOpens" json:"ActiveOpens,omitempty"`
	PassiveOpens     *int64 `protobuf:"varint,6,opt,name=PassiveOpens" json:"PassiveOpens,omitempty"`
	AttemptFails     *int64 `protobuf:"varint,7,opt,name=AttemptFails" json:"AttemptFails,omitempty"`
	EstabResets      *int64 `protobuf:"varint,8,opt,name=EstabResets" json:"EstabResets,omitempty"`
	CurrEstab        *int64 `protobuf:"varint,9,opt,name=CurrEstab" json:"CurrEstab,omitempty"`
	InSegs           *int64 `protobuf:"varint,10,opt,name=InSegs" json:"InSegs,omitempty"`
	OutSegs          *int64 `protobuf:"varint,11,opt,name=OutSegs" json:"OutSegs,omitempty"`
	RetransSegs      *int64 `protobuf:"varint,12,opt,name=RetransSegs" json:"RetransSegs,omitempty"`
	InErrs           *int64 `protobuf:"varint,13,opt,name=InErrs" json:"InErrs,omitempty"`
	OutRsts          *int64 `protobuf:"varint,14,opt,name=OutRsts" json:"OutRsts,omitempty"`
	InCsumErrors     *int64 `protobuf:"varint,15,opt,name=InCsumErrors" json:"InCsumErrors,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *TcpStatistics) Reset()                    { *m = TcpStatistics{} }
func (m *TcpStatistics) String() string            { return proto.CompactTextString(m) }
func (*TcpStatistics) ProtoMessage()               {}
func (*TcpStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{26} }

func (m *TcpStatistics) GetRtoAlgorithm() int64 {
	if m != nil && m.RtoAlgorithm != nil {
		return *m.RtoAlgorithm
	}
	return 0
}

func (m *TcpStatistics) GetRtoMin() int64 {
	if m != nil && m.RtoMin != nil {
		return *m.RtoMin
	}
	return 0
}

func (m *TcpStatistics) GetRtoMax() int64 {
	if m != nil && m.RtoMax != nil {
		return *m.RtoMax
	}
	return 0
}

func (m *TcpStatistics) GetMaxConn() int64 {
	if m != nil && m.MaxConn != nil {
		return *m.MaxConn
	}
	return 0
}

func (m *TcpStatistics) GetActiveOpens() int64 {
	if m != nil && m.ActiveOpens != nil {
		return *m.ActiveOpens
	}
	return 0
}

func (m *TcpStatistics) GetPassiveOpens() int64 {
	if m != nil && m.PassiveOpens != nil {
		return *m.PassiveOpens
	}
	return 0
}

func (m *TcpStatistics) GetAttemptFails() int64 {
	if m != nil && m.AttemptFails != nil {
		return *m.AttemptFails
	}
	return 0
}

func (m *TcpStatistics) GetEstabResets() int64 {
	if m != nil && m.EstabResets != nil {
		return *m.EstabResets
	}
	return 0
}

func (m *TcpStatistics) GetCurrEstab() int64 {
	if m != nil && m.CurrEstab != nil {
		return *m.CurrEstab
	}
	return 0
}

func (m *TcpStatistics) GetInSegs() int64 {
	if m != nil && m.InSegs != nil {
		return *m.InSegs
	}
	return 0
}

func (m *TcpStatistics) GetOutSegs() int64 {
	if m != nil && m.OutSegs != nil {
		return *m.OutSegs
	}
	return 0
}

func (m *TcpStatistics) GetRetransSegs() int64 {
	if m != nil && m.RetransSegs != nil {
		return *m.RetransSegs
	}
	return 0
}

func (m *TcpStatistics) GetInErrs() int64 {
	if m != nil && m.InErrs != nil {
		return *m.InErrs
	}
	return 0
}

func (m *TcpStatistics) GetOutRsts() int64 {
	if m != nil && m.OutRsts != nil {
		return *m.OutRsts
	}
	return 0
}

func (m *TcpStatistics) GetInCsumErrors() int64 {
	if m != nil && m.InCsumErrors != nil {
		return *m.InCsumErrors
	}
	return 0
}

type UdpStatistics struct {
	InDatagrams      *int64 `protobuf:"varint,1,opt,name=InDatagrams" json:"InDatagrams,omitempty"`
	NoPorts          *int64 `protobuf:"varint,2,opt,name=NoPorts" json:"NoPorts,omitempty"`
	InErrors         *int64 `protobuf:"varint,3,opt,name=InErrors" json:"InErrors,omitempty"`
	OutDatagrams     *int64 `protobuf:"varint,4,opt,name=OutDatagrams" json:"OutDatagrams,omitempty"`
	RcvbufErrors     *int64 `protobuf:"varint,5,opt,name=RcvbufErrors" json:"RcvbufErrors,omitempty"`
	SndbufErrors     *int64 `protobuf:"varint,6,opt,name=SndbufErrors" json:"SndbufErrors,omitempty"`
	InCsumErrors     *int64 `protobuf:"varint,7,opt,name=InCsumErrors" json:"InCsumErrors,omitempty"`
	IgnoredMulti     *int64 `protobuf:"varint,8,opt,name=IgnoredMulti" json:"IgnoredMulti,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *UdpStatistics) Reset()                    { *m = UdpStatistics{} }
func (m *UdpStatistics) String() string            { return proto.CompactTextString(m) }
func (*UdpStatistics) ProtoMessage()               {}
func (*UdpStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{27} }

func (m *UdpStatistics) GetInDatagrams() int64 {
	if m != nil && m.InDatagrams != nil {
		return *m.InDatagrams
	}
	return 0
}

func (m *UdpStatistics) GetNoPorts() int64 {
	if m != nil && m.NoPorts != nil {
		return *m.NoPorts
	}
	return 0
}

func (m *UdpStatistics) GetInErrors() int64 {
	if m != nil && m.InErrors != nil {
		return *m.InErrors
	}
	return 0
}

func (m *UdpStatistics) GetOutDatagrams() int64 {
	if m != nil && m.OutDatagrams != nil {
		return *m.OutDatagrams
	}
	return 0
}

func (m *UdpStatistics) GetRcvbufErrors() int64 {
	if m != nil && m.RcvbufErrors != nil {
		return *m.RcvbufErrors
	}
	return 0
}

func (m *UdpStatistics) GetSndbufErrors() int64 {
	if m != nil && m.SndbufErrors != nil {
		return *m.SndbufErrors
	}
	return 0
}

func (m *UdpStatistics) GetInCsumErrors() int64 {
	if m != nil && m.InCsumErrors != nil {
		return *m.InCsumErrors
	}
	return 0
}

func (m *UdpStatistics) GetIgnoredMulti() int64 {
	if m != nil && m.IgnoredMulti != nil {
		return *m.IgnoredMulti
	}
	return 0
}

type SNMPStatistics struct {
	IpStats          *IpStatistics   `protobuf:"bytes,1,opt,name=ip_stats,json=ipStats" json:"ip_stats,omitempty"`
	IcmpStats        *IcmpStatistics `protobuf:"bytes,2,opt,name=icmp_stats,json=icmpStats" json:"icmp_stats,omitempty"`
	TcpStats         *TcpStatistics  `protobuf:"bytes,3,opt,name=tcp_stats,json=tcpStats" json:"tcp_stats,omitempty"`
	UdpStats         *UdpStatistics  `protobuf:"bytes,4,opt,name=udp_stats,json=udpStats" json:"udp_stats,omitempty"`
	XXX_unrecognized []byte          `json:"-"`
}

func (m *SNMPStatistics) Reset()                    { *m = SNMPStatistics{} }
func (m *SNMPStatistics) String() string            { return proto.CompactTextString(m) }
func (*SNMPStatistics) ProtoMessage()               {}
func (*SNMPStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{28} }

func (m *SNMPStatistics) GetIpStats() *IpStatistics {
	if m != nil {
		return m.IpStats
	}
	return nil
}

func (m *SNMPStatistics) GetIcmpStats() *IcmpStatistics {
	if m != nil {
		return m.IcmpStats
	}
	return nil
}

func (m *SNMPStatistics) GetTcpStats() *TcpStatistics {
	if m != nil {
		return m.TcpStats
	}
	return nil
}

func (m *SNMPStatistics) GetUdpStats() *UdpStatistics {
	if m != nil {
		return m.UdpStats
	}
	return nil
}

// *
// A snapshot of resource usage statistics.
type ResourceStatistics struct {
	Timestamp *float64 `protobuf:"fixed64,1,req,name=timestamp" json:"timestamp,omitempty"`
	Processes *uint32  `protobuf:"varint,30,opt,name=processes" json:"processes,omitempty"`
	Threads   *uint32  `protobuf:"varint,31,opt,name=threads" json:"threads,omitempty"`
	// CPU Usage Information:
	// Total CPU time spent in user mode, and kernel mode.
	CpusUserTimeSecs   *float64 `protobuf:"fixed64,2,opt,name=cpus_user_time_secs,json=cpusUserTimeSecs" json:"cpus_user_time_secs,omitempty"`
	CpusSystemTimeSecs *float64 `protobuf:"fixed64,3,opt,name=cpus_system_time_secs,json=cpusSystemTimeSecs" json:"cpus_system_time_secs,omitempty"`
	// Number of CPUs allocated.
	CpusLimit *float64 `protobuf:"fixed64,4,opt,name=cpus_limit,json=cpusLimit" json:"cpus_limit,omitempty"`
	// cpu.stat on process throttling (for contention issues).
	CpusNrPeriods         *uint32  `protobuf:"varint,7,opt,name=cpus_nr_periods,json=cpusNrPeriods" json:"cpus_nr_periods,omitempty"`
	CpusNrThrottled       *uint32  `protobuf:"varint,8,opt,name=cpus_nr_throttled,json=cpusNrThrottled" json:"cpus_nr_throttled,omitempty"`
	CpusThrottledTimeSecs *float64 `protobuf:"fixed64,9,opt,name=cpus_throttled_time_secs,json=cpusThrottledTimeSecs" json:"cpus_throttled_time_secs,omitempty"`
	// mem_total_bytes was added in 0.23.0 to represent the total memory
	// of a process in RAM (as opposed to in Swap). This was previously
	// reported as mem_rss_bytes, which was also changed in 0.23.0 to
	// represent only the anonymous memory usage, to keep in sync with
	// Linux kernel's (arguably erroneous) use of terminology.
	MemTotalBytes *uint64 `protobuf:"varint,36,opt,name=mem_total_bytes,json=memTotalBytes" json:"mem_total_bytes,omitempty"`
	// Total memory + swap usage. This is set if swap is enabled.
	MemTotalMemswBytes *uint64 `protobuf:"varint,37,opt,name=mem_total_memsw_bytes,json=memTotalMemswBytes" json:"mem_total_memsw_bytes,omitempty"`
	// Hard memory limit for a container.
	MemLimitBytes *uint64 `protobuf:"varint,6,opt,name=mem_limit_bytes,json=memLimitBytes" json:"mem_limit_bytes,omitempty"`
	// Soft memory limit for a container.
	MemSoftLimitBytes *uint64 `protobuf:"varint,38,opt,name=mem_soft_limit_bytes,json=memSoftLimitBytes" json:"mem_soft_limit_bytes,omitempty"`
	// TODO(chzhcn) mem_file_bytes and mem_anon_bytes are deprecated in
	// 0.23.0 and will be removed in 0.24.0.
	MemFileBytes *uint64 `protobuf:"varint,10,opt,name=mem_file_bytes,json=memFileBytes" json:"mem_file_bytes,omitempty"`
	MemAnonBytes *uint64 `protobuf:"varint,11,opt,name=mem_anon_bytes,json=memAnonBytes" json:"mem_anon_bytes,omitempty"`
	// mem_cache_bytes is added in 0.23.0 to represent page cache usage.
	MemCacheBytes *uint64 `protobuf:"varint,39,opt,name=mem_cache_bytes,json=memCacheBytes" json:"mem_cache_bytes,omitempty"`
	// Since 0.23.0, mem_rss_bytes is changed to represent only
	// anonymous memory usage. Note that neither its requiredness, type,
	// name nor numeric tag has been changed.
	MemRssBytes        *uint64 `protobuf:"varint,5,opt,name=mem_rss_bytes,json=memRssBytes" json:"mem_rss_bytes,omitempty"`
	MemMappedFileBytes *uint64 `protobuf:"varint,12,opt,name=mem_mapped_file_bytes,json=memMappedFileBytes" json:"mem_mapped_file_bytes,omitempty"`
	// This is only set if swap is enabled.
	MemSwapBytes        *uint64 `protobuf:"varint,40,opt,name=mem_swap_bytes,json=memSwapBytes" json:"mem_swap_bytes,omitempty"`
	MemUnevictableBytes *uint64 `protobuf:"varint,41,opt,name=mem_unevictable_bytes,json=memUnevictableBytes" json:"mem_unevictable_bytes,omitempty"`
	// Number of occurrences of different levels of memory pressure
	// events reported by memory cgroup. Pressure listening (re)starts
	// with these values set to 0 when agent (re)starts. See
	// https://www.kernel.org/doc/Documentation/cgroups/memory.txt for
	// more details.
	MemLowPressureCounter      *uint64 `protobuf:"varint,32,opt,name=mem_low_pressure_counter,json=memLowPressureCounter" json:"mem_low_pressure_counter,omitempty"`
	MemMediumPressureCounter   *uint64 `protobuf:"varint,33,opt,name=mem_medium_pressure_counter,json=memMediumPressureCounter" json:"mem_medium_pressure_counter,omitempty"`
	MemCriticalPressureCounter *uint64 `protobuf:"varint,34,opt,name=mem_critical_pressure_counter,json=memCriticalPressureCounter" json:"mem_critical_pressure_counter,omitempty"`
	// Disk Usage Information for executor working directory.
	DiskLimitBytes *uint64 `protobuf:"varint,26,opt,name=disk_limit_bytes,json=diskLimitBytes" json:"disk_limit_bytes,omitempty"`
	DiskUsedBytes  *uint64 `protobuf:"varint,27,opt,name=disk_used_bytes,json=diskUsedBytes" json:"disk_used_bytes,omitempty"`
	// Perf statistics.
	Perf *PerfStatistics `protobuf:"bytes,13,opt,name=perf" json:"perf,omitempty"`
	// Network Usage Information:
	NetRxPackets *uint64 `protobuf:"varint,14,opt,name=net_rx_packets,json=netRxPackets" json:"net_rx_packets,omitempty"`
	NetRxBytes   *uint64 `protobuf:"varint,15,opt,name=net_rx_bytes,json=netRxBytes" json:"net_rx_bytes,omitempty"`
	NetRxErrors  *uint64 `protobuf:"varint,16,opt,name=net_rx_errors,json=netRxErrors" json:"net_rx_errors,omitempty"`
	NetRxDropped *uint64 `protobuf:"varint,17,opt,name=net_rx_dropped,json=netRxDropped" json:"net_rx_dropped,omitempty"`
	NetTxPackets *uint64 `protobuf:"varint,18,opt,name=net_tx_packets,json=netTxPackets" json:"net_tx_packets,omitempty"`
	NetTxBytes   *uint64 `protobuf:"varint,19,opt,name=net_tx_bytes,json=netTxBytes" json:"net_tx_bytes,omitempty"`
	NetTxErrors  *uint64 `protobuf:"varint,20,opt,name=net_tx_errors,json=netTxErrors" json:"net_tx_errors,omitempty"`
	NetTxDropped *uint64 `protobuf:"varint,21,opt,name=net_tx_dropped,json=netTxDropped" json:"net_tx_dropped,omitempty"`
	// The kernel keeps track of RTT (round-trip time) for its TCP
	// sockets. RTT is a way to tell the latency of a container.
	NetTcpRttMicrosecsP50     *float64 `protobuf:"fixed64,22,opt,name=net_tcp_rtt_microsecs_p50,json=netTcpRttMicrosecsP50" json:"net_tcp_rtt_microsecs_p50,omitempty"`
	NetTcpRttMicrosecsP90     *float64 `protobuf:"fixed64,23,opt,name=net_tcp_rtt_microsecs_p90,json=netTcpRttMicrosecsP90" json:"net_tcp_rtt_microsecs_p90,omitempty"`
	NetTcpRttMicrosecsP95     *float64 `protobuf:"fixed64,24,opt,name=net_tcp_rtt_microsecs_p95,json=netTcpRttMicrosecsP95" json:"net_tcp_rtt_microsecs_p95,omitempty"`
	NetTcpRttMicrosecsP99     *float64 `protobuf:"fixed64,25,opt,name=net_tcp_rtt_microsecs_p99,json=netTcpRttMicrosecsP99" json:"net_tcp_rtt_microsecs_p99,omitempty"`
	NetTcpActiveConnections   *float64 `protobuf:"fixed64,28,opt,name=net_tcp_active_connections,json=netTcpActiveConnections" json:"net_tcp_active_connections,omitempty"`
	NetTcpTimeWaitConnections *float64 `protobuf:"fixed64,29,opt,name=net_tcp_time_wait_connections,json=netTcpTimeWaitConnections" json:"net_tcp_time_wait_connections,omitempty"`
	// Network traffic flowing into or out of a container can be delayed
	// or dropped due to congestion or policy inside and outside the
	// container.
	NetTrafficControlStatistics []*TrafficControlStatistics `protobuf:"bytes,35,rep,name=net_traffic_control_statistics,json=netTrafficControlStatistics" json:"net_traffic_control_statistics,omitempty"`
	// Network SNMP statistics for each container.
	NetSnmpStatistics *SNMPStatistics `protobuf:"bytes,42,opt,name=net_snmp_statistics,json=netSnmpStatistics" json:"net_snmp_statistics,omitempty"`
	XXX_unrecognized  []byte          `json:"-"`
}

func (m *ResourceStatistics) Reset()                    { *m = ResourceStatistics{} }
func (m *ResourceStatistics) String() string            { return proto.CompactTextString(m) }
func (*ResourceStatistics) ProtoMessage()               {}
func (*ResourceStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{29} }

func (m *ResourceStatistics) GetTimestamp() float64 {
	if m != nil && m.Timestamp != nil {
		return *m.Timestamp
	}
	return 0
}

func (m *ResourceStatistics) GetProcesses() uint32 {
	if m != nil && m.Processes != nil {
		return *m.Processes
	}
	return 0
}

func (m *ResourceStatistics) GetThreads() uint32 {
	if m != nil && m.Threads != nil {
		return *m.Threads
	}
	return 0
}

func (m *ResourceStatistics) GetCpusUserTimeSecs() float64 {
	if m != nil && m.CpusUserTimeSecs != nil {
		return *m.CpusUserTimeSecs
	}
	return 0
}

func (m *ResourceStatistics) GetCpusSystemTimeSecs() float64 {
	if m != nil && m.CpusSystemTimeSecs != nil {
		return *m.CpusSystemTimeSecs
	}
	return 0
}

func (m *ResourceStatistics) GetCpusLimit() float64 {
	if m != nil && m.CpusLimit != nil {
		return *m.CpusLimit
	}
	return 0
}

func (m *ResourceStatistics) GetCpusNrPeriods() uint32 {
	if m != nil && m.CpusNrPeriods != nil {
		return *m.CpusNrPeriods
	}
	return 0
}

func (m *ResourceStatistics) GetCpusNrThrottled() uint32 {
	if m != nil && m.CpusNrThrottled != nil {
		return *m.CpusNrThrottled
	}
	return 0
}

func (m *ResourceStatistics) GetCpusThrottledTimeSecs() float64 {
	if m != nil && m.CpusThrottledTimeSecs != nil {
		return *m.CpusThrottledTimeSecs
	}
	return 0
}

func (m *ResourceStatistics) GetMemTotalBytes() uint64 {
	if m != nil && m.MemTotalBytes != nil {
		return *m.MemTotalBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemTotalMemswBytes() uint64 {
	if m != nil && m.MemTotalMemswBytes != nil {
		return *m.MemTotalMemswBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemLimitBytes() uint64 {
	if m != nil && m.MemLimitBytes != nil {
		return *m.MemLimitBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemSoftLimitBytes() uint64 {
	if m != nil && m.MemSoftLimitBytes != nil {
		return *m.MemSoftLimitBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemFileBytes() uint64 {
	if m != nil && m.MemFileBytes != nil {
		return *m.MemFileBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemAnonBytes() uint64 {
	if m != nil && m.MemAnonBytes != nil {
		return *m.MemAnonBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemCacheBytes() uint64 {
	if m != nil && m.MemCacheBytes != nil {
		return *m.MemCacheBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemRssBytes() uint64 {
	if m != nil && m.MemRssBytes != nil {
		return *m.MemRssBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemMappedFileBytes() uint64 {
	if m != nil && m.MemMappedFileBytes != nil {
		return *m.MemMappedFileBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemSwapBytes() uint64 {
	if m != nil && m.MemSwapBytes != nil {
		return *m.MemSwapBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemUnevictableBytes() uint64 {
	if m != nil && m.MemUnevictableBytes != nil {
		return *m.MemUnevictableBytes
	}
	return 0
}

func (m *ResourceStatistics) GetMemLowPressureCounter() uint64 {
	if m != nil && m.MemLowPressureCounter != nil {
		return *m.MemLowPressureCounter
	}
	return 0
}

func (m *ResourceStatistics) GetMemMediumPressureCounter() uint64 {
	if m != nil && m.MemMediumPressureCounter != nil {
		return *m.MemMediumPressureCounter
	}
	return 0
}

func (m *ResourceStatistics) GetMemCriticalPressureCounter() uint64 {
	if m != nil && m.MemCriticalPressureCounter != nil {
		return *m.MemCriticalPressureCounter
	}
	return 0
}

func (m *ResourceStatistics) GetDiskLimitBytes() uint64 {
	if m != nil && m.DiskLimitBytes != nil {
		return *m.DiskLimitBytes
	}
	return 0
}

func (m *ResourceStatistics) GetDiskUsedBytes() uint64 {
	if m != nil && m.DiskUsedBytes != nil {
		return *m.DiskUsedBytes
	}
	return 0
}

func (m *ResourceStatistics) GetPerf() *PerfStatistics {
	if m != nil {
		return m.Perf
	}
	return nil
}

func (m *ResourceStatistics) GetNetRxPackets() uint64 {
	if m != nil && m.NetRxPackets != nil {
		return *m.NetRxPackets
	}
	return 0
}

func (m *ResourceStatistics) GetNetRxBytes() uint64 {
	if m != nil && m.NetRxBytes != nil {
		return *m.NetRxBytes
	}
	return 0
}

func (m *ResourceStatistics) GetNetRxErrors() uint64 {
	if m != nil && m.NetRxErrors != nil {
		return *m.NetRxErrors
	}
	return 0
}

func (m *ResourceStatistics) GetNetRxDropped() uint64 {
	if m != nil && m.NetRxDropped != nil {
		return *m.NetRxDropped
	}
	return 0
}

func (m *ResourceStatistics) GetNetTxPackets() uint64 {
	if m != nil && m.NetTxPackets != nil {
		return *m.NetTxPackets
	}
	return 0
}

func (m *ResourceStatistics) GetNetTxBytes() uint64 {
	if m != nil && m.NetTxBytes != nil {
		return *m.NetTxBytes
	}
	return 0
}

func (m *ResourceStatistics) GetNetTxErrors() uint64 {
	if m != nil && m.NetTxErrors != nil {
		return *m.NetTxErrors
	}
	return 0
}

func (m *ResourceStatistics) GetNetTxDropped() uint64 {
	if m != nil && m.NetTxDropped != nil {
		return *m.NetTxDropped
	}
	return 0
}

func (m *ResourceStatistics) GetNetTcpRttMicrosecsP50() float64 {
	if m != nil && m.NetTcpRttMicrosecsP50 != nil {
		return *m.NetTcpRttMicrosecsP50
	}
	return 0
}

func (m *ResourceStatistics) GetNetTcpRttMicrosecsP90() float64 {
	if m != nil && m.NetTcpRttMicrosecsP90 != nil {
		return *m.NetTcpRttMicrosecsP90
	}
	return 0
}

func (m *ResourceStatistics) GetNetTcpRttMicrosecsP95() float64 {
	if m != nil && m.NetTcpRttMicrosecsP95 != nil {
		return *m.NetTcpRttMicrosecsP95
	}
	return 0
}

func (m *ResourceStatistics) GetNetTcpRttMicrosecsP99() float64 {
	if m != nil && m.NetTcpRttMicrosecsP99 != nil {
		return *m.NetTcpRttMicrosecsP99
	}
	return 0
}

func (m *ResourceStatistics) GetNetTcpActiveConnections() float64 {
	if m != nil && m.NetTcpActiveConnections != nil {
		return *m.NetTcpActiveConnections
	}
	return 0
}

func (m *ResourceStatistics) GetNetTcpTimeWaitConnections() float64 {
	if m != nil && m.NetTcpTimeWaitConnections != nil {
		return *m.NetTcpTimeWaitConnections
	}
	return 0
}

func (m *ResourceStatistics) GetNetTrafficControlStatistics() []*TrafficControlStatistics {
	if m != nil {
		return m.NetTrafficControlStatistics
	}
	return nil
}

func (m *ResourceStatistics) GetNetSnmpStatistics() *SNMPStatistics {
	if m != nil {
		return m.NetSnmpStatistics
	}
	return nil
}

// *
// Describes a snapshot of the resource usage for executors.
type ResourceUsage struct {
	Executors []*ResourceUsage_Executor `protobuf:"bytes,1,rep,name=executors" json:"executors,omitempty"`
	// Agent's total resources including checkpointed dynamic
	// reservations and persistent volumes.
	Total            []*Resource `protobuf:"bytes,2,rep,name=total" json:"total,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *ResourceUsage) Reset()                    { *m = ResourceUsage{} }
func (m *ResourceUsage) String() string            { return proto.CompactTextString(m) }
func (*ResourceUsage) ProtoMessage()               {}
func (*ResourceUsage) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{30} }

func (m *ResourceUsage) GetExecutors() []*ResourceUsage_Executor {
	if m != nil {
		return m.Executors
	}
	return nil
}

func (m *ResourceUsage) GetTotal() []*Resource {
	if m != nil {
		return m.Total
	}
	return nil
}

type ResourceUsage_Executor struct {
	ExecutorInfo *ExecutorInfo `protobuf:"bytes,1,req,name=executor_info,json=executorInfo" json:"executor_info,omitempty"`
	// This includes resources used by the executor itself
	// as well as its active tasks.
	Allocated []*Resource `protobuf:"bytes,2,rep,name=allocated" json:"allocated,omitempty"`
	// Current resource usage. If absent, the containerizer
	// cannot provide resource usage.
	Statistics *ResourceStatistics `protobuf:"bytes,3,opt,name=statistics" json:"statistics,omitempty"`
	// The container id for the executor specified in the executor_info field.
	ContainerId *ContainerID `protobuf:"bytes,4,req,name=container_id,json=containerId" json:"container_id,omitempty"`
	// Non-terminal tasks.
	Tasks            []*ResourceUsage_Executor_Task `protobuf:"bytes,5,rep,name=tasks" json:"tasks,omitempty"`
	XXX_unrecognized []byte                         `json:"-"`
}

func (m *ResourceUsage_Executor) Reset()                    { *m = ResourceUsage_Executor{} }
func (m *ResourceUsage_Executor) String() string            { return proto.CompactTextString(m) }
func (*ResourceUsage_Executor) ProtoMessage()               {}
func (*ResourceUsage_Executor) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{30, 0} }

func (m *ResourceUsage_Executor) GetExecutorInfo() *ExecutorInfo {
	if m != nil {
		return m.ExecutorInfo
	}
	return nil
}

func (m *ResourceUsage_Executor) GetAllocated() []*Resource {
	if m != nil {
		return m.Allocated
	}
	return nil
}

func (m *ResourceUsage_Executor) GetStatistics() *ResourceStatistics {
	if m != nil {
		return m.Statistics
	}
	return nil
}

func (m *ResourceUsage_Executor) GetContainerId() *ContainerID {
	if m != nil {
		return m.ContainerId
	}
	return nil
}

func (m *ResourceUsage_Executor) GetTasks() []*ResourceUsage_Executor_Task {
	if m != nil {
		return m.Tasks
	}
	return nil
}

type ResourceUsage_Executor_Task struct {
	Name             *string     `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Id               *TaskID     `protobuf:"bytes,2,req,name=id" json:"id,omitempty"`
	Resources        []*Resource `protobuf:"bytes,3,rep,name=resources" json:"resources,omitempty"`
	Labels           *Labels     `protobuf:"bytes,4,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *ResourceUsage_Executor_Task) Reset()         { *m = ResourceUsage_Executor_Task{} }
func (m *ResourceUsage_Executor_Task) String() string { return proto.CompactTextString(m) }
func (*ResourceUsage_Executor_Task) ProtoMessage()    {}
func (*ResourceUsage_Executor_Task) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{30, 0, 0}
}

func (m *ResourceUsage_Executor_Task) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *ResourceUsage_Executor_Task) GetId() *TaskID {
	if m != nil {
		return m.Id
	}
	return nil
}

func (m *ResourceUsage_Executor_Task) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *ResourceUsage_Executor_Task) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

// *
// Describes a sample of events from "perf stat". Only available on
// Linux.
//
// NOTE: Each optional field matches the name of a perf event (see
// "perf list") with the following changes:
// 1. Names are downcased.
// 2. Hyphens ('-') are replaced with underscores ('_').
// 3. Events with alternate names use the name "perf stat" returns,
//    e.g., for the event "cycles OR cpu-cycles" perf always returns
//    cycles.
type PerfStatistics struct {
	Timestamp *float64 `protobuf:"fixed64,1,req,name=timestamp" json:"timestamp,omitempty"`
	Duration  *float64 `protobuf:"fixed64,2,req,name=duration" json:"duration,omitempty"`
	// Hardware event.
	Cycles                *uint64 `protobuf:"varint,3,opt,name=cycles" json:"cycles,omitempty"`
	StalledCyclesFrontend *uint64 `protobuf:"varint,4,opt,name=stalled_cycles_frontend,json=stalledCyclesFrontend" json:"stalled_cycles_frontend,omitempty"`
	StalledCyclesBackend  *uint64 `protobuf:"varint,5,opt,name=stalled_cycles_backend,json=stalledCyclesBackend" json:"stalled_cycles_backend,omitempty"`
	Instructions          *uint64 `protobuf:"varint,6,opt,name=instructions" json:"instructions,omitempty"`
	CacheReferences       *uint64 `protobuf:"varint,7,opt,name=cache_references,json=cacheReferences" json:"cache_references,omitempty"`
	CacheMisses           *uint64 `protobuf:"varint,8,opt,name=cache_misses,json=cacheMisses" json:"cache_misses,omitempty"`
	Branches              *uint64 `protobuf:"varint,9,opt,name=branches" json:"branches,omitempty"`
	BranchMisses          *uint64 `protobuf:"varint,10,opt,name=branch_misses,json=branchMisses" json:"branch_misses,omitempty"`
	BusCycles             *uint64 `protobuf:"varint,11,opt,name=bus_cycles,json=busCycles" json:"bus_cycles,omitempty"`
	RefCycles             *uint64 `protobuf:"varint,12,opt,name=ref_cycles,json=refCycles" json:"ref_cycles,omitempty"`
	// Software event.
	CpuClock        *float64 `protobuf:"fixed64,13,opt,name=cpu_clock,json=cpuClock" json:"cpu_clock,omitempty"`
	TaskClock       *float64 `protobuf:"fixed64,14,opt,name=task_clock,json=taskClock" json:"task_clock,omitempty"`
	PageFaults      *uint64  `protobuf:"varint,15,opt,name=page_faults,json=pageFaults" json:"page_faults,omitempty"`
	MinorFaults     *uint64  `protobuf:"varint,16,opt,name=minor_faults,json=minorFaults" json:"minor_faults,omitempty"`
	MajorFaults     *uint64  `protobuf:"varint,17,opt,name=major_faults,json=majorFaults" json:"major_faults,omitempty"`
	ContextSwitches *uint64  `protobuf:"varint,18,opt,name=context_switches,json=contextSwitches" json:"context_switches,omitempty"`
	CpuMigrations   *uint64  `protobuf:"varint,19,opt,name=cpu_migrations,json=cpuMigrations" json:"cpu_migrations,omitempty"`
	AlignmentFaults *uint64  `protobuf:"varint,20,opt,name=alignment_faults,json=alignmentFaults" json:"alignment_faults,omitempty"`
	EmulationFaults *uint64  `protobuf:"varint,21,opt,name=emulation_faults,json=emulationFaults" json:"emulation_faults,omitempty"`
	// Hardware cache event.
	L1DcacheLoads          *uint64 `protobuf:"varint,22,opt,name=l1_dcache_loads,json=l1DcacheLoads" json:"l1_dcache_loads,omitempty"`
	L1DcacheLoadMisses     *uint64 `protobuf:"varint,23,opt,name=l1_dcache_load_misses,json=l1DcacheLoadMisses" json:"l1_dcache_load_misses,omitempty"`
	L1DcacheStores         *uint64 `protobuf:"varint,24,opt,name=l1_dcache_stores,json=l1DcacheStores" json:"l1_dcache_stores,omitempty"`
	L1DcacheStoreMisses    *uint64 `protobuf:"varint,25,opt,name=l1_dcache_store_misses,json=l1DcacheStoreMisses" json:"l1_dcache_store_misses,omitempty"`
	L1DcachePrefetches     *uint64 `protobuf:"varint,26,opt,name=l1_dcache_prefetches,json=l1DcachePrefetches" json:"l1_dcache_prefetches,omitempty"`
	L1DcachePrefetchMisses *uint64 `protobuf:"varint,27,opt,name=l1_dcache_prefetch_misses,json=l1DcachePrefetchMisses" json:"l1_dcache_prefetch_misses,omitempty"`
	L1IcacheLoads          *uint64 `protobuf:"varint,28,opt,name=l1_icache_loads,json=l1IcacheLoads" json:"l1_icache_loads,omitempty"`
	L1IcacheLoadMisses     *uint64 `protobuf:"varint,29,opt,name=l1_icache_load_misses,json=l1IcacheLoadMisses" json:"l1_icache_load_misses,omitempty"`
	L1IcachePrefetches     *uint64 `protobuf:"varint,30,opt,name=l1_icache_prefetches,json=l1IcachePrefetches" json:"l1_icache_prefetches,omitempty"`
	L1IcachePrefetchMisses *uint64 `protobuf:"varint,31,opt,name=l1_icache_prefetch_misses,json=l1IcachePrefetchMisses" json:"l1_icache_prefetch_misses,omitempty"`
	LlcLoads               *uint64 `protobuf:"varint,32,opt,name=llc_loads,json=llcLoads" json:"llc_loads,omitempty"`
	LlcLoadMisses          *uint64 `protobuf:"varint,33,opt,name=llc_load_misses,json=llcLoadMisses" json:"llc_load_misses,omitempty"`
	LlcStores              *uint64 `protobuf:"varint,34,opt,name=llc_stores,json=llcStores" json:"llc_stores,omitempty"`
	LlcStoreMisses         *uint64 `protobuf:"varint,35,opt,name=llc_store_misses,json=llcStoreMisses" json:"llc_store_misses,omitempty"`
	LlcPrefetches          *uint64 `protobuf:"varint,36,opt,name=llc_prefetches,json=llcPrefetches" json:"llc_prefetches,omitempty"`
	LlcPrefetchMisses      *uint64 `protobuf:"varint,37,opt,name=llc_prefetch_misses,json=llcPrefetchMisses" json:"llc_prefetch_misses,omitempty"`
	DtlbLoads              *uint64 `protobuf:"varint,38,opt,name=dtlb_loads,json=dtlbLoads" json:"dtlb_loads,omitempty"`
	DtlbLoadMisses         *uint64 `protobuf:"varint,39,opt,name=dtlb_load_misses,json=dtlbLoadMisses" json:"dtlb_load_misses,omitempty"`
	DtlbStores             *uint64 `protobuf:"varint,40,opt,name=dtlb_stores,json=dtlbStores" json:"dtlb_stores,omitempty"`
	DtlbStoreMisses        *uint64 `protobuf:"varint,41,opt,name=dtlb_store_misses,json=dtlbStoreMisses" json:"dtlb_store_misses,omitempty"`
	DtlbPrefetches         *uint64 `protobuf:"varint,42,opt,name=dtlb_prefetches,json=dtlbPrefetches" json:"dtlb_prefetches,omitempty"`
	DtlbPrefetchMisses     *uint64 `protobuf:"varint,43,opt,name=dtlb_prefetch_misses,json=dtlbPrefetchMisses" json:"dtlb_prefetch_misses,omitempty"`
	ItlbLoads              *uint64 `protobuf:"varint,44,opt,name=itlb_loads,json=itlbLoads" json:"itlb_loads,omitempty"`
	ItlbLoadMisses         *uint64 `protobuf:"varint,45,opt,name=itlb_load_misses,json=itlbLoadMisses" json:"itlb_load_misses,omitempty"`
	BranchLoads            *uint64 `protobuf:"varint,46,opt,name=branch_loads,json=branchLoads" json:"branch_loads,omitempty"`
	BranchLoadMisses       *uint64 `protobuf:"varint,47,opt,name=branch_load_misses,json=branchLoadMisses" json:"branch_load_misses,omitempty"`
	NodeLoads              *uint64 `protobuf:"varint,48,opt,name=node_loads,json=nodeLoads" json:"node_loads,omitempty"`
	NodeLoadMisses         *uint64 `protobuf:"varint,49,opt,name=node_load_misses,json=nodeLoadMisses" json:"node_load_misses,omitempty"`
	NodeStores             *uint64 `protobuf:"varint,50,opt,name=node_stores,json=nodeStores" json:"node_stores,omitempty"`
	NodeStoreMisses        *uint64 `protobuf:"varint,51,opt,name=node_store_misses,json=nodeStoreMisses" json:"node_store_misses,omitempty"`
	NodePrefetches         *uint64 `protobuf:"varint,52,opt,name=node_prefetches,json=nodePrefetches" json:"node_prefetches,omitempty"`
	NodePrefetchMisses     *uint64 `protobuf:"varint,53,opt,name=node_prefetch_misses,json=nodePrefetchMisses" json:"node_prefetch_misses,omitempty"`
	XXX_unrecognized       []byte  `json:"-"`
}

func (m *PerfStatistics) Reset()                    { *m = PerfStatistics{} }
func (m *PerfStatistics) String() string            { return proto.CompactTextString(m) }
func (*PerfStatistics) ProtoMessage()               {}
func (*PerfStatistics) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{31} }

func (m *PerfStatistics) GetTimestamp() float64 {
	if m != nil && m.Timestamp != nil {
		return *m.Timestamp
	}
	return 0
}

func (m *PerfStatistics) GetDuration() float64 {
	if m != nil && m.Duration != nil {
		return *m.Duration
	}
	return 0
}

func (m *PerfStatistics) GetCycles() uint64 {
	if m != nil && m.Cycles != nil {
		return *m.Cycles
	}
	return 0
}

func (m *PerfStatistics) GetStalledCyclesFrontend() uint64 {
	if m != nil && m.StalledCyclesFrontend != nil {
		return *m.StalledCyclesFrontend
	}
	return 0
}

func (m *PerfStatistics) GetStalledCyclesBackend() uint64 {
	if m != nil && m.StalledCyclesBackend != nil {
		return *m.StalledCyclesBackend
	}
	return 0
}

func (m *PerfStatistics) GetInstructions() uint64 {
	if m != nil && m.Instructions != nil {
		return *m.Instructions
	}
	return 0
}

func (m *PerfStatistics) GetCacheReferences() uint64 {
	if m != nil && m.CacheReferences != nil {
		return *m.CacheReferences
	}
	return 0
}

func (m *PerfStatistics) GetCacheMisses() uint64 {
	if m != nil && m.CacheMisses != nil {
		return *m.CacheMisses
	}
	return 0
}

func (m *PerfStatistics) GetBranches() uint64 {
	if m != nil && m.Branches != nil {
		return *m.Branches
	}
	return 0
}

func (m *PerfStatistics) GetBranchMisses() uint64 {
	if m != nil && m.BranchMisses != nil {
		return *m.BranchMisses
	}
	return 0
}

func (m *PerfStatistics) GetBusCycles() uint64 {
	if m != nil && m.BusCycles != nil {
		return *m.BusCycles
	}
	return 0
}

func (m *PerfStatistics) GetRefCycles() uint64 {
	if m != nil && m.RefCycles != nil {
		return *m.RefCycles
	}
	return 0
}

func (m *PerfStatistics) GetCpuClock() float64 {
	if m != nil && m.CpuClock != nil {
		return *m.CpuClock
	}
	return 0
}

func (m *PerfStatistics) GetTaskClock() float64 {
	if m != nil && m.TaskClock != nil {
		return *m.TaskClock
	}
	return 0
}

func (m *PerfStatistics) GetPageFaults() uint64 {
	if m != nil && m.PageFaults != nil {
		return *m.PageFaults
	}
	return 0
}

func (m *PerfStatistics) GetMinorFaults() uint64 {
	if m != nil && m.MinorFaults != nil {
		return *m.MinorFaults
	}
	return 0
}

func (m *PerfStatistics) GetMajorFaults() uint64 {
	if m != nil && m.MajorFaults != nil {
		return *m.MajorFaults
	}
	return 0
}

func (m *PerfStatistics) GetContextSwitches() uint64 {
	if m != nil && m.ContextSwitches != nil {
		return *m.ContextSwitches
	}
	return 0
}

func (m *PerfStatistics) GetCpuMigrations() uint64 {
	if m != nil && m.CpuMigrations != nil {
		return *m.CpuMigrations
	}
	return 0
}

func (m *PerfStatistics) GetAlignmentFaults() uint64 {
	if m != nil && m.AlignmentFaults != nil {
		return *m.AlignmentFaults
	}
	return 0
}

func (m *PerfStatistics) GetEmulationFaults() uint64 {
	if m != nil && m.EmulationFaults != nil {
		return *m.EmulationFaults
	}
	return 0
}

func (m *PerfStatistics) GetL1DcacheLoads() uint64 {
	if m != nil && m.L1DcacheLoads != nil {
		return *m.L1DcacheLoads
	}
	return 0
}

func (m *PerfStatistics) GetL1DcacheLoadMisses() uint64 {
	if m != nil && m.L1DcacheLoadMisses != nil {
		return *m.L1DcacheLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetL1DcacheStores() uint64 {
	if m != nil && m.L1DcacheStores != nil {
		return *m.L1DcacheStores
	}
	return 0
}

func (m *PerfStatistics) GetL1DcacheStoreMisses() uint64 {
	if m != nil && m.L1DcacheStoreMisses != nil {
		return *m.L1DcacheStoreMisses
	}
	return 0
}

func (m *PerfStatistics) GetL1DcachePrefetches() uint64 {
	if m != nil && m.L1DcachePrefetches != nil {
		return *m.L1DcachePrefetches
	}
	return 0
}

func (m *PerfStatistics) GetL1DcachePrefetchMisses() uint64 {
	if m != nil && m.L1DcachePrefetchMisses != nil {
		return *m.L1DcachePrefetchMisses
	}
	return 0
}

func (m *PerfStatistics) GetL1IcacheLoads() uint64 {
	if m != nil && m.L1IcacheLoads != nil {
		return *m.L1IcacheLoads
	}
	return 0
}

func (m *PerfStatistics) GetL1IcacheLoadMisses() uint64 {
	if m != nil && m.L1IcacheLoadMisses != nil {
		return *m.L1IcacheLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetL1IcachePrefetches() uint64 {
	if m != nil && m.L1IcachePrefetches != nil {
		return *m.L1IcachePrefetches
	}
	return 0
}

func (m *PerfStatistics) GetL1IcachePrefetchMisses() uint64 {
	if m != nil && m.L1IcachePrefetchMisses != nil {
		return *m.L1IcachePrefetchMisses
	}
	return 0
}

func (m *PerfStatistics) GetLlcLoads() uint64 {
	if m != nil && m.LlcLoads != nil {
		return *m.LlcLoads
	}
	return 0
}

func (m *PerfStatistics) GetLlcLoadMisses() uint64 {
	if m != nil && m.LlcLoadMisses != nil {
		return *m.LlcLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetLlcStores() uint64 {
	if m != nil && m.LlcStores != nil {
		return *m.LlcStores
	}
	return 0
}

func (m *PerfStatistics) GetLlcStoreMisses() uint64 {
	if m != nil && m.LlcStoreMisses != nil {
		return *m.LlcStoreMisses
	}
	return 0
}

func (m *PerfStatistics) GetLlcPrefetches() uint64 {
	if m != nil && m.LlcPrefetches != nil {
		return *m.LlcPrefetches
	}
	return 0
}

func (m *PerfStatistics) GetLlcPrefetchMisses() uint64 {
	if m != nil && m.LlcPrefetchMisses != nil {
		return *m.LlcPrefetchMisses
	}
	return 0
}

func (m *PerfStatistics) GetDtlbLoads() uint64 {
	if m != nil && m.DtlbLoads != nil {
		return *m.DtlbLoads
	}
	return 0
}

func (m *PerfStatistics) GetDtlbLoadMisses() uint64 {
	if m != nil && m.DtlbLoadMisses != nil {
		return *m.DtlbLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetDtlbStores() uint64 {
	if m != nil && m.DtlbStores != nil {
		return *m.DtlbStores
	}
	return 0
}

func (m *PerfStatistics) GetDtlbStoreMisses() uint64 {
	if m != nil && m.DtlbStoreMisses != nil {
		return *m.DtlbStoreMisses
	}
	return 0
}

func (m *PerfStatistics) GetDtlbPrefetches() uint64 {
	if m != nil && m.DtlbPrefetches != nil {
		return *m.DtlbPrefetches
	}
	return 0
}

func (m *PerfStatistics) GetDtlbPrefetchMisses() uint64 {
	if m != nil && m.DtlbPrefetchMisses != nil {
		return *m.DtlbPrefetchMisses
	}
	return 0
}

func (m *PerfStatistics) GetItlbLoads() uint64 {
	if m != nil && m.ItlbLoads != nil {
		return *m.ItlbLoads
	}
	return 0
}

func (m *PerfStatistics) GetItlbLoadMisses() uint64 {
	if m != nil && m.ItlbLoadMisses != nil {
		return *m.ItlbLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetBranchLoads() uint64 {
	if m != nil && m.BranchLoads != nil {
		return *m.BranchLoads
	}
	return 0
}

func (m *PerfStatistics) GetBranchLoadMisses() uint64 {
	if m != nil && m.BranchLoadMisses != nil {
		return *m.BranchLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetNodeLoads() uint64 {
	if m != nil && m.NodeLoads != nil {
		return *m.NodeLoads
	}
	return 0
}

func (m *PerfStatistics) GetNodeLoadMisses() uint64 {
	if m != nil && m.NodeLoadMisses != nil {
		return *m.NodeLoadMisses
	}
	return 0
}

func (m *PerfStatistics) GetNodeStores() uint64 {
	if m != nil && m.NodeStores != nil {
		return *m.NodeStores
	}
	return 0
}

func (m *PerfStatistics) GetNodeStoreMisses() uint64 {
	if m != nil && m.NodeStoreMisses != nil {
		return *m.NodeStoreMisses
	}
	return 0
}

func (m *PerfStatistics) GetNodePrefetches() uint64 {
	if m != nil && m.NodePrefetches != nil {
		return *m.NodePrefetches
	}
	return 0
}

func (m *PerfStatistics) GetNodePrefetchMisses() uint64 {
	if m != nil && m.NodePrefetchMisses != nil {
		return *m.NodePrefetchMisses
	}
	return 0
}

// *
// Describes a request for resources that can be used by a framework
// to proactively influence the allocator.  If 'agent_id' is provided
// then this request is assumed to only apply to resources on that
// agent.
type Request struct {
	AgentId          *AgentID    `protobuf:"bytes,1,opt,name=agent_id,json=agentId" json:"agent_id,omitempty"`
	Resources        []*Resource `protobuf:"bytes,2,rep,name=resources" json:"resources,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Request) Reset()                    { *m = Request{} }
func (m *Request) String() string            { return proto.CompactTextString(m) }
func (*Request) ProtoMessage()               {}
func (*Request) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{32} }

func (m *Request) GetAgentId() *AgentID {
	if m != nil {
		return m.AgentId
	}
	return nil
}

func (m *Request) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

// *
// Describes some resources available on an agent. An offer only
// contains resources from a single agent.
type Offer struct {
	Id          *OfferID     `protobuf:"bytes,1,req,name=id" json:"id,omitempty"`
	FrameworkId *FrameworkID `protobuf:"bytes,2,req,name=framework_id,json=frameworkId" json:"framework_id,omitempty"`
	AgentId     *AgentID     `protobuf:"bytes,3,req,name=agent_id,json=agentId" json:"agent_id,omitempty"`
	Hostname    *string      `protobuf:"bytes,4,req,name=hostname" json:"hostname,omitempty"`
	// URL for reaching the agent running on the host.
	Url         *URL          `protobuf:"bytes,8,opt,name=url" json:"url,omitempty"`
	Resources   []*Resource   `protobuf:"bytes,5,rep,name=resources" json:"resources,omitempty"`
	Attributes  []*Attribute  `protobuf:"bytes,7,rep,name=attributes" json:"attributes,omitempty"`
	ExecutorIds []*ExecutorID `protobuf:"bytes,6,rep,name=executor_ids,json=executorIds" json:"executor_ids,omitempty"`
	// Signifies that the resources in this Offer may be unavailable during
	// the given interval.  Any tasks launched using these resources may be
	// killed when the interval arrives.  For example, these resources may be
	// part of a planned maintenance schedule.
	//
	// This field only provides information about a planned unavailability.
	// The unavailability interval may not necessarily start at exactly this
	// interval, nor last for exactly the duration of this interval.
	// The unavailability may also be forever!  See comments in
	// `Unavailability` for more details.
	Unavailability   *Unavailability `protobuf:"bytes,9,opt,name=unavailability" json:"unavailability,omitempty"`
	XXX_unrecognized []byte          `json:"-"`
}

func (m *Offer) Reset()                    { *m = Offer{} }
func (m *Offer) String() string            { return proto.CompactTextString(m) }
func (*Offer) ProtoMessage()               {}
func (*Offer) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{33} }

func (m *Offer) GetId() *OfferID {
	if m != nil {
		return m.Id
	}
	return nil
}

func (m *Offer) GetFrameworkId() *FrameworkID {
	if m != nil {
		return m.FrameworkId
	}
	return nil
}

func (m *Offer) GetAgentId() *AgentID {
	if m != nil {
		return m.AgentId
	}
	return nil
}

func (m *Offer) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *Offer) GetUrl() *URL {
	if m != nil {
		return m.Url
	}
	return nil
}

func (m *Offer) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *Offer) GetAttributes() []*Attribute {
	if m != nil {
		return m.Attributes
	}
	return nil
}

func (m *Offer) GetExecutorIds() []*ExecutorID {
	if m != nil {
		return m.ExecutorIds
	}
	return nil
}

func (m *Offer) GetUnavailability() *Unavailability {
	if m != nil {
		return m.Unavailability
	}
	return nil
}

// Defines an operation that can be performed against offers.
type Offer_Operation struct {
	Type             *Offer_Operation_Type        `protobuf:"varint,1,opt,name=type,enum=mesos.v1.Offer_Operation_Type" json:"type,omitempty"`
	Launch           *Offer_Operation_Launch      `protobuf:"bytes,2,opt,name=launch" json:"launch,omitempty"`
	LaunchGroup      *Offer_Operation_LaunchGroup `protobuf:"bytes,7,opt,name=launch_group,json=launchGroup" json:"launch_group,omitempty"`
	Reserve          *Offer_Operation_Reserve     `protobuf:"bytes,3,opt,name=reserve" json:"reserve,omitempty"`
	Unreserve        *Offer_Operation_Unreserve   `protobuf:"bytes,4,opt,name=unreserve" json:"unreserve,omitempty"`
	Create           *Offer_Operation_Create      `protobuf:"bytes,5,opt,name=create" json:"create,omitempty"`
	Destroy          *Offer_Operation_Destroy     `protobuf:"bytes,6,opt,name=destroy" json:"destroy,omitempty"`
	XXX_unrecognized []byte                       `json:"-"`
}

func (m *Offer_Operation) Reset()                    { *m = Offer_Operation{} }
func (m *Offer_Operation) String() string            { return proto.CompactTextString(m) }
func (*Offer_Operation) ProtoMessage()               {}
func (*Offer_Operation) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{33, 0} }

func (m *Offer_Operation) GetType() Offer_Operation_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Offer_Operation_UNKNOWN
}

func (m *Offer_Operation) GetLaunch() *Offer_Operation_Launch {
	if m != nil {
		return m.Launch
	}
	return nil
}

func (m *Offer_Operation) GetLaunchGroup() *Offer_Operation_LaunchGroup {
	if m != nil {
		return m.LaunchGroup
	}
	return nil
}

func (m *Offer_Operation) GetReserve() *Offer_Operation_Reserve {
	if m != nil {
		return m.Reserve
	}
	return nil
}

func (m *Offer_Operation) GetUnreserve() *Offer_Operation_Unreserve {
	if m != nil {
		return m.Unreserve
	}
	return nil
}

func (m *Offer_Operation) GetCreate() *Offer_Operation_Create {
	if m != nil {
		return m.Create
	}
	return nil
}

func (m *Offer_Operation) GetDestroy() *Offer_Operation_Destroy {
	if m != nil {
		return m.Destroy
	}
	return nil
}

// TODO(vinod): Deprecate this in favor of `LaunchGroup` below.
type Offer_Operation_Launch struct {
	TaskInfos        []*TaskInfo `protobuf:"bytes,1,rep,name=task_infos,json=taskInfos" json:"task_infos,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Offer_Operation_Launch) Reset()                    { *m = Offer_Operation_Launch{} }
func (m *Offer_Operation_Launch) String() string            { return proto.CompactTextString(m) }
func (*Offer_Operation_Launch) ProtoMessage()               {}
func (*Offer_Operation_Launch) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{33, 0, 0} }

func (m *Offer_Operation_Launch) GetTaskInfos() []*TaskInfo {
	if m != nil {
		return m.TaskInfos
	}
	return nil
}

// Unlike `Launch` above, all the tasks in a `task_group` are
// atomically delivered to an executor.
//
// `NetworkInfo` set on executor will be shared by all tasks in
// the task group.
//
// TODO(vinod): Any volumes set on executor could be used by a
// task by explicitly setting `Volume.source` in its resources.
type Offer_Operation_LaunchGroup struct {
	Executor         *ExecutorInfo  `protobuf:"bytes,1,req,name=executor" json:"executor,omitempty"`
	TaskGroup        *TaskGroupInfo `protobuf:"bytes,2,req,name=task_group,json=taskGroup" json:"task_group,omitempty"`
	XXX_unrecognized []byte         `json:"-"`
}

func (m *Offer_Operation_LaunchGroup) Reset()         { *m = Offer_Operation_LaunchGroup{} }
func (m *Offer_Operation_LaunchGroup) String() string { return proto.CompactTextString(m) }
func (*Offer_Operation_LaunchGroup) ProtoMessage()    {}
func (*Offer_Operation_LaunchGroup) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{33, 0, 1}
}

func (m *Offer_Operation_LaunchGroup) GetExecutor() *ExecutorInfo {
	if m != nil {
		return m.Executor
	}
	return nil
}

func (m *Offer_Operation_LaunchGroup) GetTaskGroup() *TaskGroupInfo {
	if m != nil {
		return m.TaskGroup
	}
	return nil
}

type Offer_Operation_Reserve struct {
	Resources        []*Resource `protobuf:"bytes,1,rep,name=resources" json:"resources,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Offer_Operation_Reserve) Reset()                    { *m = Offer_Operation_Reserve{} }
func (m *Offer_Operation_Reserve) String() string            { return proto.CompactTextString(m) }
func (*Offer_Operation_Reserve) ProtoMessage()               {}
func (*Offer_Operation_Reserve) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{33, 0, 2} }

func (m *Offer_Operation_Reserve) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

type Offer_Operation_Unreserve struct {
	Resources        []*Resource `protobuf:"bytes,1,rep,name=resources" json:"resources,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Offer_Operation_Unreserve) Reset()         { *m = Offer_Operation_Unreserve{} }
func (m *Offer_Operation_Unreserve) String() string { return proto.CompactTextString(m) }
func (*Offer_Operation_Unreserve) ProtoMessage()    {}
func (*Offer_Operation_Unreserve) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{33, 0, 3}
}

func (m *Offer_Operation_Unreserve) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

type Offer_Operation_Create struct {
	Volumes          []*Resource `protobuf:"bytes,1,rep,name=volumes" json:"volumes,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Offer_Operation_Create) Reset()                    { *m = Offer_Operation_Create{} }
func (m *Offer_Operation_Create) String() string            { return proto.CompactTextString(m) }
func (*Offer_Operation_Create) ProtoMessage()               {}
func (*Offer_Operation_Create) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{33, 0, 4} }

func (m *Offer_Operation_Create) GetVolumes() []*Resource {
	if m != nil {
		return m.Volumes
	}
	return nil
}

type Offer_Operation_Destroy struct {
	Volumes          []*Resource `protobuf:"bytes,1,rep,name=volumes" json:"volumes,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Offer_Operation_Destroy) Reset()                    { *m = Offer_Operation_Destroy{} }
func (m *Offer_Operation_Destroy) String() string            { return proto.CompactTextString(m) }
func (*Offer_Operation_Destroy) ProtoMessage()               {}
func (*Offer_Operation_Destroy) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{33, 0, 5} }

func (m *Offer_Operation_Destroy) GetVolumes() []*Resource {
	if m != nil {
		return m.Volumes
	}
	return nil
}

// *
// A request to return some resources occupied by a framework.
type InverseOffer struct {
	// This is the same OfferID as found in normal offers, which allows
	// re-use of some of the OfferID-only messages.
	Id *OfferID `protobuf:"bytes,1,req,name=id" json:"id,omitempty"`
	// URL for reaching the agent running on the host.  This enables some
	// optimizations as described in MESOS-3012, such as allowing the
	// scheduler driver to bypass the master and talk directly with an agent.
	Url *URL `protobuf:"bytes,2,opt,name=url" json:"url,omitempty"`
	// The framework that should release its resources.
	// If no specifics are provided (i.e. which agent), all the framework's
	// resources are requested back.
	FrameworkId *FrameworkID `protobuf:"bytes,3,req,name=framework_id,json=frameworkId" json:"framework_id,omitempty"`
	// Specified if the resources need to be released from a particular agent.
	// All the framework's resources on this agent are requested back,
	// unless further qualified by the `resources` field.
	AgentId *AgentID `protobuf:"bytes,4,opt,name=agent_id,json=agentId" json:"agent_id,omitempty"`
	// This InverseOffer represents a planned unavailability event in the
	// specified interval.  Any tasks running on the given framework or agent
	// may be killed when the interval arrives.  Therefore, frameworks should
	// aim to gracefully terminate tasks prior to the arrival of the interval.
	//
	// For reserved resources, the resources are expected to be returned to the
	// framework after the unavailability interval.  This is an expectation,
	// not a guarantee.  For example, if the unavailability duration is not set,
	// the resources may be removed permanently.
	//
	// For other resources, there is no guarantee that requested resources will
	// be returned after the unavailability interval.  The allocator has no
	// obligation to re-offer these resources to the prior framework after
	// the unavailability.
	Unavailability *Unavailability `protobuf:"bytes,5,req,name=unavailability" json:"unavailability,omitempty"`
	// A list of resources being requested back from the framework,
	// on the agent identified by `agent_id`.  If no resources are specified
	// then all resources are being requested back.  For the purpose of
	// maintenance, this field is always empty (maintenance always requests
	// all resources back).
	Resources        []*Resource `protobuf:"bytes,6,rep,name=resources" json:"resources,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *InverseOffer) Reset()                    { *m = InverseOffer{} }
func (m *InverseOffer) String() string            { return proto.CompactTextString(m) }
func (*InverseOffer) ProtoMessage()               {}
func (*InverseOffer) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{34} }

func (m *InverseOffer) GetId() *OfferID {
	if m != nil {
		return m.Id
	}
	return nil
}

func (m *InverseOffer) GetUrl() *URL {
	if m != nil {
		return m.Url
	}
	return nil
}

func (m *InverseOffer) GetFrameworkId() *FrameworkID {
	if m != nil {
		return m.FrameworkId
	}
	return nil
}

func (m *InverseOffer) GetAgentId() *AgentID {
	if m != nil {
		return m.AgentId
	}
	return nil
}

func (m *InverseOffer) GetUnavailability() *Unavailability {
	if m != nil {
		return m.Unavailability
	}
	return nil
}

func (m *InverseOffer) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

// *
// Describes a task. Passed from the scheduler all the way to an
// executor (see SchedulerDriver::launchTasks and
// Executor::launchTask). Either ExecutorInfo or CommandInfo should be set.
// A different executor can be used to launch this task, and subsequent tasks
// meant for the same executor can reuse the same ExecutorInfo struct.
type TaskInfo struct {
	Name      *string       `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	TaskId    *TaskID       `protobuf:"bytes,2,req,name=task_id,json=taskId" json:"task_id,omitempty"`
	AgentId   *AgentID      `protobuf:"bytes,3,req,name=agent_id,json=agentId" json:"agent_id,omitempty"`
	Resources []*Resource   `protobuf:"bytes,4,rep,name=resources" json:"resources,omitempty"`
	Executor  *ExecutorInfo `protobuf:"bytes,5,opt,name=executor" json:"executor,omitempty"`
	Command   *CommandInfo  `protobuf:"bytes,7,opt,name=command" json:"command,omitempty"`
	// Task provided with a container will launch the container as part
	// of this task paired with the task's CommandInfo.
	Container *ContainerInfo `protobuf:"bytes,9,opt,name=container" json:"container,omitempty"`
	// A health check for the task. Implemented for executor-less
	// command-based tasks. For tasks that specify an executor, it is
	// the executor's responsibility to implement the health checking.
	HealthCheck *HealthCheck `protobuf:"bytes,8,opt,name=health_check,json=healthCheck" json:"health_check,omitempty"`
	// A kill policy for the task. Implemented for executor-less
	// command-based and docker tasks. For tasks that specify other
	// executor, it is the executor's responsibility to implement
	// the kill policy.
	KillPolicy *KillPolicy `protobuf:"bytes,12,opt,name=kill_policy,json=killPolicy" json:"kill_policy,omitempty"`
	Data       []byte      `protobuf:"bytes,6,opt,name=data" json:"data,omitempty"`
	// Labels are free-form key value pairs which are exposed through
	// master and agent endpoints. Labels will not be interpreted or
	// acted upon by Mesos itself. As opposed to the data field, labels
	// will be kept in memory on master and agent processes. Therefore,
	// labels should be used to tag tasks with light-weight meta-data.
	// Labels should not contain duplicate key-value pairs.
	Labels *Labels `protobuf:"bytes,10,opt,name=labels" json:"labels,omitempty"`
	// Service discovery information for the task. It is not interpreted
	// or acted upon by Mesos. It is up to a service discovery system
	// to use this information as needed and to handle tasks without
	// service discovery information.
	Discovery        *DiscoveryInfo `protobuf:"bytes,11,opt,name=discovery" json:"discovery,omitempty"`
	XXX_unrecognized []byte         `json:"-"`
}

func (m *TaskInfo) Reset()                    { *m = TaskInfo{} }
func (m *TaskInfo) String() string            { return proto.CompactTextString(m) }
func (*TaskInfo) ProtoMessage()               {}
func (*TaskInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{35} }

func (m *TaskInfo) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *TaskInfo) GetTaskId() *TaskID {
	if m != nil {
		return m.TaskId
	}
	return nil
}

func (m *TaskInfo) GetAgentId() *AgentID {
	if m != nil {
		return m.AgentId
	}
	return nil
}

func (m *TaskInfo) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *TaskInfo) GetExecutor() *ExecutorInfo {
	if m != nil {
		return m.Executor
	}
	return nil
}

func (m *TaskInfo) GetCommand() *CommandInfo {
	if m != nil {
		return m.Command
	}
	return nil
}

func (m *TaskInfo) GetContainer() *ContainerInfo {
	if m != nil {
		return m.Container
	}
	return nil
}

func (m *TaskInfo) GetHealthCheck() *HealthCheck {
	if m != nil {
		return m.HealthCheck
	}
	return nil
}

func (m *TaskInfo) GetKillPolicy() *KillPolicy {
	if m != nil {
		return m.KillPolicy
	}
	return nil
}

func (m *TaskInfo) GetData() []byte {
	if m != nil {
		return m.Data
	}
	return nil
}

func (m *TaskInfo) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

func (m *TaskInfo) GetDiscovery() *DiscoveryInfo {
	if m != nil {
		return m.Discovery
	}
	return nil
}

// *
// Describes a group of tasks that belong to an executor. The
// executor will receive the task group in a single message to
// allow the group to be launched "atomically".
//
// NOTES:
// 1) `NetworkInfo` must not be set inside task's `ContainerInfo`.
// 2) `TaskInfo.executor` doesn't need to set. If set, it should match
//    `LaunchGroup.executor`.
type TaskGroupInfo struct {
	Tasks            []*TaskInfo `protobuf:"bytes,1,rep,name=tasks" json:"tasks,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *TaskGroupInfo) Reset()                    { *m = TaskGroupInfo{} }
func (m *TaskGroupInfo) String() string            { return proto.CompactTextString(m) }
func (*TaskGroupInfo) ProtoMessage()               {}
func (*TaskGroupInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{36} }

func (m *TaskGroupInfo) GetTasks() []*TaskInfo {
	if m != nil {
		return m.Tasks
	}
	return nil
}

// *
// Describes a task, similar to `TaskInfo`.
//
// `Task` is used in some of the Mesos messages found below.
// `Task` is used instead of `TaskInfo` if:
//   1) we need additional IDs, such as a specific
//      framework, executor, or agent; or
//   2) we do not need the additional data, such as the command run by the
//      task or the health checks.  These additional fields may be large and
//      unnecessary for some Mesos messages.
//
// `Task` is generally constructed from a `TaskInfo`.  See protobuf::createTask.
type Task struct {
	Name        *string       `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	TaskId      *TaskID       `protobuf:"bytes,2,req,name=task_id,json=taskId" json:"task_id,omitempty"`
	FrameworkId *FrameworkID  `protobuf:"bytes,3,req,name=framework_id,json=frameworkId" json:"framework_id,omitempty"`
	ExecutorId  *ExecutorID   `protobuf:"bytes,4,opt,name=executor_id,json=executorId" json:"executor_id,omitempty"`
	AgentId     *AgentID      `protobuf:"bytes,5,req,name=agent_id,json=agentId" json:"agent_id,omitempty"`
	State       *TaskState    `protobuf:"varint,6,req,name=state,enum=mesos.v1.TaskState" json:"state,omitempty"`
	Resources   []*Resource   `protobuf:"bytes,7,rep,name=resources" json:"resources,omitempty"`
	Statuses    []*TaskStatus `protobuf:"bytes,8,rep,name=statuses" json:"statuses,omitempty"`
	// These fields correspond to the state and uuid of the latest
	// status update forwarded to the master.
	// NOTE: Either both the fields must be set or both must be unset.
	StatusUpdateState *TaskState `protobuf:"varint,9,opt,name=status_update_state,json=statusUpdateState,enum=mesos.v1.TaskState" json:"status_update_state,omitempty"`
	StatusUpdateUuid  []byte     `protobuf:"bytes,10,opt,name=status_update_uuid,json=statusUpdateUuid" json:"status_update_uuid,omitempty"`
	Labels            *Labels    `protobuf:"bytes,11,opt,name=labels" json:"labels,omitempty"`
	// Service discovery information for the task. It is not interpreted
	// or acted upon by Mesos. It is up to a service discovery system
	// to use this information as needed and to handle tasks without
	// service discovery information.
	Discovery *DiscoveryInfo `protobuf:"bytes,12,opt,name=discovery" json:"discovery,omitempty"`
	// Container information for the task.
	Container *ContainerInfo `protobuf:"bytes,13,opt,name=container" json:"container,omitempty"`
	// Specific user under which task is running.
	User             *string `protobuf:"bytes,14,opt,name=user" json:"user,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Task) Reset()                    { *m = Task{} }
func (m *Task) String() string            { return proto.CompactTextString(m) }
func (*Task) ProtoMessage()               {}
func (*Task) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{37} }

func (m *Task) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Task) GetTaskId() *TaskID {
	if m != nil {
		return m.TaskId
	}
	return nil
}

func (m *Task) GetFrameworkId() *FrameworkID {
	if m != nil {
		return m.FrameworkId
	}
	return nil
}

func (m *Task) GetExecutorId() *ExecutorID {
	if m != nil {
		return m.ExecutorId
	}
	return nil
}

func (m *Task) GetAgentId() *AgentID {
	if m != nil {
		return m.AgentId
	}
	return nil
}

func (m *Task) GetState() TaskState {
	if m != nil && m.State != nil {
		return *m.State
	}
	return TaskState_TASK_STAGING
}

func (m *Task) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *Task) GetStatuses() []*TaskStatus {
	if m != nil {
		return m.Statuses
	}
	return nil
}

func (m *Task) GetStatusUpdateState() TaskState {
	if m != nil && m.StatusUpdateState != nil {
		return *m.StatusUpdateState
	}
	return TaskState_TASK_STAGING
}

func (m *Task) GetStatusUpdateUuid() []byte {
	if m != nil {
		return m.StatusUpdateUuid
	}
	return nil
}

func (m *Task) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

func (m *Task) GetDiscovery() *DiscoveryInfo {
	if m != nil {
		return m.Discovery
	}
	return nil
}

func (m *Task) GetContainer() *ContainerInfo {
	if m != nil {
		return m.Container
	}
	return nil
}

func (m *Task) GetUser() string {
	if m != nil && m.User != nil {
		return *m.User
	}
	return ""
}

// *
// Describes the current status of a task.
type TaskStatus struct {
	TaskId     *TaskID            `protobuf:"bytes,1,req,name=task_id,json=taskId" json:"task_id,omitempty"`
	State      *TaskState         `protobuf:"varint,2,req,name=state,enum=mesos.v1.TaskState" json:"state,omitempty"`
	Message    *string            `protobuf:"bytes,4,opt,name=message" json:"message,omitempty"`
	Source     *TaskStatus_Source `protobuf:"varint,9,opt,name=source,enum=mesos.v1.TaskStatus_Source" json:"source,omitempty"`
	Reason     *TaskStatus_Reason `protobuf:"varint,10,opt,name=reason,enum=mesos.v1.TaskStatus_Reason" json:"reason,omitempty"`
	Data       []byte             `protobuf:"bytes,3,opt,name=data" json:"data,omitempty"`
	AgentId    *AgentID           `protobuf:"bytes,5,opt,name=agent_id,json=agentId" json:"agent_id,omitempty"`
	ExecutorId *ExecutorID        `protobuf:"bytes,7,opt,name=executor_id,json=executorId" json:"executor_id,omitempty"`
	Timestamp  *float64           `protobuf:"fixed64,6,opt,name=timestamp" json:"timestamp,omitempty"`
	// Statuses that are delivered reliably to the scheduler will
	// include a 'uuid'. The status is considered delivered once
	// it is acknowledged by the scheduler. Schedulers can choose
	// to either explicitly acknowledge statuses or let the scheduler
	// driver implicitly acknowledge (default).
	//
	// TODO(bmahler): This is currently overwritten in the scheduler
	// driver and executor driver, but executors will need to set this
	// to a valid RFC-4122 UUID if using the HTTP API.
	Uuid []byte `protobuf:"bytes,11,opt,name=uuid" json:"uuid,omitempty"`
	// Describes whether the task has been determined to be healthy
	// (true) or unhealthy (false) according to the HealthCheck field in
	// the command info.
	Healthy *bool `protobuf:"varint,8,opt,name=healthy" json:"healthy,omitempty"`
	// Labels are free-form key value pairs which are exposed through
	// master and agent endpoints. Labels will not be interpreted or
	// acted upon by Mesos itself. As opposed to the data field, labels
	// will be kept in memory on master and agent processes. Therefore,
	// labels should be used to tag TaskStatus message with light-weight
	// meta-data.  Labels should not contain duplicate key-value pairs.
	Labels *Labels `protobuf:"bytes,12,opt,name=labels" json:"labels,omitempty"`
	// Container related information that is resolved dynamically such as
	// network address.
	ContainerStatus *ContainerStatus `protobuf:"bytes,13,opt,name=container_status,json=containerStatus" json:"container_status,omitempty"`
	// The time (according to the master's clock) when the agent where
	// this task was running became unreachable. This is only set on
	// status updates for tasks running on agents that are unreachable
	// (e.g., partitioned away from the master).
	UnreachableTime  *TimeInfo `protobuf:"bytes,14,opt,name=unreachable_time,json=unreachableTime" json:"unreachable_time,omitempty"`
	XXX_unrecognized []byte    `json:"-"`
}

func (m *TaskStatus) Reset()                    { *m = TaskStatus{} }
func (m *TaskStatus) String() string            { return proto.CompactTextString(m) }
func (*TaskStatus) ProtoMessage()               {}
func (*TaskStatus) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{38} }

func (m *TaskStatus) GetTaskId() *TaskID {
	if m != nil {
		return m.TaskId
	}
	return nil
}

func (m *TaskStatus) GetState() TaskState {
	if m != nil && m.State != nil {
		return *m.State
	}
	return TaskState_TASK_STAGING
}

func (m *TaskStatus) GetMessage() string {
	if m != nil && m.Message != nil {
		return *m.Message
	}
	return ""
}

func (m *TaskStatus) GetSource() TaskStatus_Source {
	if m != nil && m.Source != nil {
		return *m.Source
	}
	return TaskStatus_SOURCE_MASTER
}

func (m *TaskStatus) GetReason() TaskStatus_Reason {
	if m != nil && m.Reason != nil {
		return *m.Reason
	}
	return TaskStatus_REASON_COMMAND_EXECUTOR_FAILED
}

func (m *TaskStatus) GetData() []byte {
	if m != nil {
		return m.Data
	}
	return nil
}

func (m *TaskStatus) GetAgentId() *AgentID {
	if m != nil {
		return m.AgentId
	}
	return nil
}

func (m *TaskStatus) GetExecutorId() *ExecutorID {
	if m != nil {
		return m.ExecutorId
	}
	return nil
}

func (m *TaskStatus) GetTimestamp() float64 {
	if m != nil && m.Timestamp != nil {
		return *m.Timestamp
	}
	return 0
}

func (m *TaskStatus) GetUuid() []byte {
	if m != nil {
		return m.Uuid
	}
	return nil
}

func (m *TaskStatus) GetHealthy() bool {
	if m != nil && m.Healthy != nil {
		return *m.Healthy
	}
	return false
}

func (m *TaskStatus) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

func (m *TaskStatus) GetContainerStatus() *ContainerStatus {
	if m != nil {
		return m.ContainerStatus
	}
	return nil
}

func (m *TaskStatus) GetUnreachableTime() *TimeInfo {
	if m != nil {
		return m.UnreachableTime
	}
	return nil
}

// *
// Describes possible filters that can be applied to unused resources
// (see SchedulerDriver::launchTasks) to influence the allocator.
type Filters struct {
	// Time to consider unused resources refused. Note that all unused
	// resources will be considered refused and use the default value
	// (below) regardless of whether Filters was passed to
	// SchedulerDriver::launchTasks. You MUST pass Filters with this
	// field set to change this behavior (i.e., get another offer which
	// includes unused resources sooner or later than the default).
	RefuseSeconds    *float64 `protobuf:"fixed64,1,opt,name=refuse_seconds,json=refuseSeconds,def=5" json:"refuse_seconds,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *Filters) Reset()                    { *m = Filters{} }
func (m *Filters) String() string            { return proto.CompactTextString(m) }
func (*Filters) ProtoMessage()               {}
func (*Filters) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{39} }

const Default_Filters_RefuseSeconds float64 = 5

func (m *Filters) GetRefuseSeconds() float64 {
	if m != nil && m.RefuseSeconds != nil {
		return *m.RefuseSeconds
	}
	return Default_Filters_RefuseSeconds
}

// *
// Describes a collection of environment variables. This is used with
// CommandInfo in order to set environment variables before running a
// command.
type Environment struct {
	Variables        []*Environment_Variable `protobuf:"bytes,1,rep,name=variables" json:"variables,omitempty"`
	XXX_unrecognized []byte                  `json:"-"`
}

func (m *Environment) Reset()                    { *m = Environment{} }
func (m *Environment) String() string            { return proto.CompactTextString(m) }
func (*Environment) ProtoMessage()               {}
func (*Environment) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{40} }

func (m *Environment) GetVariables() []*Environment_Variable {
	if m != nil {
		return m.Variables
	}
	return nil
}

type Environment_Variable struct {
	Name             *string `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Value            *string `protobuf:"bytes,2,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Environment_Variable) Reset()                    { *m = Environment_Variable{} }
func (m *Environment_Variable) String() string            { return proto.CompactTextString(m) }
func (*Environment_Variable) ProtoMessage()               {}
func (*Environment_Variable) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{40, 0} }

func (m *Environment_Variable) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Environment_Variable) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// A generic (key, value) pair used in various places for parameters.
type Parameter struct {
	Key              *string `protobuf:"bytes,1,req,name=key" json:"key,omitempty"`
	Value            *string `protobuf:"bytes,2,req,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Parameter) Reset()                    { *m = Parameter{} }
func (m *Parameter) String() string            { return proto.CompactTextString(m) }
func (*Parameter) ProtoMessage()               {}
func (*Parameter) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{41} }

func (m *Parameter) GetKey() string {
	if m != nil && m.Key != nil {
		return *m.Key
	}
	return ""
}

func (m *Parameter) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// Collection of Parameter.
type Parameters struct {
	Parameter        []*Parameter `protobuf:"bytes,1,rep,name=parameter" json:"parameter,omitempty"`
	XXX_unrecognized []byte       `json:"-"`
}

func (m *Parameters) Reset()                    { *m = Parameters{} }
func (m *Parameters) String() string            { return proto.CompactTextString(m) }
func (*Parameters) ProtoMessage()               {}
func (*Parameters) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{42} }

func (m *Parameters) GetParameter() []*Parameter {
	if m != nil {
		return m.Parameter
	}
	return nil
}

// *
// Credential used in various places for authentication and
// authorization.
//
// NOTE: A 'principal' is different from 'FrameworkInfo.user'. The
// former is used for authentication and authorization while the
// latter is used to determine the default user under which the
// framework's executors/tasks are run.
type Credential struct {
	Principal        *string `protobuf:"bytes,1,req,name=principal" json:"principal,omitempty"`
	Secret           *string `protobuf:"bytes,2,opt,name=secret" json:"secret,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Credential) Reset()                    { *m = Credential{} }
func (m *Credential) String() string            { return proto.CompactTextString(m) }
func (*Credential) ProtoMessage()               {}
func (*Credential) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{43} }

func (m *Credential) GetPrincipal() string {
	if m != nil && m.Principal != nil {
		return *m.Principal
	}
	return ""
}

func (m *Credential) GetSecret() string {
	if m != nil && m.Secret != nil {
		return *m.Secret
	}
	return ""
}

// *
// Credentials used for framework authentication, HTTP authentication
// (where the common 'username' and 'password' are captured as
// 'principal' and 'secret' respectively), etc.
type Credentials struct {
	Credentials      []*Credential `protobuf:"bytes,1,rep,name=credentials" json:"credentials,omitempty"`
	XXX_unrecognized []byte        `json:"-"`
}

func (m *Credentials) Reset()                    { *m = Credentials{} }
func (m *Credentials) String() string            { return proto.CompactTextString(m) }
func (*Credentials) ProtoMessage()               {}
func (*Credentials) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{44} }

func (m *Credentials) GetCredentials() []*Credential {
	if m != nil {
		return m.Credentials
	}
	return nil
}

// *
// Rate (queries per second, QPS) limit for messages from a framework to master.
// Strictly speaking they are the combined rate from all frameworks of the same
// principal.
type RateLimit struct {
	// Leaving QPS unset gives it unlimited rate (i.e., not throttled),
	// which also implies unlimited capacity.
	Qps *float64 `protobuf:"fixed64,1,opt,name=qps" json:"qps,omitempty"`
	// Principal of framework(s) to be throttled. Should match
	// FrameworkInfo.principal and Credential.principal (if using authentication).
	Principal *string `protobuf:"bytes,2,req,name=principal" json:"principal,omitempty"`
	// Max number of outstanding messages from frameworks of this principal
	// allowed by master before the next message is dropped and an error is sent
	// back to the sender. Messages received before the capacity is reached are
	// still going to be processed after the error is sent.
	// If unspecified, this principal is assigned unlimited capacity.
	// NOTE: This value is ignored if 'qps' is not set.
	Capacity         *uint64 `protobuf:"varint,3,opt,name=capacity" json:"capacity,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *RateLimit) Reset()                    { *m = RateLimit{} }
func (m *RateLimit) String() string            { return proto.CompactTextString(m) }
func (*RateLimit) ProtoMessage()               {}
func (*RateLimit) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{45} }

func (m *RateLimit) GetQps() float64 {
	if m != nil && m.Qps != nil {
		return *m.Qps
	}
	return 0
}

func (m *RateLimit) GetPrincipal() string {
	if m != nil && m.Principal != nil {
		return *m.Principal
	}
	return ""
}

func (m *RateLimit) GetCapacity() uint64 {
	if m != nil && m.Capacity != nil {
		return *m.Capacity
	}
	return 0
}

// *
// Collection of RateLimit.
// Frameworks without rate limits defined here are not throttled unless
// 'aggregate_default_qps' is specified.
type RateLimits struct {
	// Items should have unique principals.
	Limits []*RateLimit `protobuf:"bytes,1,rep,name=limits" json:"limits,omitempty"`
	// All the frameworks not specified in 'limits' get this default rate.
	// This rate is an aggregate rate for all of them, i.e., their combined
	// traffic is throttled together at this rate.
	AggregateDefaultQps *float64 `protobuf:"fixed64,2,opt,name=aggregate_default_qps,json=aggregateDefaultQps" json:"aggregate_default_qps,omitempty"`
	// All the frameworks not specified in 'limits' get this default capacity.
	// This is an aggregate value similar to 'aggregate_default_qps'.
	AggregateDefaultCapacity *uint64 `protobuf:"varint,3,opt,name=aggregate_default_capacity,json=aggregateDefaultCapacity" json:"aggregate_default_capacity,omitempty"`
	XXX_unrecognized         []byte  `json:"-"`
}

func (m *RateLimits) Reset()                    { *m = RateLimits{} }
func (m *RateLimits) String() string            { return proto.CompactTextString(m) }
func (*RateLimits) ProtoMessage()               {}
func (*RateLimits) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{46} }

func (m *RateLimits) GetLimits() []*RateLimit {
	if m != nil {
		return m.Limits
	}
	return nil
}

func (m *RateLimits) GetAggregateDefaultQps() float64 {
	if m != nil && m.AggregateDefaultQps != nil {
		return *m.AggregateDefaultQps
	}
	return 0
}

func (m *RateLimits) GetAggregateDefaultCapacity() uint64 {
	if m != nil && m.AggregateDefaultCapacity != nil {
		return *m.AggregateDefaultCapacity
	}
	return 0
}

// *
// Describe an image used by tasks or executors. Note that it's only
// for tasks or executors launched by MesosContainerizer currently.
type Image struct {
	Type *Image_Type `protobuf:"varint,1,req,name=type,enum=mesos.v1.Image_Type" json:"type,omitempty"`
	// Only one of the following image messages should be set to match
	// the type.
	Appc   *Image_Appc   `protobuf:"bytes,2,opt,name=appc" json:"appc,omitempty"`
	Docker *Image_Docker `protobuf:"bytes,3,opt,name=docker" json:"docker,omitempty"`
	// With this flag set to false, the mesos containerizer will pull
	// the docker/appc image from the registry even if the image is
	// already downloaded on the agent.
	Cached           *bool  `protobuf:"varint,4,opt,name=cached,def=1" json:"cached,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *Image) Reset()                    { *m = Image{} }
func (m *Image) String() string            { return proto.CompactTextString(m) }
func (*Image) ProtoMessage()               {}
func (*Image) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{47} }

const Default_Image_Cached bool = true

func (m *Image) GetType() Image_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Image_APPC
}

func (m *Image) GetAppc() *Image_Appc {
	if m != nil {
		return m.Appc
	}
	return nil
}

func (m *Image) GetDocker() *Image_Docker {
	if m != nil {
		return m.Docker
	}
	return nil
}

func (m *Image) GetCached() bool {
	if m != nil && m.Cached != nil {
		return *m.Cached
	}
	return Default_Image_Cached
}

// Protobuf for specifying an Appc container image. See:
// https://github.com/appc/spec/blob/master/spec/aci.md
type Image_Appc struct {
	// The name of the image.
	Name *string `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	// An image ID is a string of the format "hash-value", where
	// "hash" is the hash algorithm used and "value" is the hex
	// encoded string of the digest. Currently the only permitted
	// hash algorithm is sha512.
	Id *string `protobuf:"bytes,2,opt,name=id" json:"id,omitempty"`
	// Optional labels. Suggested labels: "version", "os", and "arch".
	Labels           *Labels `protobuf:"bytes,3,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Image_Appc) Reset()                    { *m = Image_Appc{} }
func (m *Image_Appc) String() string            { return proto.CompactTextString(m) }
func (*Image_Appc) ProtoMessage()               {}
func (*Image_Appc) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{47, 0} }

func (m *Image_Appc) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Image_Appc) GetId() string {
	if m != nil && m.Id != nil {
		return *m.Id
	}
	return ""
}

func (m *Image_Appc) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

type Image_Docker struct {
	// The name of the image. Expected format:
	//   [REGISTRY_HOST[:REGISTRY_PORT]/]REPOSITORY[:TAG|@TYPE:DIGEST]
	//
	// See: https://docs.docker.com/reference/commandline/pull/
	Name *string `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	// Credential to authenticate with docker registry.
	// NOTE: This is not encrypted, therefore framework and operators
	// should enable SSL when passing this information.
	Credential       *Credential `protobuf:"bytes,2,opt,name=credential" json:"credential,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Image_Docker) Reset()                    { *m = Image_Docker{} }
func (m *Image_Docker) String() string            { return proto.CompactTextString(m) }
func (*Image_Docker) ProtoMessage()               {}
func (*Image_Docker) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{47, 1} }

func (m *Image_Docker) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Image_Docker) GetCredential() *Credential {
	if m != nil {
		return m.Credential
	}
	return nil
}

// *
// Describes a volume mapping either from host to container or vice
// versa. Both paths can either refer to a directory or a file.
type Volume struct {
	// TODO(gyliu513): Make this as `optional` after deprecation cycle of 1.0.
	Mode *Volume_Mode `protobuf:"varint,3,req,name=mode,enum=mesos.v1.Volume_Mode" json:"mode,omitempty"`
	// Path pointing to a directory or file in the container. If the
	// path is a relative path, it is relative to the container work
	// directory. If the path is an absolute path, that path must
	// already exist.
	ContainerPath *string `protobuf:"bytes,1,req,name=container_path,json=containerPath" json:"container_path,omitempty"`
	// Absolute path pointing to a directory or file on the host or a
	// path relative to the container work directory.
	HostPath *string `protobuf:"bytes,2,opt,name=host_path,json=hostPath" json:"host_path,omitempty"`
	// The source of the volume is an Image which describes a root
	// filesystem which will be provisioned by Mesos.
	Image            *Image         `protobuf:"bytes,4,opt,name=image" json:"image,omitempty"`
	Source           *Volume_Source `protobuf:"bytes,5,opt,name=source" json:"source,omitempty"`
	XXX_unrecognized []byte         `json:"-"`
}

func (m *Volume) Reset()                    { *m = Volume{} }
func (m *Volume) String() string            { return proto.CompactTextString(m) }
func (*Volume) ProtoMessage()               {}
func (*Volume) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{48} }

func (m *Volume) GetMode() Volume_Mode {
	if m != nil && m.Mode != nil {
		return *m.Mode
	}
	return Volume_RW
}

func (m *Volume) GetContainerPath() string {
	if m != nil && m.ContainerPath != nil {
		return *m.ContainerPath
	}
	return ""
}

func (m *Volume) GetHostPath() string {
	if m != nil && m.HostPath != nil {
		return *m.HostPath
	}
	return ""
}

func (m *Volume) GetImage() *Image {
	if m != nil {
		return m.Image
	}
	return nil
}

func (m *Volume) GetSource() *Volume_Source {
	if m != nil {
		return m.Source
	}
	return nil
}

// Describes where a volume originates from.
type Volume_Source struct {
	// Enum fields should be optional, see: MESOS-4997.
	Type *Volume_Source_Type `protobuf:"varint,1,opt,name=type,enum=mesos.v1.Volume_Source_Type" json:"type,omitempty"`
	// The source of the volume created by docker volume driver.
	DockerVolume     *Volume_Source_DockerVolume `protobuf:"bytes,2,opt,name=docker_volume,json=dockerVolume" json:"docker_volume,omitempty"`
	SandboxPath      *Volume_Source_SandboxPath  `protobuf:"bytes,3,opt,name=sandbox_path,json=sandboxPath" json:"sandbox_path,omitempty"`
	XXX_unrecognized []byte                      `json:"-"`
}

func (m *Volume_Source) Reset()                    { *m = Volume_Source{} }
func (m *Volume_Source) String() string            { return proto.CompactTextString(m) }
func (*Volume_Source) ProtoMessage()               {}
func (*Volume_Source) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{48, 0} }

func (m *Volume_Source) GetType() Volume_Source_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Volume_Source_UNKNOWN
}

func (m *Volume_Source) GetDockerVolume() *Volume_Source_DockerVolume {
	if m != nil {
		return m.DockerVolume
	}
	return nil
}

func (m *Volume_Source) GetSandboxPath() *Volume_Source_SandboxPath {
	if m != nil {
		return m.SandboxPath
	}
	return nil
}

type Volume_Source_DockerVolume struct {
	// Driver of the volume, it can be flocker, convoy, raxrey etc.
	Driver *string `protobuf:"bytes,1,opt,name=driver" json:"driver,omitempty"`
	// Name of the volume.
	Name *string `protobuf:"bytes,2,req,name=name" json:"name,omitempty"`
	// Volume driver specific options.
	DriverOptions    *Parameters `protobuf:"bytes,3,opt,name=driver_options,json=driverOptions" json:"driver_options,omitempty"`
	XXX_unrecognized []byte      `json:"-"`
}

func (m *Volume_Source_DockerVolume) Reset()         { *m = Volume_Source_DockerVolume{} }
func (m *Volume_Source_DockerVolume) String() string { return proto.CompactTextString(m) }
func (*Volume_Source_DockerVolume) ProtoMessage()    {}
func (*Volume_Source_DockerVolume) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{48, 0, 0}
}

func (m *Volume_Source_DockerVolume) GetDriver() string {
	if m != nil && m.Driver != nil {
		return *m.Driver
	}
	return ""
}

func (m *Volume_Source_DockerVolume) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Volume_Source_DockerVolume) GetDriverOptions() *Parameters {
	if m != nil {
		return m.DriverOptions
	}
	return nil
}

// Describe a path from a container's sandbox. The container can
// be the current container (SELF), or its parent container
// (PARENT). PARENT allows all child containers to share a volume
// from their parent container's sandbox. It'll be an error if
// the current container is a top level container.
type Volume_Source_SandboxPath struct {
	Type *Volume_Source_SandboxPath_Type `protobuf:"varint,1,opt,name=type,enum=mesos.v1.Volume_Source_SandboxPath_Type" json:"type,omitempty"`
	// A path relative to the corresponding container's sandbox.
	// Note that upwards traversal (i.e. ../../abc) is not allowed.
	Path             *string `protobuf:"bytes,2,req,name=path" json:"path,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Volume_Source_SandboxPath) Reset()         { *m = Volume_Source_SandboxPath{} }
func (m *Volume_Source_SandboxPath) String() string { return proto.CompactTextString(m) }
func (*Volume_Source_SandboxPath) ProtoMessage()    {}
func (*Volume_Source_SandboxPath) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{48, 0, 1}
}

func (m *Volume_Source_SandboxPath) GetType() Volume_Source_SandboxPath_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return Volume_Source_SandboxPath_UNKNOWN
}

func (m *Volume_Source_SandboxPath) GetPath() string {
	if m != nil && m.Path != nil {
		return *m.Path
	}
	return ""
}

// *
// Describes a network request from a framework as well as network resolution
// provided by Mesos.
//
// A framework may request the network isolator on the Agent to isolate the
// container in a network namespace and create a virtual network interface.
// The `NetworkInfo` message describes the properties of that virtual
// interface, including the IP addresses and network isolation policy
// (network group membership).
//
// The NetworkInfo message is not interpreted by the Master or Agent and is
// intended to be used by Agent and Master modules implementing network
// isolation. If the modules are missing, the message is simply ignored. In
// future, the task launch will fail if there is no module providing the
// network isolation capabilities (MESOS-3390).
//
// An executor, Agent, or an Agent module may append NetworkInfos inside
// TaskStatus::container_status to provide information such as the container IP
// address and isolation groups.
type NetworkInfo struct {
	// When included in a ContainerInfo, each of these represent a
	// request for an IP address. Each request can specify an explicit address
	// or the IP protocol to use.
	//
	// When included in a TaskStatus message, these inform the framework
	// scheduler about the IP addresses that are bound to the container
	// interface. When there are no custom network isolator modules installed,
	// this field is filled in automatically with the Agent IP address.
	IpAddresses []*NetworkInfo_IPAddress `protobuf:"bytes,5,rep,name=ip_addresses,json=ipAddresses" json:"ip_addresses,omitempty"`
	// Name of the network which will be used by network isolator to determine
	// the network that the container joins. It's up to the network isolator
	// to decide how to interpret this field.
	Name *string `protobuf:"bytes,6,opt,name=name" json:"name,omitempty"`
	// A group is the name given to a set of logically-related interfaces that
	// are allowed to communicate among themselves. Network traffic is allowed
	// between two container interfaces that share at least one network group.
	// For example, one might want to create separate groups for isolating dev,
	// testing, qa and prod deployment environments.
	Groups []string `protobuf:"bytes,3,rep,name=groups" json:"groups,omitempty"`
	// To tag certain metadata to be used by Isolator/IPAM, e.g., rack, etc.
	Labels           *Labels                    `protobuf:"bytes,4,opt,name=labels" json:"labels,omitempty"`
	PortMappings     []*NetworkInfo_PortMapping `protobuf:"bytes,7,rep,name=port_mappings,json=portMappings" json:"port_mappings,omitempty"`
	XXX_unrecognized []byte                     `json:"-"`
}

func (m *NetworkInfo) Reset()                    { *m = NetworkInfo{} }
func (m *NetworkInfo) String() string            { return proto.CompactTextString(m) }
func (*NetworkInfo) ProtoMessage()               {}
func (*NetworkInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{49} }

func (m *NetworkInfo) GetIpAddresses() []*NetworkInfo_IPAddress {
	if m != nil {
		return m.IpAddresses
	}
	return nil
}

func (m *NetworkInfo) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *NetworkInfo) GetGroups() []string {
	if m != nil {
		return m.Groups
	}
	return nil
}

func (m *NetworkInfo) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

func (m *NetworkInfo) GetPortMappings() []*NetworkInfo_PortMapping {
	if m != nil {
		return m.PortMappings
	}
	return nil
}

// Specifies a request for an IP address, or reports the assigned container
// IP address.
//
// Users can request an automatically assigned IP (for example, via an
// IPAM service) or a specific IP by adding a NetworkInfo to the
// ContainerInfo for a task.  On a request, specifying neither `protocol`
// nor `ip_address` means that any available address may be assigned.
type NetworkInfo_IPAddress struct {
	// Specify IP address requirement. Set protocol to the desired value to
	// request the network isolator on the Agent to assign an IP address to the
	// container being launched. If a specific IP address is specified in
	// ip_address, this field should not be set.
	Protocol *NetworkInfo_Protocol `protobuf:"varint,1,opt,name=protocol,enum=mesos.v1.NetworkInfo_Protocol" json:"protocol,omitempty"`
	// Statically assigned IP provided by the Framework. This IP will be
	// assigned to the container by the network isolator module on the Agent.
	// This field should not be used with the protocol field above.
	//
	// If an explicit address is requested but is unavailable, the network
	// isolator should fail the task.
	IpAddress        *string `protobuf:"bytes,2,opt,name=ip_address,json=ipAddress" json:"ip_address,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *NetworkInfo_IPAddress) Reset()                    { *m = NetworkInfo_IPAddress{} }
func (m *NetworkInfo_IPAddress) String() string            { return proto.CompactTextString(m) }
func (*NetworkInfo_IPAddress) ProtoMessage()               {}
func (*NetworkInfo_IPAddress) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{49, 0} }

func (m *NetworkInfo_IPAddress) GetProtocol() NetworkInfo_Protocol {
	if m != nil && m.Protocol != nil {
		return *m.Protocol
	}
	return NetworkInfo_IPv4
}

func (m *NetworkInfo_IPAddress) GetIpAddress() string {
	if m != nil && m.IpAddress != nil {
		return *m.IpAddress
	}
	return ""
}

// Specifies a port mapping request for the task on this network.
type NetworkInfo_PortMapping struct {
	HostPort      *uint32 `protobuf:"varint,1,req,name=host_port,json=hostPort" json:"host_port,omitempty"`
	ContainerPort *uint32 `protobuf:"varint,2,req,name=container_port,json=containerPort" json:"container_port,omitempty"`
	// Protocol to expose as (ie: tcp, udp).
	Protocol         *string `protobuf:"bytes,3,opt,name=protocol" json:"protocol,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *NetworkInfo_PortMapping) Reset()                    { *m = NetworkInfo_PortMapping{} }
func (m *NetworkInfo_PortMapping) String() string            { return proto.CompactTextString(m) }
func (*NetworkInfo_PortMapping) ProtoMessage()               {}
func (*NetworkInfo_PortMapping) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{49, 1} }

func (m *NetworkInfo_PortMapping) GetHostPort() uint32 {
	if m != nil && m.HostPort != nil {
		return *m.HostPort
	}
	return 0
}

func (m *NetworkInfo_PortMapping) GetContainerPort() uint32 {
	if m != nil && m.ContainerPort != nil {
		return *m.ContainerPort
	}
	return 0
}

func (m *NetworkInfo_PortMapping) GetProtocol() string {
	if m != nil && m.Protocol != nil {
		return *m.Protocol
	}
	return ""
}

// *
// Encapsulation of `Capabilities` supported by Linux.
// Reference: http://linux.die.net/man/7/capabilities.
type CapabilityInfo struct {
	Capabilities     []CapabilityInfo_Capability `protobuf:"varint,1,rep,name=capabilities,enum=mesos.v1.CapabilityInfo_Capability" json:"capabilities,omitempty"`
	XXX_unrecognized []byte                      `json:"-"`
}

func (m *CapabilityInfo) Reset()                    { *m = CapabilityInfo{} }
func (m *CapabilityInfo) String() string            { return proto.CompactTextString(m) }
func (*CapabilityInfo) ProtoMessage()               {}
func (*CapabilityInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{50} }

func (m *CapabilityInfo) GetCapabilities() []CapabilityInfo_Capability {
	if m != nil {
		return m.Capabilities
	}
	return nil
}

// *
// Encapsulation for Linux specific configuration.
// E.g, capabilities, limits etc.
type LinuxInfo struct {
	// Represents the capability whitelist.
	CapabilityInfo   *CapabilityInfo `protobuf:"bytes,1,opt,name=capability_info,json=capabilityInfo" json:"capability_info,omitempty"`
	XXX_unrecognized []byte          `json:"-"`
}

func (m *LinuxInfo) Reset()                    { *m = LinuxInfo{} }
func (m *LinuxInfo) String() string            { return proto.CompactTextString(m) }
func (*LinuxInfo) ProtoMessage()               {}
func (*LinuxInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{51} }

func (m *LinuxInfo) GetCapabilityInfo() *CapabilityInfo {
	if m != nil {
		return m.CapabilityInfo
	}
	return nil
}

// *
// Describes a container configuration and allows extensible
// configurations for different container implementations.
type ContainerInfo struct {
	Type     *ContainerInfo_Type `protobuf:"varint,1,req,name=type,enum=mesos.v1.ContainerInfo_Type" json:"type,omitempty"`
	Volumes  []*Volume           `protobuf:"bytes,2,rep,name=volumes" json:"volumes,omitempty"`
	Hostname *string             `protobuf:"bytes,4,opt,name=hostname" json:"hostname,omitempty"`
	// Only one of the following *Info messages should be set to match
	// the type.
	Docker *ContainerInfo_DockerInfo `protobuf:"bytes,3,opt,name=docker" json:"docker,omitempty"`
	Mesos  *ContainerInfo_MesosInfo  `protobuf:"bytes,5,opt,name=mesos" json:"mesos,omitempty"`
	// A list of network requests. A framework can request multiple IP addresses
	// for the container.
	NetworkInfos []*NetworkInfo `protobuf:"bytes,7,rep,name=network_infos,json=networkInfos" json:"network_infos,omitempty"`
	// Linux specific information for the container.
	LinuxInfo        *LinuxInfo `protobuf:"bytes,8,opt,name=linux_info,json=linuxInfo" json:"linux_info,omitempty"`
	XXX_unrecognized []byte     `json:"-"`
}

func (m *ContainerInfo) Reset()                    { *m = ContainerInfo{} }
func (m *ContainerInfo) String() string            { return proto.CompactTextString(m) }
func (*ContainerInfo) ProtoMessage()               {}
func (*ContainerInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{52} }

func (m *ContainerInfo) GetType() ContainerInfo_Type {
	if m != nil && m.Type != nil {
		return *m.Type
	}
	return ContainerInfo_DOCKER
}

func (m *ContainerInfo) GetVolumes() []*Volume {
	if m != nil {
		return m.Volumes
	}
	return nil
}

func (m *ContainerInfo) GetHostname() string {
	if m != nil && m.Hostname != nil {
		return *m.Hostname
	}
	return ""
}

func (m *ContainerInfo) GetDocker() *ContainerInfo_DockerInfo {
	if m != nil {
		return m.Docker
	}
	return nil
}

func (m *ContainerInfo) GetMesos() *ContainerInfo_MesosInfo {
	if m != nil {
		return m.Mesos
	}
	return nil
}

func (m *ContainerInfo) GetNetworkInfos() []*NetworkInfo {
	if m != nil {
		return m.NetworkInfos
	}
	return nil
}

func (m *ContainerInfo) GetLinuxInfo() *LinuxInfo {
	if m != nil {
		return m.LinuxInfo
	}
	return nil
}

type ContainerInfo_DockerInfo struct {
	// The docker image that is going to be passed to the registry.
	Image        *string                                 `protobuf:"bytes,1,req,name=image" json:"image,omitempty"`
	Network      *ContainerInfo_DockerInfo_Network       `protobuf:"varint,2,opt,name=network,enum=mesos.v1.ContainerInfo_DockerInfo_Network,def=1" json:"network,omitempty"`
	PortMappings []*ContainerInfo_DockerInfo_PortMapping `protobuf:"bytes,3,rep,name=port_mappings,json=portMappings" json:"port_mappings,omitempty"`
	Privileged   *bool                                   `protobuf:"varint,4,opt,name=privileged,def=0" json:"privileged,omitempty"`
	// Allowing arbitrary parameters to be passed to docker CLI.
	// Note that anything passed to this field is not guaranteed
	// to be supported moving forward, as we might move away from
	// the docker CLI.
	Parameters []*Parameter `protobuf:"bytes,5,rep,name=parameters" json:"parameters,omitempty"`
	// With this flag set to true, the docker containerizer will
	// pull the docker image from the registry even if the image
	// is already downloaded on the agent.
	ForcePullImage *bool `protobuf:"varint,6,opt,name=force_pull_image,json=forcePullImage" json:"force_pull_image,omitempty"`
	// The name of volume driver plugin.
	VolumeDriver     *string `protobuf:"bytes,7,opt,name=volume_driver,json=volumeDriver" json:"volume_driver,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *ContainerInfo_DockerInfo) Reset()                    { *m = ContainerInfo_DockerInfo{} }
func (m *ContainerInfo_DockerInfo) String() string            { return proto.CompactTextString(m) }
func (*ContainerInfo_DockerInfo) ProtoMessage()               {}
func (*ContainerInfo_DockerInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{52, 0} }

const Default_ContainerInfo_DockerInfo_Network ContainerInfo_DockerInfo_Network = ContainerInfo_DockerInfo_HOST
const Default_ContainerInfo_DockerInfo_Privileged bool = false

func (m *ContainerInfo_DockerInfo) GetImage() string {
	if m != nil && m.Image != nil {
		return *m.Image
	}
	return ""
}

func (m *ContainerInfo_DockerInfo) GetNetwork() ContainerInfo_DockerInfo_Network {
	if m != nil && m.Network != nil {
		return *m.Network
	}
	return Default_ContainerInfo_DockerInfo_Network
}

func (m *ContainerInfo_DockerInfo) GetPortMappings() []*ContainerInfo_DockerInfo_PortMapping {
	if m != nil {
		return m.PortMappings
	}
	return nil
}

func (m *ContainerInfo_DockerInfo) GetPrivileged() bool {
	if m != nil && m.Privileged != nil {
		return *m.Privileged
	}
	return Default_ContainerInfo_DockerInfo_Privileged
}

func (m *ContainerInfo_DockerInfo) GetParameters() []*Parameter {
	if m != nil {
		return m.Parameters
	}
	return nil
}

func (m *ContainerInfo_DockerInfo) GetForcePullImage() bool {
	if m != nil && m.ForcePullImage != nil {
		return *m.ForcePullImage
	}
	return false
}

func (m *ContainerInfo_DockerInfo) GetVolumeDriver() string {
	if m != nil && m.VolumeDriver != nil {
		return *m.VolumeDriver
	}
	return ""
}

type ContainerInfo_DockerInfo_PortMapping struct {
	HostPort      *uint32 `protobuf:"varint,1,req,name=host_port,json=hostPort" json:"host_port,omitempty"`
	ContainerPort *uint32 `protobuf:"varint,2,req,name=container_port,json=containerPort" json:"container_port,omitempty"`
	// Protocol to expose as (ie: tcp, udp).
	Protocol         *string `protobuf:"bytes,3,opt,name=protocol" json:"protocol,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *ContainerInfo_DockerInfo_PortMapping) Reset()         { *m = ContainerInfo_DockerInfo_PortMapping{} }
func (m *ContainerInfo_DockerInfo_PortMapping) String() string { return proto.CompactTextString(m) }
func (*ContainerInfo_DockerInfo_PortMapping) ProtoMessage()    {}
func (*ContainerInfo_DockerInfo_PortMapping) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{52, 0, 0}
}

func (m *ContainerInfo_DockerInfo_PortMapping) GetHostPort() uint32 {
	if m != nil && m.HostPort != nil {
		return *m.HostPort
	}
	return 0
}

func (m *ContainerInfo_DockerInfo_PortMapping) GetContainerPort() uint32 {
	if m != nil && m.ContainerPort != nil {
		return *m.ContainerPort
	}
	return 0
}

func (m *ContainerInfo_DockerInfo_PortMapping) GetProtocol() string {
	if m != nil && m.Protocol != nil {
		return *m.Protocol
	}
	return ""
}

type ContainerInfo_MesosInfo struct {
	Image            *Image `protobuf:"bytes,1,opt,name=image" json:"image,omitempty"`
	XXX_unrecognized []byte `json:"-"`
}

func (m *ContainerInfo_MesosInfo) Reset()                    { *m = ContainerInfo_MesosInfo{} }
func (m *ContainerInfo_MesosInfo) String() string            { return proto.CompactTextString(m) }
func (*ContainerInfo_MesosInfo) ProtoMessage()               {}
func (*ContainerInfo_MesosInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{52, 1} }

func (m *ContainerInfo_MesosInfo) GetImage() *Image {
	if m != nil {
		return m.Image
	}
	return nil
}

// *
// Container related information that is resolved during container
// setup. The information is sent back to the framework as part of the
// TaskStatus message.
type ContainerStatus struct {
	// This field can be reliably used to identify the container IP address.
	NetworkInfos []*NetworkInfo `protobuf:"bytes,1,rep,name=network_infos,json=networkInfos" json:"network_infos,omitempty"`
	// Information about Linux control group (cgroup).
	CgroupInfo *CgroupInfo `protobuf:"bytes,2,opt,name=cgroup_info,json=cgroupInfo" json:"cgroup_info,omitempty"`
	// Information about Executor PID.
	ExecutorPid      *uint32 `protobuf:"varint,3,opt,name=executor_pid,json=executorPid" json:"executor_pid,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *ContainerStatus) Reset()                    { *m = ContainerStatus{} }
func (m *ContainerStatus) String() string            { return proto.CompactTextString(m) }
func (*ContainerStatus) ProtoMessage()               {}
func (*ContainerStatus) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{53} }

func (m *ContainerStatus) GetNetworkInfos() []*NetworkInfo {
	if m != nil {
		return m.NetworkInfos
	}
	return nil
}

func (m *ContainerStatus) GetCgroupInfo() *CgroupInfo {
	if m != nil {
		return m.CgroupInfo
	}
	return nil
}

func (m *ContainerStatus) GetExecutorPid() uint32 {
	if m != nil && m.ExecutorPid != nil {
		return *m.ExecutorPid
	}
	return 0
}

// *
// Linux control group (cgroup) information.
type CgroupInfo struct {
	NetCls           *CgroupInfo_NetCls `protobuf:"bytes,1,opt,name=net_cls,json=netCls" json:"net_cls,omitempty"`
	XXX_unrecognized []byte             `json:"-"`
}

func (m *CgroupInfo) Reset()                    { *m = CgroupInfo{} }
func (m *CgroupInfo) String() string            { return proto.CompactTextString(m) }
func (*CgroupInfo) ProtoMessage()               {}
func (*CgroupInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{54} }

func (m *CgroupInfo) GetNetCls() *CgroupInfo_NetCls {
	if m != nil {
		return m.NetCls
	}
	return nil
}

// Configuration of a net_cls cgroup subsystem.
type CgroupInfo_NetCls struct {
	// The 32-bit classid consists of two parts, a 16 bit major handle
	// and a 16-bit minor handle. The major and minor handle are
	// represented using the format 0xAAAABBBB, where 0xAAAA is the
	// 16-bit major handle and 0xBBBB is the 16-bit minor handle.
	Classid          *uint32 `protobuf:"varint,1,opt,name=classid" json:"classid,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *CgroupInfo_NetCls) Reset()                    { *m = CgroupInfo_NetCls{} }
func (m *CgroupInfo_NetCls) String() string            { return proto.CompactTextString(m) }
func (*CgroupInfo_NetCls) ProtoMessage()               {}
func (*CgroupInfo_NetCls) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{54, 0} }

func (m *CgroupInfo_NetCls) GetClassid() uint32 {
	if m != nil && m.Classid != nil {
		return *m.Classid
	}
	return 0
}

// *
// Collection of labels. Labels should not contain duplicate key-value
// pairs.
type Labels struct {
	Labels           []*Label `protobuf:"bytes,1,rep,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *Labels) Reset()                    { *m = Labels{} }
func (m *Labels) String() string            { return proto.CompactTextString(m) }
func (*Labels) ProtoMessage()               {}
func (*Labels) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{55} }

func (m *Labels) GetLabels() []*Label {
	if m != nil {
		return m.Labels
	}
	return nil
}

// *
// Key, value pair used to store free form user-data.
type Label struct {
	Key              *string `protobuf:"bytes,1,req,name=key" json:"key,omitempty"`
	Value            *string `protobuf:"bytes,2,opt,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Label) Reset()                    { *m = Label{} }
func (m *Label) String() string            { return proto.CompactTextString(m) }
func (*Label) ProtoMessage()               {}
func (*Label) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{56} }

func (m *Label) GetKey() string {
	if m != nil && m.Key != nil {
		return *m.Key
	}
	return ""
}

func (m *Label) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// Named port used for service discovery.
type Port struct {
	// Port number on which the framework exposes a service.
	Number *uint32 `protobuf:"varint,1,req,name=number" json:"number,omitempty"`
	// Name of the service hosted on this port.
	Name *string `protobuf:"bytes,2,opt,name=name" json:"name,omitempty"`
	// Layer 4-7 protocol on which the framework exposes its services.
	Protocol *string `protobuf:"bytes,3,opt,name=protocol" json:"protocol,omitempty"`
	// This field restricts discovery within a framework (FRAMEWORK),
	// within a Mesos cluster (CLUSTER), or places no restrictions (EXTERNAL).
	// The visibility setting for a Port overrides the general visibility setting
	// in the DiscoveryInfo.
	Visibility *DiscoveryInfo_Visibility `protobuf:"varint,4,opt,name=visibility,enum=mesos.v1.DiscoveryInfo_Visibility" json:"visibility,omitempty"`
	// This can be used to decorate the message with metadata to be
	// interpreted by external applications such as firewalls.
	Labels           *Labels `protobuf:"bytes,5,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Port) Reset()                    { *m = Port{} }
func (m *Port) String() string            { return proto.CompactTextString(m) }
func (*Port) ProtoMessage()               {}
func (*Port) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{57} }

func (m *Port) GetNumber() uint32 {
	if m != nil && m.Number != nil {
		return *m.Number
	}
	return 0
}

func (m *Port) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Port) GetProtocol() string {
	if m != nil && m.Protocol != nil {
		return *m.Protocol
	}
	return ""
}

func (m *Port) GetVisibility() DiscoveryInfo_Visibility {
	if m != nil && m.Visibility != nil {
		return *m.Visibility
	}
	return DiscoveryInfo_FRAMEWORK
}

func (m *Port) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

// *
// Collection of ports.
type Ports struct {
	Ports            []*Port `protobuf:"bytes,1,rep,name=ports" json:"ports,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Ports) Reset()                    { *m = Ports{} }
func (m *Ports) String() string            { return proto.CompactTextString(m) }
func (*Ports) ProtoMessage()               {}
func (*Ports) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{58} }

func (m *Ports) GetPorts() []*Port {
	if m != nil {
		return m.Ports
	}
	return nil
}

// *
// Service discovery information.
// The visibility field restricts discovery within a framework (FRAMEWORK),
// within a Mesos cluster (CLUSTER), or places no restrictions (EXTERNAL).
// Each port in the ports field also has an optional visibility field.
// If visibility is specified for a port, it overrides the default service-wide
// DiscoveryInfo.visibility for that port.
// The environment, location, and version fields provide first class support for
// common attributes used to differentiate between similar services. The
// environment may receive values such as PROD/QA/DEV, the location field may
// receive values like EAST-US/WEST-US/EUROPE/AMEA, and the version field may
// receive values like v2.0/v0.9. The exact use of these fields is up to each
// service discovery system.
type DiscoveryInfo struct {
	Visibility       *DiscoveryInfo_Visibility `protobuf:"varint,1,req,name=visibility,enum=mesos.v1.DiscoveryInfo_Visibility" json:"visibility,omitempty"`
	Name             *string                   `protobuf:"bytes,2,opt,name=name" json:"name,omitempty"`
	Environment      *string                   `protobuf:"bytes,3,opt,name=environment" json:"environment,omitempty"`
	Location         *string                   `protobuf:"bytes,4,opt,name=location" json:"location,omitempty"`
	Version          *string                   `protobuf:"bytes,5,opt,name=version" json:"version,omitempty"`
	Ports            *Ports                    `protobuf:"bytes,6,opt,name=ports" json:"ports,omitempty"`
	Labels           *Labels                   `protobuf:"bytes,7,opt,name=labels" json:"labels,omitempty"`
	XXX_unrecognized []byte                    `json:"-"`
}

func (m *DiscoveryInfo) Reset()                    { *m = DiscoveryInfo{} }
func (m *DiscoveryInfo) String() string            { return proto.CompactTextString(m) }
func (*DiscoveryInfo) ProtoMessage()               {}
func (*DiscoveryInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{59} }

func (m *DiscoveryInfo) GetVisibility() DiscoveryInfo_Visibility {
	if m != nil && m.Visibility != nil {
		return *m.Visibility
	}
	return DiscoveryInfo_FRAMEWORK
}

func (m *DiscoveryInfo) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *DiscoveryInfo) GetEnvironment() string {
	if m != nil && m.Environment != nil {
		return *m.Environment
	}
	return ""
}

func (m *DiscoveryInfo) GetLocation() string {
	if m != nil && m.Location != nil {
		return *m.Location
	}
	return ""
}

func (m *DiscoveryInfo) GetVersion() string {
	if m != nil && m.Version != nil {
		return *m.Version
	}
	return ""
}

func (m *DiscoveryInfo) GetPorts() *Ports {
	if m != nil {
		return m.Ports
	}
	return nil
}

func (m *DiscoveryInfo) GetLabels() *Labels {
	if m != nil {
		return m.Labels
	}
	return nil
}

// *
// Named WeightInfo to indicate resource allocation
// priority between the different roles.
type WeightInfo struct {
	Weight *float64 `protobuf:"fixed64,1,req,name=weight" json:"weight,omitempty"`
	// Related role name.
	Role             *string `protobuf:"bytes,2,opt,name=role" json:"role,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *WeightInfo) Reset()                    { *m = WeightInfo{} }
func (m *WeightInfo) String() string            { return proto.CompactTextString(m) }
func (*WeightInfo) ProtoMessage()               {}
func (*WeightInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{60} }

func (m *WeightInfo) GetWeight() float64 {
	if m != nil && m.Weight != nil {
		return *m.Weight
	}
	return 0
}

func (m *WeightInfo) GetRole() string {
	if m != nil && m.Role != nil {
		return *m.Role
	}
	return ""
}

// *
// Version information of a component.
type VersionInfo struct {
	Version          *string  `protobuf:"bytes,1,req,name=version" json:"version,omitempty"`
	BuildDate        *string  `protobuf:"bytes,2,opt,name=build_date,json=buildDate" json:"build_date,omitempty"`
	BuildTime        *float64 `protobuf:"fixed64,3,opt,name=build_time,json=buildTime" json:"build_time,omitempty"`
	BuildUser        *string  `protobuf:"bytes,4,opt,name=build_user,json=buildUser" json:"build_user,omitempty"`
	GitSha           *string  `protobuf:"bytes,5,opt,name=git_sha,json=gitSha" json:"git_sha,omitempty"`
	GitBranch        *string  `protobuf:"bytes,6,opt,name=git_branch,json=gitBranch" json:"git_branch,omitempty"`
	GitTag           *string  `protobuf:"bytes,7,opt,name=git_tag,json=gitTag" json:"git_tag,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *VersionInfo) Reset()                    { *m = VersionInfo{} }
func (m *VersionInfo) String() string            { return proto.CompactTextString(m) }
func (*VersionInfo) ProtoMessage()               {}
func (*VersionInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{61} }

func (m *VersionInfo) GetVersion() string {
	if m != nil && m.Version != nil {
		return *m.Version
	}
	return ""
}

func (m *VersionInfo) GetBuildDate() string {
	if m != nil && m.BuildDate != nil {
		return *m.BuildDate
	}
	return ""
}

func (m *VersionInfo) GetBuildTime() float64 {
	if m != nil && m.BuildTime != nil {
		return *m.BuildTime
	}
	return 0
}

func (m *VersionInfo) GetBuildUser() string {
	if m != nil && m.BuildUser != nil {
		return *m.BuildUser
	}
	return ""
}

func (m *VersionInfo) GetGitSha() string {
	if m != nil && m.GitSha != nil {
		return *m.GitSha
	}
	return ""
}

func (m *VersionInfo) GetGitBranch() string {
	if m != nil && m.GitBranch != nil {
		return *m.GitBranch
	}
	return ""
}

func (m *VersionInfo) GetGitTag() string {
	if m != nil && m.GitTag != nil {
		return *m.GitTag
	}
	return ""
}

// *
// Flag consists of a name and optionally its value.
type Flag struct {
	Name             *string `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Value            *string `protobuf:"bytes,2,opt,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *Flag) Reset()                    { *m = Flag{} }
func (m *Flag) String() string            { return proto.CompactTextString(m) }
func (*Flag) ProtoMessage()               {}
func (*Flag) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{62} }

func (m *Flag) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Flag) GetValue() string {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return ""
}

// *
// Describes a Role. Roles can be used to specify that certain resources are
// reserved for the use of one or more frameworks.
type Role struct {
	Name             *string        `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Weight           *float64       `protobuf:"fixed64,2,req,name=weight" json:"weight,omitempty"`
	Frameworks       []*FrameworkID `protobuf:"bytes,3,rep,name=frameworks" json:"frameworks,omitempty"`
	Resources        []*Resource    `protobuf:"bytes,4,rep,name=resources" json:"resources,omitempty"`
	XXX_unrecognized []byte         `json:"-"`
}

func (m *Role) Reset()                    { *m = Role{} }
func (m *Role) String() string            { return proto.CompactTextString(m) }
func (*Role) ProtoMessage()               {}
func (*Role) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{63} }

func (m *Role) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Role) GetWeight() float64 {
	if m != nil && m.Weight != nil {
		return *m.Weight
	}
	return 0
}

func (m *Role) GetFrameworks() []*FrameworkID {
	if m != nil {
		return m.Frameworks
	}
	return nil
}

func (m *Role) GetResources() []*Resource {
	if m != nil {
		return m.Resources
	}
	return nil
}

// *
// Metric consists of a name and optionally its value.
type Metric struct {
	Name             *string  `protobuf:"bytes,1,req,name=name" json:"name,omitempty"`
	Value            *float64 `protobuf:"fixed64,2,opt,name=value" json:"value,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *Metric) Reset()                    { *m = Metric{} }
func (m *Metric) String() string            { return proto.CompactTextString(m) }
func (*Metric) ProtoMessage()               {}
func (*Metric) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{64} }

func (m *Metric) GetName() string {
	if m != nil && m.Name != nil {
		return *m.Name
	}
	return ""
}

func (m *Metric) GetValue() float64 {
	if m != nil && m.Value != nil {
		return *m.Value
	}
	return 0
}

// *
// Describes a File.
type FileInfo struct {
	// Absolute path to the file.
	Path *string `protobuf:"bytes,1,req,name=path" json:"path,omitempty"`
	// Number of hard links.
	Nlink *int32 `protobuf:"varint,2,opt,name=nlink" json:"nlink,omitempty"`
	// Total size in bytes.
	Size *uint64 `protobuf:"varint,3,opt,name=size" json:"size,omitempty"`
	// Last modification time.
	Mtime *TimeInfo `protobuf:"bytes,4,opt,name=mtime" json:"mtime,omitempty"`
	// Represents a file's mode and permission bits. The bits have the same
	// definition on all systems and is portable.
	Mode *uint32 `protobuf:"varint,5,opt,name=mode" json:"mode,omitempty"`
	// User ID of owner.
	Uid *string `protobuf:"bytes,6,opt,name=uid" json:"uid,omitempty"`
	// Group ID of owner.
	Gid              *string `protobuf:"bytes,7,opt,name=gid" json:"gid,omitempty"`
	XXX_unrecognized []byte  `json:"-"`
}

func (m *FileInfo) Reset()                    { *m = FileInfo{} }
func (m *FileInfo) String() string            { return proto.CompactTextString(m) }
func (*FileInfo) ProtoMessage()               {}
func (*FileInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{65} }

func (m *FileInfo) GetPath() string {
	if m != nil && m.Path != nil {
		return *m.Path
	}
	return ""
}

func (m *FileInfo) GetNlink() int32 {
	if m != nil && m.Nlink != nil {
		return *m.Nlink
	}
	return 0
}

func (m *FileInfo) GetSize() uint64 {
	if m != nil && m.Size != nil {
		return *m.Size
	}
	return 0
}

func (m *FileInfo) GetMtime() *TimeInfo {
	if m != nil {
		return m.Mtime
	}
	return nil
}

func (m *FileInfo) GetMode() uint32 {
	if m != nil && m.Mode != nil {
		return *m.Mode
	}
	return 0
}

func (m *FileInfo) GetUid() string {
	if m != nil && m.Uid != nil {
		return *m.Uid
	}
	return ""
}

func (m *FileInfo) GetGid() string {
	if m != nil && m.Gid != nil {
		return *m.Gid
	}
	return ""
}

func init() {
	proto.RegisterType((*FrameworkID)(nil), "mesos.v1.FrameworkID")
	proto.RegisterType((*OfferID)(nil), "mesos.v1.OfferID")
	proto.RegisterType((*AgentID)(nil), "mesos.v1.AgentID")
	proto.RegisterType((*TaskID)(nil), "mesos.v1.TaskID")
	proto.RegisterType((*ExecutorID)(nil), "mesos.v1.ExecutorID")
	proto.RegisterType((*ContainerID)(nil), "mesos.v1.ContainerID")
	proto.RegisterType((*TimeInfo)(nil), "mesos.v1.TimeInfo")
	proto.RegisterType((*DurationInfo)(nil), "mesos.v1.DurationInfo")
	proto.RegisterType((*Address)(nil), "mesos.v1.Address")
	proto.RegisterType((*URL)(nil), "mesos.v1.URL")
	proto.RegisterType((*Unavailability)(nil), "mesos.v1.Unavailability")
	proto.RegisterType((*MachineID)(nil), "mesos.v1.MachineID")
	proto.RegisterType((*MachineInfo)(nil), "mesos.v1.MachineInfo")
	proto.RegisterType((*FrameworkInfo)(nil), "mesos.v1.FrameworkInfo")
	proto.RegisterType((*FrameworkInfo_Capability)(nil), "mesos.v1.FrameworkInfo.Capability")
	proto.RegisterType((*HealthCheck)(nil), "mesos.v1.HealthCheck")
	proto.RegisterType((*HealthCheck_HTTPCheckInfo)(nil), "mesos.v1.HealthCheck.HTTPCheckInfo")
	proto.RegisterType((*HealthCheck_TCPCheckInfo)(nil), "mesos.v1.HealthCheck.TCPCheckInfo")
	proto.RegisterType((*KillPolicy)(nil), "mesos.v1.KillPolicy")
	proto.RegisterType((*CommandInfo)(nil), "mesos.v1.CommandInfo")
	proto.RegisterType((*CommandInfo_URI)(nil), "mesos.v1.CommandInfo.URI")
	proto.RegisterType((*ExecutorInfo)(nil), "mesos.v1.ExecutorInfo")
	proto.RegisterType((*MasterInfo)(nil), "mesos.v1.MasterInfo")
	proto.RegisterType((*AgentInfo)(nil), "mesos.v1.AgentInfo")
	proto.RegisterType((*Value)(nil), "mesos.v1.Value")
	proto.RegisterType((*Value_Scalar)(nil), "mesos.v1.Value.Scalar")
	proto.RegisterType((*Value_Range)(nil), "mesos.v1.Value.Range")
	proto.RegisterType((*Value_Ranges)(nil), "mesos.v1.Value.Ranges")
	proto.RegisterType((*Value_Set)(nil), "mesos.v1.Value.Set")
	proto.RegisterType((*Value_Text)(nil), "mesos.v1.Value.Text")
	proto.RegisterType((*Attribute)(nil), "mesos.v1.Attribute")
	proto.RegisterType((*Resource)(nil), "mesos.v1.Resource")
	proto.RegisterType((*Resource_ReservationInfo)(nil), "mesos.v1.Resource.ReservationInfo")
	proto.RegisterType((*Resource_DiskInfo)(nil), "mesos.v1.Resource.DiskInfo")
	proto.RegisterType((*Resource_DiskInfo_Persistence)(nil), "mesos.v1.Resource.DiskInfo.Persistence")
	proto.RegisterType((*Resource_DiskInfo_Source)(nil), "mesos.v1.Resource.DiskInfo.Source")
	proto.RegisterType((*Resource_DiskInfo_Source_Path)(nil), "mesos.v1.Resource.DiskInfo.Source.Path")
	proto.RegisterType((*Resource_DiskInfo_Source_Mount)(nil), "mesos.v1.Resource.DiskInfo.Source.Mount")
	proto.RegisterType((*Resource_RevocableInfo)(nil), "mesos.v1.Resource.RevocableInfo")
	proto.RegisterType((*Resource_SharedInfo)(nil), "mesos.v1.Resource.SharedInfo")
	proto.RegisterType((*TrafficControlStatistics)(nil), "mesos.v1.TrafficControlStatistics")
	proto.RegisterType((*IpStatistics)(nil), "mesos.v1.IpStatistics")
	proto.RegisterType((*IcmpStatistics)(nil), "mesos.v1.IcmpStatistics")
	proto.RegisterType((*TcpStatistics)(nil), "mesos.v1.TcpStatistics")
	proto.RegisterType((*UdpStatistics)(nil), "mesos.v1.UdpStatistics")
	proto.RegisterType((*SNMPStatistics)(nil), "mesos.v1.SNMPStatistics")
	proto.RegisterType((*ResourceStatistics)(nil), "mesos.v1.ResourceStatistics")
	proto.RegisterType((*ResourceUsage)(nil), "mesos.v1.ResourceUsage")
	proto.RegisterType((*ResourceUsage_Executor)(nil), "mesos.v1.ResourceUsage.Executor")
	proto.RegisterType((*ResourceUsage_Executor_Task)(nil), "mesos.v1.ResourceUsage.Executor.Task")
	proto.RegisterType((*PerfStatistics)(nil), "mesos.v1.PerfStatistics")
	proto.RegisterType((*Request)(nil), "mesos.v1.Request")
	proto.RegisterType((*Offer)(nil), "mesos.v1.Offer")
	proto.RegisterType((*Offer_Operation)(nil), "mesos.v1.Offer.Operation")
	proto.RegisterType((*Offer_Operation_Launch)(nil), "mesos.v1.Offer.Operation.Launch")
	proto.RegisterType((*Offer_Operation_LaunchGroup)(nil), "mesos.v1.Offer.Operation.LaunchGroup")
	proto.RegisterType((*Offer_Operation_Reserve)(nil), "mesos.v1.Offer.Operation.Reserve")
	proto.RegisterType((*Offer_Operation_Unreserve)(nil), "mesos.v1.Offer.Operation.Unreserve")
	proto.RegisterType((*Offer_Operation_Create)(nil), "mesos.v1.Offer.Operation.Create")
	proto.RegisterType((*Offer_Operation_Destroy)(nil), "mesos.v1.Offer.Operation.Destroy")
	proto.RegisterType((*InverseOffer)(nil), "mesos.v1.InverseOffer")
	proto.RegisterType((*TaskInfo)(nil), "mesos.v1.TaskInfo")
	proto.RegisterType((*TaskGroupInfo)(nil), "mesos.v1.TaskGroupInfo")
	proto.RegisterType((*Task)(nil), "mesos.v1.Task")
	proto.RegisterType((*TaskStatus)(nil), "mesos.v1.TaskStatus")
	proto.RegisterType((*Filters)(nil), "mesos.v1.Filters")
	proto.RegisterType((*Environment)(nil), "mesos.v1.Environment")
	proto.RegisterType((*Environment_Variable)(nil), "mesos.v1.Environment.Variable")
	proto.RegisterType((*Parameter)(nil), "mesos.v1.Parameter")
	proto.RegisterType((*Parameters)(nil), "mesos.v1.Parameters")
	proto.RegisterType((*Credential)(nil), "mesos.v1.Credential")
	proto.RegisterType((*Credentials)(nil), "mesos.v1.Credentials")
	proto.RegisterType((*RateLimit)(nil), "mesos.v1.RateLimit")
	proto.RegisterType((*RateLimits)(nil), "mesos.v1.RateLimits")
	proto.RegisterType((*Image)(nil), "mesos.v1.Image")
	proto.RegisterType((*Image_Appc)(nil), "mesos.v1.Image.Appc")
	proto.RegisterType((*Image_Docker)(nil), "mesos.v1.Image.Docker")
	proto.RegisterType((*Volume)(nil), "mesos.v1.Volume")
	proto.RegisterType((*Volume_Source)(nil), "mesos.v1.Volume.Source")
	proto.RegisterType((*Volume_Source_DockerVolume)(nil), "mesos.v1.Volume.Source.DockerVolume")
	proto.RegisterType((*Volume_Source_SandboxPath)(nil), "mesos.v1.Volume.Source.SandboxPath")
	proto.RegisterType((*NetworkInfo)(nil), "mesos.v1.NetworkInfo")
	proto.RegisterType((*NetworkInfo_IPAddress)(nil), "mesos.v1.NetworkInfo.IPAddress")
	proto.RegisterType((*NetworkInfo_PortMapping)(nil), "mesos.v1.NetworkInfo.PortMapping")
	proto.RegisterType((*CapabilityInfo)(nil), "mesos.v1.CapabilityInfo")
	proto.RegisterType((*LinuxInfo)(nil), "mesos.v1.LinuxInfo")
	proto.RegisterType((*ContainerInfo)(nil), "mesos.v1.ContainerInfo")
	proto.RegisterType((*ContainerInfo_DockerInfo)(nil), "mesos.v1.ContainerInfo.DockerInfo")
	proto.RegisterType((*ContainerInfo_DockerInfo_PortMapping)(nil), "mesos.v1.ContainerInfo.DockerInfo.PortMapping")
	proto.RegisterType((*ContainerInfo_MesosInfo)(nil), "mesos.v1.ContainerInfo.MesosInfo")
	proto.RegisterType((*ContainerStatus)(nil), "mesos.v1.ContainerStatus")
	proto.RegisterType((*CgroupInfo)(nil), "mesos.v1.CgroupInfo")
	proto.RegisterType((*CgroupInfo_NetCls)(nil), "mesos.v1.CgroupInfo.NetCls")
	proto.RegisterType((*Labels)(nil), "mesos.v1.Labels")
	proto.RegisterType((*Label)(nil), "mesos.v1.Label")
	proto.RegisterType((*Port)(nil), "mesos.v1.Port")
	proto.RegisterType((*Ports)(nil), "mesos.v1.Ports")
	proto.RegisterType((*DiscoveryInfo)(nil), "mesos.v1.DiscoveryInfo")
	proto.RegisterType((*WeightInfo)(nil), "mesos.v1.WeightInfo")
	proto.RegisterType((*VersionInfo)(nil), "mesos.v1.VersionInfo")
	proto.RegisterType((*Flag)(nil), "mesos.v1.Flag")
	proto.RegisterType((*Role)(nil), "mesos.v1.Role")
	proto.RegisterType((*Metric)(nil), "mesos.v1.Metric")
	proto.RegisterType((*FileInfo)(nil), "mesos.v1.FileInfo")
	proto.RegisterEnum("mesos.v1.Status", Status_name, Status_value)
	proto.RegisterEnum("mesos.v1.TaskState", TaskState_name, TaskState_value)
	proto.RegisterEnum("mesos.v1.MachineInfo_Mode", MachineInfo_Mode_name, MachineInfo_Mode_value)
	proto.RegisterEnum("mesos.v1.FrameworkInfo_Capability_Type", FrameworkInfo_Capability_Type_name, FrameworkInfo_Capability_Type_value)
	proto.RegisterEnum("mesos.v1.HealthCheck_Type", HealthCheck_Type_name, HealthCheck_Type_value)
	proto.RegisterEnum("mesos.v1.ExecutorInfo_Type", ExecutorInfo_Type_name, ExecutorInfo_Type_value)
	proto.RegisterEnum("mesos.v1.Value_Type", Value_Type_name, Value_Type_value)
	proto.RegisterEnum("mesos.v1.Resource_DiskInfo_Source_Type", Resource_DiskInfo_Source_Type_name, Resource_DiskInfo_Source_Type_value)
	proto.RegisterEnum("mesos.v1.Offer_Operation_Type", Offer_Operation_Type_name, Offer_Operation_Type_value)
	proto.RegisterEnum("mesos.v1.TaskStatus_Source", TaskStatus_Source_name, TaskStatus_Source_value)
	proto.RegisterEnum("mesos.v1.TaskStatus_Reason", TaskStatus_Reason_name, TaskStatus_Reason_value)
	proto.RegisterEnum("mesos.v1.Image_Type", Image_Type_name, Image_Type_value)
	proto.RegisterEnum("mesos.v1.Volume_Mode", Volume_Mode_name, Volume_Mode_value)
	proto.RegisterEnum("mesos.v1.Volume_Source_Type", Volume_Source_Type_name, Volume_Source_Type_value)
	proto.RegisterEnum("mesos.v1.Volume_Source_SandboxPath_Type", Volume_Source_SandboxPath_Type_name, Volume_Source_SandboxPath_Type_value)
	proto.RegisterEnum("mesos.v1.NetworkInfo_Protocol", NetworkInfo_Protocol_name, NetworkInfo_Protocol_value)
	proto.RegisterEnum("mesos.v1.CapabilityInfo_Capability", CapabilityInfo_Capability_name, CapabilityInfo_Capability_value)
	proto.RegisterEnum("mesos.v1.ContainerInfo_Type", ContainerInfo_Type_name, ContainerInfo_Type_value)
	proto.RegisterEnum("mesos.v1.ContainerInfo_DockerInfo_Network", ContainerInfo_DockerInfo_Network_name, ContainerInfo_DockerInfo_Network_value)
	proto.RegisterEnum("mesos.v1.DiscoveryInfo_Visibility", DiscoveryInfo_Visibility_name, DiscoveryInfo_Visibility_value)
}

func init() { proto.RegisterFile("mesos.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 8324 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0xd4, 0x7c, 0xc9, 0x8f, 0x1b, 0x49,
	0x97, 0xdf, 0xc7, 0x9d, 0x7c, 0x24, 0xab, 0x52, 0x51, 0x92, 0x9a, 0xa2, 0x96, 0xae, 0xce, 0x6e,
	0x75, 0x57, 0xeb, 0xeb, 0xae, 0x96, 0x4a, 0xad, 0x5e, 0xa4, 0xef, 0xfb, 0x3c, 0x2c, 0x32, 0x4b,
	0xe2, 0xa8, 0xb8, 0x4c, 0x90, 0x94, 0xba, 0x0d, 0x03, 0x44, 0x2a, 0x19, 0x55, 0x95, 0x16, 0x99,
	0xc9, 0xce, 0x4c, 0x96, 0x24, 0x9f, 0x3c, 0x9b, 0x97, 0xf1, 0x8c, 0x0f, 0x63, 0xc3, 0x18, 0x60,
	0xce, 0x86, 0x01, 0x0f, 0xe0, 0x7f, 0xc0, 0x86, 0x6f, 0x86, 0x57, 0x18, 0xf0, 0xc1, 0x3e, 0x18,
	0x06, 0x7c, 0xf9, 0x60, 0xcc, 0x78, 0x19, 0x7b, 0xbc, 0x8d, 0x3d, 0xe3, 0x0d, 0xb1, 0x65, 0x46,
	0x26, 0xc9, 0xaa, 0x52, 0xdb, 0x30, 0x30, 0x27, 0x32, 0x5e, 0xfc, 0x5e, 0xe4, 0x8b, 0xf7, 0x5e,
	0x44, 0xbc, 0x58, 0xa1, 0x3c, 0x23, 0xbe, 0xeb, 0xef, 0xce, 0x3d, 0x37, 0x70, 0x51, 0x91, 0x27,
	0x4e, 0xef, 0xe9, 0xef, 0x43, 0xf9, 0xc0, 0x33, 0x67, 0xe4, 0x95, 0xeb, 0xbd, 0x6c, 0xb7, 0xd0,
	0x65, 0xc8, 0x9d, 0x9a, 0xd3, 0x05, 0xa9, 0xa5, 0xb6, 0xd3, 0x3b, 0x25, 0xcc, 0x13, 0xfa, 0xbb,
	0x50, 0xe8, 0x1d, 0x1d, 0x11, 0xef, 0x2c, 0x40, 0xe3, 0x98, 0x38, 0xc1, 0x5a, 0xc0, 0x2d, 0xc8,
	0x0f, 0x4d, 0x7f, 0xfd, 0x17, 0x74, 0x00, 0xe3, 0x35, 0xb1, 0x16, 0x81, 0xbb, 0xfe, 0x23, 0x18,
	0xca, 0x4d, 0xd7, 0x09, 0x4c, 0xdb, 0x59, 0x2f, 0x09, 0xfa, 0x14, 0xf2, 0x73, 0xd3, 0x23, 0x4e,
	0x50, 0x4b, 0x6f, 0xa7, 0x76, 0xca, 0x7b, 0x57, 0x76, 0x65, 0x55, 0x77, 0x15, 0x66, 0x2c, 0x40,
	0xfa, 0x27, 0x50, 0x1c, 0xda, 0x33, 0xd2, 0x76, 0x8e, 0x5c, 0xb4, 0x0d, 0x65, 0xc7, 0x74, 0x5c,
	0x9f, 0x58, 0xae, 0x33, 0xf1, 0x59, 0xb1, 0x19, 0xac, 0x92, 0xf4, 0xbb, 0x50, 0x69, 0x2d, 0x3c,
	0x33, 0xb0, 0x5d, 0xe7, 0x82, 0x1c, 0x6d, 0x28, 0x34, 0x26, 0x13, 0x8f, 0xf8, 0x3e, 0xaa, 0x43,
	0xf1, 0xc4, 0xf5, 0x03, 0xc7, 0x9c, 0x51, 0x91, 0x53, 0x3b, 0x25, 0x1c, 0xa6, 0xd1, 0x06, 0xa4,
	0xed, 0x39, 0x93, 0xb8, 0x84, 0xd3, 0xf6, 0x1c, 0x21, 0xc8, 0xce, 0x5d, 0x2f, 0xa8, 0x65, 0xb6,
	0xd3, 0x3b, 0x39, 0xcc, 0xfe, 0xeb, 0x7f, 0x35, 0x05, 0x99, 0x11, 0x3e, 0x44, 0x57, 0x21, 0xef,
	0x5b, 0x27, 0x64, 0x26, 0x2b, 0x2e, 0x52, 0xe8, 0x87, 0x50, 0x30, 0xf9, 0xa7, 0x6a, 0xe9, 0xed,
	0xf4, 0x4e, 0x79, 0xef, 0x52, 0x54, 0x75, 0x21, 0x03, 0x96, 0x08, 0xf6, 0x01, 0x33, 0x38, 0xa9,
	0x65, 0xd8, 0x27, 0xd9, 0x7f, 0xf4, 0x31, 0xe4, 0xbe, 0x5b, 0x10, 0xef, 0x4d, 0x2d, 0xbb, 0x9d,
	0xd9, 0x29, 0xef, 0x6d, 0x45, 0xec, 0x7d, 0x93, 0xba, 0x48, 0x40, 0x3c, 0xcc, 0x11, 0xb4, 0x2e,
	0x47, 0x9e, 0x79, 0x3c, 0xa3, 0x7a, 0xce, 0xf1, 0xba, 0xc8, 0xb4, 0xee, 0xc0, 0xc6, 0xc8, 0x31,
	0x4f, 0x4d, 0x7b, 0x6a, 0xbe, 0xb0, 0xa7, 0x76, 0xf0, 0x06, 0xed, 0x40, 0xce, 0x0f, 0x4c, 0x2f,
	0x60, 0x02, 0x97, 0xf7, 0x50, 0x54, 0xb0, 0xd4, 0x3d, 0xe6, 0x00, 0xb4, 0x07, 0xc5, 0x89, 0x50,
	0xb0, 0xb0, 0xdf, 0xd5, 0x08, 0xac, 0xaa, 0x1e, 0x87, 0x38, 0xfd, 0x4b, 0x28, 0x75, 0x4c, 0xeb,
	0xc4, 0x76, 0x48, 0xbb, 0xf5, 0x36, 0x4a, 0xd6, 0xff, 0x51, 0x0a, 0xca, 0x92, 0x93, 0x5a, 0xf3,
	0x7d, 0x48, 0xdb, 0x13, 0x21, 0xa3, 0x52, 0xf9, 0xb0, 0x70, 0x9c, 0xb6, 0x27, 0x68, 0x17, 0xb2,
	0x33, 0x77, 0x42, 0x58, 0x31, 0x1b, 0x7b, 0xf5, 0x65, 0x98, 0x73, 0xe4, 0xee, 0x76, 0xdc, 0x09,
	0xc1, 0x0c, 0x87, 0x7e, 0x06, 0x36, 0x16, 0x31, 0x6d, 0x30, 0x95, 0x97, 0xf7, 0x6a, 0x11, 0x67,
	0x5c, 0x5b, 0x38, 0x81, 0xd7, 0x3f, 0x84, 0x2c, 0x2d, 0x0f, 0xe5, 0x21, 0x3d, 0xea, 0x6b, 0x29,
	0x54, 0x81, 0x62, 0x0b, 0x37, 0xda, 0xdd, 0x76, 0xf7, 0xb1, 0x96, 0x46, 0x45, 0xc8, 0xb6, 0x7a,
	0xcf, 0xbb, 0x5a, 0x46, 0xff, 0x69, 0x16, 0xaa, 0x51, 0x53, 0xa6, 0x15, 0x42, 0x90, 0x5d, 0xf8,
	0xc4, 0x13, 0x7e, 0xc2, 0xfe, 0x53, 0x1a, 0x53, 0x4e, 0x9a, 0xd3, 0x98, 0x62, 0x6e, 0xb3, 0x8a,
	0x67, 0x92, 0xed, 0x45, 0xe9, 0x17, 0x58, 0xd5, 0x3f, 0x01, 0xed, 0xc8, 0xb4, 0xa7, 0xee, 0x29,
	0xf1, 0xc6, 0x81, 0x3d, 0x23, 0xee, 0x22, 0xa8, 0x65, 0xb7, 0x53, 0x3b, 0xa9, 0x87, 0xa9, 0xbb,
	0x78, 0x53, 0x66, 0x0d, 0x79, 0x0e, 0xba, 0x0d, 0x60, 0x9d, 0x10, 0xeb, 0xe5, 0xdc, 0xb5, 0x85,
	0x93, 0x14, 0x1f, 0xe6, 0x8e, 0xcc, 0xa9, 0x4f, 0xb0, 0x92, 0x81, 0xae, 0x40, 0xd6, 0x73, 0xa7,
	0xa4, 0x96, 0xa7, 0x66, 0x79, 0x98, 0xba, 0x83, 0x59, 0x32, 0x66, 0xc7, 0x42, 0xc2, 0x8e, 0x37,
	0xa0, 0x34, 0xf7, 0x6c, 0xc7, 0xb2, 0xe7, 0xe6, 0xb4, 0x56, 0x64, 0x99, 0x11, 0x01, 0x5d, 0x87,
	0xd2, 0x2b, 0xf2, 0x62, 0x61, 0x8f, 0x17, 0xde, 0xb4, 0x56, 0xe2, 0xac, 0x8c, 0x30, 0xf2, 0xa6,
	0xe8, 0x00, 0x2a, 0x96, 0x39, 0xe7, 0x9a, 0xb5, 0x89, 0x5f, 0x03, 0xe6, 0xe9, 0xfa, 0xaa, 0x3a,
	0x53, 0x3b, 0x36, 0x25, 0xf6, 0x0d, 0x8e, 0xf1, 0xa1, 0x1d, 0xc8, 0x4f, 0xcd, 0x17, 0x64, 0xea,
	0xd7, 0xca, 0x4c, 0x6b, 0x5a, 0x54, 0xc2, 0x21, 0xa3, 0x63, 0x91, 0x5f, 0xff, 0xc7, 0x29, 0x80,
	0xa8, 0x18, 0xf4, 0x08, 0xb2, 0xc1, 0x9b, 0x39, 0xf7, 0xcd, 0x8d, 0xbd, 0x8f, 0xce, 0xff, 0xf0,
	0xee, 0xf0, 0xcd, 0x9c, 0x60, 0xc6, 0xa4, 0xff, 0x42, 0x0a, 0xb2, 0x34, 0x89, 0xca, 0x50, 0x18,
	0x75, 0x9f, 0x76, 0xa9, 0xdd, 0x7f, 0x80, 0xde, 0x81, 0x2d, 0x6c, 0x3c, 0xeb, 0x35, 0x1b, 0xfb,
	0x87, 0xc6, 0x18, 0x1b, 0x83, 0xde, 0x08, 0x37, 0x8d, 0x81, 0x96, 0x42, 0x57, 0x01, 0x0d, 0x1b,
	0x83, 0xa7, 0xe3, 0xa7, 0xed, 0xc3, 0xc3, 0x76, 0xf7, 0xf1, 0x78, 0x30, 0x6c, 0x0c, 0x0d, 0x2d,
	0x8d, 0x2e, 0x41, 0xf5, 0x71, 0x7f, 0xa4, 0x40, 0x33, 0xe8, 0x32, 0x68, 0x83, 0x27, 0x0d, 0x6c,
	0xb4, 0x14, 0x6a, 0x16, 0x6d, 0xc1, 0x66, 0xbf, 0x81, 0x87, 0xed, 0x61, 0xbb, 0xd7, 0x1d, 0x37,
	0x9e, 0x37, 0xb0, 0xa1, 0xe5, 0xf4, 0xbf, 0x9c, 0x83, 0xf2, 0x13, 0x62, 0x4e, 0x83, 0x93, 0x26,
	0xb5, 0x22, 0xfa, 0x08, 0xaa, 0x13, 0x32, 0x35, 0xdf, 0x8c, 0x65, 0x2f, 0x98, 0x66, 0x2e, 0x91,
	0xbe, 0xf7, 0x00, 0x57, 0x58, 0xc6, 0x80, 0xd3, 0xd1, 0xa7, 0xa0, 0xd9, 0x4e, 0x40, 0xbc, 0x53,
	0x73, 0x1a, 0x62, 0x33, 0x02, 0x7b, 0x17, 0x6f, 0xca, 0x3c, 0x09, 0xff, 0x21, 0x6c, 0x0a, 0x27,
	0x0b, 0xd1, 0xdc, 0xd9, 0xd2, 0x7b, 0x77, 0xf1, 0x86, 0xc8, 0x92, 0xe0, 0xcf, 0xe1, 0xb2, 0xe5,
	0x3a, 0x3e, 0x1d, 0x40, 0xec, 0x53, 0x32, 0xa6, 0xbe, 0xb8, 0xf0, 0x88, 0xcf, 0xdc, 0xae, 0xfa,
	0x30, 0x75, 0x1f, 0x6f, 0x29, 0xd9, 0x07, 0x22, 0x97, 0x72, 0x1d, 0x7b, 0xa6, 0x45, 0xc6, 0x73,
	0xe2, 0xd9, 0xee, 0x24, 0xfc, 0x4e, 0x3e, 0x94, 0x0a, 0xb1, 0xfc, 0x3e, 0xcb, 0x96, 0xdf, 0xda,
	0x15, 0x26, 0x2c, 0x26, 0x7b, 0x00, 0x45, 0x2b, 0x8a, 0xd5, 0xd0, 0x67, 0x50, 0xb0, 0xdc, 0xd9,
	0xcc, 0x74, 0x26, 0xcc, 0x93, 0x13, 0x43, 0x12, 0xcb, 0x60, 0x3d, 0x9a, 0x44, 0xa1, 0x2f, 0x21,
	0x7b, 0x12, 0x04, 0x73, 0xe6, 0x23, 0xe5, 0xbd, 0xf7, 0x57, 0x7f, 0xe0, 0xc9, 0x70, 0xd8, 0x67,
	0xff, 0x18, 0x2f, 0x63, 0x40, 0x9f, 0x43, 0x26, 0xb0, 0xe6, 0xcc, 0xe9, 0x63, 0x4e, 0x1d, 0x13,
	0xac, 0xa9, 0xb0, 0x51, 0x78, 0xfd, 0x25, 0x54, 0x63, 0x85, 0x29, 0x03, 0x0c, 0x1f, 0x1d, 0xe4,
	0x00, 0x23, 0x07, 0x25, 0xda, 0x9d, 0x54, 0xf9, 0xa0, 0x14, 0x8e, 0x23, 0x69, 0x65, 0x1c, 0xa9,
	0x43, 0xd1, 0x0f, 0xcc, 0x60, 0xe1, 0x13, 0x9f, 0x0d, 0x25, 0x55, 0x1c, 0xa6, 0xeb, 0x3a, 0x54,
	0x54, 0x09, 0x56, 0x95, 0xa9, 0xdf, 0x5f, 0xe5, 0xe5, 0x65, 0x28, 0x34, 0x7b, 0x9d, 0x4e, 0xa3,
	0xdb, 0xd2, 0x52, 0xb4, 0xd3, 0xa3, 0x22, 0x6b, 0x69, 0x54, 0x80, 0xcc, 0xb0, 0xd9, 0xd7, 0x32,
	0xfa, 0x63, 0x80, 0xa7, 0xf6, 0x74, 0xda, 0x77, 0xa7, 0xb6, 0xf5, 0x06, 0x7d, 0x0d, 0x15, 0xd5,
	0xb2, 0x42, 0x95, 0xeb, 0xc6, 0x92, 0xb2, 0x62, 0x65, 0xfd, 0x77, 0xd3, 0x34, 0xcc, 0x08, 0xcd,
	0x82, 0x3e, 0x85, 0xec, 0xc2, 0xb3, 0xe9, 0xe0, 0x4e, 0xbb, 0x8a, 0x6b, 0x2b, 0x6d, 0xb7, 0x3b,
	0xc2, 0x6d, 0xcc, 0x60, 0xe8, 0x4b, 0x28, 0x13, 0xe7, 0xd4, 0xf6, 0x5c, 0x67, 0xb6, 0x32, 0x08,
	0x31, 0xa2, 0x4c, 0xac, 0x22, 0x51, 0x1d, 0x72, 0xfe, 0x09, 0x99, 0x4e, 0x99, 0xf7, 0x15, 0x1f,
	0x66, 0x03, 0x6f, 0x41, 0x30, 0x27, 0x45, 0xa1, 0x0e, 0x37, 0x88, 0x08, 0x75, 0x6e, 0x40, 0xc9,
	0xf4, 0x8e, 0x17, 0x94, 0xdb, 0xaf, 0x15, 0xb6, 0x33, 0xb4, 0x1f, 0x0c, 0x09, 0x61, 0xe7, 0xcf,
	0x87, 0x67, 0xf6, 0xbf, 0xfe, 0xeb, 0x2c, 0x84, 0x68, 0xaf, 0x09, 0x9d, 0x6e, 0x01, 0x10, 0x16,
	0x83, 0x99, 0x2f, 0xa6, 0x7c, 0x80, 0x2b, 0x62, 0x85, 0x82, 0x6e, 0x41, 0x81, 0xbc, 0x0e, 0x3c,
	0xd3, 0x0a, 0x98, 0x1c, 0x52, 0x46, 0x49, 0xa4, 0xa5, 0x5a, 0xa6, 0x75, 0x42, 0x58, 0x3b, 0x2d,
	0x62, 0x9e, 0x40, 0xef, 0x42, 0xd9, 0x5d, 0x04, 0xf3, 0x45, 0x30, 0x3e, 0xb2, 0xa7, 0x44, 0x88,
	0x03, 0x9c, 0x74, 0x60, 0x4f, 0x89, 0xfe, 0x3b, 0x59, 0xa8, 0x84, 0xb1, 0x1f, 0xd5, 0xf8, 0x67,
	0xa2, 0x81, 0x6d, 0xb2, 0x06, 0x76, 0x5d, 0xd1, 0x9d, 0x82, 0x52, 0x5b, 0xd8, 0x03, 0x28, 0x13,
	0x91, 0x35, 0x0e, 0x47, 0xf0, 0xcb, 0x2b, 0xf8, 0x5a, 0xb2, 0x3e, 0xae, 0xd7, 0x9e, 0xa0, 0xaf,
	0xa0, 0x72, 0x24, 0x7b, 0x5d, 0xca, 0x57, 0x3c, 0x6b, 0x00, 0x2c, 0x87, 0xd0, 0xf6, 0xe4, 0xed,
	0x9b, 0xf4, 0x03, 0x28, 0x59, 0x32, 0xfa, 0x14, 0x43, 0xc6, 0x3b, 0xab, 0x02, 0x53, 0xca, 0x14,
	0x21, 0xd1, 0x5d, 0x28, 0x79, 0xc4, 0x77, 0x17, 0x9e, 0xc5, 0xfa, 0xb2, 0x4c, 0x3c, 0x78, 0xc2,
	0x22, 0x0b, 0x47, 0xa0, 0x70, 0x78, 0xe7, 0x03, 0x1f, 0x1f, 0xde, 0xeb, 0x90, 0xe7, 0xd9, 0x35,
	0xa0, 0xd4, 0xfd, 0x74, 0x2d, 0x85, 0x05, 0x85, 0xe2, 0x27, 0x66, 0x60, 0x32, 0x93, 0x55, 0x30,
	0xfb, 0x4f, 0x85, 0x9d, 0xd8, 0xbe, 0x45, 0x07, 0xf3, 0x37, 0xb5, 0x4a, 0x52, 0xd8, 0x96, 0xcc,
	0xe2, 0xc2, 0x86, 0x48, 0xf4, 0xb3, 0x70, 0xc5, 0x3f, 0x59, 0x04, 0x13, 0xf7, 0x95, 0x33, 0x8e,
	0x35, 0xbe, 0xea, 0x99, 0x8d, 0x6f, 0x4b, 0x32, 0x3d, 0x8e, 0x1a, 0xa1, 0x32, 0xbe, 0x6e, 0x9c,
	0x3d, 0xbe, 0xea, 0x9f, 0xac, 0xe9, 0x2c, 0x5a, 0xc6, 0x41, 0x63, 0x74, 0x38, 0xd4, 0x52, 0x08,
	0x20, 0xdf, 0x1c, 0x0d, 0x86, 0xbd, 0x8e, 0x96, 0xd6, 0xff, 0x66, 0x0a, 0xa0, 0x63, 0xfa, 0x01,
	0x57, 0x35, 0x8b, 0x08, 0x27, 0xa2, 0x11, 0xd0, 0x08, 0x47, 0x46, 0x88, 0xb4, 0x2f, 0xa2, 0x61,
	0x78, 0x4d, 0x09, 0xc3, 0xab, 0x0f, 0xb3, 0x0f, 0xee, 0x3e, 0xb8, 0x2b, 0xfa, 0x3d, 0x0d, 0x32,
	0x73, 0x7b, 0xc2, 0xd4, 0x56, 0xc2, 0xf4, 0x6f, 0x2c, 0x62, 0xc9, 0x25, 0x22, 0x96, 0x1a, 0x14,
	0x4e, 0x89, 0xe7, 0xd3, 0xa8, 0x96, 0xc5, 0x39, 0x58, 0x26, 0xd5, 0xa0, 0x9d, 0x7b, 0xd2, 0x19,
	0x41, 0xbb, 0xfe, 0x0f, 0x53, 0x50, 0xe2, 0xd3, 0x2c, 0x2a, 0x7c, 0x3c, 0xd4, 0x4d, 0x27, 0x3e,
	0xc8, 0x05, 0xa7, 0x2e, 0x9d, 0x63, 0x82, 0xdf, 0x13, 0x82, 0xc7, 0x5c, 0x2a, 0x73, 0x11, 0x97,
	0xba, 0x0f, 0x60, 0x06, 0x81, 0x67, 0xbf, 0x58, 0x04, 0xa1, 0x17, 0x2a, 0xe1, 0x71, 0x43, 0xe6,
	0x61, 0x05, 0x86, 0xde, 0x63, 0x9a, 0xcd, 0x2f, 0x55, 0x89, 0x4f, 0x12, 0xa9, 0xb2, 0xf5, 0x7f,
	0x96, 0x81, 0xdc, 0x33, 0xd6, 0xf1, 0xec, 0x84, 0x41, 0x51, 0x7a, 0x67, 0x43, 0x6d, 0xb8, 0x2c,
	0x5b, 0x6d, 0xe9, 0xbb, 0x74, 0x68, 0x32, 0xa7, 0xa6, 0xb7, 0x3c, 0x3b, 0xe0, 0xd8, 0x01, 0xcb,
	0xc5, 0x02, 0x45, 0xf1, 0x9e, 0xe9, 0x1c, 0x13, 0x5f, 0x44, 0xb7, 0x4b, 0x78, 0xcc, 0x72, 0xb1,
	0x40, 0xa1, 0xdb, 0x90, 0xf1, 0x09, 0x8f, 0x6a, 0x63, 0x95, 0x14, 0x85, 0x93, 0x00, 0xd3, 0x7c,
	0x26, 0x30, 0x79, 0xcd, 0xa3, 0xda, 0xf2, 0x0a, 0x81, 0xc9, 0xeb, 0x00, 0x33, 0x44, 0xfd, 0x16,
	0xe4, 0xb9, 0x48, 0xf1, 0x3e, 0x37, 0x25, 0xfa, 0xdc, 0xfa, 0x67, 0x90, 0x63, 0x22, 0xd0, 0xec,
	0x17, 0xe4, 0xd8, 0x76, 0x58, 0x76, 0x16, 0xf3, 0x04, 0x75, 0x33, 0xe2, 0x4c, 0x98, 0x47, 0x66,
	0x31, 0xfd, 0x5b, 0x7f, 0x00, 0x79, 0x2e, 0x33, 0xfa, 0x21, 0xe4, 0x98, 0xd4, 0x62, 0x64, 0xba,
	0xb2, 0xb2, 0x6a, 0x98, 0x63, 0xea, 0xd7, 0x20, 0x33, 0x20, 0x6c, 0xb8, 0xb6, 0x03, 0x32, 0x63,
	0x2c, 0x25, 0xcc, 0xfe, 0xd7, 0x6f, 0x40, 0x96, 0x0a, 0xbc, 0x66, 0xd2, 0x7d, 0x4f, 0xb4, 0x2f,
	0x80, 0xfc, 0xa0, 0xd9, 0x38, 0x6c, 0x60, 0xed, 0x07, 0xf4, 0x3f, 0x6e, 0x74, 0x1f, 0xb3, 0x20,
	0xb3, 0x00, 0x99, 0x81, 0x31, 0xe4, 0x13, 0x91, 0xa1, 0xf1, 0xcd, 0x50, 0xcb, 0xe8, 0x7f, 0x40,
	0xdd, 0x54, 0xba, 0x42, 0xd8, 0x23, 0xa5, 0x94, 0x09, 0x87, 0x34, 0x78, 0xfa, 0x2d, 0x0c, 0x9e,
	0x79, 0x4b, 0x83, 0x67, 0xdf, 0xc6, 0xe0, 0xf9, 0xff, 0x57, 0x06, 0xd7, 0x7f, 0x5a, 0x84, 0xa2,
	0x6c, 0x45, 0x7f, 0x34, 0xea, 0x9e, 0x3b, 0xa7, 0xee, 0x6b, 0x66, 0x68, 0x2d, 0x28, 0x7b, 0xc4,
	0xa7, 0x21, 0x3b, 0x9b, 0xad, 0x17, 0x93, 0x41, 0xa7, 0x54, 0x02, 0xfd, 0x23, 0x51, 0x3c, 0xda,
	0x52, 0xd8, 0xe8, 0x58, 0x3f, 0xb1, 0xfd, 0x97, 0xa2, 0xf3, 0xbb, 0xbe, 0x82, 0xbd, 0x65, 0xfb,
	0x22, 0xc6, 0xa5, 0x40, 0xf4, 0x13, 0xda, 0x7f, 0x9d, 0xba, 0x16, 0x8b, 0x51, 0x78, 0xa4, 0xbb,
	0xbd, 0xf2, 0xa3, 0x02, 0xc3, 0x47, 0xa9, 0x90, 0x05, 0x3d, 0x80, 0xbc, 0x7f, 0x62, 0x7a, 0x64,
	0xc2, 0x06, 0xc3, 0xf2, 0xde, 0xcd, 0x15, 0xcc, 0x03, 0x06, 0x60, 0x9c, 0x02, 0x5c, 0xff, 0x16,
	0x36, 0x13, 0xf5, 0x88, 0x4f, 0x43, 0x53, 0xc9, 0x69, 0x68, 0x34, 0x82, 0xa5, 0xcf, 0x99, 0x21,
	0xfe, 0xa5, 0x2c, 0x14, 0x65, 0x25, 0x51, 0x1b, 0xca, 0x73, 0x3a, 0x34, 0xf8, 0x01, 0x71, 0x2c,
	0x22, 0xe2, 0xd6, 0x8f, 0xce, 0x50, 0xcb, 0x6e, 0x3f, 0x82, 0x63, 0x95, 0x97, 0x4a, 0x70, 0xea,
	0x4e, 0x17, 0x33, 0xb2, 0x2c, 0xc1, 0x33, 0x46, 0xc7, 0x22, 0x1f, 0x3d, 0x0c, 0x03, 0x84, 0xcc,
	0x5a, 0x2b, 0x86, 0xdf, 0x1b, 0xf0, 0x01, 0x42, 0x70, 0xd4, 0x1f, 0x41, 0x59, 0x91, 0x60, 0x69,
	0x44, 0x8d, 0x29, 0x29, 0x9d, 0x50, 0x52, 0xfd, 0x37, 0xd2, 0x90, 0xe7, 0xe5, 0x29, 0x13, 0xe3,
	0x74, 0x7c, 0x62, 0xbc, 0x4e, 0x02, 0xb5, 0xa5, 0x3c, 0x52, 0x66, 0x21, 0xe5, 0x0b, 0x31, 0xf7,
	0xcd, 0xe0, 0x44, 0x4c, 0x57, 0x7e, 0x02, 0xb9, 0x99, 0xbb, 0x70, 0x02, 0x51, 0xf9, 0x9d, 0x0b,
	0x70, 0x77, 0x28, 0x1e, 0x73, 0xb6, 0x7a, 0x1d, 0xb2, 0xb4, 0x34, 0xda, 0xd8, 0x3d, 0xd7, 0x0d,
	0x64, 0x63, 0xa7, 0xff, 0xeb, 0xd7, 0x21, 0xc7, 0xb0, 0xab, 0x32, 0xf5, 0xeb, 0xa2, 0x6b, 0x2d,
	0x42, 0xb6, 0xdf, 0x18, 0x3e, 0xd1, 0x52, 0xa8, 0x04, 0xb9, 0x4e, 0x6f, 0xd4, 0x1d, 0x6a, 0xe9,
	0xfa, 0x26, 0x54, 0x63, 0x3e, 0x5c, 0xaf, 0x00, 0x44, 0x7e, 0xa9, 0xff, 0xc5, 0x34, 0xd4, 0x86,
	0x9e, 0x79, 0x74, 0x64, 0x5b, 0x34, 0x7a, 0xf4, 0xdc, 0xe9, 0x20, 0x30, 0x03, 0xdb, 0x0f, 0x6c,
	0xcb, 0x5f, 0x32, 0x42, 0x0d, 0x0a, 0x2f, 0x4c, 0xeb, 0xe5, 0xd4, 0x3d, 0x66, 0x1a, 0xca, 0x62,
	0x99, 0x64, 0xa3, 0xce, 0x9b, 0x40, 0x0c, 0x8f, 0x74, 0xd4, 0xa1, 0x09, 0x4a, 0x9d, 0x78, 0xee,
	0x9c, 0xf7, 0x23, 0x59, 0xcc, 0x13, 0x74, 0x7a, 0x40, 0x03, 0xbd, 0xa9, 0x3d, 0xb3, 0x03, 0x3e,
	0xb3, 0xce, 0x62, 0x85, 0x42, 0xbf, 0x32, 0x37, 0xad, 0x97, 0x24, 0xe0, 0x13, 0xe8, 0x2c, 0x96,
	0x49, 0x5a, 0xf9, 0xef, 0xa6, 0xc4, 0x61, 0x8d, 0x3c, 0x8b, 0xd9, 0x7f, 0x8a, 0xf6, 0xcc, 0x80,
	0xbc, 0x98, 0xfb, 0xac, 0xeb, 0xc8, 0x62, 0x99, 0x94, 0x39, 0xf3, 0xb9, 0xcf, 0xda, 0xb7, 0xc8,
	0x99, 0xcf, 0xd9, 0x0a, 0xaa, 0x47, 0xbe, 0x5b, 0x90, 0x05, 0x5b, 0xb9, 0xa1, 0x59, 0x61, 0x5a,
	0xff, 0xa5, 0x1c, 0x54, 0xda, 0x73, 0x45, 0x09, 0xb7, 0x00, 0x0e, 0x5c, 0xef, 0x95, 0xe9, 0x4d,
	0x6c, 0xe7, 0x98, 0x35, 0xa4, 0x0c, 0x56, 0x28, 0x34, 0xbf, 0x45, 0x8e, 0xcc, 0xc5, 0x34, 0x18,
	0x0e, 0x0f, 0x99, 0x5e, 0x32, 0x58, 0xa1, 0xd0, 0xfc, 0xb6, 0x83, 0x89, 0x45, 0xec, 0x53, 0xa1,
	0x9f, 0x0c, 0x56, 0x28, 0x68, 0x1b, 0xca, 0x6d, 0xe7, 0xc9, 0xc4, 0x33, 0x3c, 0xcf, 0xf5, 0xb8,
	0xaa, 0x32, 0x58, 0x25, 0x21, 0x1d, 0x2a, 0x6d, 0x87, 0x06, 0x71, 0x02, 0x92, 0x63, 0x90, 0x18,
	0x0d, 0x7d, 0x00, 0x55, 0x2a, 0x53, 0xcb, 0x0c, 0xcc, 0x63, 0xcf, 0x9c, 0x71, 0xd5, 0x65, 0x70,
	0x9c, 0x88, 0x76, 0x60, 0xb3, 0xed, 0x8c, 0x9c, 0x97, 0x8e, 0xfb, 0xca, 0xe9, 0x7b, 0x6e, 0xe0,
	0xf2, 0x68, 0x31, 0x83, 0x93, 0x64, 0x2e, 0x35, 0x0d, 0xd1, 0x4d, 0x6f, 0xc2, 0x35, 0xcb, 0xa4,
	0x96, 0x14, 0x91, 0x4f, 0xa6, 0x36, 0x0d, 0x40, 0x99, 0x7e, 0x79, 0xbe, 0xa0, 0xd0, 0x5a, 0xf5,
	0x16, 0x01, 0xa6, 0x5a, 0xf5, 0x03, 0xae, 0xe5, 0x0c, 0x56, 0x49, 0x02, 0x11, 0x7e, 0xa2, 0x1c,
	0x22, 0xc2, 0x6f, 0x70, 0x44, 0xd7, 0xc5, 0x2e, 0x8b, 0x18, 0x2b, 0x21, 0x42, 0x92, 0xa8, 0x66,
	0x30, 0x31, 0xfd, 0x99, 0x58, 0x2b, 0x64, 0x33, 0x84, 0x0c, 0x8e, 0xd1, 0xa8, 0xa4, 0x2c, 0x8d,
	0xc9, 0x77, 0x13, 0x3e, 0x0d, 0xc8, 0x60, 0x85, 0x42, 0x9d, 0x81, 0xa5, 0x7a, 0x4f, 0x7d, 0x36,
	0x53, 0xcc, 0xe0, 0x30, 0x1d, 0xf2, 0x1e, 0x98, 0xf6, 0xd4, 0xaf, 0x69, 0x0a, 0x2f, 0xa3, 0x50,
	0x17, 0x3b, 0xf0, 0xcc, 0x63, 0xca, 0x7a, 0x89, 0x65, 0xca, 0x24, 0xed, 0xaf, 0xe8, 0x5f, 0xce,
	0x88, 0x58, 0x5e, 0x44, 0xa0, 0x35, 0xa3, 0x89, 0xa6, 0x47, 0x4c, 0x5a, 0xb3, 0x2d, 0x5e, 0x33,
	0x85, 0xa4, 0xff, 0xed, 0x02, 0x6c, 0xb4, 0xad, 0x99, 0xea, 0x88, 0x57, 0x21, 0xdf, 0x76, 0x3a,
	0xfe, 0xb1, 0x2f, 0x9c, 0x50, 0xa4, 0x68, 0x05, 0xda, 0x8e, 0x70, 0x0d, 0xee, 0x7e, 0x61, 0x9a,
	0xbb, 0x4e, 0xd3, 0x5f, 0xcc, 0x44, 0x7e, 0x46, 0xba, 0x4e, 0x44, 0x43, 0x1f, 0xc2, 0x06, 0x35,
	0x9c, 0x1f, 0x8c, 0x1c, 0x8f, 0x98, 0xd6, 0x89, 0xf4, 0xc1, 0x04, 0x95, 0x3b, 0x2a, 0xd5, 0xaa,
	0xf1, 0xda, 0x9a, 0x48, 0x2f, 0x54, 0x49, 0x1c, 0xd1, 0x37, 0xbd, 0x59, 0xdf, 0x73, 0x5f, 0x48,
	0x17, 0x54, 0x49, 0x5c, 0x9e, 0x81, 0x67, 0xfd, 0xdc, 0x82, 0x38, 0xf4, 0x4b, 0x05, 0x29, 0x4f,
	0x44, 0xe3, 0xa5, 0x60, 0x32, 0xb1, 0x3d, 0x62, 0x05, 0xd2, 0xf7, 0x54, 0x12, 0x55, 0x7b, 0xdb,
	0x31, 0xac, 0x13, 0x57, 0x7a, 0x9e, 0x4c, 0x72, 0xb7, 0xa4, 0x7f, 0x31, 0x99, 0x4b, 0xaf, 0x53,
	0x28, 0xfc, 0xfb, 0x54, 0x60, 0x3f, 0x30, 0x67, 0x73, 0xe9, 0x75, 0x31, 0x1a, 0x6f, 0x24, 0x61,
	0x9a, 0x15, 0x54, 0x91, 0x8d, 0x24, 0x46, 0xe6, 0x92, 0xd2, 0x46, 0xd8, 0x31, 0xfd, 0x97, 0xbe,
	0xf0, 0x3e, 0x95, 0xc4, 0x75, 0x2b, 0x93, 0xac, 0xa8, 0x0d, 0xa9, 0x5b, 0x95, 0x4a, 0x6b, 0xd4,
	0x5b, 0x04, 0xcc, 0xb8, 0xdc, 0x07, 0x65, 0x92, 0x3a, 0x52, 0x6f, 0x11, 0x08, 0xf3, 0x71, 0x0f,
	0x8c, 0x08, 0x54, 0x56, 0xda, 0x62, 0x54, 0xe3, 0x71, 0x47, 0x4c, 0x92, 0x69, 0xcd, 0x7b, 0x8b,
	0x20, 0x32, 0x1f, 0xf7, 0xc9, 0x18, 0x4d, 0x60, 0x22, 0x03, 0x6e, 0x85, 0x98, 0xc8, 0x82, 0x1f,
	0x40, 0xb5, 0xb7, 0x08, 0x14, 0x13, 0x5e, 0xe6, 0x1d, 0x4d, 0x8c, 0x28, 0x4a, 0x8a, 0x8c, 0x78,
	0x25, 0x2c, 0x29, 0xb2, 0x62, 0x1d, 0x8a, 0xb4, 0x22, 0xcc, 0x8c, 0x57, 0xb9, 0xdf, 0xca, 0xb4,
	0x68, 0xfa, 0xa1, 0x21, 0xdf, 0x09, 0x9b, 0x7e, 0x68, 0x49, 0x2e, 0x87, 0x62, 0xca, 0x5a, 0x28,
	0x87, 0x62, 0xcb, 0x3b, 0xa0, 0xa9, 0x04, 0x56, 0xd8, 0x35, 0x06, 0x5c, 0xa2, 0x0b, 0x99, 0x23,
	0x73, 0xd6, 0x43, 0x99, 0x23, 0x7b, 0x72, 0x7d, 0xc7, 0x0c, 0x7a, 0x3d, 0xd4, 0xb7, 0x4a, 0xd6,
	0xff, 0x49, 0x06, 0xaa, 0x43, 0x4b, 0x6d, 0xbf, 0xb4, 0xb3, 0x0a, 0xdc, 0xc6, 0xf4, 0xd8, 0xf5,
	0xec, 0xe0, 0x64, 0x26, 0x5a, 0x71, 0x8c, 0x46, 0xdb, 0x38, 0x0e, 0xdc, 0x8e, 0xed, 0x88, 0x96,
	0x2c, 0x52, 0x92, 0x6e, 0xbe, 0x16, 0x2d, 0x58, 0xa4, 0xa8, 0xdf, 0x74, 0xcc, 0xd7, 0x4d, 0xd7,
	0x71, 0x44, 0xa3, 0x95, 0x49, 0xaa, 0xc1, 0x86, 0x15, 0xd8, 0xa7, 0xa4, 0x37, 0x27, 0x4e, 0xd8,
	0x5a, 0x15, 0x12, 0x95, 0xa7, 0x6f, 0xfa, 0x7e, 0x08, 0xe1, 0xcd, 0x35, 0x46, 0xa3, 0x98, 0x46,
	0x10, 0x90, 0xd9, 0x3c, 0xe0, 0x3d, 0x99, 0x68, 0xaf, 0x2a, 0x8d, 0x7e, 0xc9, 0xf0, 0x03, 0xf3,
	0x05, 0x8d, 0x6b, 0xa3, 0xf6, 0xaa, 0x90, 0xa8, 0x0f, 0x37, 0x17, 0x9e, 0xc7, 0x48, 0xa2, 0xc5,
	0x46, 0x04, 0xde, 0xaf, 0x0d, 0xc8, 0xb1, 0x6c, 0xaf, 0x22, 0x25, 0xda, 0x04, 0xcb, 0x28, 0x87,
	0x6d, 0x82, 0xe5, 0x6c, 0x43, 0x19, 0x93, 0xc0, 0x33, 0x1d, 0x9f, 0xe5, 0x8a, 0x81, 0x41, 0x21,
	0xf1, 0x32, 0x0d, 0xcf, 0x93, 0x8d, 0x52, 0xa4, 0x44, 0x99, 0x98, 0x0e, 0x49, 0x1b, 0x61, 0x99,
	0x34, 0xb9, 0xd4, 0x53, 0x6e, 0x2e, 0xf7, 0x94, 0xfa, 0x6f, 0xa6, 0xa1, 0x3a, 0x9a, 0xa8, 0x36,
	0x65, 0x3d, 0x40, 0x34, 0xe8, 0xa6, 0x64, 0x0f, 0x10, 0x0d, 0xb9, 0x35, 0x28, 0x74, 0xdd, 0xbe,
	0xeb, 0x05, 0xb2, 0x73, 0x96, 0xc9, 0x58, 0xbf, 0x9d, 0x59, 0xee, 0xb7, 0x69, 0x03, 0x0e, 0x0b,
	0xce, 0x86, 0xbe, 0x18, 0x95, 0x4c, 0xfd, 0xc9, 0x3a, 0x7d, 0xb1, 0x38, 0x8a, 0x87, 0x05, 0x2a,
	0x8d, 0x62, 0x06, 0xce, 0x24, 0xc2, 0x08, 0x1b, 0xab, 0xb4, 0xa5, 0x9a, 0x17, 0x56, 0x8c, 0x11,
	0x14, 0x73, 0xec, 0xb8, 0x1e, 0x99, 0x74, 0x16, 0xd3, 0xc0, 0x16, 0x46, 0x8e, 0xd1, 0xf4, 0xdf,
	0x4e, 0xc1, 0xc6, 0xa0, 0xdb, 0xe9, 0x2b, 0xea, 0xb9, 0x07, 0x45, 0x7b, 0x3e, 0xf6, 0x03, 0x33,
	0xf0, 0x97, 0x97, 0xce, 0xd5, 0x28, 0x0b, 0x17, 0x6c, 0x96, 0xf2, 0xd1, 0x97, 0x00, 0xb6, 0x35,
	0x93, 0x4c, 0xe9, 0xe4, 0x1e, 0x67, 0x7c, 0x4c, 0xc4, 0x25, 0x5b, 0xa4, 0x7d, 0xf4, 0x39, 0x94,
	0x02, 0x4b, 0xf2, 0x65, 0x92, 0xab, 0x8d, 0xb1, 0xa6, 0x88, 0x8b, 0x81, 0x15, 0x71, 0x2d, 0x26,
	0x92, 0x2b, 0x9b, 0xe4, 0x8a, 0x19, 0x1b, 0x17, 0x17, 0x3c, 0xe9, 0xeb, 0xff, 0x60, 0x13, 0x90,
	0x0c, 0xea, 0x95, 0xea, 0xde, 0x80, 0x52, 0x20, 0xbb, 0x14, 0xb1, 0x3c, 0x13, 0x11, 0xf8, 0x14,
	0xc6, 0xb5, 0x88, 0xef, 0x13, 0xbf, 0x76, 0x6b, 0x3b, 0xb5, 0x53, 0xc5, 0x11, 0x81, 0xfa, 0x49,
	0x70, 0xe2, 0x11, 0x73, 0xe2, 0xd7, 0xde, 0x65, 0x79, 0x32, 0x89, 0x3e, 0x85, 0x2d, 0x6b, 0xbe,
	0xf0, 0xc7, 0x0b, 0x5f, 0xec, 0x97, 0x8e, 0x7d, 0x62, 0x89, 0xed, 0x31, 0xac, 0xd1, 0xac, 0x91,
	0xcf, 0xb7, 0x4b, 0x07, 0x84, 0xe9, 0xfc, 0x0a, 0x83, 0xfb, 0x6f, 0xfc, 0x80, 0xcc, 0x14, 0x06,
	0xb6, 0x47, 0x86, 0x11, 0xcd, 0x1c, 0xb0, 0xbc, 0x90, 0xe5, 0x26, 0x00, 0x63, 0x61, 0x01, 0x38,
	0xdf, 0x1d, 0xc3, 0x25, 0x4a, 0x39, 0xa4, 0x04, 0xf4, 0x21, 0x6c, 0xb2, 0x6c, 0xc7, 0x13, 0x2b,
	0xb1, 0xdc, 0x47, 0xaa, 0xb8, 0x4a, 0xc9, 0x5d, 0x8f, 0xaf, 0xb5, 0xd2, 0xce, 0xf6, 0x92, 0xc4,
	0x05, 0x27, 0x9e, 0x1b, 0x04, 0x53, 0xc2, 0x17, 0xc3, 0xab, 0x78, 0x93, 0x23, 0x87, 0x92, 0x8c,
	0xbe, 0x84, 0x1a, 0xc3, 0x86, 0x40, 0x45, 0xd0, 0x12, 0x13, 0x80, 0xd5, 0x22, 0x64, 0x08, 0x65,
	0xfd, 0x10, 0x36, 0x67, 0xb4, 0x5a, 0x6e, 0x60, 0x4e, 0xc7, 0x7c, 0xce, 0xf1, 0x01, 0x0b, 0xe1,
	0xab, 0x33, 0x32, 0x1b, 0x52, 0xea, 0x3e, 0x9b, 0x7b, 0xdc, 0x83, 0x2b, 0x11, 0x6e, 0x46, 0x66,
	0xfe, 0x2b, 0x81, 0xbe, 0xcd, 0xd0, 0x48, 0xa2, 0x3b, 0x34, 0x8b, 0xb3, 0x88, 0xa2, 0x99, 0x16,
	0x04, 0x38, 0x1f, 0x16, 0xcd, 0x54, 0xc1, 0x71, 0x9f, 0xc1, 0x65, 0x8a, 0xf3, 0xdd, 0xa3, 0x20,
	0x06, 0xfe, 0x90, 0x81, 0x2f, 0xcd, 0xc8, 0x6c, 0xe0, 0x1e, 0x05, 0x0a, 0xc3, 0x07, 0xb0, 0x41,
	0x19, 0x8e, 0xec, 0x29, 0x11, 0x50, 0x3e, 0xeb, 0xa8, 0xcc, 0xc8, 0xec, 0xc0, 0x9e, 0x92, 0x18,
	0xca, 0x74, 0x5c, 0x47, 0xa0, 0xca, 0x21, 0xaa, 0xe1, 0xb8, 0x4e, 0x4c, 0x48, 0xb6, 0x27, 0x22,
	0x60, 0x1f, 0x85, 0x42, 0x36, 0x29, 0x95, 0xe3, 0x74, 0xa0, 0x84, 0xb1, 0xe7, 0xfb, 0x02, 0xc5,
	0x27, 0x5a, 0xe5, 0x19, 0x99, 0x61, 0xdf, 0x8f, 0xe9, 0x68, 0x66, 0xce, 0xe7, 0x64, 0xa2, 0x8a,
	0x57, 0x09, 0x75, 0xd4, 0x61, 0x79, 0x4b, 0x42, 0xfa, 0xaf, 0xcc, 0xb9, 0xc0, 0xee, 0x84, 0x42,
	0x0e, 0x5e, 0x99, 0x73, 0x8e, 0xda, 0xe3, 0x05, 0x2f, 0x1c, 0x72, 0x6a, 0x5b, 0x6c, 0xd3, 0x47,
	0x80, 0x3f, 0x66, 0xe0, 0xad, 0x19, 0x99, 0x8d, 0xa2, 0x3c, 0xce, 0xf3, 0x25, 0xd4, 0x98, 0xf6,
	0xdd, 0x57, 0xe3, 0xb9, 0x47, 0x7c, 0x7f, 0xe1, 0x91, 0xb1, 0x45, 0xe7, 0xbc, 0xc4, 0xab, 0x6d,
	0x33, 0x36, 0x5a, 0xe6, 0xa1, 0xfb, 0xaa, 0x2f, 0x72, 0x9b, 0x3c, 0x13, 0xfd, 0x18, 0xae, 0xb3,
	0x5a, 0x90, 0x89, 0xbd, 0x98, 0x2d, 0xf3, 0xbe, 0xc7, 0x78, 0x69, 0xd9, 0x1d, 0x86, 0x48, 0xb2,
	0x37, 0xe0, 0x26, 0x53, 0xa8, 0x67, 0x07, 0xb6, 0x65, 0x4e, 0x97, 0x0b, 0xd0, 0x59, 0x01, 0x75,
	0xaa, 0x5e, 0x81, 0x49, 0x16, 0xb1, 0x03, 0xda, 0xc4, 0xf6, 0x5f, 0xc6, 0x9c, 0xa1, 0xce, 0xb8,
	0x36, 0x28, 0x5d, 0xf1, 0x84, 0x0f, 0x61, 0x93, 0x21, 0x17, 0x3e, 0x99, 0x08, 0xe0, 0x75, 0x6e,
	0x3d, 0x4a, 0x1e, 0xf9, 0x64, 0xc2, 0x71, 0x9f, 0x40, 0x76, 0x4e, 0xbc, 0x23, 0xb1, 0xe5, 0xa1,
	0xf4, 0x7f, 0x7d, 0xe2, 0x1d, 0x29, 0x5d, 0x12, 0x43, 0x51, 0xa3, 0x38, 0x24, 0x18, 0x7b, 0xaf,
	0xc7, 0x72, 0xe2, 0xbc, 0xc1, 0x8d, 0xe2, 0x90, 0x00, 0xbf, 0xee, 0x8b, 0xd9, 0xf3, 0x36, 0x54,
	0x04, 0x8a, 0x7f, 0x78, 0x93, 0xcf, 0xbc, 0x19, 0x26, 0xf4, 0x19, 0x81, 0x20, 0x51, 0xbc, 0x99,
	0xc5, 0x65, 0x06, 0x09, 0x27, 0x9a, 0xf2, 0x5b, 0x74, 0x36, 0x3f, 0x27, 0x13, 0x16, 0x70, 0xca,
	0x6f, 0xb5, 0x38, 0x4d, 0xa2, 0x82, 0x48, 0x22, 0x14, 0xa2, 0x86, 0x49, 0x89, 0x02, 0x29, 0xd1,
	0x56, 0x28, 0xd1, 0x30, 0x2e, 0x51, 0x10, 0x4a, 0x74, 0x39, 0x94, 0x68, 0x98, 0x90, 0x28, 0x88,
	0x24, 0xba, 0xa2, 0x7c, 0x4b, 0x4a, 0xf4, 0x15, 0x5c, 0x63, 0x28, 0x6b, 0x3e, 0xf6, 0x82, 0x60,
	0x3c, 0xb3, 0x2d, 0xcf, 0xa5, 0xbd, 0xcd, 0x78, 0xfe, 0xe0, 0x2e, 0x0b, 0x3f, 0x53, 0xf8, 0x0a,
	0x65, 0xb0, 0xe6, 0x38, 0x08, 0x3a, 0x32, 0xb7, 0xff, 0xe0, 0xee, 0x19, 0x9c, 0x5f, 0xdf, 0x65,
	0x91, 0xe9, 0x6a, 0xce, 0xaf, 0xcf, 0xe4, 0x7c, 0xc0, 0xe2, 0xd5, 0x35, 0x9c, 0x0f, 0xce, 0xe2,
	0xfc, 0x9a, 0x05, 0xb0, 0x6b, 0x38, 0xbf, 0x46, 0x8f, 0xa0, 0x2e, 0x39, 0x4d, 0x16, 0xec, 0x8d,
	0x2d, 0xd7, 0x71, 0x88, 0x15, 0xd8, 0xae, 0xe3, 0xd7, 0x6e, 0x30, 0xd6, 0x77, 0x38, 0x2b, 0x0f,
	0x06, 0x9b, 0x51, 0x36, 0xfa, 0x19, 0xb8, 0x29, 0x99, 0x59, 0x77, 0xfc, 0xca, 0xb4, 0x83, 0x18,
	0xff, 0x4d, 0xc6, 0x7f, 0x8d, 0xf3, 0xd3, 0x3e, 0xf9, 0xb9, 0x69, 0x07, 0x6a, 0x09, 0xc7, 0x70,
	0x8b, 0x95, 0xc0, 0x97, 0x94, 0x28, 0x6f, 0xe0, 0xb9, 0x53, 0x36, 0xbe, 0x72, 0x97, 0xad, 0xbd,
	0x9f, 0x3c, 0x2a, 0xb3, 0x6e, 0xf9, 0x09, 0x5f, 0xa7, 0x9f, 0x59, 0xb7, 0x36, 0xf5, 0x04, 0xb6,
	0xe8, 0x87, 0x7c, 0x47, 0xc4, 0x0a, 0xa2, 0xf4, 0x3b, 0xc9, 0x06, 0x13, 0x8f, 0x48, 0xf0, 0x25,
	0x87, 0x04, 0x03, 0x47, 0x8d, 0x21, 0xf4, 0xbf, 0x93, 0x85, 0xaa, 0x1c, 0xcc, 0x47, 0xbe, 0x79,
	0x4c, 0xd0, 0x4f, 0xa0, 0x24, 0xb7, 0x77, 0xe5, 0x7e, 0xfd, 0x8a, 0xb5, 0x61, 0x86, 0x0d, 0xf7,
	0x84, 0x71, 0xc4, 0x82, 0x76, 0x20, 0xc7, 0xc6, 0x9d, 0x5a, 0x7a, 0xed, 0xbe, 0x18, 0x07, 0xd4,
	0xff, 0x7e, 0x06, 0x8a, 0xb2, 0x04, 0xf4, 0x08, 0xaa, 0xd1, 0xf6, 0xb3, 0x73, 0xe4, 0x8a, 0x0d,
	0xe8, 0xab, 0xab, 0x37, 0xae, 0x71, 0x85, 0xa8, 0x9b, 0xdd, 0x77, 0xa1, 0x64, 0x4e, 0xa7, 0xae,
	0x65, 0x06, 0x64, 0x72, 0xc6, 0x77, 0x23, 0x10, 0xfa, 0x11, 0x80, 0xa2, 0x38, 0x1e, 0x31, 0xdd,
	0x58, 0x66, 0x51, 0x94, 0xa7, 0xe0, 0xd1, 0x57, 0x50, 0x09, 0xf7, 0x97, 0xc7, 0x6c, 0x07, 0x33,
	0xbd, 0xfe, 0x94, 0x64, 0x39, 0x84, 0xb6, 0x27, 0xe8, 0x11, 0xe4, 0x02, 0x36, 0xc1, 0xe2, 0x5b,
	0x80, 0xb7, 0xcf, 0xd3, 0xec, 0xee, 0x90, 0xce, 0xa9, 0x38, 0x4f, 0xfd, 0x37, 0x52, 0x90, 0xa5,
	0xe9, 0x95, 0x5b, 0x22, 0xdb, 0x6c, 0xbd, 0x92, 0x1f, 0x5a, 0x54, 0x56, 0xa9, 0xf9, 0x81, 0x51,
	0xb6, 0x82, 0xf9, 0xf6, 0xbb, 0x96, 0xd1, 0xfa, 0x7b, 0xf6, 0x9c, 0x1d, 0xe4, 0x7f, 0xa1, 0xc1,
	0x46, 0xbc, 0x7b, 0x3e, 0x27, 0x20, 0xac, 0xc7, 0x0e, 0x29, 0xd2, 0xcc, 0x30, 0x4d, 0x27, 0x30,
	0xd6, 0x1b, 0x6b, 0x1a, 0xae, 0xa8, 0x8a, 0x14, 0xfa, 0x02, 0xde, 0xf1, 0x03, 0x73, 0x4a, 0x03,
	0x26, 0x4e, 0x19, 0x1f, 0x79, 0xae, 0x13, 0x10, 0x67, 0x22, 0x16, 0x59, 0xaf, 0x88, 0xec, 0x26,
	0xcb, 0x3d, 0x10, 0x99, 0xe8, 0x73, 0xb8, 0x9a, 0xe0, 0x7b, 0x41, 0x3b, 0x61, 0x67, 0x22, 0xe2,
	0x82, 0xcb, 0x31, 0xb6, 0x7d, 0x9e, 0x47, 0xc3, 0x7e, 0xdb, 0xf1, 0x03, 0x6f, 0x21, 0x9a, 0x3f,
	0x0f, 0x87, 0x62, 0x34, 0xf4, 0x31, 0x68, 0x3c, 0x18, 0xf1, 0xc8, 0x11, 0xf1, 0x88, 0x43, 0x35,
	0xcb, 0x17, 0x68, 0x37, 0x19, 0x1d, 0x87, 0x64, 0xf4, 0x1e, 0x54, 0x38, 0x74, 0x66, 0xb3, 0x20,
	0x98, 0x2f, 0xd8, 0x96, 0x19, 0xad, 0xc3, 0x48, 0x54, 0x27, 0x2f, 0x3c, 0xd3, 0xb1, 0x4e, 0x88,
	0x5c, 0xb5, 0x0d, 0xd3, 0xe8, 0x7d, 0xa8, 0xf2, 0xff, 0x92, 0x5f, 0x44, 0x51, 0x9c, 0x28, 0x0a,
	0xb8, 0x09, 0xf0, 0x62, 0xe1, 0x8b, 0x4a, 0x8a, 0x08, 0xaa, 0xf4, 0x62, 0xe1, 0xf3, 0x8a, 0xd1,
	0x6c, 0x8f, 0x1c, 0xc9, 0x6c, 0x1e, 0xe7, 0x94, 0x3c, 0x72, 0x24, 0xb2, 0xaf, 0x03, 0x8d, 0x7b,
	0xc7, 0xd6, 0xd4, 0xb5, 0x5e, 0xb2, 0xc1, 0x37, 0x85, 0x8b, 0xd6, 0x7c, 0xd1, 0xa4, 0x69, 0xca,
	0x4b, 0x9d, 0x50, 0xe4, 0x6e, 0xf0, 0x30, 0x99, 0x52, 0x78, 0xf6, 0xbb, 0x50, 0x9e, 0x9b, 0xc7,
	0x64, 0xcc, 0x56, 0x7e, 0xc3, 0xe1, 0x95, 0x92, 0x0e, 0x18, 0x85, 0x56, 0x7f, 0x66, 0x3b, 0xae,
	0x27, 0x11, 0x62, 0x74, 0x65, 0x34, 0x05, 0x62, 0xfe, 0xc9, 0x08, 0x72, 0x49, 0x40, 0x28, 0x4d,
	0x40, 0xa8, 0xbe, 0xa9, 0x51, 0x5f, 0x07, 0x63, 0xff, 0x95, 0x1d, 0x30, 0x4d, 0x21, 0xa1, 0x6f,
	0x4e, 0x1f, 0x08, 0x32, 0xba, 0x0d, 0x1b, 0xb4, 0x36, 0x33, 0xfb, 0x98, 0x7b, 0x95, 0x1c, 0x61,
	0x69, 0xdc, 0xde, 0x09, 0x89, 0xb4, 0x44, 0x73, 0x6a, 0x1f, 0xb3, 0xe3, 0x43, 0xf2, 0xc3, 0x7c,
	0x9c, 0xdd, 0x0c, 0xe9, 0xd1, 0xc7, 0xc9, 0x6c, 0x31, 0x65, 0x8c, 0x12, 0xca, 0x47, 0xdb, 0xcd,
	0x90, 0x2e, 0xa0, 0x1f, 0xc2, 0xe6, 0xf4, 0xde, 0x78, 0xc2, 0x0d, 0x3e, 0x75, 0xe9, 0xc4, 0xe6,
	0x2a, 0xff, 0xfa, 0xf4, 0x5e, 0x8b, 0x51, 0x0f, 0x29, 0x91, 0x06, 0xa1, 0x71, 0x9c, 0xb4, 0xee,
	0x3b, 0x3c, 0x08, 0x55, 0xd1, 0xc2, 0xc6, 0x3b, 0xa0, 0x45, 0x2c, 0x7e, 0xe0, 0x7a, 0x84, 0x2f,
	0xff, 0x64, 0xf1, 0x86, 0x44, 0x0f, 0x18, 0x15, 0xdd, 0x87, 0xab, 0x09, 0xa4, 0x2c, 0xfd, 0x1a,
	0x8f, 0x44, 0x63, 0x78, 0x51, 0xfc, 0x5d, 0xb8, 0x1c, 0x31, 0xcd, 0xa9, 0x5b, 0x73, 0x2d, 0xd7,
	0xe3, 0x02, 0xf5, 0xc3, 0x1c, 0xf4, 0x35, 0x5c, 0x5b, 0xe6, 0x90, 0x5f, 0xe2, 0x01, 0xde, 0xd5,
	0x24, 0x9b, 0xf8, 0x18, 0x57, 0x93, 0xad, 0xaa, 0xe9, 0x86, 0x54, 0x53, 0x7b, 0x49, 0x4d, 0xf6,
	0xb2, 0x9a, 0x6e, 0x4a, 0xa9, 0xda, 0x49, 0x35, 0xf1, 0x7a, 0xd8, 0x4b, 0xf5, 0xb8, 0x15, 0xe7,
	0x58, 0xaa, 0x87, 0xbd, 0xba, 0x1e, 0xef, 0xca, 0x7a, 0xb4, 0x57, 0xd5, 0xe3, 0x3a, 0x94, 0xa6,
	0x53, 0x4b, 0xd4, 0x80, 0xc7, 0xeb, 0xc5, 0xe9, 0xd4, 0xe2, 0xc2, 0xd3, 0x4a, 0x8a, 0x4c, 0x59,
	0xda, 0x7b, 0xa2, 0x92, 0x1c, 0x12, 0x35, 0x5e, 0x8a, 0x13, 0x26, 0xe5, 0x81, 0x37, 0x2d, 0x56,
	0x58, 0x93, 0xda, 0x5d, 0x66, 0xcb, 0x72, 0xde, 0x17, 0x76, 0x17, 0x20, 0x51, 0xd0, 0x6d, 0xa0,
	0x14, 0xb5, 0xd2, 0x1f, 0x84, 0xdf, 0x53, 0xea, 0xbb, 0x0b, 0x5b, 0x2a, 0x4c, 0x96, 0xc9, 0xa7,
	0x88, 0x97, 0x14, 0x6c, 0x24, 0xdf, 0x24, 0x98, 0xbe, 0x10, 0xb5, 0xe4, 0xf3, 0xbd, 0x12, 0xa5,
	0xf0, 0x6a, 0xd2, 0x79, 0x80, 0xcc, 0x96, 0x65, 0x7d, 0x24, 0xe6, 0x01, 0x02, 0x24, 0x0a, 0x7a,
	0x17, 0xca, 0x0c, 0x29, 0x6a, 0xca, 0xe7, 0x50, 0xac, 0x6c, 0x51, 0xd5, 0x3b, 0x70, 0x29, 0x02,
	0xc8, 0xb2, 0xf8, 0xec, 0x69, 0x33, 0x84, 0x89, 0xc2, 0x3e, 0x02, 0x46, 0x52, 0x6b, 0x7b, 0x27,
	0xfa, 0xaa, 0x52, 0xdd, 0xbb, 0x70, 0x39, 0x06, 0x94, 0xe5, 0xfe, 0x90, 0x3b, 0x84, 0x8a, 0x8e,
	0x2a, 0x6c, 0x47, 0x15, 0xfe, 0x84, 0x57, 0xd8, 0x56, 0x2b, 0x6c, 0x27, 0x2b, 0xfc, 0x29, 0xff,
	0xb4, 0x1d, 0xaf, 0xf0, 0x7b, 0x20, 0xba, 0x69, 0x51, 0xd4, 0x2e, 0xef, 0xd8, 0x38, 0x8d, 0x17,
	0xf6, 0x09, 0x20, 0x05, 0x22, 0x8b, 0xfb, 0x8c, 0x01, 0xb5, 0x08, 0x18, 0x49, 0xe6, 0xb8, 0x13,
	0xd9, 0x64, 0xee, 0x72, 0xc9, 0x28, 0x25, 0x94, 0x2c, 0xcc, 0x96, 0x45, 0xdd, 0xe3, 0x92, 0x49,
	0x50, 0x64, 0x0a, 0x86, 0x14, 0xa6, 0xd8, 0x13, 0x73, 0x10, 0x77, 0x42, 0x22, 0x53, 0x44, 0x00,
	0x59, 0xd6, 0x7d, 0x6e, 0x8a, 0x10, 0x16, 0x99, 0x82, 0x61, 0x15, 0x53, 0x7c, 0x1e, 0x7d, 0x35,
	0x6e, 0x8a, 0x18, 0x50, 0x96, 0xfb, 0x80, 0x9b, 0x42, 0x45, 0xf3, 0xa2, 0x75, 0x1b, 0x0a, 0x62,
	0xef, 0x0c, 0x7d, 0x02, 0x45, 0xf3, 0x98, 0x76, 0xd6, 0xb6, 0x3c, 0x91, 0xba, 0xe2, 0x68, 0x54,
	0x81, 0x41, 0xda, 0x89, 0x98, 0x27, 0x7d, 0x81, 0x98, 0x47, 0xff, 0x43, 0x80, 0x1c, 0xbb, 0xa7,
	0x23, 0x8e, 0x5f, 0xa5, 0x92, 0xd7, 0x40, 0xc4, 0x25, 0x1e, 0x16, 0x52, 0x25, 0x4f, 0x3f, 0xa6,
	0x93, 0x81, 0xe0, 0xda, 0xd3, 0x8f, 0x6a, 0x35, 0x32, 0x4b, 0x37, 0x4d, 0x92, 0xd5, 0x50, 0x8f,
	0xa9, 0x65, 0x13, 0xc7, 0xd4, 0xde, 0x85, 0xcc, 0xc2, 0x9b, 0x8a, 0xb3, 0x23, 0x55, 0x65, 0xfd,
	0x0e, 0x1f, 0x62, 0x9a, 0xf3, 0x3d, 0x0e, 0x40, 0xc6, 0x4f, 0xab, 0x15, 0x2e, 0x76, 0x5a, 0xed,
	0x4b, 0xa8, 0x28, 0x07, 0x48, 0x69, 0xbc, 0x94, 0x59, 0x7b, 0x82, 0xb4, 0x1c, 0x9d, 0x20, 0xf5,
	0x57, 0xdc, 0xee, 0x28, 0xbd, 0xdd, 0xed, 0x8e, 0xfa, 0xdf, 0x2d, 0x40, 0xa9, 0x37, 0x27, 0x22,
	0x7c, 0xdc, 0x8b, 0x5d, 0x0f, 0xb8, 0x95, 0xb0, 0xdc, 0x6e, 0x08, 0x54, 0x0f, 0x3f, 0x7c, 0x45,
	0x23, 0xdd, 0x85, 0x63, 0xc9, 0xe3, 0x0f, 0xdb, 0xeb, 0xb9, 0x0e, 0x19, 0x0e, 0x0b, 0x3c, 0x7a,
	0x02, 0x15, 0xfe, 0x6f, 0x7c, 0xec, 0xb9, 0x8b, 0xb9, 0x38, 0x84, 0x73, 0xfb, 0x3c, 0xfe, 0xc7,
	0x14, 0x8c, 0xcb, 0xd3, 0x28, 0x81, 0x1e, 0x41, 0x81, 0x9f, 0xea, 0x91, 0x47, 0x48, 0xde, 0x5b,
	0x5f, 0x08, 0x3f, 0x47, 0x43, 0xb0, 0xe4, 0x40, 0x0d, 0x28, 0x2d, 0x1c, 0xc9, 0x9e, 0x4d, 0x1e,
	0x7a, 0x4f, 0xb2, 0x8f, 0x24, 0x14, 0x47, 0x5c, 0x54, 0x07, 0x16, 0xdb, 0x81, 0x15, 0xa7, 0x99,
	0xce, 0xd0, 0x01, 0xdf, 0xa9, 0xc5, 0x02, 0x4f, 0x25, 0x9f, 0x10, 0x3f, 0xf0, 0xdc, 0x37, 0xe2,
	0x10, 0xd8, 0x19, 0x92, 0xb7, 0x38, 0x10, 0x4b, 0x8e, 0xfa, 0x23, 0xc8, 0x73, 0x95, 0xa0, 0x7b,
	0x22, 0xc6, 0xa4, 0xf3, 0x3f, 0x39, 0xf7, 0x44, 0x89, 0xa9, 0x0c, 0x3b, 0x89, 0x14, 0x88, 0x7f,
	0x7e, 0xfd, 0x0d, 0x94, 0x15, 0x7d, 0xa2, 0x3d, 0x28, 0x4a, 0xcf, 0x3a, 0x67, 0x02, 0x19, 0xe2,
	0xd0, 0x17, 0xe2, 0xab, 0xdc, 0x7c, 0xbc, 0x05, 0xbf, 0x13, 0xff, 0x2a, 0x2b, 0x3c, 0xfa, 0x34,
	0x4b, 0xd6, 0x1f, 0xd1, 0x3e, 0x89, 0x6b, 0x2e, 0xd6, 0xc2, 0x52, 0x17, 0x68, 0x61, 0xf5, 0x1f,
	0x43, 0x29, 0xb4, 0xc1, 0xf7, 0x60, 0xff, 0x02, 0xf2, 0xdc, 0x04, 0xe8, 0x13, 0x28, 0xf0, 0x03,
	0x48, 0x67, 0x71, 0x4a, 0x48, 0xfd, 0x4b, 0x28, 0x08, 0xfd, 0xbf, 0x1d, 0xa3, 0x7e, 0xb4, 0xea,
	0x84, 0x30, 0x40, 0xfe, 0xb0, 0x31, 0xea, 0x36, 0x9f, 0x68, 0x29, 0xa4, 0x41, 0x85, 0xff, 0x1f,
	0x3f, 0xc6, 0xbd, 0x51, 0x5f, 0xcb, 0x53, 0x28, 0x36, 0x06, 0x06, 0x7e, 0x66, 0x68, 0x69, 0x54,
	0x85, 0xd2, 0xa8, 0x2b, 0x93, 0x19, 0x76, 0x9c, 0x18, 0x1b, 0x8d, 0xa1, 0xa1, 0x65, 0xf9, 0x39,
	0xe3, 0xc1, 0x10, 0xf7, 0xbe, 0xd5, 0x72, 0xfa, 0xdf, 0x48, 0x43, 0xa5, 0xed, 0x9c, 0x12, 0xcf,
	0x27, 0x17, 0xee, 0x84, 0x45, 0x07, 0x98, 0x5e, 0xdb, 0x01, 0x26, 0x7b, 0xe9, 0xcc, 0xf7, 0xea,
	0xa5, 0xb3, 0xe7, 0x0e, 0x36, 0xcb, 0x1d, 0x59, 0x8e, 0x7d, 0xe9, 0xc2, 0x1d, 0x59, 0xdc, 0x13,
	0xf2, 0x17, 0x19, 0xae, 0x7e, 0x2b, 0x0b, 0x45, 0xd9, 0x30, 0x56, 0xae, 0x0b, 0x7c, 0x0c, 0x05,
	0xde, 0xa8, 0xd6, 0x2f, 0x0e, 0xe4, 0x59, 0x7b, 0x7a, 0xdb, 0x31, 0x29, 0x26, 0x6b, 0xf6, 0x22,
	0xc3, 0x8a, 0xda, 0x3a, 0x73, 0xc9, 0x1d, 0xb1, 0x35, 0xad, 0xf3, 0xff, 0xee, 0x96, 0x40, 0xe9,
	0xc2, 0xb7, 0x04, 0xbe, 0x82, 0xca, 0x09, 0xbb, 0xe1, 0x33, 0x66, 0xf7, 0xea, 0x96, 0xef, 0x31,
	0x28, 0xf7, 0x7f, 0x70, 0xf9, 0x44, 0xb9, 0xbb, 0xf5, 0x00, 0xca, 0x2f, 0xed, 0xe9, 0x74, 0x3c,
	0x67, 0xb7, 0x66, 0xc4, 0x59, 0x7f, 0x65, 0xd8, 0x8b, 0x6e, 0xd4, 0x60, 0x78, 0x19, 0xdd, 0xae,
	0x91, 0x97, 0x06, 0xf2, 0xca, 0xa5, 0x81, 0x68, 0xbd, 0x05, 0xce, 0x5e, 0x6f, 0x89, 0x5f, 0x2f,
	0x28, 0x5f, 0xf4, 0x7a, 0x81, 0xfe, 0x35, 0x54, 0x63, 0xfd, 0x19, 0x5b, 0xad, 0x63, 0xeb, 0x51,
	0xeb, 0x7b, 0x5b, 0x0e, 0xd0, 0x7f, 0x3d, 0x77, 0xc6, 0xe2, 0xd3, 0x5b, 0x38, 0xd9, 0xf7, 0x6f,
	0x8c, 0x89, 0x1b, 0x2a, 0xd9, 0xa4, 0xa2, 0xd7, 0xdc, 0x50, 0x51, 0xbd, 0x3a, 0x77, 0xae, 0x57,
	0x7f, 0xcc, 0xae, 0xd9, 0x06, 0xa4, 0x96, 0x67, 0x67, 0x28, 0xb7, 0xe2, 0xf5, 0x18, 0xd0, 0x2c,
	0xcc, 0x11, 0xf1, 0x06, 0x50, 0xb8, 0x48, 0x03, 0xb8, 0xab, 0x5c, 0xea, 0x2a, 0x26, 0xc3, 0x23,
	0x59, 0xfe, 0xc2, 0x8f, 0xae, 0x7a, 0xa1, 0x26, 0x6c, 0xf1, 0xff, 0xe3, 0xc5, 0x7c, 0x62, 0x06,
	0x64, 0xcc, 0x85, 0x2b, 0xb1, 0xd0, 0x66, 0xa5, 0x70, 0x97, 0x38, 0x7e, 0xc4, 0xe0, 0x8c, 0x44,
	0x27, 0x17, 0xf1, 0x42, 0x16, 0x0b, 0x9b, 0x1f, 0xdd, 0xad, 0x60, 0x4d, 0x85, 0x8f, 0x16, 0xf6,
	0xe4, 0xe2, 0xd7, 0x32, 0xbf, 0xef, 0x1d, 0x97, 0x58, 0x0b, 0xad, 0x5e, 0xb8, 0x85, 0xca, 0xbb,
	0x58, 0x1b, 0xd1, 0x5d, 0x2c, 0xfd, 0x97, 0x2b, 0x00, 0x91, 0xde, 0x54, 0x37, 0x4c, 0x9d, 0xe3,
	0x86, 0xa1, 0x9d, 0xd3, 0xe7, 0xda, 0xb9, 0x06, 0x85, 0x19, 0xf1, 0x7d, 0xf3, 0x98, 0x88, 0xab,
	0x2a, 0x32, 0x89, 0xee, 0x87, 0x67, 0x7e, 0x4b, 0xc9, 0x6b, 0x56, 0x91, 0x54, 0x89, 0xc3, 0xbe,
	0x94, 0xc9, 0x23, 0xa6, 0xef, 0x3a, 0xcc, 0x02, 0xeb, 0x98, 0x30, 0x83, 0x60, 0x01, 0x0d, 0x7b,
	0x8b, 0x8c, 0xd2, 0x5b, 0xc4, 0x1d, 0xfb, 0xbc, 0xc1, 0x29, 0xd1, 0x7a, 0x0a, 0x17, 0x6c, 0x3d,
	0xb1, 0x55, 0xdc, 0xbc, 0x58, 0xf6, 0x0b, 0x57, 0x71, 0xa9, 0x4d, 0xa8, 0x2f, 0x95, 0xb9, 0x58,
	0xf4, 0x3f, 0x55, 0x17, 0xef, 0x1e, 0xdf, 0xb0, 0x4e, 0xb4, 0x88, 0x65, 0x52, 0xf1, 0xac, 0xca,
	0x39, 0x9e, 0xd5, 0xe2, 0xeb, 0x7c, 0x7c, 0x81, 0x9d, 0x7b, 0xa8, 0xf0, 0x94, 0x6b, 0x2b, 0x3c,
	0x45, 0xb4, 0x9a, 0x4d, 0x2b, 0x4e, 0x40, 0x3f, 0x06, 0x6d, 0xc1, 0x8f, 0x80, 0xb1, 0x5d, 0x58,
	0x2a, 0xb6, 0xb8, 0x0a, 0xb5, 0xea, 0xf6, 0xfc, 0xa6, 0x82, 0xa5, 0x44, 0x7d, 0x3f, 0x3c, 0x57,
	0x7d, 0x09, 0xaa, 0xfc, 0x42, 0xef, 0xb8, 0xd3, 0x18, 0x0c, 0x0d, 0xac, 0xfd, 0x80, 0xc6, 0x3b,
	0x82, 0xd4, 0x78, 0x6c, 0x74, 0x87, 0x5a, 0x0a, 0x6d, 0xc1, 0xa6, 0xa0, 0x18, 0xdf, 0x18, 0xcd,
	0xd1, 0xb0, 0x87, 0xb5, 0xb4, 0xfe, 0xd3, 0x3c, 0xe4, 0xb9, 0x29, 0x91, 0x0e, 0xb7, 0xb0, 0xd1,
	0x18, 0xf4, 0xba, 0x63, 0x71, 0x07, 0x33, 0xc4, 0x8d, 0x0f, 0x1a, 0xed, 0x43, 0xa3, 0xa5, 0xfd,
	0x20, 0x86, 0xe9, 0x0e, 0x1b, 0xed, 0xae, 0x81, 0xc7, 0x22, 0xac, 0x12, 0x98, 0x2b, 0xe8, 0x5d,
	0xb8, 0xbe, 0x8c, 0x69, 0x77, 0xda, 0xc3, 0xc6, 0xb0, 0xdd, 0xeb, 0x6a, 0x5b, 0xe8, 0x03, 0xd8,
	0x3e, 0x03, 0x30, 0x6e, 0xb5, 0x07, 0x4f, 0xb5, 0xcb, 0xe8, 0x43, 0xd0, 0xcf, 0x42, 0x75, 0x8c,
	0x4e, 0x0f, 0x7f, 0xab, 0x15, 0xd1, 0x2d, 0xa8, 0x2f, 0xe1, 0xfa, 0xd8, 0x30, 0x3a, 0xfd, 0xa1,
	0xd1, 0xd2, 0x2e, 0xad, 0x14, 0x79, 0xd4, 0x6f, 0x35, 0x86, 0x86, 0x14, 0xf9, 0x2a, 0xda, 0x81,
	0x0f, 0x04, 0x26, 0xac, 0x32, 0x36, 0x1e, 0xb7, 0x07, 0x43, 0xcc, 0x3f, 0x36, 0x6c, 0x77, 0x8c,
	0xde, 0x68, 0xa8, 0xbd, 0x83, 0xee, 0xc0, 0x87, 0xcb, 0xc8, 0x95, 0xd8, 0x9a, 0x22, 0x59, 0x88,
	0x1d, 0x1a, 0xb8, 0xd3, 0xee, 0x36, 0xa8, 0x64, 0x29, 0xb4, 0x0d, 0x37, 0x92, 0xf9, 0x34, 0x06,
	0xa5, 0x65, 0x19, 0xd8, 0x68, 0x69, 0x69, 0x74, 0x03, 0x6a, 0x02, 0x71, 0x80, 0x1b, 0x1d, 0xe3,
	0x79, 0x0f, 0x3f, 0x1d, 0x63, 0xa3, 0xd3, 0x7b, 0x66, 0xb4, 0xb4, 0x0c, 0x35, 0xa8, 0xc8, 0x7d,
	0xdc, 0x1c, 0x1b, 0x18, 0xf7, 0xb0, 0x96, 0x55, 0x3e, 0xda, 0xee, 0x3e, 0x6b, 0x1c, 0xb6, 0x5b,
	0x11, 0x6b, 0xbb, 0xa5, 0xe5, 0xd0, 0x35, 0xb8, 0x92, 0xc8, 0xef, 0x1d, 0x1c, 0x18, 0x78, 0xa0,
	0xe5, 0x15, 0x56, 0xee, 0x45, 0xd4, 0x12, 0xcd, 0x5e, 0xb7, 0x6b, 0x34, 0xa9, 0xbc, 0x05, 0x85,
	0x15, 0x1b, 0xcd, 0x5e, 0xb7, 0xd9, 0x3e, 0x6c, 0x73, 0x93, 0x96, 0x14, 0x41, 0xc3, 0xab, 0xe5,
	0x63, 0x19, 0x87, 0x23, 0x74, 0x13, 0xae, 0x89, 0x5c, 0xe6, 0x8b, 0xf1, 0x72, 0x01, 0xd5, 0xe0,
	0x72, 0x2c, 0x5b, 0xd6, 0xb0, 0x8c, 0xea, 0x70, 0x35, 0x91, 0x33, 0x18, 0x36, 0x30, 0xe5, 0xaa,
	0x2c, 0x71, 0xc9, 0xcf, 0x55, 0x95, 0xcf, 0xb1, 0x9b, 0xf1, 0x2c, 0xde, 0x97, 0xb5, 0xd5, 0xae,
	0x29, 0x0e, 0xa1, 0x64, 0x8f, 0xba, 0x8d, 0xd1, 0xf0, 0x49, 0x0f, 0xb7, 0xff, 0xb8, 0xd1, 0xd2,
	0xea, 0xfc, 0xba, 0x7d, 0x84, 0x91, 0xcc, 0x1b, 0x4a, 0x45, 0x59, 0x46, 0x8c, 0x6d, 0x33, 0xc9,
	0x26, 0x45, 0xd2, 0xf4, 0xfb, 0x50, 0x38, 0xb0, 0xa7, 0x01, 0x61, 0xfb, 0x8f, 0x1b, 0x1e, 0x39,
	0x5a, 0xf8, 0x64, 0x1c, 0xbd, 0x28, 0xc2, 0x9e, 0x57, 0x78, 0x80, 0xab, 0x3c, 0x43, 0xdc, 0x41,
	0xd7, 0x7f, 0x3e, 0x05, 0x65, 0xe5, 0x26, 0x31, 0xfa, 0x11, 0x94, 0x4e, 0x4d, 0xcf, 0xa6, 0xed,
	0x5f, 0xc6, 0x43, 0xb7, 0x56, 0xde, 0x39, 0xde, 0x7d, 0x26, 0x60, 0x38, 0x62, 0xa8, 0x7f, 0x0e,
	0x45, 0x49, 0x5e, 0x19, 0x22, 0x85, 0x37, 0xc3, 0xd2, 0xea, 0xcd, 0xb0, 0xfb, 0x50, 0x0a, 0xdf,
	0x05, 0x41, 0x1a, 0x64, 0x5e, 0x92, 0x37, 0x82, 0x8b, 0xfe, 0x5d, 0xc3, 0xf4, 0xc7, 0x00, 0x42,
	0x26, 0x1f, 0xdd, 0x83, 0xd2, 0x5c, 0xa6, 0x84, 0xd8, 0x2b, 0x5f, 0x1d, 0x89, 0x50, 0xfa, 0x3e,
	0x40, 0xd3, 0x23, 0x13, 0xe2, 0x04, 0xb6, 0x39, 0x4d, 0xde, 0xc1, 0x49, 0xc7, 0xef, 0xe0, 0x5c,
	0x85, 0xbc, 0x4f, 0x2c, 0x8f, 0x04, 0xe2, 0xe6, 0x89, 0x48, 0xe9, 0x06, 0x94, 0xa3, 0x32, 0x7c,
	0xf4, 0x05, 0x94, 0xad, 0x28, 0x29, 0xe4, 0x50, 0x86, 0x97, 0x08, 0x8b, 0x55, 0xa0, 0xfe, 0x1c,
	0x4a, 0xd8, 0x0c, 0x08, 0x3f, 0x6c, 0xa5, 0x41, 0xe6, 0xbb, 0xb9, 0x30, 0x18, 0xa6, 0x7f, 0x93,
	0x57, 0x5f, 0x12, 0xb2, 0xd5, 0xa1, 0x68, 0x99, 0x73, 0xd3, 0x92, 0x2f, 0x82, 0x64, 0x71, 0x98,
	0xd6, 0x7f, 0x2b, 0x05, 0x10, 0x96, 0xec, 0xa3, 0x1f, 0x42, 0x5e, 0x5c, 0xba, 0x58, 0x52, 0x51,
	0x88, 0xc2, 0x02, 0x82, 0xf6, 0xe0, 0x8a, 0x79, 0x7c, 0xec, 0x91, 0x63, 0x1a, 0x2c, 0x4d, 0xf8,
	0x75, 0x86, 0x31, 0x95, 0x8c, 0x9f, 0x3b, 0xdb, 0x0a, 0x33, 0xc5, 0x55, 0x87, 0x9f, 0x9b, 0xfb,
	0xe8, 0x47, 0x50, 0x5f, 0xe6, 0x49, 0x48, 0x57, 0x4b, 0x32, 0x36, 0xa5, 0xb4, 0xbf, 0x97, 0x86,
	0x5c, 0x7b, 0x46, 0x63, 0x8a, 0xb5, 0xf7, 0x38, 0x59, 0xb6, 0xba, 0x66, 0xb5, 0x03, 0x59, 0x73,
	0x3e, 0xb7, 0xc4, 0xc4, 0x77, 0x09, 0xd9, 0x98, 0xcf, 0x2d, 0xcc, 0x10, 0x68, 0x17, 0xf2, 0x13,
	0xd7, 0x7a, 0x49, 0x56, 0x5c, 0x82, 0xe3, 0xd8, 0x16, 0xcb, 0xc5, 0x02, 0x85, 0x6e, 0x40, 0x9e,
	0x6d, 0x73, 0xf0, 0x20, 0x5b, 0xde, 0x51, 0x17, 0xb4, 0xfa, 0x10, 0xb2, 0xb4, 0xec, 0x95, 0x5e,
	0xbe, 0x21, 0x76, 0xa1, 0x53, 0xe2, 0xd6, 0x4c, 0x34, 0xe4, 0x67, 0xce, 0xb9, 0xc1, 0x85, 0x21,
	0xcf, 0xa5, 0x58, 0x59, 0xee, 0xe7, 0x00, 0x91, 0xd7, 0x2c, 0xd7, 0x58, 0xf1, 0x2e, 0x05, 0xa7,
	0xdf, 0x88, 0x2e, 0x07, 0x35, 0xfa, 0xfd, 0x26, 0xbf, 0xc7, 0xdc, 0xea, 0x35, 0x9f, 0x1a, 0x74,
	0x6c, 0xfe, 0xfd, 0x1c, 0xe4, 0xf9, 0x25, 0x2e, 0xf4, 0xb1, 0x78, 0x90, 0x26, 0xc3, 0x94, 0x7e,
	0x25, 0x79, 0xc9, 0x4b, 0x7d, 0x8b, 0xe6, 0x36, 0x6c, 0x44, 0xa1, 0x09, 0xbb, 0x30, 0xc5, 0xe5,
	0xac, 0x86, 0x54, 0x76, 0x91, 0xe9, 0x3a, 0x94, 0x4e, 0x5c, 0x3f, 0x18, 0x2b, 0x0f, 0x3b, 0xb0,
	0x25, 0x5b, 0x96, 0x79, 0x1b, 0x72, 0xf6, 0x4c, 0xc6, 0x93, 0xe5, 0xbd, 0xcd, 0x84, 0x39, 0x30,
	0xcf, 0x45, 0x9f, 0x85, 0xe1, 0x65, 0x2e, 0x19, 0x25, 0x0b, 0xb9, 0x12, 0xf7, 0xc8, 0x7e, 0x2d,
	0x1b, 0x86, 0x2c, 0x77, 0x63, 0x8b, 0xa0, 0x37, 0xd6, 0x70, 0xaa, 0xee, 0xd4, 0x86, 0x2a, 0x37,
	0xff, 0x38, 0x76, 0xe3, 0xed, 0x83, 0x75, 0xac, 0xdc, 0x5a, 0xe2, 0x16, 0x5c, 0x65, 0xa2, 0xa4,
	0xd0, 0x01, 0x54, 0x7c, 0xd3, 0x99, 0xbc, 0x70, 0x5f, 0x8f, 0xc3, 0x07, 0x92, 0x62, 0xeb, 0x91,
	0xf1, 0x92, 0x06, 0x1c, 0xcb, 0xae, 0x93, 0x95, 0xfd, 0x28, 0x51, 0x7f, 0x05, 0x15, 0xf5, 0x2b,
	0xb4, 0x2f, 0x9a, 0x78, 0xf6, 0x29, 0xeb, 0xe7, 0x58, 0x5f, 0xc4, 0x53, 0x2b, 0xdf, 0xe3, 0x79,
	0x04, 0x1b, 0x3c, 0x77, 0xec, 0xce, 0xf9, 0xfe, 0x6f, 0x26, 0xe9, 0x35, 0x51, 0x27, 0x8a, 0xab,
	0x1c, 0xdb, 0xe3, 0xd0, 0xfa, 0xaf, 0xa4, 0xa0, 0xac, 0x48, 0x85, 0x7e, 0x14, 0xd3, 0xe6, 0xce,
	0x05, 0x2a, 0xa2, 0x6a, 0x36, 0x7a, 0xdf, 0x23, 0x2d, 0xdf, 0xf7, 0xd0, 0x3f, 0x5e, 0xb5, 0xa0,
	0x56, 0x84, 0xec, 0xc0, 0x38, 0x3c, 0xe0, 0x7e, 0xda, 0x6f, 0x60, 0x1a, 0x58, 0xa6, 0xf5, 0xaf,
	0x56, 0x41, 0x2f, 0x41, 0x95, 0x3b, 0xf2, 0xf8, 0x59, 0xef, 0x70, 0xd4, 0x31, 0xf8, 0x12, 0xdc,
	0xa0, 0xd1, 0x6d, 0xed, 0xf7, 0xbe, 0x19, 0xb3, 0xab, 0x70, 0x69, 0xfd, 0x6a, 0xf4, 0xea, 0x11,
	0x7e, 0xae, 0xa5, 0xd8, 0x6f, 0x4f, 0x4b, 0xeb, 0xff, 0x2a, 0x03, 0xe5, 0x2e, 0x09, 0xc2, 0x37,
	0x8e, 0xf6, 0xa1, 0x62, 0xcf, 0xc7, 0xe2, 0x86, 0x7c, 0xb8, 0x49, 0xf0, 0x6e, 0x54, 0x4d, 0x05,
	0xbc, 0xdb, 0xee, 0xcb, 0x3b, 0xf5, 0x65, 0x7b, 0xde, 0x90, 0x3c, 0xa1, 0x0d, 0xf2, 0xca, 0xa3,
	0x09, 0x57, 0x21, 0xcf, 0x56, 0x55, 0xf9, 0x71, 0x93, 0x12, 0x16, 0xa9, 0x8b, 0x9f, 0x2b, 0x41,
	0x07, 0x50, 0x9d, 0xbb, 0x5e, 0xc0, 0x8e, 0x69, 0xda, 0xce, 0xb1, 0x9c, 0x67, 0xbf, 0xb7, 0x5a,
	0xb4, 0xbe, 0xeb, 0x05, 0x1d, 0x8e, 0xc4, 0x95, 0x79, 0x94, 0xf0, 0xeb, 0x47, 0x50, 0x0a, 0xe5,
	0x46, 0x0f, 0xa1, 0xc8, 0x5e, 0x70, 0xb3, 0xdc, 0xe9, 0xf2, 0x26, 0x41, 0xac, 0x3c, 0x81, 0xc2,
	0x21, 0x9e, 0x6d, 0x0a, 0x86, 0xaa, 0x92, 0x97, 0x31, 0x43, 0x3d, 0xd4, 0x67, 0x50, 0x56, 0x84,
	0x88, 0x7a, 0x81, 0xe8, 0x79, 0x16, 0xde, 0x0b, 0xb8, 0x5e, 0x90, 0xe8, 0x49, 0x28, 0x82, 0x3f,
	0x9a, 0xa0, 0xf4, 0x24, 0x14, 0x56, 0x57, 0xa4, 0xe5, 0x4f, 0x97, 0x84, 0x69, 0xfd, 0x16, 0x14,
	0xa5, 0x8c, 0xd4, 0x79, 0xda, 0xfd, 0xd3, 0xcf, 0xf9, 0xcb, 0x2e, 0xed, 0xfe, 0xe9, 0x17, 0x5a,
	0x5a, 0xff, 0x97, 0x39, 0xd8, 0x88, 0x9e, 0x41, 0x62, 0xb6, 0x7e, 0x9c, 0x78, 0xbd, 0x89, 0x0e,
	0x87, 0x1b, 0x6a, 0xdb, 0x8c, 0xe3, 0xd7, 0x3e, 0xdf, 0xa4, 0xff, 0x62, 0x2e, 0xf6, 0x28, 0x53,
	0x62, 0x65, 0x38, 0xd7, 0x7c, 0x42, 0xff, 0xfe, 0x76, 0x01, 0x5d, 0x82, 0x4a, 0xab, 0xd1, 0x1c,
	0xf7, 0x9e, 0x19, 0x18, 0xb7, 0x5b, 0x86, 0xf6, 0x3b, 0x05, 0x74, 0x19, 0x36, 0x29, 0x09, 0x1b,
	0x8d, 0xd6, 0x78, 0x60, 0x34, 0x70, 0xf3, 0x89, 0xf6, 0xaf, 0x0b, 0xa8, 0x0c, 0xf9, 0x83, 0xde,
	0xf3, 0xae, 0x81, 0xb5, 0x7f, 0xc3, 0x13, 0x03, 0x63, 0xd8, 0x6e, 0x69, 0xff, 0xb6, 0x80, 0x4a,
	0x90, 0x7d, 0xda, 0x3e, 0x3c, 0xd4, 0xfe, 0x1d, 0xa3, 0x0f, 0x8c, 0xe1, 0xe3, 0x76, 0x4b, 0xfb,
	0x5d, 0x99, 0x18, 0xb5, 0x5b, 0xda, 0xbf, 0x2f, 0xa0, 0x0a, 0x14, 0x06, 0xc6, 0xb0, 0xdf, 0x6c,
	0xf4, 0xb5, 0xff, 0xc0, 0x3e, 0x71, 0xd8, 0xee, 0x8e, 0xbe, 0x19, 0xb7, 0x3b, 0x9d, 0xd1, 0xb0,
	0xb1, 0x7f, 0x68, 0x68, 0xbf, 0x57, 0x40, 0x57, 0x40, 0xeb, 0x1a, 0xc3, 0xf1, 0x7e, 0xbb, 0x4b,
	0x3f, 0x8c, 0x9f, 0xb5, 0x9b, 0x86, 0xf6, 0x1f, 0x0b, 0x08, 0x41, 0x95, 0x91, 0x71, 0xaf, 0xd1,
	0x6a, 0x36, 0x06, 0x43, 0xed, 0x3f, 0x15, 0xd0, 0x06, 0x94, 0x28, 0xad, 0xd1, 0xea, 0xb4, 0xbb,
	0xda, 0x7f, 0x66, 0xc5, 0xd3, 0x34, 0x6e, 0x3c, 0xd7, 0xfe, 0x4b, 0x01, 0x55, 0xa1, 0xd8, 0xee,
	0x37, 0xc7, 0x87, 0xbd, 0xe6, 0x53, 0xed, 0xbf, 0x32, 0x30, 0x4d, 0x72, 0xe9, 0x7f, 0xbf, 0x80,
	0x36, 0x01, 0x06, 0xdf, 0x0e, 0xc6, 0x9d, 0x5e, 0x6b, 0x74, 0x68, 0x68, 0xff, 0x8d, 0x01, 0x28,
	0x01, 0x37, 0x9e, 0xb7, 0x7b, 0xda, 0x7f, 0x0f, 0x01, 0xcd, 0x27, 0xb8, 0xd7, 0x1b, 0x6a, 0x7f,
	0x10, 0x12, 0xfa, 0x43, 0xdc, 0x68, 0x1a, 0xda, 0x1f, 0x86, 0x1c, 0xfd, 0x46, 0xb3, 0x39, 0xd4,
	0xfe, 0x47, 0x98, 0xe6, 0xf2, 0xfc, 0x4f, 0x26, 0x01, 0x4d, 0xef, 0x53, 0xfe, 0xff, 0x15, 0x26,
	0xbb, 0xb4, 0x46, 0xff, 0x9b, 0x29, 0x9d, 0x7d, 0x4f, 0xcc, 0x16, 0xb4, 0x3f, 0x5d, 0x94, 0x08,
	0x3a, 0x7f, 0xd2, 0x7e, 0xbe, 0x88, 0xb6, 0x60, 0x83, 0x25, 0x87, 0xdf, 0xd2, 0x89, 0xdb, 0x41,
	0xfb, 0xb1, 0xf6, 0x0b, 0x45, 0x6a, 0xb7, 0xce, 0xd3, 0x6e, 0xaf, 0xa5, 0xfd, 0x22, 0xfb, 0x7f,
	0x68, 0x34, 0x06, 0x86, 0xf6, 0x4b, 0x45, 0xa4, 0x41, 0xb9, 0x31, 0x6a, 0xb5, 0x87, 0xe3, 0xe7,
	0xb8, 0x3d, 0x34, 0xb4, 0x5f, 0x2e, 0x52, 0x95, 0x71, 0x0a, 0x9d, 0xf5, 0xe1, 0xde, 0xa1, 0xf6,
	0x67, 0x8a, 0xc2, 0x02, 0x07, 0xd4, 0x02, 0x7f, 0xb6, 0x48, 0x45, 0xe8, 0xa8, 0x76, 0xff, 0x73,
	0x45, 0x5a, 0x07, 0x4a, 0xe2, 0x75, 0xf8, 0xf3, 0x45, 0x66, 0xbf, 0x6f, 0x07, 0x87, 0xbd, 0xc7,
	0xda, 0xaf, 0x14, 0xa9, 0x06, 0x9e, 0x37, 0x9e, 0x1a, 0xe3, 0xc6, 0x61, 0x03, 0x77, 0xb4, 0xbf,
	0xc0, 0x3e, 0xb1, 0x4f, 0x15, 0x3c, 0x1e, 0x8c, 0x06, 0x7d, 0xa3, 0xdb, 0xd2, 0x7e, 0x95, 0x81,
	0xf8, 0x67, 0xa9, 0xef, 0x68, 0xbf, 0x56, 0xd4, 0xbb, 0x50, 0x3a, 0xb4, 0x9d, 0xc5, 0x6b, 0xe6,
	0xdb, 0x0d, 0xd8, 0x0c, 0x5d, 0xf4, 0x8d, 0x3c, 0x46, 0x98, 0xd8, 0x4a, 0x8c, 0xbb, 0x37, 0xde,
	0xb0, 0x62, 0x69, 0xfd, 0x9f, 0x17, 0xa0, 0x1a, 0x5b, 0x82, 0x52, 0x46, 0xd2, 0x74, 0x7c, 0x24,
	0x8d, 0xc1, 0xd4, 0xfe, 0xfe, 0x4e, 0xb4, 0xb5, 0xc2, 0xb7, 0x9c, 0x97, 0x6f, 0x8d, 0x4b, 0x40,
	0x62, 0x67, 0x37, 0xfe, 0xe2, 0xc9, 0xc3, 0x44, 0xd8, 0xa6, 0xaf, 0xfb, 0x36, 0x1f, 0x24, 0xf9,
	0x5d, 0x7b, 0x11, 0xc2, 0x7d, 0x09, 0x39, 0x06, 0x16, 0xa1, 0xc3, 0x7b, 0xeb, 0x58, 0x3b, 0x94,
	0xcc, 0xd7, 0x79, 0x19, 0x02, 0x3d, 0x64, 0xa7, 0x8e, 0xf9, 0xea, 0x2c, 0xdb, 0x87, 0x2b, 0x24,
	0x5f, 0xc6, 0x50, 0x7a, 0x48, 0x76, 0xce, 0x58, 0x26, 0x68, 0xdc, 0x0c, 0x53, 0x6a, 0x0c, 0xae,
	0xfa, 0x62, 0xf2, 0x4d, 0x84, 0xd0, 0x50, 0xb8, 0x34, 0x95, 0x7f, 0xeb, 0x7f, 0x25, 0x0b, 0x10,
	0xc9, 0x4f, 0x67, 0x3c, 0x3c, 0x34, 0x12, 0x0f, 0x68, 0xf0, 0x48, 0xe8, 0x67, 0xa1, 0x20, 0x3e,
	0x24, 0xde, 0x0c, 0xbc, 0x73, 0xbe, 0x2a, 0xa4, 0x9c, 0x0f, 0xb3, 0x4f, 0x7a, 0x83, 0x21, 0x96,
	0x05, 0xa0, 0x41, 0x72, 0x48, 0xe1, 0x47, 0x21, 0x77, 0x2f, 0x50, 0xe2, 0xda, 0xf1, 0x05, 0xdd,
	0x06, 0x98, 0x7b, 0xf6, 0xa9, 0x3d, 0x25, 0xc7, 0x61, 0xd4, 0x2c, 0x1f, 0xea, 0x8b, 0x32, 0xd0,
	0x7d, 0x80, 0x70, 0x16, 0xb6, 0xe2, 0x19, 0x98, 0x68, 0xb2, 0xa6, 0xc0, 0xd0, 0x0e, 0x68, 0x47,
	0xae, 0x67, 0x91, 0xf1, 0x7c, 0x31, 0x9d, 0x8e, 0xb9, 0x76, 0xd8, 0xfb, 0x56, 0x78, 0x83, 0xd1,
	0xfb, 0x8b, 0xe9, 0x94, 0xcf, 0x1d, 0x3e, 0x82, 0x2a, 0xf7, 0xab, 0xb1, 0x08, 0x93, 0x0a, 0xe1,
	0x5b, 0x45, 0x15, 0x9e, 0xd1, 0x62, 0xf4, 0xff, 0xdf, 0xc3, 0xd4, 0x7d, 0x28, 0x08, 0x63, 0xb0,
	0x57, 0xc7, 0x7a, 0x03, 0xf1, 0xa4, 0xd0, 0x3e, 0x6e, 0xb7, 0x1e, 0x1b, 0xfc, 0xdd, 0x93, 0x6e,
	0xaf, 0x6b, 0x68, 0x19, 0xfa, 0x6f, 0x34, 0x30, 0xb0, 0x96, 0xad, 0xef, 0x41, 0x29, 0x74, 0xce,
	0x28, 0x62, 0x4e, 0x9d, 0x15, 0x31, 0xeb, 0x37, 0xa3, 0x87, 0x56, 0x44, 0x98, 0xcf, 0xdf, 0x03,
	0x30, 0x06, 0xbd, 0x81, 0x96, 0xd6, 0xff, 0x5a, 0x0a, 0x36, 0x13, 0xab, 0x86, 0xcb, 0xfe, 0x9e,
	0xba, 0xb8, 0xbf, 0x3f, 0x80, 0xb2, 0xc5, 0x42, 0x1a, 0xee, 0xf0, 0xcb, 0xd3, 0x92, 0xe3, 0x70,
	0xe3, 0x18, 0xac, 0xf0, 0x3f, 0x7a, 0x4f, 0x39, 0x29, 0x31, 0x17, 0x8f, 0x46, 0x56, 0xa3, 0x33,
	0x11, 0x7d, 0x7b, 0xa2, 0x1f, 0x01, 0x44, 0xcc, 0xe8, 0x73, 0xe6, 0xfe, 0x63, 0x6b, 0x2a, 0x6f,
	0x92, 0x5d, 0x5f, 0xf5, 0x0d, 0x2a, 0x68, 0x93, 0xc6, 0x4e, 0x0e, 0xfb, 0xad, 0xeb, 0x90, 0xe7,
	0x14, 0x54, 0x83, 0x82, 0x35, 0x35, 0x7d, 0x5f, 0x1c, 0x99, 0xa9, 0x62, 0x99, 0xd4, 0xef, 0x41,
	0x9e, 0x47, 0x5c, 0xe8, 0xa3, 0x30, 0x26, 0xe3, 0x0a, 0xd8, 0x4c, 0xc4, 0x64, 0xe1, 0x51, 0xdf,
	0xcf, 0x20, 0xc7, 0x08, 0x67, 0x2f, 0x57, 0x44, 0x4f, 0xac, 0xe9, 0x7f, 0x2b, 0x05, 0x59, 0xe6,
	0x22, 0x57, 0x21, 0xef, 0x2c, 0x66, 0x2f, 0xc4, 0x63, 0x9a, 0x55, 0x2c, 0x52, 0x4a, 0xf8, 0xae,
	0xbe, 0xb7, 0xb5, 0xd6, 0x9d, 0xd0, 0x3e, 0xc0, 0xa9, 0xed, 0xdb, 0x62, 0x8f, 0x35, 0xcb, 0x3a,
	0x04, 0x7d, 0xcd, 0xc6, 0xc3, 0xee, 0xb3, 0x10, 0x89, 0x15, 0x2e, 0x25, 0x04, 0xcd, 0x9d, 0x73,
	0xb4, 0xf9, 0x53, 0xc8, 0xf1, 0x3b, 0x8b, 0x1f, 0x40, 0x6e, 0xce, 0xee, 0x32, 0x72, 0x05, 0x6d,
	0x28, 0xed, 0xd6, 0xf5, 0x02, 0xcc, 0x33, 0xf5, 0xbf, 0x97, 0x86, 0x6a, 0x4c, 0x82, 0x84, 0xb8,
	0x7c, 0x18, 0x79, 0x5b, 0x71, 0x57, 0xa9, 0x68, 0x3b, 0xfe, 0x4a, 0x1e, 0xd7, 0x52, 0xe2, 0x39,
	0xbc, 0x22, 0x3b, 0xf0, 0x6e, 0xbb, 0x8e, 0x1c, 0x5c, 0x64, 0x5a, 0x7d, 0x4e, 0x2b, 0x17, 0x7f,
	0x4e, 0xeb, 0xb6, 0xac, 0x67, 0x3e, 0xd9, 0xd6, 0x98, 0x1e, 0x44, 0x45, 0x15, 0x0d, 0x16, 0xce,
	0xd1, 0xe0, 0x17, 0x00, 0x51, 0xb5, 0x50, 0x15, 0x4a, 0xe1, 0x92, 0xa9, 0x78, 0x93, 0xf0, 0x70,
	0xc4, 0x56, 0xd5, 0xd9, 0xb3, 0xac, 0xc6, 0x37, 0x43, 0x03, 0x77, 0x1b, 0x87, 0x6c, 0xe2, 0x03,
	0xcf, 0x89, 0x7d, 0x7c, 0x12, 0xc8, 0x17, 0x15, 0x5f, 0xb1, 0x94, 0x38, 0x4c, 0x2e, 0x52, 0xfc,
	0x55, 0x90, 0x69, 0xa8, 0x1a, 0xfa, 0x5f, 0xff, 0xa7, 0x29, 0x28, 0x3f, 0xe3, 0xd5, 0x61, 0xbc,
	0x4a, 0x65, 0xb9, 0xbb, 0x86, 0x95, 0x65, 0x47, 0xa6, 0xed, 0xe9, 0x64, 0x3c, 0xe1, 0x9b, 0x41,
	0x2c, 0x9e, 0x67, 0x94, 0x96, 0x19, 0x90, 0x28, 0x9b, 0x6d, 0x1e, 0xf0, 0x5b, 0x84, 0x3c, 0x7b,
	0x68, 0xcf, 0x94, 0x6c, 0xb6, 0x33, 0x95, 0x55, 0xb8, 0x47, 0x3e, 0xf1, 0xd0, 0x3b, 0x50, 0x38,
	0xb6, 0x83, 0xb1, 0x7f, 0x62, 0x0a, 0x1d, 0xe7, 0x8f, 0xed, 0x60, 0x70, 0x62, 0x52, 0x3e, 0x9a,
	0xc1, 0x0f, 0xf6, 0x89, 0x29, 0x53, 0xe9, 0xd8, 0x0e, 0xf6, 0x19, 0x41, 0xf2, 0x05, 0xe6, 0xb1,
	0x78, 0xb7, 0x95, 0xf2, 0x0d, 0xcd, 0x63, 0xfd, 0x2e, 0x64, 0x0f, 0xa6, 0xe6, 0xf1, 0x79, 0x0b,
	0x8c, 0x4a, 0xe3, 0xfb, 0xcd, 0x14, 0x64, 0xb1, 0xbb, 0x66, 0x4d, 0x32, 0x52, 0x69, 0x3a, 0xa6,
	0xd2, 0x07, 0x00, 0xe1, 0xc6, 0xab, 0x1c, 0x1f, 0xd7, 0xec, 0xd0, 0x2a, 0xc0, 0xb7, 0x3f, 0x11,
	0xa0, 0xef, 0x41, 0xbe, 0x43, 0x02, 0xcf, 0xb6, 0xce, 0xaf, 0x91, 0x7c, 0xed, 0x4b, 0xff, 0xeb,
	0x29, 0x28, 0x1e, 0xd8, 0xfc, 0x41, 0x97, 0x70, 0x6a, 0x9d, 0x8a, 0xa6, 0xd6, 0x94, 0xcd, 0x99,
	0xda, 0x0e, 0x0f, 0x15, 0x72, 0x98, 0x27, 0x28, 0xd2, 0xb7, 0xff, 0x14, 0x11, 0x2b, 0x71, 0xec,
	0x3f, 0xda, 0x81, 0xdc, 0x8c, 0x19, 0x36, 0xbb, 0x76, 0x57, 0x88, 0x03, 0x28, 0x37, 0x5b, 0x20,
	0x62, 0x6f, 0xa1, 0x8a, 0x95, 0x20, 0x0d, 0x32, 0x0b, 0xf1, 0x3e, 0x5b, 0x09, 0xd3, 0xbf, 0x94,
	0x72, 0x2c, 0xf6, 0xd6, 0x4a, 0x98, 0xfe, 0xbd, 0xf3, 0x27, 0x20, 0x2f, 0xc6, 0x99, 0xab, 0x80,
	0x5a, 0xb8, 0xfd, 0xcc, 0xc0, 0xe3, 0x6e, 0x6f, 0x38, 0x96, 0xeb, 0xec, 0x29, 0x84, 0x60, 0x43,
	0xd0, 0xf1, 0xa8, 0x2b, 0xde, 0x23, 0x8e, 0x68, 0x8d, 0xfd, 0x1e, 0xc3, 0x65, 0x14, 0xda, 0x60,
	0xd8, 0xeb, 0xf7, 0x8d, 0x96, 0x96, 0xbd, 0xf3, 0xab, 0x69, 0x28, 0x85, 0xdb, 0x95, 0x74, 0xfe,
	0xcf, 0x96, 0xc5, 0x07, 0xc3, 0xc6, 0x63, 0x5a, 0x4e, 0x1e, 0x5d, 0x82, 0xaa, 0xa4, 0xe0, 0x21,
	0x25, 0xfd, 0x20, 0x04, 0xc9, 0x8f, 0xa5, 0x42, 0x8a, 0x78, 0xe1, 0x56, 0x2b, 0x86, 0x6c, 0x07,
	0xed, 0x6e, 0x7b, 0xf0, 0x84, 0xed, 0x94, 0x6c, 0x42, 0x99, 0x93, 0xf8, 0x96, 0x4e, 0x26, 0x24,
	0x50, 0x2e, 0x2a, 0x0b, 0xda, 0x00, 0x60, 0x04, 0xbe, 0x51, 0x42, 0x27, 0x24, 0x25, 0x96, 0x3e,
	0xa4, 0xa3, 0x7d, 0x2e, 0xfc, 0x4a, 0x0b, 0x73, 0xe1, 0x4b, 0xe8, 0x32, 0x68, 0x62, 0x15, 0x1f,
	0x1b, 0x8d, 0xe6, 0x13, 0x36, 0x45, 0x83, 0x90, 0xed, 0x31, 0x0d, 0x07, 0xca, 0xe8, 0x1a, 0x5c,
	0x09, 0x93, 0xe3, 0xfd, 0x6f, 0xc7, 0xbd, 0xbe, 0x81, 0x1b, 0xc3, 0x1e, 0xd6, 0x2a, 0x61, 0x89,
	0xe1, 0xc6, 0xc4, 0xfe, 0x4d, 0xd8, 0x72, 0xbd, 0xe3, 0x5d, 0x73, 0x6e, 0x5a, 0x27, 0x24, 0xb4,
	0xe5, 0x7e, 0x9e, 0x3f, 0xeb, 0xf2, 0x7f, 0x02, 0x00, 0x00, 0xff, 0xff, 0xaf, 0x89, 0xda, 0x1f,
	0xbd, 0x5d, 0x00, 0x00,
}
